# Acoustic characteristics of stimuli

setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/epistles/014_rolloff/soundgen_ac-cor-em')

library(ggplot2)
library(lme4)
library(brms)

# load data
df = read.csv('data/rn.csv')  # final sample of "clean" data
# df = read.csv('data/rn_all.csv') # w/o excluding any participants
table(df$sound_base, df$cond)

df = droplevels(df[!is.na(df$rolloff), ])
summary(df$rolloff)
colnames(df)

ac = read.csv('/home/allgoodguys/Documents/Studying/Lund_PhD/epistles/014_rolloff/soundgen_ac-cor-em/data/rn_sumtab.csv')
ac = droplevels(ac[!is.na(ac$rolloff), ])
# colnames(ac)
# myVars = c('sound_master', 'sex', 'rolloff_dB', 'pitchMedian', 'sylLenMedian', 'sylLenMax', 'loudness_median', 'loudness_max') 
# df[, myVars] = ac[match(df$sound, ac$sound1), myVars]
# ac$rolloff = df$rolloff[match(ac$sound1, df$sound)]

## summary table
st = aggregate(sound_base ~ callType, ac, function(x) length(unique(x)))
br = aggregate(breathing ~ callType, ac, function(x) sum(x) / 3)[, 2]  # /3 b/c three sounds per prototype
st$sound_base = paste0(st$sound_base, ' (', br, ')')
sex_temp = aggregate(sound_base ~ callType + sex, ac, function(x) length(unique(x)))
st$sex = aggregate(sound_base ~ callType, sex_temp, function(x) paste(x, collapse = '/'))[, 2]

rolloff_mean = aggregate(rolloff_dB ~ callType, ac, function(x) mean(x[x > 0]))[, 2]
rolloff_min = aggregate(rolloff_dB ~ callType, ac, function(x) min(x[x > 0]))[, 2]
rolloff_max = aggregate(rolloff_dB ~ callType, ac, function(x) max(x[x > 0]))[, 2]
st$rolloff = paste0('±', rolloff_mean, ' [', rolloff_min, ', ', rolloff_max, ']')
v = c('dur', 'sylLenMedian', 'pitchMedian', 'HNR_median', 'specCentroid_median')
nDigits = c(1, 1, 0, 1, 1)

for (i in 1:length(v)) {
  myMean = aggregate(get(v[i]) ~ callType, ac, function(x) round(mean(x), nDigits[i]))[, 2]
  myRange = aggregate(get(v[i]) ~ callType, ac, function(x) round(range(x), nDigits[i]))[, 2]
  myRange = apply(myRange, 1, function(x) paste0('[', x[1], ', ', x[2], ']'))
  st[, v[i]] = paste(myMean, myRange)
}
st
write.csv(st, 'data/sum_stimuli.csv')



