setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'cry_481_ut_sad-cry_33-f'
fileIdx = '04'

# original (closest to pitch jump)
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 700, 701, 900, 1100),
                                        value = c(460, 370, 610, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              rolloff = c(-12, -8, -30),
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(nSyl = 3, sylLen = 80, pauseLen = 350,
              pitchAnchors = c(600, 500), 
              pitchAnchorsGlobal = c(0, -1),
              rolloff = -4,
              nonlinBalance = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 35,
              temperature = 0.1,
              formants = c(550, 1600, 3500, 5200),
              formantDep = 1,
              mouthAnchors = c(.5, .4),
              noiseAnchors = data.frame(time = c(-60, -30, 0, 35, 80, 200),
                                        value = c(-20, 10, -10, -10, -10, -60)),
              rolloffNoise = -2,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)
s2 = s2 * seq(1, .2, length.out = length(s2))

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_', 'r', rolloff, '.wav'))

# no nonlin effects
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 900, 1100),
                                        value = c(460, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              rolloff = c(-12, -8, -30),
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))

# One pitch jump r00
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 700, 701, 900, 1100),
                                        value = c(460, 370, 610, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              rolloff = c(-12, -8, -30),
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100_r00.wav'))

# One pitch jump and r+
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 700, 701, 900, 1100),
                                        value = c(460, 370, 610, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              rolloff = c(-12, -8, -30) + 4,
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100_r+4.wav'))

# One pitch jump and r-
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 700, 701, 900, 1100),
                                        value = c(460, 370, 610, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              rolloff = c(-12, -8, -30) - 4, invalidArgAction = 'ignore',
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100_r-4.wav'))


# subh
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 900, 1100),
                                        value = c(460, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              nonlinBalance = 30, subFreq = 130, subDep = 70, jitterDep = 0, shortestEpoch = 200,
              rolloff = c(-12, -8, -30),
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))



# chaos
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 900, 1100),
                                        value = c(460, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              nonlinBalance = 50, subFreq = 130, subDep = 0, jitterDep = 2, shortestEpoch = 200,
              rolloff = c(-12, -8, -30),
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 700, 701, 900, 1100),
                                        value = c(460, 370, 610, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              nonlinBalance = 40, subFreq = 130, subDep = 70, jitterDep = 2, shortestEpoch = 200,
              rolloff = c(-12, -8, -30),
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s1 = soundgen(sylLen = 1150,
              pitchAnchors = data.frame(time = c(0, 700, 701, 900, 1100),
                                        value = c(460, 370, 610, 620, 450)),
              vibratoFreq = 2, vibratoDep = 1,
              temperature = 0.001,
              nonlinBalance = 60, subFreq = 130, subDep = 90, jitterDep = 3, shortestEpoch = 200,
              rolloff = c(-12, -8, -30),
              formants = c(550, 1600, 3000, 4000, 5200),
              noiseAnchors = -30,
              rolloffNoise = 0,
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .15)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
