setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'cry_494_ut_sad-cry_46-f'
fileIdx = '06'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

# original (closest to 111)
s1 = soundgen(sylLen = 1450,
              pitchAnchors = data.frame(time = c(0, 200, 201, 850, 1000, 1001, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 40, subFreq = 200, subDep = 120, jitterDep = .1,
              temperature = 0.001,
              rolloff = -8,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(nSyl = 2, sylLen = 240, pauseLen = 220,
              pitchAnchors = data.frame (time = c(0, 70, 150, 280),
                                         value = c(780, 1020, 650, 430)),
              amplAnchors = data.frame (time = c(0, 70, 120, 150, 280),
                                        value = c(80, 80, 50, 70, 60)),
              pitchAnchorsGlobal = c(0, -8),
              rolloff = -15,
              temperature = 0.001,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = c(.5, .3),
              noiseAnchors = data.frame(time = c(-30, 90, 120, 280), 
                                        value = c(-10, -20, -10, -40) - 5),
              rolloffNoise = -6,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s1 = soundgen(sylLen = 1450,
              pitchAnchors = data.frame(time = c(0, 200, 300, 850, 1000, 1100, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 0, 
              temperature = 0.001,
              rolloff = -8,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))

# Pitch jump
s1 = soundgen(sylLen = 1450,
              pitchAnchors = data.frame(time = c(0, 200, 201, 850, 1000, 1001, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 0, 
              temperature = 0.001,
              rolloff = -8,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subharm
s1 = soundgen(sylLen = 1450,
              pitchAnchors = data.frame(time = c(0, 200, 300, 850, 1000, 1100, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 40, subFreq = 200, subDep = 130, jitterDep = 0,
              temperature = 0.001,
              rolloff = -8,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s1 = soundgen(sylLen = 1450, 
              pitchAnchors = data.frame(time = c(0, 200, 300, 850, 1000, 1100, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 50, subFreq = 200, subDep = 0, jitterDep = 2, shortestEpoch = 100,
              temperature = 0.001,
              rolloff = -8,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s1 = soundgen(sylLen = 1450,
              pitchAnchors = data.frame(time = c(0, 200, 300, 850, 1000, 1001, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 50, subFreq = 200, subDep = 120, jitterDep = .5, 
              temperature = 0.001,
              rolloff = -8,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r00.wav'))

# psc level 1 rolloff +4
s1 = soundgen(sylLen = 1450,
              pitchAnchors = data.frame(time = c(0, 200, 300, 850, 1000, 1001, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 50, subFreq = 200, subDep = 120, jitterDep = .5, 
              temperature = 0.001,
              rolloff = -8 + 4,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r+4.wav'))

# psc level 1 rolloff -4
s1 = soundgen(sylLen = 1450,
              pitchAnchors = data.frame(time = c(0, 200, 300, 850, 1000, 1001, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 50, subFreq = 200, subDep = 120, jitterDep = .5, 
              temperature = 0.001,
              rolloff = -8 - 4,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r-4.wav'))

# psc level 2
s1 = soundgen(sylLen = 1450,
              pitchAnchors = data.frame(time = c(0, 200, 201, 850, 1000, 1001, 1450),
                                        value = c(500, 670, 1020, 1040, 1030, 660, 580)),
              vibratoDep = .25, vibratoFreq = 5,
              nonlinBalance = 65, subFreq = 200, subDep = 150, jitterDep = 1.5, shortestEpoch = 200,
              temperature = 0.001,
              rolloff = -8,
              formants = c(600, 1600, 2500, 3600),
              mouthAnchors = rnorm(5, .5, .05),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)
# playme(s1, 22050)
s = addVectors(s1, s2 / 2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
