setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'cry_496_ut_sad-cry_48-f'
fileIdx = '07'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original (closest to no nonlin)

# target = '/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_valid/stimuli/ut/cut/cry_496_ut_sad-cry_48-f.wav'
# a = analyze(target, plot = T)
# p = round(a$pitch[a$time <= 1600])
# pitch = p[seq(3, length(p), 4)]
# paste0(pitch, collapse = ', ')
# time = round(seq(0, 1600, length.out = length(pitch)))
# paste0(time, collapse = ', ')

s1 = soundgen(
  sylLen = 1600,
  pitchAnchors = data.frame(
    time = c(0, 107, 213, 320, 427, 533, 640, 747, 853, 960, 1067, 1173, 1280, 1387, 1493, 1600),
    value = c(417, 408, 434, 463, 479, 453, 416, 363, 341, 379, 376, 373, 376, 361, 354, 381)
  ),
  temperature = 0.001,
  rolloff = -8,
  formants = c(1200, 1800, 3200),
  mouthAnchors = rnorm(4, .5, .1),
  addSilence = 0,
  samplingRate = 22050, play = T, plot = T, osc = T
)

s2 = soundgen(
  repeatBout = 2, sylLen = 520, pauseLen = 20,
  pitchAnchors = data.frame(time = c(0, 50, 100, 200, 250, 300, 470, 520) / 520, 
                            value = c(380, 760, 180, 170, 500, 320, 250, 320)),
  amplAnchors = data.frame(time = c(0, 50, 100, 200, 250, 300, 470, 520) / 520, 
                           value = c(80, 80, 70, 70, 80, 70, 65, 65)),
  rolloff = -14,
  temperature = 0.001,
  formants = list(f1 = c(1200, 900, 1000),
                  f2 = 1800, f3 = 3200), 
  noiseAnchors = data.frame(time = c(0, 50, 170, 260, 360),
                            value = c(-30, -10, -20, -10, -40)),
  rolloffNoise = -6,
  addSilence = 0, attackLen = 10, 
  samplingRate = 22050, play = T, plot = T, osc = T
)

s2 = fade(s2, fadeIn = 0, fadeOut = length(s2))

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))

# no nonlin r+
s1 = soundgen(
  sylLen = 1600,
  pitchAnchors = data.frame(
    time = c(0, 107, 213, 320, 427, 533, 640, 747, 853, 960, 1067, 1173, 1280, 1387, 1493, 1600),
    value = c(417, 408, 434, 463, 479, 453, 416, 363, 341, 379, 376, 373, 376, 361, 354, 381)
  ),
  temperature = 0.001,
  rolloff = -8 + 4,
  formants = c(1200, 1800, 3200),
  mouthAnchors = rnorm(4, .5, .1),
  addSilence = 0,
  samplingRate = 22050, play = T, plot = T, osc = T
)

s2 = soundgen(
  repeatBout = 2, sylLen = 520, pauseLen = 20,
  pitchAnchors = data.frame(time = c(0, 50, 100, 200, 250, 300, 470, 520) / 520, 
                            value = c(380, 760, 180, 170, 500, 320, 250, 320)),
  amplAnchors = data.frame(time = c(0, 50, 100, 200, 250, 300, 470, 520) / 520, 
                           value = c(80, 80, 70, 70, 80, 70, 65, 65)),
  rolloff = -14 + 4,
  temperature = 0.001,
  formants = list(f1 = c(1200, 900, 1000),
                  f2 = 1800, f3 = 3200), 
  noiseAnchors = data.frame(time = c(0, 50, 170, 260, 360),
                            value = c(-30, -10, -20, -10, -40)),
  rolloffNoise = -6,
  addSilence = 0, attackLen = 10, 
  samplingRate = 22050, play = T, plot = T, osc = T
)

s2 = fade(s2, fadeIn = 0, fadeOut = length(s2))

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+4.wav'))

# no nonlin r-
s1 = soundgen(
  sylLen = 1600,
  pitchAnchors = data.frame(
    time = c(0, 107, 213, 320, 427, 533, 640, 747, 853, 960, 1067, 1173, 1280, 1387, 1493, 1600),
    value = c(417, 408, 434, 463, 479, 453, 416, 363, 341, 379, 376, 373, 376, 361, 354, 381)
  ),
  temperature = 0.001,
  rolloff = -8 - 4,
  formants = c(1200, 1800, 3200),
  mouthAnchors = rnorm(4, .5, .1),
  addSilence = 0,
  samplingRate = 22050, play = T, plot = T, osc = T
)

s2 = soundgen(
  repeatBout = 2, sylLen = 520, pauseLen = 20,
  pitchAnchors = data.frame(time = c(0, 50, 100, 200, 250, 300, 470, 520) / 520, 
                            value = c(380, 760, 180, 170, 500, 320, 250, 320)),
  amplAnchors = data.frame(time = c(0, 50, 100, 200, 250, 300, 470, 520) / 520, 
                           value = c(80, 80, 70, 70, 80, 70, 65, 65)),
  rolloff = -14 - 4,
  temperature = 0.001,
  formants = list(f1 = c(1200, 900, 1000),
                  f2 = 1800, f3 = 3200), 
  noiseAnchors = data.frame(time = c(0, 50, 170, 260, 360),
                            value = c(-30, -10, -20, -10, -40)),
  rolloffNoise = -6,
  addSilence = 0, attackLen = 10, 
  samplingRate = 22050, play = T, plot = T, osc = T
)

s2 = fade(s2, fadeIn = 0, fadeOut = length(s2))

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-4.wav'))


# pitch jump
s1 = soundgen(
  sylLen = 1600,
  pitchAnchors = data.frame(
    time = c(0, 153, 154, 320, 427, 533, 640, 747, 853, 960, 1067, 1173, 1280, 1387, 1493, 1600),
    value = c(300, 320, 434, 463, 479, 453, 416, 363, 341, 379, 376, 373, 376, 361, 354, 381)
  ),
  temperature = 0.001,
  rolloff = -8,
  formants = c(1200, 1800, 3200),
  mouthAnchors = rnorm(4, .5, .1),
  addSilence = 0,
  samplingRate = 22050, play = T, plot = T, osc = T
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subharm
s1 = soundgen(
  sylLen = 1600,
  pitchAnchors = data.frame(
    time = c(0, 107, 213, 320, 427, 533, 640, 747, 853, 960, 1067, 1173, 1280, 1387, 1493, 1600),
    value = c(417, 408, 434, 463, 479, 453, 416, 363, 341, 379, 376, 373, 376, 361, 354, 381)
  ),
  temperature = 0.001,
  nonlinBalance = 30, subFreq = 200, subDep = 80, jitterDep = 0, shortestEpoch = 100,
  rolloff = -8,
  formants = c(1200, 1800, 3200),
  mouthAnchors = rnorm(4, .5, .1),
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, play = T, plot = T, osc = T
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s1 = soundgen(
  sylLen = 1600,
  pitchAnchors = data.frame(
    time = c(0, 107, 213, 320, 427, 533, 640, 747, 853, 960, 1067, 1173, 1280, 1387, 1493, 1600),
    value = c(417, 408, 434, 463, 479, 453, 416, 363, 341, 379, 376, 373, 376, 361, 354, 381)
  ),
  temperature = 0.001,
  nonlinBalance = 50, subDep = 0, jitterDep = 2, shortestEpoch = 200,
  rolloff = -8,
  formants = c(1200, 1800, 3200),
  mouthAnchors = rnorm(4, .5, .1),
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, play = T, plot = T, osc = T
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s1 = soundgen(
  sylLen = 1600,
  pitchAnchors = data.frame(
    time = c(0, 153, 154, 320, 427, 533, 640, 747, 853, 960, 1067, 1173, 1280, 1387, 1493, 1600),
    value = c(300, 320, 434, 463, 479, 453, 416, 363, 341, 379, 376, 373, 376, 361, 354, 381)
  ),
  temperature = 0.001,
  nonlinBalance = 35, subFreq = 200, subDep = 80, jitterDep = 2, shortestEpoch = 100,
  rolloff = -8,
  formants = c(1200, 1800, 3200),
  mouthAnchors = rnorm(4, .5, .1),
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, play = T, plot = T, osc = T
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s1 = soundgen(
  sylLen = 1600,
  pitchAnchors = data.frame(
    time = c(0, 153, 154, 320, 427, 533, 640, 747, 853, 960, 1067, 1173, 1280, 1387, 1493, 1600),
    value = c(300, 320, 434, 463, 479, 453, 416, 363, 341, 379, 376, 373, 376, 361, 354, 381)
  ),
  temperature = 0.001,
  nonlinBalance = 55, subFreq = 200, subDep = 110, jitterDep = 3, shortestEpoch = 300,
  rolloff = -8,
  formants = c(1200, 1800, 3200),
  mouthAnchors = rnorm(4, .5, .1),
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, play = T, plot = T, osc = T
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
