setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'cry_498_ut_sad-cry_50-m'
fileIdx = '08'

# original (closest to 000)
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(250, 300, 270, 250),
              amplAnchors = c(80, 50),
              temperature = 0.001,
              nonlinBalance = 40, subFreq = 150, subDep = 60, jitterDep = 0, shortestEpoch = 50,
              rolloff = -30,
              formants = list(f1 = c(500, 250), f2 = 1500, f3 = 2500, f4 = 3500, f5 = 5500),
              mouthAnchors = c(.5, .6),
              noiseAnchors = data.frame(time = c(0, 215, 400), value = c(-20, -15, -40)),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 180,
              pitchAnchors = c(240, 260, 245, 240),
              rolloff = c(-12, -16, -16),
              temperature = 0.001,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-275, -175, 200),
                                        value = c(-60, -35, -50)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)


t = c(0, 60, 130, 190, 310) / 310
s3 = soundgen(repeatBout = 2, sylLen = 310, pauseLen = 0,
              pitchAnchors = data.frame(time = t,
                                        value = c(240, 260, 240, 260, 240)),
              rolloff = getSmoothContour(len = 30, method = 'approx',
                                         anchors = data.frame(time = t,
                                                              value = c(-16, -12, -26, -12, -14))),
              temperature = 0.001,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-10, 130, 320),
                                        value = c(-50, -20, -40)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)
s3 = fade(s3, fadeIn = 0, fadeOut = length(s3) / 2)

s = addVectors(s1, s2, insertionPoint = 22050 * .5)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .03)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

# no nonlin r00
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(250, 300, 270, 250),
              amplAnchors = c(80, 50),
              temperature = 0.001,
              # nonlinBalance = 40, subFreq = 150, subDep = 60, jitterDep = 0, shortestEpoch = 50,
              rolloff = -30,
              formants = list(f1 = c(500, 250), f2 = 1500, f3 = 2500, f4 = 3500, f5 = 5500),
              mouthAnchors = c(.5, .6),
              noiseAnchors = data.frame(time = c(0, 215, 400), value = c(-20, -15, -40)),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 180,
              pitchAnchors = c(240, 260, 245, 240),
              rolloff = c(-12, -16, -16),
              temperature = 0.001,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-275, -175, 200),
                                        value = c(-60, -35, -50)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

t = c(0, 60, 130, 190, 310) / 310
s3 = soundgen(repeatBout = 2, sylLen = 310, pauseLen = 0,
              pitchAnchors = data.frame(time = t,
                                        value = c(240, 260, 240, 260, 240)),
              rolloff = getSmoothContour(len = 30, method = 'approx',
                                         anchors = data.frame(time = t,
                                                              value = c(-16, -12, -26, -12, -14))),
              temperature = 0.001,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-10, 130, 320),
                                        value = c(-50, -20, -40)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)
s3 = fade(s3, fadeIn = 0, fadeOut = length(s3) / 2)

s = addVectors(s1, s2, insertionPoint = 22050 * .5)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .03)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))

# no nonlin r+4
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(250, 300, 270, 250),
              amplAnchors = c(80, 50),
              temperature = 0.001,
              # nonlinBalance = 40, subFreq = 150, subDep = 60, jitterDep = 0, shortestEpoch = 50,
              rolloff = -30 + 20,
              formants = list(f1 = c(500, 250), f2 = 1500, f3 = 2500, f4 = 3500, f5 = 5500),
              mouthAnchors = c(.5, .6),
              noiseAnchors = data.frame(time = c(0, 215, 400), value = c(-20, -15, -40)),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 180,
              pitchAnchors = c(240, 260, 245, 240),
              rolloff = c(-12, -16, -16) + 4,
              temperature = 0.001,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-275, -175, 200),
                                        value = c(-60, -35, -50)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

t = c(0, 60, 130, 190, 310) / 310
s3 = soundgen(repeatBout = 2, sylLen = 310, pauseLen = 0,
              pitchAnchors = data.frame(time = t,
                                        value = c(240, 260, 240, 260, 240)),
              rolloff = getSmoothContour(len = 30, method = 'approx',
                                         anchors = data.frame(time = t,
                                                              value = c(-16, -12, -26, -12, -14) + 4)),
              temperature = 0.001,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-10, 130, 320),
                                        value = c(-50, -20, -40)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)
s3 = fade(s3, fadeIn = 0, fadeOut = length(s3) / 2)

s = addVectors(s1, s2, insertionPoint = 22050 * .5)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .03)

playme(s, 22050)
seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+4.wav'))


# no nonlin r-4
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(250, 300, 270, 250),
              amplAnchors = c(80, 50),
              temperature = 0.001,
              # nonlinBalance = 40, subFreq = 150, subDep = 60, jitterDep = 0, shortestEpoch = 50,
              rolloff = -30 - 16, invalidArgAction = 'ignore',
              formants = list(f1 = c(500, 250), f2 = 1500, f3 = 2500, f4 = 3500, f5 = 5500),
              mouthAnchors = c(.5, .6),
              noiseAnchors = data.frame(time = c(0, 215, 400), value = c(-20, -15, -40)),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 180,
              pitchAnchors = c(240, 260, 245, 240),
              rolloff = c(-12, -16, -16) - 4,
              temperature = 0.001,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-275, -175, 200),
                                        value = c(-60, -35, -50)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

t = c(0, 60, 130, 190, 310) / 310
s3 = soundgen(repeatBout = 2, sylLen = 310, pauseLen = 0,
              pitchAnchors = data.frame(time = t,
                                        value = c(240, 260, 240, 260, 240)),
              rolloff = getSmoothContour(len = 30, method = 'approx',
                                         anchors = data.frame(time = t,
                                                              value = c(-16, -12, -26, -12, -14) - 4)),
              invalidArgAction = 'ignore',
              temperature = 0.001,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-10, 130, 320),
                                        value = c(-50, -20, -40)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)
s3 = fade(s3, fadeIn = 0, fadeOut = length(s3) / 2)

s = addVectors(s1, s2, insertionPoint = 22050 * .5)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .03)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-4.wav'))


# subharm
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(250, 300, 270, 250),
              amplAnchors = c(80, 50),
              temperature = 0.001,
              nonlinBalance = 40, subFreq = 150, subDep = 60, jitterDep = 0, shortestEpoch = 50,
              rolloff = -30,
              formants = list(f1 = c(500, 250), f2 = 1500, f3 = 2500, f4 = 3500, f5 = 5500),
              mouthAnchors = c(.5, .6),
              noiseAnchors = data.frame(time = c(0, 215, 400), value = c(-20, -15, -40)),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 180,
              pitchAnchors = c(240, 260, 245, 240),
              rolloff = c(-12, -16, -16),
              temperature = 0.001,
              nonlinBalance = 40, subFreq = 90, subDep = 40, jitterDep = 0, shortestEpoch = 50,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-275, -175, 200),
                                        value = c(-60, -35, -50)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

t = c(0, 60, 130, 190, 310) / 310
s3 = soundgen(repeatBout = 2, sylLen = 310, pauseLen = 0,
              pitchAnchors = data.frame(time = t,
                                        value = c(240, 260, 240, 260, 240)),
              rolloff = getSmoothContour(len = 30, method = 'approx',
                                         anchors = data.frame(time = t,
                                                              value = c(-16, -12, -26, -12, -14))),
              temperature = 0.001,
              nonlinBalance = 40, subFreq = 90, subDep = 40, jitterDep = 0, shortestEpoch = 50,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-10, 130, 320),
                                        value = c(-50, -20, -40)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)
s3 = fade(s3, fadeIn = 0, fadeOut = length(s3) / 2)

s = addVectors(s1, s2, insertionPoint = 22050 * .5)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .03)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(250, 300, 270, 250),
              amplAnchors = c(80, 50),
              temperature = 0.001,
              nonlinBalance = 70, subFreq = 150, subDep = 0, jitterDep = 1, shortestEpoch = 50,
              rolloff = -30,
              formants = list(f1 = c(500, 250), f2 = 1500, f3 = 2500, f4 = 3500, f5 = 5500),
              mouthAnchors = c(.5, .6),
              noiseAnchors = data.frame(time = c(0, 215, 400), value = c(-20, -15, -40)),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 180,
              pitchAnchors = c(240, 260, 245, 240),
              rolloff = c(-12, -16, -16),
              temperature = 0.001,
              nonlinBalance = 70, subFreq = 150, subDep = 0, jitterDep = 1, shortestEpoch = 50,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-275, -175, 200),
                                        value = c(-60, -35, -50)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

t = c(0, 60, 130, 190, 310) / 310
s3 = soundgen(repeatBout = 2, sylLen = 310, pauseLen = 0,
              pitchAnchors = data.frame(time = t,
                                        value = c(240, 260, 240, 260, 240)),
              rolloff = getSmoothContour(len = 30, method = 'approx',
                                         anchors = data.frame(time = t,
                                                              value = c(-16, -12, -26, -12, -14))),
              temperature = 0.001,
              nonlinBalance = 70, subFreq = 150, subDep = 0, jitterDep = 1, shortestEpoch = 50,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-10, 130, 320),
                                        value = c(-50, -20, -40)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)
s3 = fade(s3, fadeIn = 0, fadeOut = length(s3) / 2)

s = addVectors(s1, s2, insertionPoint = 22050 * .5)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .03)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(250, 300, 270, 250),
              amplAnchors = c(80, 50),
              temperature = 0.001,
              nonlinBalance = 70, subFreq = 150, subDep = 40, jitterDep = 1, shortestEpoch = 50,
              rolloff = -30,
              formants = list(f1 = c(500, 250), f2 = 1500, f3 = 2500, f4 = 3500, f5 = 5500),
              mouthAnchors = c(.5, .6),
              noiseAnchors = data.frame(time = c(0, 215, 400), value = c(-20, -15, -40)),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 180,
              pitchAnchors = c(240, 260, 245, 240),
              rolloff = c(-12, -16, -16),
              temperature = 0.001,
              nonlinBalance = 50, subFreq = 150, subDep = 40, jitterDep = 1, shortestEpoch = 50,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-275, -175, 200),
                                        value = c(-60, -35, -50)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

t = c(0, 60, 130, 190, 310) / 310
s3 = soundgen(repeatBout = 2, sylLen = 310, pauseLen = 0,
              pitchAnchors = data.frame(time = t,
                                        value = c(240, 260, 240, 260, 240)),
              rolloff = getSmoothContour(len = 30, method = 'approx',
                                         anchors = data.frame(time = t,
                                                              value = c(-16, -12, -26, -12, -14))),
              temperature = 0.001,
              nonlinBalance = 50, subFreq = 150, subDep = 40, jitterDep = 1, shortestEpoch = 50,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-10, 130, 320),
                                        value = c(-50, -20, -40)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)
s3 = fade(s3, fadeIn = 0, fadeOut = length(s3) / 2)

s = addVectors(s1, s2, insertionPoint = 22050 * .5)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .03)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# psc level 2
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(250, 300, 270, 250),
              amplAnchors = c(80, 50),
              temperature = 0.001,
              nonlinBalance = 100, subFreq = 150, subDep = 50, jitterDep = 2, shortestEpoch = 50,
              rolloff = -30,
              formants = list(f1 = c(500, 250), f2 = 1500, f3 = 2500, f4 = 3500, f5 = 5500),
              mouthAnchors = c(.5, .6),
              noiseAnchors = data.frame(time = c(0, 215, 400), value = c(-20, -15, -40)),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 180,
              pitchAnchors = c(240, 260, 245, 240),
              rolloff = c(-12, -16, -16),
              temperature = 0.001,
              nonlinBalance = 60, subFreq = 150, subDep = 50, jitterDep = 2, shortestEpoch = 100,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-275, -175, 200),
                                        value = c(-60, -35, -50)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

t = c(0, 60, 130, 190, 310) / 310
s3 = soundgen(repeatBout = 2, sylLen = 310, pauseLen = 0,
              pitchAnchors = data.frame(time = t,
                                        value = c(240, 260, 240, 260, 240)),
              rolloff = getSmoothContour(len = 30, method = 'approx',
                                         anchors = data.frame(time = t,
                                                              value = c(-16, -12, -26, -12, -14))),
              temperature = 0.001,
              nonlinBalance = 80, subFreq = 150, subDep = 50, jitterDep = 2, shortestEpoch = 200,
              formants = c(490, 1500, 2500),
              noiseAnchors = data.frame(time = c(-10, 130, 320),
                                        value = c(-50, -20, -40)),
              rolloffNoise = -8,
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)
s3 = fade(s3, fadeIn = 0, fadeOut = length(s3) / 2)

s = addVectors(s1, s2, insertionPoint = 22050 * .5)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .03)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
