setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'gasp_192_ut_exams_20-f-happy-sigh'
fileIdx = '12'

# original (closest to 000)
s = soundgen(sylLen = 990,
             pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
             amplAnchors = c(80, 80, 75),
             rolloff = -15,
             temperature = 0.001,
             formants = c(1000, 1400, 3100, 4200),
             mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
             noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
             rolloffNoise = -2,
             samplingRate = 22050, play = T, plot = T, osc = T)

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))

# no nonlin rolloff +8
s = soundgen(sylLen = 990,
             pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
             amplAnchors = c(80, 80, 75),
             rolloff = -15 + 8,
             temperature = 0.001,
             formants = c(1000, 1400, 3100, 4200),
             mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
             noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
             rolloffNoise = -2,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+8.wav'))


# no nonlin rolloff -8
s = soundgen(sylLen = 990,
             pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
             amplAnchors = c(80, 80, 75),
             rolloff = -15 - 8,
             temperature = 0.001,
             formants = c(1000, 1400, 3100, 4200),
             mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
             noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
             rolloffNoise = -2,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-8.wav'))


# sc level 1
s = soundgen(sylLen = 990,
             pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
             amplAnchors = c(80, 80, 75),
             rolloff = -15 - 8,
             temperature = 0.001,
             nonlinBalance = 50, subFreq = 140, subDep = 80, jitterDep = 1, shortestEpoch = 200,
             formants = c(1000, 1400, 3100, 4200),
             mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
             noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
             rolloffNoise = -2,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s = soundgen(sylLen = 990,
             pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
             amplAnchors = c(80, 80, 75),
             rolloff = -15 - 8,
             temperature = 0.001,
             nonlinBalance = 60, subFreq = 140, subDep = 100, jitterDep = 2, shortestEpoch = 200,
             formants = c(1000, 1400, 3100, 4200),
             mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
             noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
             rolloffNoise = -2,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
