setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'gasp_426_ut_pregn_33-f-surprise-intake-of-breath'
fileIdx = '13'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original (closest to 000)
s = soundgen(sylLen = 650,
             pitchAnchors = data.frame(time = c(0, .4, 1), value = c(520, 510, 350)),
             nonlinBalance = 100, subDep = 0, jitterDep = 0.1, shimmerDep = 15,
             rolloff = -15,
             temperature = 0.001,
             formants = c(800, 1500, 2900),
             noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), value = c(-30, -10, -10, -50)),
             rolloffNoise = 0,
             mouthAnchors = c(0, .5, .5, .5, .4),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))

# no nonlin effects rolloff +8
s = soundgen(sylLen = 650,
             pitchAnchors = data.frame(time = c(0, .4, 1), value = c(520, 510, 350)),
             nonlinBalance = 100, subDep = 0, jitterDep = 0.1, shimmerDep = 15,
             rolloff = -15 + 8,
             temperature = 0.001,
             formants = c(800, 1500, 2900),
             noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), value = c(-30, -10, -10, -50)),
             rolloffNoise = 0,
             mouthAnchors = c(0, .5, .5, .5, .4),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+8.wav'))


# no nonlin effects rolloff -8
s = soundgen(sylLen = 650,
             pitchAnchors = data.frame(time = c(0, .4, 1), value = c(520, 510, 350)),
             nonlinBalance = 100, subDep = 0, jitterDep = 0.1, shimmerDep = 15,
             rolloff = -15 - 8,
             temperature = 0.001,
             formants = c(800, 1500, 2900),
             noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), value = c(-30, -10, -10, -50)),
             rolloffNoise = 0,
             mouthAnchors = c(0, .5, .5, .5, .4),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-8.wav'))


# psc level 1
nonlin = '011'

s = soundgen(sylLen = 650,
             pitchAnchors = data.frame(time = c(0, .4, 1), value = c(520, 510, 350)),
             nonlinBalance = 50, subFreq = 150, subDep = 80, shortestEpoch = 100,
             jitterDep = 1, shimmerDep = 15,
             rolloff = -15,
             temperature = 0.001,
             formants = c(800, 1500, 2900),
             noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), value = c(-30, -10, -10, -50)),
             rolloffNoise = 0,
             mouthAnchors = c(0, .5, .5, .5, .4),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_', nonlin, '.wav'))

# psc level 2
nonlin = '022'

s = soundgen(sylLen = 650,
             pitchAnchors = data.frame(time = c(0, .4, 1), value = c(520, 510, 350)),
             nonlinBalance = 70, subFreq = 150, subDep = 100, shortestEpoch = 100,
             jitterDep = 1.5, shimmerDep = 15,
             rolloff = -15,
             temperature = 0.001,
             formants = c(800, 1500, 2900),
             noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), value = c(-30, -10, -10, -50)),
             rolloffNoise = 0,
             mouthAnchors = c(0, .5, .5, .5, .4),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_', nonlin, '.wav'))
