setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'gasp_443_ut_pregn_50-1-m-surprise-delight'
fileIdx = '14'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original with temp = 0.001
s = soundgen(sylLen = 1040,
             pitchAnchors = c(230, 315, 295),
             rolloff = c(-17, -13, -13, -13, -17), rolloffOct = 0, 
             temperature = 0.001,
             formants = c(850, 1500, 2800, 3800, 4700, 6400),
             noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                                       value = c(0, -5, -20, -20)),
             rolloffNoise = -1, 
             mouthAnchors = c(.4, .5, .5, .45),
             attackLen = 200, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))

# no nonlin effects rolloff +6
s = soundgen(sylLen = 1040,
             pitchAnchors = c(230, 315, 295),
             rolloff = c(-17, -13, -13, -13, -17) + 6, rolloffOct = 0, 
             temperature = 0.001,
             formants = c(850, 1500, 2800, 3800, 4700, 6400),
             noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                                       value = c(0, -5, -20, -20)),
             rolloffNoise = -1, 
             mouthAnchors = c(.4, .5, .5, .45),
             attackLen = 200, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+6.wav'))


# no nonlin effects rolloff -6
s = soundgen(sylLen = 1040,
             pitchAnchors = c(230, 315, 295),
             rolloff = c(-17, -13, -13, -13, -17) - 6, rolloffOct = 0, 
             temperature = 0.001,
             formants = c(850, 1500, 2800, 3800, 4700, 6400),
             noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                                       value = c(0, -5, -20, -20)),
             rolloffNoise = -1, 
             mouthAnchors = c(.4, .5, .5, .45),
             attackLen = 200, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-6.wav'))


# psc level 1
nonlin = '011'

s = soundgen(sylLen = 1040,
             pitchAnchors = c(230, 315, 295),
             rolloff = c(-14, -10, -10, -10, -14) -3, rolloffOct = 0, 
             temperature = 0.001,
             nonlinBalance = 50, subFreq = 140, subDep = 80, jitterDep = 1, shortestEpoch = 100,
             formants = c(850, 1500, 2800, 3800, 4700, 6400),
             noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                                       value = c(0, -5, -20, -20)),
             rolloffNoise = -1, 
             mouthAnchors = c(.4, .5, .5, .45),
             attackLen = 200, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_', nonlin, '.wav'))

# psc level 2
nonlin = '022'

s = soundgen(sylLen = 1040,
             pitchAnchors = c(230, 315, 295),
             rolloff = c(-14, -10, -10, -10, -14) -3, rolloffOct = 0, 
             temperature = 0.001,
             nonlinBalance = 70, subFreq = 140, subDep = 100, jitterDep = 1.5, shortestEpoch = 100,
             formants = c(850, 1500, 2800, 3800, 4700, 6400),
             noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                                       value = c(0, -5, -20, -20)),
             rolloffNoise = -1, 
             mouthAnchors = c(.4, .5, .5, .45),
             attackLen = 200, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_', nonlin, '.wav'))
