setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'gasp_449_ut_pregn_54-1-f-surprise'
fileIdx = '15'

# rolloff original (closest to 000)
s = soundgen(sylLen = 1200,
             pitchAnchors = data.frame(time = c(0, 200, 1200), value = c(260, 285, 200)),
             amplAnchors = data.frame(time = c(0, 200, 800, 1200), value = c(70, 80, 70, 60)),
             rolloff = -20,
             temperature = 0.001,
             formants = c(750, 1400, 2800),
             noiseAnchors = data.frame(time = c(-50, 0, 1400), value = c(-50, -30, -60)),
             rolloffNoise = -4,
             mouthAnchors = data.frame(time = c(0, 200, 1200), value = c(.4, .6, .5)),
             samplingRate = 22050, play = T, plot = T, osc = T)

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))


# no nonlin rolloff +8
s = soundgen(sylLen = 1200,
             pitchAnchors = data.frame(time = c(0, 200, 1200), value = c(260, 285, 200)),
             amplAnchors = data.frame(time = c(0, 200, 800, 1200), value = c(70, 80, 70, 60)),
             rolloff = -20 + 8,
             temperature = 0.001,
             formants = c(750, 1400, 2800),
             noiseAnchors = data.frame(time = c(-50, 0, 1400), value = c(-50, -30, -60)),
             rolloffNoise = -4,
             mouthAnchors = data.frame(time = c(0, 200, 1200), value = c(.4, .6, .5)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+8.wav'))


# no nonlin rolloff -8
s = soundgen(sylLen = 1200,
             pitchAnchors = data.frame(time = c(0, 200, 1200), value = c(260, 285, 200)),
             amplAnchors = data.frame(time = c(0, 200, 800, 1200), value = c(70, 80, 70, 60)),
             rolloff = -20 - 8,
             temperature = 0.001,
             formants = c(750, 1400, 2800),
             noiseAnchors = data.frame(time = c(-50, 0, 1400), value = c(-50, -30, -60)),
             rolloffNoise = -4,
             mouthAnchors = data.frame(time = c(0, 200, 1200), value = c(.4, .6, .5)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-8.wav'))


# sc level 1
s = soundgen(sylLen = 1200,
             pitchAnchors = data.frame(time = c(0, 200, 1200), value = c(260, 285, 200)),
             amplAnchors = data.frame(time = c(0, 200, 800, 1200), value = c(70, 80, 70, 60)),
             rolloff = -20 - 8,
             temperature = 0.001,
             nonlinBalance = 40, subFreq = 90, subDep = 40, jitterDep = 1, shortestEpoch = 300,
             formants = c(750, 1400, 2800),
             noiseAnchors = data.frame(time = c(-50, 0, 1400), value = c(-50, -30, -60)),
             rolloffNoise = -4,
             mouthAnchors = data.frame(time = c(0, 200, 1200), value = c(.4, .6, .5)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s = soundgen(sylLen = 1200,
             pitchAnchors = data.frame(time = c(0, 200, 1200), value = c(260, 285, 200)),
             amplAnchors = data.frame(time = c(0, 200, 800, 1200), value = c(70, 80, 70, 60)),
             rolloff = -20 - 8,
             temperature = 0.001,
             nonlinBalance = 60, subFreq = 90, subDep = 50, jitterDep = 1.5, shortestEpoch = 300,
             formants = c(750, 1400, 2800),
             noiseAnchors = data.frame(time = c(-50, 0, 1400), value = c(-50, -30, -60)),
             rolloffNoise = -4,
             mouthAnchors = data.frame(time = c(0, 200, 1200), value = c(.4, .6, .5)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
