setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'grunt_135_ut_effort-m-22-sports'
fileIdx = '17'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original (closest to 001)
s = soundgen(sylLen = 450,
             pitchAnchors = data.frame(time = c(0, 120, 230, 450),
                                       value = c(185, 400, 420, 280)),
             amplAnchors = data.frame(time = c(0, 120, 230, 420),
                                      value = c(60, 75, 80, 70)),
             rolloff = -8, rolloffOct = -3, 
             temperature = 0.001,
             nonlinBalance = 100, subDep = 0, 
             jitterDep = .5, shimmerDep = 20, shortestEpoch = 100,
             formants = c(500, 1200, 1700, 3500, 4200, 5100, 5500), 
             mouthAnchors = c(.5, .5, .4),
             noiseAnchors = data.frame(time = c(0, 100, 160, 450, 470),
                                       value = c(-40, -30, -10, -20, -35)),
             formantsNoise = 550,
             rolloffNoise = c(-2, -2, -2, -12),
             attackLen = 50, throwaway = -120, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

# no nonlin effects
s = soundgen(sylLen = 450,
             pitchAnchors = data.frame(time = c(0, 120, 230, 450),
                                       value = c(185, 400, 420, 280)),
             amplAnchors = data.frame(time = c(0, 120, 230, 420),
                                      value = c(60, 75, 80, 70)),
             rolloff = -8, rolloffOct = -3, 
             temperature = 0.001,
             # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 20, shortestEpoch = 100,
             formants = c(500, 1200, 1700, 3500, 4200, 5100, 5500), 
             mouthAnchors = c(.5, .5, .4),
             noiseAnchors = data.frame(time = c(0, 100, 160, 450, 470),
                                       value = c(-40, -30, -10, -20, -35)),
             formantsNoise = 550,
             rolloffNoise = c(-2, -2, -2, -12),
             attackLen = 50, throwaway = -120, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# subh
s = soundgen(sylLen = 450,
             pitchAnchors = data.frame(time = c(0, 120, 230, 450),
                                       value = c(185, 400, 420, 280)),
             amplAnchors = data.frame(time = c(0, 120, 230, 420),
                                      value = c(60, 75, 80, 70)),
             rolloff = -8, rolloffOct = -3, 
             temperature = 0.001,
             nonlinBalance = 60, subFreq = 90, subDep = 50, jitterDep = 0, shimmerDep = 0, shortestEpoch = 100,
             formants = c(500, 1200, 1700, 3500, 4200, 5100, 5500), 
             mouthAnchors = c(.5, .5, .4),
             noiseAnchors = data.frame(time = c(0, 100, 160, 450, 470),
                                       value = c(-40, -30, -10, -20, -35)),
             formantsNoise = 550,
             rolloffNoise = c(-2, -2, -2, -12),
             attackLen = 50, throwaway = -120, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 450,
             pitchAnchors = data.frame(time = c(0, 120, 230, 450),
                                       value = c(185, 400, 420, 280)),
             amplAnchors = data.frame(time = c(0, 120, 230, 420),
                                      value = c(60, 75, 80, 70)),
             rolloff = -8, rolloffOct = -3, 
             temperature = 0.001,
             nonlinBalance = 100, subFreq = 90, subDep = 0, jitterDep = 1.5, shimmerDep = 20, shortestEpoch = 100,
             formants = c(500, 1200, 1700, 3500, 4200, 5100, 5500), 
             mouthAnchors = c(.5, .5, .4),
             noiseAnchors = data.frame(time = c(0, 100, 160, 450, 470),
                                       value = c(-40, -30, -10, -20, -35)),
             formantsNoise = 550,
             rolloffNoise = c(-2, -2, -2, -12),
             attackLen = 50, throwaway = -120, addSilence = 0,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))



# psc level 1
s = soundgen(sylLen = 450,
             pitchAnchors = data.frame(time = c(0, 120, 230, 450),
                                       value = c(185, 400, 420, 280)),
             amplAnchors = data.frame(time = c(0, 120, 230, 420),
                                      value = c(60, 75, 80, 70)),
             rolloff = -8, rolloffOct = -3, 
             temperature = 0.001,
             nonlinBalance = 70, subFreq = 90, subDep = 50, 
             jitterDep = 1.5, shimmerDep = 20, shortestEpoch = 100,
             formants = c(500, 1200, 1700, 3500, 4200, 5100, 5500), 
             mouthAnchors = c(.5, .5, .4),
             noiseAnchors = data.frame(time = c(0, 100, 160, 450, 470),
                                       value = c(-40, -30, -10, -20, -35)),
             formantsNoise = 550,
             rolloffNoise = c(-2, -2, -2, -12),
             attackLen = 50, throwaway = -120, addSilence = 0,
             samplingRate = 22000, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011_r00.wav'))


# psc level 1 rolloff +4
s = soundgen(sylLen = 450,
             pitchAnchors = data.frame(time = c(0, 120, 230, 450),
                                       value = c(185, 400, 420, 280)),
             amplAnchors = data.frame(time = c(0, 120, 230, 420),
                                      value = c(60, 75, 80, 70)),
             rolloff = -8 + 4, rolloffOct = -3, 
             temperature = 0.001,
             nonlinBalance = 70, subFreq = 90, subDep = 50, 
             jitterDep = 1.5, shimmerDep = 20, shortestEpoch = 100,
             formants = c(500, 1200, 1700, 3500, 4200, 5100, 5500), 
             mouthAnchors = c(.5, .5, .4),
             noiseAnchors = data.frame(time = c(0, 100, 160, 450, 470),
                                       value = c(-40, -30, -10, -20, -35)),
             formantsNoise = 550,
             rolloffNoise = c(-2, -2, -2, -12),
             attackLen = 50, throwaway = -120, addSilence = 0,
             samplingRate = 22000, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011_r+4.wav'))


# psc level 1 rolloff -4
s = soundgen(sylLen = 450,
             pitchAnchors = data.frame(time = c(0, 120, 230, 450),
                                       value = c(185, 400, 420, 280)),
             amplAnchors = data.frame(time = c(0, 120, 230, 420),
                                      value = c(60, 75, 80, 70)),
             rolloff = -8 - 4, rolloffOct = -3, 
             temperature = 0.001,
             nonlinBalance = 70, subFreq = 90, subDep = 50, 
             jitterDep = 1.5, shimmerDep = 20, shortestEpoch = 100,
             formants = c(500, 1200, 1700, 3500, 4200, 5100, 5500), 
             mouthAnchors = c(.5, .5, .4),
             noiseAnchors = data.frame(time = c(0, 100, 160, 450, 470),
                                       value = c(-40, -30, -10, -20, -35)),
             formantsNoise = 550,
             rolloffNoise = c(-2, -2, -2, -12),
             attackLen = 50, throwaway = -120, addSilence = 0,
             samplingRate = 22000, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011_r-4.wav'))


# psc level 2
s = soundgen(sylLen = 450,
             pitchAnchors = data.frame(time = c(0, 120, 230, 450),
                                       value = c(185, 400, 420, 280)),
             amplAnchors = data.frame(time = c(0, 120, 230, 420),
                                      value = c(60, 75, 80, 70)),
             rolloff = -8, rolloffOct = -3, 
             temperature = 0.001,
             nonlinBalance = 100, subFreq = 90, subDep = 50, 
             jitterDep = 2.5, shimmerDep = 30, shortestEpoch = 100,
             formants = c(500, 1200, 1700, 3500, 4200, 5100, 5500), 
             mouthAnchors = c(.5, .5, .4),
             noiseAnchors = data.frame(time = c(0, 100, 160, 450, 470),
                                       value = c(-40, -30, -10, -20, -35)),
             formantsNoise = 550,
             rolloffNoise = c(-2, -2, -2, -12),
             attackLen = 50, throwaway = -120, addSilence = 0,
             samplingRate = 22000, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
