setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'grunt_155_ut_effort_f_08-mild'
fileIdx = '18'

# rolloff original (closest to 000)
s = soundgen(sylLen = 140,
             pitchAnchors = c(300, 250),
             amplAnchors = c(80, 50),
             rolloff = c(-15, -20, -20),
             temperature = 0.001,
             formants = NULL, vocalTract = 11,
             mouthAnchors = 0,
             noiseAnchors = data.frame(time = c(0, 140, 220), value = c(-10, -20, -40)),
             rolloffNoise = c(0, -15),
             attackLen = 20, windowLength = 20,
             samplingRate = 22050, play = T, plot = T, osc = T)

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))


# no nonlin rolloff +10
s = soundgen(sylLen = 140,
             pitchAnchors = c(300, 250),
             amplAnchors = c(80, 50),
             rolloff = c(-15, -20, -20) + 10,
             temperature = 0.001,
             formants = NULL, vocalTract = 11,
             mouthAnchors = 0,
             noiseAnchors = data.frame(time = c(0, 140, 220), value = c(-10, -20, -40)),
             rolloffNoise = c(0, -15),
             attackLen = 20, windowLength = 20,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+10.wav'))


# no nonlin rolloff -10
s = soundgen(sylLen = 140,
             pitchAnchors = c(300, 250),
             amplAnchors = c(80, 50),
             rolloff = c(-15, -20, -20) - 10,
             temperature = 0.001,
             formants = NULL, vocalTract = 11,
             mouthAnchors = 0,
             noiseAnchors = data.frame(time = c(0, 140, 220), value = c(-10, -20, -40)),
             rolloffNoise = c(0, -15),
             attackLen = 20, windowLength = 20,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-10.wav'))


# subh
s = soundgen(sylLen = 140,
             pitchAnchors = c(300, 250),
             amplAnchors = c(80, 50),
             rolloff = c(-15, -20, -20),
             nonlinBalance = 100, subFreq = 120, subDep = 90, jitterDep = 0,
             temperature = 0.001,
             formants = NULL, vocalTract = 11,
             mouthAnchors = 0,
             noiseAnchors = data.frame(time = c(0, 140, 220), value = c(-10, -20, -40)),
             rolloffNoise = c(0, -15),
             attackLen = 20, windowLength = 20,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 140,
             pitchAnchors = c(300, 250),
             amplAnchors = c(80, 50),
             rolloff = c(-15, -20, -20),
             nonlinBalance = 100, subFreq = 120, subDep = 0, jitterDep = 2,
             temperature = 0.001,
             formants = NULL, vocalTract = 11,
             mouthAnchors = 0,
             noiseAnchors = data.frame(time = c(0, 140, 220), value = c(-10, -20, -40)),
             rolloffNoise = c(0, -15),
             attackLen = 20, windowLength = 20,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# sc level 1
s = soundgen(sylLen = 140,
             pitchAnchors = c(300, 250),
             amplAnchors = c(80, 50),
             rolloff = c(-15, -20, -20),
             nonlinBalance = 100, subFreq = 120, subDep = 80, jitterDep = 2,
             temperature = 0.001,
             formants = NULL, vocalTract = 11,
             mouthAnchors = 0,
             noiseAnchors = data.frame(time = c(0, 140, 220), value = c(-10, -20, -40)),
             rolloffNoise = c(0, -15),
             attackLen = 20, windowLength = 20,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s = soundgen(sylLen = 140,
             pitchAnchors = c(300, 250),
             amplAnchors = c(80, 50),
             rolloff = c(-15, -20, -20),
             nonlinBalance = 100, subFreq = 120, subDep = 100, jitterDep = 3,
             temperature = 0.001,
             formants = NULL, vocalTract = 11,
             mouthAnchors = 0,
             noiseAnchors = data.frame(time = c(0, 140, 220), value = c(-10, -20, -40)),
             rolloffNoise = c(0, -15),
             attackLen = 20, windowLength = 20,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
