setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'grunt_183_ut_exams_11-f-grunt-achievement'
fileIdx = '19'

# original (closest to 001, chaos)
s = soundgen(sylLen = 200,
             pitchAnchors = data.frame(time = c(0, 90, 140, 200),
                                       value = c(315, 300, 400, 300)),
             amplAnchors = data.frame(time = c(0, 90, 140, 200),
                                      value = c(70, 60, 80, 75)),
             nonlinBalance = 70, subFreq = 150, subDep = 0, 
             jitterDep = 3, shortestEpoch = 50,
             temperature = 0.001,
             rolloff = c(-3, -6),
             formants = c(500, 2000, 2400, 4000), 
             lipRad = 0,
             noiseAnchors = data.frame(time = c(0, 200, 300),
                                       value = c(-20, -10, -20)),
             rolloffNoise = c(0, -10),
             samplingRate = 22050, play = T, plot = T, osc = T)


# no nonlin
s = soundgen(sylLen = 200,
             pitchAnchors = data.frame(time = c(0, 90, 140, 200),
                                       value = c(315, 300, 400, 300)),
             amplAnchors = data.frame(time = c(0, 90, 140, 200),
                                      value = c(70, 60, 80, 75)),
             # nonlinBalance = 70, subFreq = 150, subDep = 0, jitterDep = 3, shortestEpoch = 50,
             temperature = 0.001,
             rolloff = c(-3, -6),
             formants = c(500, 2000, 2400, 4000), 
             lipRad = 0,
             noiseAnchors = data.frame(time = c(0, 200, 300),
                                       value = c(-20, -10, -20)),
             rolloffNoise = c(0, -10),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# subh
s = soundgen(sylLen = 200,
             pitchAnchors = data.frame(time = c(0, 90, 140, 200),
                                       value = c(315, 300, 400, 300)),
             amplAnchors = data.frame(time = c(0, 90, 140, 200),
                                      value = c(70, 60, 80, 75)),
             nonlinBalance = 100, subFreq = 110, subDep = 70, jitterDep = 0,
             temperature = 0.001,
             rolloff = c(-3, -6),
             formants = c(500, 2000, 2400, 4000), 
             lipRad = 0,
             noiseAnchors = data.frame(time = c(0, 200, 300),
                                       value = c(-20, -10, -20)),
             rolloffNoise = c(0, -10),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 200,
             pitchAnchors = data.frame(time = c(0, 90, 140, 200),
                                       value = c(315, 300, 400, 300)),
             amplAnchors = data.frame(time = c(0, 90, 140, 200),
                                      value = c(70, 60, 80, 75)),
             nonlinBalance = 100, subFreq = 110, subDep = 0, jitterDep = 2,
             temperature = 0.001,
             rolloff = c(-3, -6),
             formants = c(500, 2000, 2400, 4000), 
             lipRad = 0,
             noiseAnchors = data.frame(time = c(0, 200, 300),
                                       value = c(-20, -10, -20)),
             rolloffNoise = c(0, -10),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r00.wav'))


# chaos rolloff +4
s = soundgen(sylLen = 200,
             pitchAnchors = data.frame(time = c(0, 90, 140, 200),
                                       value = c(315, 300, 400, 300)),
             amplAnchors = data.frame(time = c(0, 90, 140, 200),
                                      value = c(70, 60, 80, 75)),
             nonlinBalance = 100, subFreq = 110, subDep = 0, jitterDep = 2,
             temperature = 0.001,
             rolloff = c(-3, -6) + 4, invalidArgAction = 'ignore',
             formants = c(500, 2000, 2400, 4000), 
             lipRad = 0,
             noiseAnchors = data.frame(time = c(0, 200, 300),
                                       value = c(-20, -10, -20)),
             rolloffNoise = c(0, -10),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r+4.wav'))


# chaos rolloff -4
s = soundgen(sylLen = 200,
             pitchAnchors = data.frame(time = c(0, 90, 140, 200),
                                       value = c(315, 300, 400, 300)),
             amplAnchors = data.frame(time = c(0, 90, 140, 200),
                                      value = c(70, 60, 80, 75)),
             nonlinBalance = 100, subFreq = 110, subDep = 0, jitterDep = 2,
             temperature = 0.001,
             rolloff = c(-3, -6) - 4, invalidArgAction = 'ignore',
             formants = c(500, 2000, 2400, 4000), 
             lipRad = 0,
             noiseAnchors = data.frame(time = c(0, 200, 300),
                                       value = c(-20, -10, -20)),
             rolloffNoise = c(0, -10),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r-4.wav'))


# sc level 1
s = soundgen(sylLen = 200,
             pitchAnchors = data.frame(time = c(0, 90, 140, 200),
                                       value = c(315, 300, 400, 300)),
             amplAnchors = data.frame(time = c(0, 90, 140, 200),
                                      value = c(70, 60, 80, 75)),
             nonlinBalance = 100, subFreq = 110, subDep = 70, jitterDep = 2,
             temperature = 0.001,
             rolloff = c(-3, -6),
             formants = c(500, 2000, 2400, 4000), 
             lipRad = 0,
             noiseAnchors = data.frame(time = c(0, 200, 300),
                                       value = c(-20, -10, -20)),
             rolloffNoise = c(0, -10),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s = soundgen(sylLen = 200,
             pitchAnchors = data.frame(time = c(0, 90, 140, 200),
                                       value = c(315, 300, 400, 300)),
             amplAnchors = data.frame(time = c(0, 90, 140, 200),
                                      value = c(70, 60, 80, 75)),
             nonlinBalance = 100, subFreq = 110, subDep = 90, jitterDep = 3,
             temperature = 0.001,
             rolloff = c(-3, -6),
             formants = c(500, 2000, 2400, 4000), 
             lipRad = 0,
             noiseAnchors = data.frame(time = c(0, 200, 300),
                                       value = c(-20, -10, -20)),
             rolloffNoise = c(0, -10),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
