setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'grunt_540_ut_sex_59-m-grunt'
fileIdx = '20'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original (closest to sc level 1)
s = soundgen(sylLen = 250,
             pitchAnchors = c(220, 160),
             amplAnchors = data.frame(time = c(0, 100, 160, 250), value = c(70, 70, 80, 50)),
             nonlinBalance = 70, subFreq = 75, subDep = 50, jitterDep = 1, shortestEpoch = 50,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001,
             formants = c(500, 1500, 2500, 3400),
             noiseAnchors = data.frame(time = c(0, 400, 550), 
                                       value = c(-25, -20, -40) + 10),
             formantsNoise = c(600, 1300, 1600, 2400, 3500, 4500, 5500, 6800),
             rolloffNoise = c(0, 5, 7),
             attackLen = 20, throwaway = -120,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s = soundgen(sylLen = 250,
             pitchAnchors = c(220, 160),
             amplAnchors = data.frame(time = c(0, 100, 160, 250), value = c(70, 70, 80, 50)),
             nonlinBalance = 0, subFreq = 75, subDep = 50, jitterDep = 1, shortestEpoch = 50,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001,
             formants = c(500, 1500, 2500, 3400),
             noiseAnchors = data.frame(time = c(0, 400, 550), 
                                       value = c(-25, -20, -40) + 10),
             formantsNoise = c(600, 1300, 1600, 2400, 3500, 4500, 5500, 6800),
             rolloffNoise = c(0, 5, 7),
             attackLen = 20, throwaway = -120,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# subh
s = soundgen(sylLen = 250,
             pitchAnchors = c(220, 160),
             amplAnchors = data.frame(time = c(0, 100, 160, 250), value = c(70, 70, 80, 50)),
             nonlinBalance = 50, subFreq = 75, subDep = 50, jitterDep = 0, shortestEpoch = 50,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001,
             formants = c(500, 1500, 2500, 3400),
             noiseAnchors = data.frame(time = c(0, 400, 550), 
                                       value = c(-25, -20, -40) + 10),
             formantsNoise = c(600, 1300, 1600, 2400, 3500, 4500, 5500, 6800),
             rolloffNoise = c(0, 5, 7),
             attackLen = 20, throwaway = -120,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 250,
             pitchAnchors = c(220, 160),
             amplAnchors = data.frame(time = c(0, 100, 160, 250), value = c(70, 70, 80, 50)),
             nonlinBalance = 70, subFreq = 75, subDep = 0, jitterDep = 2, shortestEpoch = 50,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001,
             formants = c(500, 1500, 2500, 3400),
             noiseAnchors = data.frame(time = c(0, 400, 550), 
                                       value = c(-25, -20, -40) + 10),
             formantsNoise = c(600, 1300, 1600, 2400, 3500, 4500, 5500, 6800),
             rolloffNoise = c(0, 5, 7),
             attackLen = 20, throwaway = -120,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# sc level 1
s = soundgen(sylLen = 250,
             pitchAnchors = c(220, 160),
             amplAnchors = data.frame(time = c(0, 100, 160, 250), value = c(70, 70, 80, 50)),
             nonlinBalance = 60, subFreq = 75, subDep = 50, jitterDep = 2, shortestEpoch = 50,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001,
             formants = c(500, 1500, 2500, 3400),
             noiseAnchors = data.frame(time = c(0, 400, 550), 
                                       value = c(-25, -20, -40) + 10),
             formantsNoise = c(600, 1300, 1600, 2400, 3500, 4500, 5500, 6800),
             rolloffNoise = c(0, 5, 7),
             attackLen = 20, throwaway = -120,
             samplingRate = 22000, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011_r00.wav'))


# sc level 1 rolloff +4
s = soundgen(sylLen = 250,
             pitchAnchors = c(220, 160),
             amplAnchors = data.frame(time = c(0, 100, 160, 250), value = c(70, 70, 80, 50)),
             nonlinBalance = 60, subFreq = 75, subDep = 50, jitterDep = 2, shortestEpoch = 50,
             rolloff = -12 + 4, rolloffOct = 0,
             temperature = 0.001,
             formants = c(500, 1500, 2500, 3400),
             noiseAnchors = data.frame(time = c(0, 400, 550), 
                                       value = c(-25, -20, -40) + 10),
             formantsNoise = c(600, 1300, 1600, 2400, 3500, 4500, 5500, 6800),
             rolloffNoise = c(0, 5, 7),
             attackLen = 20, throwaway = -120,
             samplingRate = 22000, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011_r+4.wav'))


# sc level 1 rolloff -4
s = soundgen(sylLen = 250,
             pitchAnchors = c(220, 160),
             amplAnchors = data.frame(time = c(0, 100, 160, 250), value = c(70, 70, 80, 50)),
             nonlinBalance = 60, subFreq = 75, subDep = 50, jitterDep = 2, shortestEpoch = 50,
             rolloff = -12 - 4, rolloffOct = 0,
             temperature = 0.001,
             formants = c(500, 1500, 2500, 3400),
             noiseAnchors = data.frame(time = c(0, 400, 550), 
                                       value = c(-25, -20, -40) + 10),
             formantsNoise = c(600, 1300, 1600, 2400, 3500, 4500, 5500, 6800),
             rolloffNoise = c(0, 5, 7),
             attackLen = 20, throwaway = -120,
             samplingRate = 22000, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011_r-4.wav'))


# psc level 2
s = soundgen(sylLen = 250,
             pitchAnchors = c(220, 160),
             amplAnchors = data.frame(time = c(0, 100, 160, 250), value = c(70, 70, 80, 50)),
             nonlinBalance = 100, subFreq = 75, subDep = 70, jitterDep = 3, shortestEpoch = 50,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001,
             formants = c(500, 1500, 2500, 3400),
             noiseAnchors = data.frame(time = c(0, 400, 550), 
                                       value = c(-25, -20, -40) + 10),
             formantsNoise = c(600, 1300, 1600, 2400, 3500, 4500, 5500, 6800),
             rolloffNoise = c(0, 5, 7),
             attackLen = 20, throwaway = -120,
             samplingRate = 22000, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
