setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'laugh_289_ut_laugh-amused_41-f'
fileIdx = '25'

# original (closest to no nonlin)
s1 = soundgen(nSyl = 5, sylLen = 120, pauseLen = 100,
              pitchAnchors = 550,
              amplAnchorsGlobal = c(80, 40),
              rolloff = -10,
              nonlinBalance = 100, subFreq = 250, subDep = 100, 
              shimmerDep = 25, jitterDep = 1, shortestEpoch = 100,
              temperature = 0.001,
              formants = list(f1 = 900, f2 = c(2100, 1900), f3 = c(2300, 2100), 
                              f4 = c(4900, 4500), f5 = c(5100, 5300),
                              f6 = 7600), 
              noiseAnchors = 5,
              rolloffNoise = 3,
              attackLen = 20, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(nSyl = 6, sylLen = 90, pauseLen = 130,
              pitchAnchors = c(600, 850),
              pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
              amplAnchorsGlobal = c(60, 80, 60),
              rolloff = -10,
              nonlinBalance = 100, subDep = 0, jitterDep = 1.5, jitterLen = 50,
              temperature = 0.001,
              formants = c(500, 2200, 2600, 4500, 5500), 
              addSilence = 0, attackLen = 50,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 * 2, insertionPoint = 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))


# no nonlin rolloff +8
s1 = soundgen(nSyl = 5, sylLen = 120, pauseLen = 100,
              pitchAnchors = 550,
              amplAnchorsGlobal = c(80, 40),
              rolloff = -10 + 8,
              nonlinBalance = 100, subFreq = 250, subDep = 100, 
              shimmerDep = 25, jitterDep = 1, shortestEpoch = 100,
              temperature = 0.001,
              formants = list(f1 = 900, f2 = c(2100, 1900), f3 = c(2300, 2100), 
                              f4 = c(4900, 4500), f5 = c(5100, 5300),
                              f6 = 7600), 
              noiseAnchors = 5,
              rolloffNoise = 3,
              attackLen = 20, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(nSyl = 6, sylLen = 90, pauseLen = 130,
              pitchAnchors = c(600, 850),
              pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
              amplAnchorsGlobal = c(60, 80, 60),
              rolloff = -10 + 8,
              nonlinBalance = 100, subDep = 0, jitterDep = 1.5, jitterLen = 50,
              temperature = 0.001,
              formants = c(500, 2200, 2600, 4500, 5500), 
              addSilence = 0, attackLen = 50,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 * 2, insertionPoint = 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+8.wav'))


# no nonlin rolloff -8
s1 = soundgen(nSyl = 5, sylLen = 120, pauseLen = 100,
              pitchAnchors = 550,
              amplAnchorsGlobal = c(80, 40),
              rolloff = -10 - 8,
              nonlinBalance = 100, subFreq = 250, subDep = 100, 
              shimmerDep = 25, jitterDep = 1, shortestEpoch = 100,
              temperature = 0.001,
              formants = list(f1 = 900, f2 = c(2100, 1900), f3 = c(2300, 2100), 
                              f4 = c(4900, 4500), f5 = c(5100, 5300),
                              f6 = 7600), 
              noiseAnchors = 5,
              rolloffNoise = 3,
              attackLen = 20, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(nSyl = 6, sylLen = 90, pauseLen = 130,
              pitchAnchors = c(600, 850),
              pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
              amplAnchorsGlobal = c(60, 80, 60),
              rolloff = -10 - 8,
              nonlinBalance = 100, subDep = 0, jitterDep = 1.5, jitterLen = 50,
              temperature = 0.001,
              formants = c(500, 2200, 2600, 4500, 5500), 
              addSilence = 0, attackLen = 50,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 * 2, insertionPoint = 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-8.wav'))

# subh
s1 = soundgen(nSyl = 5, sylLen = 120, pauseLen = 100,
              pitchAnchors = 550,
              amplAnchorsGlobal = c(80, 40),
              rolloff = -10,
              nonlinBalance = 100, subFreq = 250, subDep = 100, 
              shimmerDep = 25, jitterDep = 1, shortestEpoch = 100,
              temperature = 0.001,
              formants = list(f1 = 900, f2 = c(2100, 1900), f3 = c(2300, 2100), 
                              f4 = c(4900, 4500), f5 = c(5100, 5300),
                              f6 = 7600), 
              noiseAnchors = 5,
              rolloffNoise = 3,
              attackLen = 20, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(nSyl = 6, sylLen = 90, pauseLen = 130,
              pitchAnchors = c(600, 850),
              pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
              amplAnchorsGlobal = c(60, 80, 60),
              rolloff = -10,
              nonlinBalance = 40, subFreq = 140, subDep = 80, jitterDep = 0,
              temperature = 0.001,
              formants = c(500, 2200, 2600, 4500, 5500), 
              addSilence = 0, attackLen = 50,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 * 2, insertionPoint = 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s2 = soundgen(nSyl = 6, sylLen = 90, pauseLen = 130,
              pitchAnchors = c(600, 850),
              pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
              amplAnchorsGlobal = c(60, 80, 60),
              rolloff = -10,
              nonlinBalance = 70, subFreq = 140, subDep = 0, jitterDep = 1,
              temperature = 0.001,
              formants = c(500, 2200, 2600, 4500, 5500), 
              addSilence = 0, attackLen = 50,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 * 2, insertionPoint = 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# sc level 1
s2 = soundgen(nSyl = 6, sylLen = 90, pauseLen = 130,
              pitchAnchors = c(600, 850),
              pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
              amplAnchorsGlobal = c(60, 80, 60),
              rolloff = -10,
              nonlinBalance = 70, subFreq = 140, subDep = 80, jitterDep = 1,
              temperature = 0.001,
              formants = c(500, 2200, 2600, 4500, 5500), 
              addSilence = 0, attackLen = 50,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 * 2, insertionPoint = 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s2 = soundgen(nSyl = 6, sylLen = 90, pauseLen = 130,
              pitchAnchors = c(600, 850),
              pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
              amplAnchorsGlobal = c(60, 80, 60),
              rolloff = -10,
              nonlinBalance = 100, subFreq = 140, subDep = 100, jitterDep = 2,
              temperature = 0.001,
              formants = c(500, 2200, 2600, 4500, 5500), 
              addSilence = 0, attackLen = 50,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 * 2, insertionPoint = 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
