setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'laugh_309_ut_laugh-malice_11'
fileIdx = '27'

# original (closest to chaos)
s = soundgen(nSyl = 7, sylLen = 70, pauseLen = 150,
             pitchAnchors = c(280, 380, 280),
             pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
             nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001, 
             formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
             noiseAnchors = data.frame(time = c(-160, -80, 0, 35, 70, 230),
                                       value = c(-40, -20, -40, -20, -40, -50) + 10),
             formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
             rolloffNoise = -2,
             mouthAnchors = c(.2, .6, .5, .4, .3),
             samplingRate = 22050, play = T, plot = T, osc = T)


# no nonlin
s = soundgen(nSyl = 7, sylLen = 70, pauseLen = 150,
             pitchAnchors = c(280, 380, 280),
             pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
             # nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001, 
             formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
             noiseAnchors = data.frame(time = c(-160, -80, 0, 35, 70, 230),
                                       value = c(-40, -20, -40, -20, -40, -50) + 10),
             formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
             rolloffNoise = -2,
             mouthAnchors = c(.2, .6, .5, .4, .3),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# subh
s = soundgen(nSyl = 7, sylLen = 70, pauseLen = 150,
             pitchAnchors = c(280, 380, 280),
             pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
             nonlinBalance = 30, subFreq = 100, subDep = 70, jitterDep = 0, shimmerDep = 0,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001, 
             formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
             noiseAnchors = data.frame(time = c(-160, -80, 0, 35, 70, 230),
                                       value = c(-40, -20, -40, -20, -40, -50) + 10),
             formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
             rolloffNoise = -2,
             mouthAnchors = c(.2, .6, .5, .4, .3),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(nSyl = 7, sylLen = 70, pauseLen = 150,
             pitchAnchors = c(280, 380, 280),
             pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
             nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001, 
             formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
             noiseAnchors = data.frame(time = c(-160, -80, 0, 35, 70, 230),
                                       value = c(-40, -20, -40, -20, -40, -50) + 10),
             formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
             rolloffNoise = -2,
             mouthAnchors = c(.2, .6, .5, .4, .3),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r00.wav'))


# chaos rolloff +4
s = soundgen(nSyl = 7, sylLen = 70, pauseLen = 150,
             pitchAnchors = c(280, 380, 280),
             pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
             nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
             rolloff = -12 + 4, rolloffOct = 0,
             temperature = 0.001, 
             formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
             noiseAnchors = data.frame(time = c(-160, -80, 0, 35, 70, 230),
                                       value = c(-40, -20, -40, -20, -40, -50) + 10),
             formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
             rolloffNoise = -2,
             mouthAnchors = c(.2, .6, .5, .4, .3),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r+4.wav'))


# chaos rolloff -4
s = soundgen(nSyl = 7, sylLen = 70, pauseLen = 150,
             pitchAnchors = c(280, 380, 280),
             pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
             nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
             rolloff = -12 - 4, rolloffOct = 0,
             temperature = 0.001, 
             formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
             noiseAnchors = data.frame(time = c(-160, -80, 0, 35, 70, 230),
                                       value = c(-40, -20, -40, -20, -40, -50) + 10),
             formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
             rolloffNoise = -2,
             mouthAnchors = c(.2, .6, .5, .4, .3),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r-4.wav'))


# sc level 1
s = soundgen(nSyl = 7, sylLen = 70, pauseLen = 150,
             pitchAnchors = c(280, 380, 280),
             pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
             nonlinBalance = 60, subFreq = 100, subDep = 70, jitterDep = 1, shimmerDep = 35,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001, 
             formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
             noiseAnchors = data.frame(time = c(-160, -80, 0, 35, 70, 230),
                                       value = c(-40, -20, -40, -20, -40, -50) + 10),
             formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
             rolloffNoise = -2,
             mouthAnchors = c(.2, .6, .5, .4, .3),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s = soundgen(nSyl = 7, sylLen = 70, pauseLen = 150,
             pitchAnchors = c(280, 380, 280),
             pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
             nonlinBalance = 80, subFreq = 100, subDep = 90, jitterDep = 2, shimmerDep = 35,
             rolloff = -12, rolloffOct = 0,
             temperature = 0.001, 
             formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
             noiseAnchors = data.frame(time = c(-160, -80, 0, 35, 70, 230),
                                       value = c(-40, -20, -40, -20, -40, -50) + 10),
             formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
             rolloffNoise = -2,
             mouthAnchors = c(.2, .6, .5, .4, .3),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
