setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'laugh_315_ut_laugh-malice_18'
fileIdx = '29'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

# original (closest to subh)
s1 = soundgen(sylLen = 430,
              pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
              rolloff = -6, rolloffOct = 0,
              nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = .1, shortestEpoch = 100,
              temperature = 0.001,
              formants = c(800, 1300, 2700, 3800, 5000),
              mouthAnchors = c(.3, .5),
              noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2_1 = soundgen(sylLen = 420,
                pitchAnchors = c(1440, 1050),
                rolloff = -20,
                formants = c(1200, 1500, 2700, 3800),
                addSilence = 0, attackLen = 10,
                samplingRate = 22050, play = T, plot = T, osc = T)
s2_2 = soundgen(sylLen = 1300,
                pitchAnchors = c(1450, 1000), vibratoDep = .5,
                amplAnchors = c(80, 20),
                rolloff = -20,
                formants = c(1200, 1500, 2700, 3800),
                mouthAnchors = c(.4, .55),
                noiseAnchors = c(10, -40),
                rolloffNoise = 0,
                addSilence = 0, attackLen = 10,
                samplingRate = 22050, play = T, plot = T, osc = T)
s2 = addVectors(s2_1 / 2, s2_2)
# playme(s2, 22050)

s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5,
              nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = .5,
              temperature = 0.001,
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s1 = soundgen(sylLen = 430,
              pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
              rolloff = -6, rolloffOct = 0,
              # nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = .1, shortestEpoch = 100,
              temperature = 0.001,
              formants = c(800, 1300, 2700, 3800, 5000),
              mouthAnchors = c(.3, .5),
              noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
              addSilence = 0, attackLen = 10, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5,
              # nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = .5,
              temperature = 0.001, tempEffects = list(sylLenDep = .5),
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = data.frame(time = c(0, 70, 71, 180),
                                        value = c(600, 750, 700, 600)), 
              vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5,
              # nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = .5,
              temperature = 0.001, tempEffects = list(sylLenDep = .5),
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subh
s1 = soundgen(sylLen = 430,
              pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
              rolloff = -6, rolloffOct = 0,
              nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = 0, shortestEpoch = 100,
              temperature = 0.001,
              formants = c(800, 1300, 2700, 3800, 5000),
              mouthAnchors = c(.3, .5),
              noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5,
              nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = 0,
              temperature = 0.001,
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r00.wav'))


# subh rolloff +4
s1 = soundgen(sylLen = 430,
              pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
              rolloff = -6 + 4, rolloffOct = 0,
              nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = 0, shortestEpoch = 100,
              temperature = 0.001,
              formants = c(800, 1300, 2700, 3800, 5000),
              mouthAnchors = c(.3, .5),
              noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5 + 4,
              nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = 0,
              temperature = 0.001,
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r+4.wav'))


# subh rolloff -4
s1 = soundgen(sylLen = 430,
              pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
              rolloff = -6 - 4, rolloffOct = 0,
              nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = 0, shortestEpoch = 100,
              temperature = 0.001,
              formants = c(800, 1300, 2700, 3800, 5000),
              mouthAnchors = c(.3, .5),
              noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
              addSilence = 0, attackLen = 10,
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5 - 4,
              nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = 0,
              temperature = 0.001,
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r-4.wav'))


# chaos
s1 = soundgen(sylLen = 430,
              pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
              rolloff = -6, rolloffOct = 0,
              nonlinBalance = 60, subFreq = 80, subDep = 0, jitterDep = 2, shortestEpoch = 200,
              temperature = 0.001,
              formants = c(800, 1300, 2700, 3800, 5000),
              mouthAnchors = c(.3, .5),
              noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
              addSilence = 0, attackLen = 10, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5,
              nonlinBalance = 50, subFreq = 170, subDep = 0, jitterDep = 2, shortestEpoch = 50,
              temperature = 0.001, tempEffects = list(sylLenDep = .5),
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s1 = soundgen(sylLen = 430,
              pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
              rolloff = -6, rolloffOct = 0,
              nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = 2, shortestEpoch = 200,
              temperature = 0.001,
              formants = c(800, 1300, 2700, 3800, 5000),
              mouthAnchors = c(.3, .5),
              noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
              addSilence = 0, attackLen = 10, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = data.frame(time = c(0, 70, 71, 180),
                                        value = c(600, 750, 700, 600)), 
              vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5,
              nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = 2,
              temperature = 0.001, tempEffects = list(sylLenDep = .5),
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s1 = soundgen(sylLen = 430,
              pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
              rolloff = -6, rolloffOct = 0,
              nonlinBalance = 70, subFreq = 80, subDep = 50, jitterDep = 3, shortestEpoch = 200,
              temperature = 0.001,
              formants = c(800, 1300, 2700, 3800, 5000),
              mouthAnchors = c(.3, .5),
              noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
              addSilence = 0, attackLen = 10, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 6, sylLen = 180, pauseLen = 100,
              pitchAnchors = data.frame(time = c(0, 70, 71, 180),
                                        value = c(600, 750, 700, 600)), 
              vibratoFreq = 9, vibratoDep = 1,
              pitchAnchorsGlobal = c(0, -9),
              rolloff = -5,
              nonlinBalance = 60, subFreq = 170, subDep = 100, jitterDep = 3,
              temperature = 0.001, tempEffects = list(sylLenDep = .5),
              formants = c(800, 1400, 2700, 3800),
              mouthAnchors = c(.4, .7),
              noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                                       value = c(-30, -10, -30, -10, -30) + 5),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
