setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'laugh_316_ut_laugh-malice_19-m'
fileIdx = '30'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original (closest to pitch jump)
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(350, 320),
              rolloff = c(-3, -8),
              temperature = 0.001,
              formants = c(850, 1200, 2200, 3100, 3900),
              mouthAnchors = c(.1, .4, .5),
              noiseAnchors = data.frame(time = c(0, 370), value = c(-20, 0)),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              addSilence = 0, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 1000,
              pitchAnchors = data.frame(time = c(0, .1, 1), value = c(500, 970, 770)), vibratoDep = .5,
              amplAnchors = data.frame(time = c(0, .1, 1), value = c(50, 80, 20)),
              rolloff = -25,
              nonlinBalance = 100, subFreq = 230, subDep = 150, jitterDep = 1, shimmerDep = 20,
              formants = c(850, 1400, 2300, 3200),
              mouthAnchors = c(.4, .55),
              noiseAnchors = c(0, -30, -50),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, .31, 1), 
                                        value = c(450, 510, 350, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3), 
              rolloff = -8, 
              temperature = 0.001,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050, osc = T)


# no nonlin effects
s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, 1), 
                                        value = c(450, 510, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3), tempEffects = list(pitchAnchorsDep = 3),
              rolloff = -8, 
              temperature = 0.001,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, .31, 1), 
                                        value = c(450, 510, 350, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3), 
              rolloff = -8, 
              temperature = 0.001,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100_r00.wav'))


# pitch jump rolloff +4
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(350, 320),
              rolloff = c(-3, -8) + 4, invalidArgAction = 'ignore',
              temperature = 0.001,
              formants = c(850, 1200, 2200, 3100, 3900),
              mouthAnchors = c(.1, .4, .5),
              noiseAnchors = data.frame(time = c(0, 370), value = c(-20, 0)),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              addSilence = 0, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, .31, 1), 
                                        value = c(450, 510, 350, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3), 
              rolloff = -8 + 4, 
              temperature = 0.001,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100_r+4.wav'))


# pitch jump rolloff -4
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(350, 320),
              rolloff = c(-3, -8) - 4, invalidArgAction = 'ignore',
              temperature = 0.001,
              formants = c(850, 1200, 2200, 3100, 3900),
              mouthAnchors = c(.1, .4, .5),
              noiseAnchors = data.frame(time = c(0, 370), value = c(-20, 0)),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              addSilence = 0, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, .31, 1), 
                                        value = c(450, 510, 350, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3), 
              rolloff = -8 - 4, 
              temperature = 0.001,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100_r-4.wav'))


# subh
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(350, 320),
              rolloff = c(-3, -8),
              temperature = 0.001,
              nonlinBalance = 30, subFreq = 150, subDep = 70, jitterDep = 0, shortestEpoch = 100,
              formants = c(850, 1200, 2200, 3100, 3900),
              mouthAnchors = c(.1, .4, .5),
              noiseAnchors = data.frame(time = c(0, 370), value = c(-20, 0)),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              addSilence = 0, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, 1), 
                                        value = c(450, 510, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3), tempEffects = list(pitchAnchorsDep = 3),
              rolloff = -8, 
              temperature = 0.001,
              nonlinBalance = 40, subFreq = 150, subDep = 80, jitterDep = 0, shortestEpoch = 50,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos 1
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(350, 320),
              rolloff = c(-3, -8),
              temperature = 0.001,
              nonlinBalance = 50, subFreq = 150, subDep = 0, jitterDep = 1, shortestEpoch = 100,
              formants = c(850, 1200, 2200, 3100, 3900),
              mouthAnchors = c(.1, .4, .5),
              noiseAnchors = data.frame(time = c(0, 370), value = c(-20, 0)),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              addSilence = 0, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, 1), 
                                        value = c(450, 510, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3),
              rolloff = -8, 
              temperature = 0.001,
              nonlinBalance = 70, subFreq = 150, subDep = 0, jitterDep = 1,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(350, 320),
              rolloff = c(-3, -8),
              temperature = 0.001,
              nonlinBalance = 50, subFreq = 150, subDep = 70, jitterDep = 1, shortestEpoch = 100,
              formants = c(850, 1200, 2200, 3100, 3900),
              mouthAnchors = c(.1, .4, .5),
              noiseAnchors = data.frame(time = c(0, 370), value = c(-20, 0)),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              addSilence = 0, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, 1), 
                                        value = c(450, 510, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3),
              rolloff = -8, 
              temperature = 0.001,
              nonlinBalance = 50, subFreq = 150, subDep = 70, jitterDep = 1, shortestEpoch = 100,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s1 = soundgen(sylLen = 315,
              pitchAnchors = c(350, 320),
              rolloff = c(-3, -8),
              temperature = 0.001,
              nonlinBalance = 70, subFreq = 150, subDep = 90, jitterDep = 2, shortestEpoch = 100,
              formants = c(850, 1200, 2200, 3100, 3900),
              mouthAnchors = c(.1, .4, .5),
              noiseAnchors = data.frame(time = c(0, 370), value = c(-20, 0)),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              addSilence = 0, 
              samplingRate = 22050, play = T, plot = T, osc = T)

s3 = soundgen(nSyl = 4, sylLen = 120, pauseLen = 120,
              pitchAnchors = data.frame(time = c(0, .3, 1), 
                                        value = c(450, 510, 320)), 
              vibratoFreq = 9, vibratoDep = 1,
              amplAnchorsGlobal = c(80, 70),
              pitchAnchorsGlobal = c(0, -3), 
              rolloff = -8, 
              temperature = 0.001,
              nonlinBalance = 70, subFreq = 150, subDep = 90, jitterDep = 2, shortestEpoch = 100,
              formants = c(900, 1350, 3000, 4100, 4900),
              mouthAnchors = c(.4, .6),
              noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                                        value = c(-30, -20, -30, -20, -30) + 10),
              formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
              rolloffNoise = 0,
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
