setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'moan_180_ut_exams_08-f-sigh-relief'
fileIdx = '31'

# original (closest to no nonlin)
s = soundgen(sylLen = 380, 
             pitchAnchors = data.frame(time = c(0, 100, 380),
                                       value = c(250, 310, 250)),
             temperature = 0.001, 
             rolloff = -10,
             formants = list(f1 = c(850, 750), f2 = 1150, f3 = 2900, f4 = 4200),
             mouthAnchors = data.frame(time = c(0, 100, 380, 720), 
                                       value = c(.4, .5, .5, .7)),
             noiseAnchors = data.frame(time = c(0, 300, 400, 720), 
                                       value = c(-40, -30, -10, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))


# no nonlin rolloff +4
s = soundgen(sylLen = 380, pitchAnchors = data.frame(time = c(0, 100, 380),
                                                     value = c(250, 310, 250)),
             temperature = 0.001, 
             rolloff = -10 + 4,
             formants = list(f1 = c(850, 750), f2 = 1150, f3 = 2900, f4 = 4200),
             mouthAnchors = data.frame(time = c(0, 100, 380, 720), 
                                       value = c(.4, .5, .5, .7)),
             noiseAnchors = data.frame(time = c(0, 300, 400, 720), 
                                       value = c(-40, -30, -10, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+4.wav'))


# no nonlin rolloff -4
s = soundgen(sylLen = 380, pitchAnchors = data.frame(time = c(0, 100, 380),
                                                     value = c(250, 310, 250)),
             temperature = 0.001, 
             rolloff = -10 - 4,
             formants = list(f1 = c(850, 750), f2 = 1150, f3 = 2900, f4 = 4200),
             mouthAnchors = data.frame(time = c(0, 100, 380, 720), 
                                       value = c(.4, .5, .5, .7)),
             noiseAnchors = data.frame(time = c(0, 300, 400, 720), 
                                       value = c(-40, -30, -10, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-4.wav'))


# subh
s = soundgen(sylLen = 380, 
             pitchAnchors = data.frame(time = c(0, 100, 380),
                                       value = c(250, 310, 250)),
             nonlinBalance = 40, subFreq = 140, subDep = 80, jitterDep = 0, shortestEpoch = 100,
             temperature = 0.001, 
             rolloff = -10,
             formants = list(f1 = c(850, 750), f2 = 1150, f3 = 2900, f4 = 4200),
             mouthAnchors = data.frame(time = c(0, 100, 380, 720), 
                                       value = c(.4, .5, .5, .7)),
             noiseAnchors = data.frame(time = c(0, 300, 400, 720), 
                                       value = c(-40, -30, -10, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 380, 
             pitchAnchors = data.frame(time = c(0, 100, 380),
                                       value = c(250, 310, 250)),
             nonlinBalance = 60, subFreq = 140, subDep = 0, jitterDep = 1, shortestEpoch = 100,
             temperature = 0.001, 
             rolloff = -10,
             formants = list(f1 = c(850, 750), f2 = 1150, f3 = 2900, f4 = 4200),
             mouthAnchors = data.frame(time = c(0, 100, 380, 720), 
                                       value = c(.4, .5, .5, .7)),
             noiseAnchors = data.frame(time = c(0, 300, 400, 720), 
                                       value = c(-40, -30, -10, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# sc level 1
s = soundgen(sylLen = 380, 
             pitchAnchors = data.frame(time = c(0, 100, 380),
                                       value = c(250, 310, 250)),
             nonlinBalance = 60, subFreq = 140, subDep = 80, jitterDep = 1, shortestEpoch = 100,
             temperature = 0.001, 
             rolloff = -10,
             formants = list(f1 = c(850, 750), f2 = 1150, f3 = 2900, f4 = 4200),
             mouthAnchors = data.frame(time = c(0, 100, 380, 720), 
                                       value = c(.4, .5, .5, .7)),
             noiseAnchors = data.frame(time = c(0, 300, 400, 720), 
                                       value = c(-40, -30, -10, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s = soundgen(sylLen = 380, 
             pitchAnchors = data.frame(time = c(0, 100, 380),
                                       value = c(250, 310, 250)),
             nonlinBalance = 100, subFreq = 140, subDep = 100, jitterDep = 2, shortestEpoch = 100,
             temperature = 0.001, 
             rolloff = -10,
             formants = list(f1 = c(850, 750), f2 = 1150, f3 = 2900, f4 = 4200),
             mouthAnchors = data.frame(time = c(0, 100, 380, 720), 
                                       value = c(.4, .5, .5, .7)),
             noiseAnchors = data.frame(time = c(0, 300, 400, 720), 
                                       value = c(-40, -30, -10, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
