setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'moan_521_ut_sex_18-f-effortful-moans'
fileIdx = '34'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original (closest to sc level 2)
s1 = soundgen(repeatBout = 2, sylLen = 650, pauseLen = 300, 
              pitchAnchors = data.frame(time = c(0, .3, 1), value = c(490, 525, 370)),
              vibratoDep = .1, vibratoFreq = 10, 
              nonlinBalance = 30, subFreq = 130, subDep = 65, 
              jitterDep = 2, shortestEpoch = 200,
              temperature = 0.001,
              rolloff = c(-8, -12), 
              formants = c(850, 1700, 3200, 4300), 
              noiseAnchors = data.frame(time = c(0, 600, 750), 
                                        value = c(-40, -10, -40)),
              mouthAnchors = seq(.5, .7, length.out = 16) * rep(c(.9, 1.1), 8),
              rolloffNoise = -4, 
              throwaway = -120, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(pitchAnchors = NULL,
              noiseAnchors = data.frame(time = c(0, 10, 130, 260, 270),
                                        value = c(-60, 0, 10, 0, -60)),
              formantsNoise = list(f1 = data.frame(freq = 480, width = 400, amp = 4),
                                   f2 = data.frame(freq = 8200, width = 8000, amp = 45)),
              rolloffNoise = -2, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 5, s2, insertionPoint = 22050 * .75)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s1 = soundgen(repeatBout = 2, sylLen = 650, pauseLen = 300, 
              pitchAnchors = data.frame(time = c(0, .3, 1), value = c(490, 525, 370)),
              vibratoDep = .1, vibratoFreq = 10, 
              # nonlinBalance = 30, subFreq = 130, subDep = 65, jitterDep = 2, shortestEpoch = 200,
              temperature = 0.001,
              rolloff = c(-8, -12), 
              formants = c(850, 1700, 3200, 4300), 
              noiseAnchors = data.frame(time = c(0, 600, 750), 
                                        value = c(-40, -10, -40)),
              mouthAnchors = seq(.5, .7, length.out = 16) * rep(c(.9, 1.1), 8),
              rolloffNoise = -4, 
              throwaway = -120, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 5, s2, insertionPoint = 22050 * .75)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# subh
s1 = soundgen(repeatBout = 2, sylLen = 650, pauseLen = 300, 
              pitchAnchors = data.frame(time = c(0, .3, 1), value = c(490, 525, 370)),
              vibratoDep = .1, vibratoFreq = 10, 
              nonlinBalance = 30, subFreq = 130, subDep = 65, jitterDep = 0, shortestEpoch = 100,
              temperature = 0.001,
              rolloff = c(-8, -12), 
              formants = c(850, 1700, 3200, 4300), 
              noiseAnchors = data.frame(time = c(0, 600, 750), 
                                        value = c(-40, -10, -40)),
              mouthAnchors = seq(.5, .7, length.out = 16) * rep(c(.9, 1.1), 8),
              rolloffNoise = -4, 
              throwaway = -120, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 5, s2, insertionPoint = 22050 * .75)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s1 = soundgen(repeatBout = 2, sylLen = 650, pauseLen = 300, 
              pitchAnchors = data.frame(time = c(0, .3, 1), value = c(490, 525, 370)),
              vibratoDep = .1, vibratoFreq = 10, 
              nonlinBalance = 60, subFreq = 130, subDep = 0, jitterDep = 2, shortestEpoch = 100,
              temperature = 0.001,
              rolloff = c(-8, -12), 
              formants = c(850, 1700, 3200, 4300), 
              noiseAnchors = data.frame(time = c(0, 600, 750), 
                                        value = c(-40, -10, -40)),
              mouthAnchors = seq(.5, .7, length.out = 16) * rep(c(.9, 1.1), 8),
              rolloffNoise = -4, 
              throwaway = -120, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 5, s2, insertionPoint = 22050 * .75)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s1 = soundgen(repeatBout = 2, sylLen = 650, pauseLen = 300, 
              pitchAnchors = data.frame(time = c(0, .3, 1), value = c(490, 525, 370)),
              vibratoDep = .1, vibratoFreq = 10, 
              nonlinBalance = 40, subFreq = 130, subDep = 65, jitterDep = 1, shortestEpoch = 100,
              temperature = 0.001,
              rolloff = c(-8, -12), 
              formants = c(850, 1700, 3200, 4300), 
              noiseAnchors = data.frame(time = c(0, 600, 750), 
                                        value = c(-40, -10, -40)),
              mouthAnchors = seq(.5, .7, length.out = 16) * rep(c(.9, 1.1), 8),
              rolloffNoise = -4, 
              throwaway = -120, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 5, s2, insertionPoint = 22050 * .75)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# psc level 2
s1 = soundgen(repeatBout = 2, sylLen = 650, pauseLen = 300, 
              pitchAnchors = data.frame(time = c(0, .3, 1), value = c(490, 525, 370)),
              vibratoDep = .1, vibratoFreq = 10, 
              nonlinBalance = 60, subFreq = 130, subDep = 65, jitterDep = 2, shortestEpoch = 200,
              temperature = 0.001,
              rolloff = c(-8, -12), 
              formants = c(850, 1700, 3200, 4300), 
              noiseAnchors = data.frame(time = c(0, 600, 750), 
                                        value = c(-40, -10, -40)),
              mouthAnchors = seq(.5, .7, length.out = 16) * rep(c(.9, 1.1), 8),
              rolloffNoise = -4, 
              throwaway = -120, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 5, s2, insertionPoint = 22050 * .75)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022_r00.wav'))


# psc level 2 rolloff +4
s1 = soundgen(repeatBout = 2, sylLen = 650, pauseLen = 300, 
              pitchAnchors = data.frame(time = c(0, .3, 1), value = c(490, 525, 370)),
              vibratoDep = .1, vibratoFreq = 10, 
              nonlinBalance = 60, subFreq = 130, subDep = 65, jitterDep = 2, shortestEpoch = 200,
              temperature = 0.001,
              rolloff = c(-8, -12) + 4, 
              formants = c(850, 1700, 3200, 4300), 
              noiseAnchors = data.frame(time = c(0, 600, 750), 
                                        value = c(-40, -10, -40)),
              mouthAnchors = seq(.5, .7, length.out = 16) * rep(c(.9, 1.1), 8),
              rolloffNoise = -4, 
              throwaway = -120, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 5, s2, insertionPoint = 22050 * .75)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022_r+4.wav'))


# psc level 2 rolloff -4
s1 = soundgen(repeatBout = 2, sylLen = 650, pauseLen = 300, 
              pitchAnchors = data.frame(time = c(0, .3, 1), value = c(490, 525, 370)),
              vibratoDep = .1, vibratoFreq = 10, 
              nonlinBalance = 60, subFreq = 130, subDep = 65, jitterDep = 2, shortestEpoch = 200,
              temperature = 0.001,
              rolloff = c(-8, -12) - 4, 
              formants = c(850, 1700, 3200, 4300), 
              noiseAnchors = data.frame(time = c(0, 600, 750), 
                                        value = c(-40, -10, -40)),
              mouthAnchors = seq(.5, .7, length.out = 16) * rep(c(.9, 1.1), 8),
              rolloffNoise = -4, 
              throwaway = -120, addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 5, s2, insertionPoint = 22050 * .75)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022_r-4.wav'))
