setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'moan_530_ut_sex_36-m-moaning'
fileIdx = '36'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

# original (closest to subh)
s = soundgen(sylLen = 600,
             pitchAnchors = data.frame(time = c(0, 80, 115, 600),
                                       value = c(158, 135, 175, 145)),
             temperature = 0.001,
             nonlinBalance = 10, subFreq = 75, subDep = 50, shortestEpoch = 50,
             rolloff = c(-2, -12),
             formants = c(520, 1150, 2600, 3600, 4600, 5400),
             noiseAnchors = data.frame(time = c(0, 600, 950), 
                                       value = c(-10, 0, -50)),
             formantsNoise = list(f1 = 520, f2 = 1150, 
                                  f3 = data.frame(freq = 2600, amp = c(20, 35)),
                                  f4 = data.frame(freq = 3600, amp = c(20, 50)),
                                  f5 = data.frame(freq = 4600, amp = c(20, 40)),
                                  f6 = data.frame(freq = c(5400, 4800)),
                                  f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
             rolloffNoise = 2,
             mouthAnchors = c(.5, .8),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s = soundgen(sylLen = 600,
             pitchAnchors = data.frame(time = c(0, 100, 200, 600),
                                       value = c(158, 135, 175, 145)),
             temperature = 0.001,
             # nonlinBalance = 10, subFreq = 75, subDep = 50, shortestEpoch = 50,
             rolloff = c(-2, -12),
             formants = c(520, 1150, 2600, 3600, 4600, 5400),
             noiseAnchors = data.frame(time = c(0, 600, 950), 
                                       value = c(-10, 0, -50)),
             formantsNoise = list(f1 = 520, f2 = 1150, 
                                  f3 = data.frame(freq = 2600, amp = c(20, 35)),
                                  f4 = data.frame(freq = 3600, amp = c(20, 50)),
                                  f5 = data.frame(freq = 4600, amp = c(20, 40)),
                                  f6 = data.frame(freq = c(5400, 4800)),
                                  f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
             rolloffNoise = 2,
             mouthAnchors = c(.5, .8),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# subh
s = soundgen(sylLen = 600,
             pitchAnchors = data.frame(time = c(0, 100, 200, 600),
                                       value = c(158, 135, 175, 145)),
             temperature = 0.001,
             nonlinBalance = 30, subFreq = 75, subDep = 30, jitterDep = 0, shortestEpoch = 50,
             rolloff = c(-2, -12),
             formants = c(520, 1150, 2600, 3600, 4600, 5400),
             noiseAnchors = data.frame(time = c(0, 600, 950), 
                                       value = c(-10, 0, -50)),
             formantsNoise = list(f1 = 520, f2 = 1150, 
                                  f3 = data.frame(freq = 2600, amp = c(20, 35)),
                                  f4 = data.frame(freq = 3600, amp = c(20, 50)),
                                  f5 = data.frame(freq = 4600, amp = c(20, 40)),
                                  f6 = data.frame(freq = c(5400, 4800)),
                                  f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
             rolloffNoise = 2,
             mouthAnchors = c(.5, .8),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r00.wav'))


# subh rolloff +4
s = soundgen(sylLen = 600,
             pitchAnchors = data.frame(time = c(0, 100, 200, 600),
                                       value = c(158, 135, 175, 145)),
             temperature = 0.001,
             nonlinBalance = 30, subFreq = 75, subDep = 30, jitterDep = 0, shortestEpoch = 50,
             rolloff = c(-2, -12) + 4, invalidArgAction = 'ignore',
             formants = c(520, 1150, 2600, 3600, 4600, 5400),
             noiseAnchors = data.frame(time = c(0, 600, 950), 
                                       value = c(-10, 0, -50)),
             formantsNoise = list(f1 = 520, f2 = 1150, 
                                  f3 = data.frame(freq = 2600, amp = c(20, 35)),
                                  f4 = data.frame(freq = 3600, amp = c(20, 50)),
                                  f5 = data.frame(freq = 4600, amp = c(20, 40)),
                                  f6 = data.frame(freq = c(5400, 4800)),
                                  f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
             rolloffNoise = 2,
             mouthAnchors = c(.5, .8),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r+4.wav'))


# subh rolloff -4
s = soundgen(sylLen = 600,
             pitchAnchors = data.frame(time = c(0, 100, 200, 600),
                                       value = c(158, 135, 175, 145)),
             temperature = 0.001,
             nonlinBalance = 30, subFreq = 75, subDep = 30, jitterDep = 0, shortestEpoch = 50,
             rolloff = c(-2, -12) - 4, 
             formants = c(520, 1150, 2600, 3600, 4600, 5400),
             noiseAnchors = data.frame(time = c(0, 600, 950), 
                                       value = c(-10, 0, -50)),
             formantsNoise = list(f1 = 520, f2 = 1150, 
                                  f3 = data.frame(freq = 2600, amp = c(20, 35)),
                                  f4 = data.frame(freq = 3600, amp = c(20, 50)),
                                  f5 = data.frame(freq = 4600, amp = c(20, 40)),
                                  f6 = data.frame(freq = c(5400, 4800)),
                                  f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
             rolloffNoise = 2,
             mouthAnchors = c(.5, .8),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r-4.wav'))


# chaos
s = soundgen(sylLen = 600,
             pitchAnchors = data.frame(time = c(0, 100, 200, 600),
                                       value = c(158, 135, 175, 145)),
             temperature = 0.001,
             nonlinBalance = 50, subFreq = 75, subDep = 0, jitterDep = 1, shortestEpoch = 100,
             rolloff = c(-2, -12),
             formants = c(520, 1150, 2600, 3600, 4600, 5400),
             noiseAnchors = data.frame(time = c(0, 600, 950), 
                                       value = c(-10, 0, -50)),
             formantsNoise = list(f1 = 520, f2 = 1150, 
                                  f3 = data.frame(freq = 2600, amp = c(20, 35)),
                                  f4 = data.frame(freq = 3600, amp = c(20, 50)),
                                  f5 = data.frame(freq = 4600, amp = c(20, 40)),
                                  f6 = data.frame(freq = c(5400, 4800)),
                                  f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
             rolloffNoise = 2,
             mouthAnchors = c(.5, .8),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s = soundgen(sylLen = 600,
             pitchAnchors = data.frame(time = c(0, 100, 200, 600),
                                       value = c(158, 135, 175, 145)),
             temperature = 0.001,
             nonlinBalance = 40, subFreq = 75, subDep = 30, jitterDep = 1, shortestEpoch = 50,
             rolloff = c(-2, -12),
             formants = c(520, 1150, 2600, 3600, 4600, 5400),
             noiseAnchors = data.frame(time = c(0, 600, 950), 
                                       value = c(-10, 0, -50)),
             formantsNoise = list(f1 = 520, f2 = 1150, 
                                  f3 = data.frame(freq = 2600, amp = c(20, 35)),
                                  f4 = data.frame(freq = 3600, amp = c(20, 50)),
                                  f5 = data.frame(freq = 4600, amp = c(20, 40)),
                                  f6 = data.frame(freq = c(5400, 4800)),
                                  f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
             rolloffNoise = 2,
             mouthAnchors = c(.5, .8),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# psc level 2
s = soundgen(sylLen = 600,
             pitchAnchors = data.frame(time = c(0, 100, 200, 600),
                                       value = c(158, 135, 175, 145)),
             temperature = 0.001,
             nonlinBalance = 70, subFreq = 75, subDep = 40, jitterDep = 2, shortestEpoch = 150,
             rolloff = c(-2, -12),
             formants = c(520, 1150, 2600, 3600, 4600, 5400),
             noiseAnchors = data.frame(time = c(0, 600, 950), 
                                       value = c(-10, 0, -50)),
             formantsNoise = list(f1 = 520, f2 = 1150, 
                                  f3 = data.frame(freq = 2600, amp = c(20, 35)),
                                  f4 = data.frame(freq = 3600, amp = c(20, 50)),
                                  f5 = data.frame(freq = 4600, amp = c(20, 40)),
                                  f6 = data.frame(freq = c(5400, 4800)),
                                  f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
             rolloffNoise = 2,
             mouthAnchors = c(.5, .8),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
