setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'moan_549_ut_sex_68-m-moans'
fileIdx = '38'

# original (closest to no nonlin)
s = soundgen(nSyl = 3, sylLen = 520, pauseLen = 400,
             pitchAnchors = c(270, 210), vibratoDep = .5,
             temperature = 0.001, 
             rolloff = c(-20, -30),
             formants = c(900, 1400, 3100, 3750, 4900, 6200, 6800),
             noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                                       value = c(-55, -40, -45, -60, -40, -60)),
             rolloffNoise = c(0, 0, -5),
             mouthAnchors = c(.5, .6),
             samplingRate = 22050, play = T, plot = T, osc = T)

# no nonlin
s = soundgen(nSyl = 2, sylLen = 520, pauseLen = 400,
             pitchAnchors = c(270, 210), vibratoDep = .5,
             temperature = 0.001, 
             rolloff = c(-20, -30),
             formants = c(900, 1400, 3100, 3750, 4900, 6200, 6800),
             noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                                       value = c(-55, -40, -45, -60, -40, -60)),
             rolloffNoise = c(0, 0, -5),
             mouthAnchors = c(.5, .6),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r00.wav'))


# rolloff +10
s = soundgen(nSyl = 2, sylLen = 520, pauseLen = 400,
             pitchAnchors = c(270, 210), vibratoDep = .5,
             temperature = 0.001, 
             rolloff = c(-20, -30) + 10,
             formants = c(900, 1400, 3100, 3750, 4900, 6200, 6800),
             noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                                       value = c(-55, -40, -45, -60, -40, -60)),
             rolloffNoise = c(0, 0, -5),
             mouthAnchors = c(.5, .6),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r+10.wav'))

# rolloff -10
s = soundgen(nSyl = 2, sylLen = 520, pauseLen = 400,
             pitchAnchors = c(270, 210), vibratoDep = .5,
             temperature = 0.001, 
             rolloff = c(-20, -30) - 10, invalidArgAction = 'ignore',
             formants = c(900, 1400, 3100, 3750, 4900, 6200, 6800),
             noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                                       value = c(-55, -40, -45, -60, -40, -60)),
             rolloffNoise = c(0, 0, -5),
             mouthAnchors = c(.5, .6),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000_r-10.wav'))


# subh
s = soundgen(nSyl = 2, sylLen = 520, pauseLen = 400,
             pitchAnchors = c(270, 210), vibratoDep = .5,
             temperature = 0.001, 
             nonlinBalance = 30, subFreq = 110, subDep = 60, jitterDep = 0, shortestEpoch = 100,
             rolloff = c(-20, -30),
             formants = c(900, 1400, 3100, 3750, 4900, 6200, 6800),
             noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                                       value = c(-55, -40, -45, -60, -40, -60)),
             rolloffNoise = c(0, 0, -5),
             mouthAnchors = c(.5, .6),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(nSyl = 2, sylLen = 520, pauseLen = 400,
             pitchAnchors = c(270, 210), vibratoDep = .5,
             temperature = 0.001, 
             nonlinBalance = 50, subFreq = 110, subDep = 0, jitterDep = 1, shortestEpoch = 100,
             rolloff = c(-20, -30),
             formants = c(900, 1400, 3100, 3750, 4900, 6200, 6800),
             noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                                       value = c(-55, -40, -45, -60, -40, -60)),
             rolloffNoise = c(0, 0, -5),
             mouthAnchors = c(.5, .6),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# sc level 1
s = soundgen(nSyl = 2, sylLen = 520, pauseLen = 400,
             pitchAnchors = c(270, 210), vibratoDep = .5,
             temperature = 0.001, 
             nonlinBalance = 50, subFreq = 110, subDep = 60, jitterDep = 1, shortestEpoch = 100,
             rolloff = c(-20, -30),
             formants = c(900, 1400, 3100, 3750, 4900, 6200, 6800),
             noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                                       value = c(-55, -40, -45, -60, -40, -60)),
             rolloffNoise = c(0, 0, -5),
             mouthAnchors = c(.5, .6),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s = soundgen(nSyl = 2, sylLen = 520, pauseLen = 400,
             pitchAnchors = c(270, 210), vibratoDep = .5,
             temperature = 0.001, 
             nonlinBalance = 60, subFreq = 110, subDep = 60, jitterDep = 1.5, shortestEpoch = 100,
             rolloff = c(-20, -30),
             formants = c(900, 1400, 3100, 3750, 4900, 6200, 6800),
             noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                                       value = c(-55, -40, -45, -60, -40, -60)),
             rolloffNoise = c(0, 0, -5),
             mouthAnchors = c(.5, .6),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022.wav'))
