setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'roar_007_ut_anger_06-f-roar'
fileIdx = '41'

# original (closest to sc level 1)
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 177, 472, 590),
                                 value = c(260, 750, 700, 260)),
             temperature = 0.001, 
             rolloff = -4,
             nonlinBalance = 100, subFreq = 80, subDep = 70, jitterDep = 1.2,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)


# no nonlin
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 177, 472, 590),
                                 value = c(260, 750, 700, 260)),
             temperature = 0.001, 
             rolloff = -4,
             # nonlinBalance = 100, subFreq = 80, subDep = 70, jitterDep = 1.2,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 170, 171, 470, 471, 590),
                                 value = c(260, 280, 750, 700, 280, 260)),
             temperature = 0.001, 
             rolloff = -4,
             # nonlinBalance = 100, subFreq = 80, subDep = 70, jitterDep = 1.2,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subh
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 177, 472, 590),
                                 value = c(260, 750, 700, 260)),
             temperature = 0.001, 
             rolloff = -4,
             nonlinBalance = 50, subFreq = 80, subDep = 40, jitterDep = 0, shortestEpoch = 100,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 177, 472, 590),
                                 value = c(260, 750, 700, 260)),
             temperature = 0.001, 
             rolloff = -4,
             nonlinBalance = 80, subFreq = 80, subDep = 0, jitterDep = 1.2, shortestEpoch = 100,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 170, 171, 470, 471, 590),
                                 value = c(260, 280, 750, 700, 280, 260)),
             temperature = 0.001, 
             rolloff = -4,
             nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = 1.2,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 170, 171, 470, 471, 590),
                                 value = c(260, 280, 750, 700, 280, 260)),
             temperature = 0.001, 
             rolloff = -4,
             nonlinBalance = 90, subFreq = 80, subDep = 40, jitterDep = 2,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222_r00.wav'))


# psc level 2 rolloff +4
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 170, 171, 470, 471, 590),
                                 value = c(260, 280, 750, 700, 280, 260)),
             temperature = 0.001, 
             rolloff = -4 + 4,
             nonlinBalance = 90, subFreq = 80, subDep = 40, jitterDep = 2,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222_r+4.wav'))


# psc level 2 rolloff -4
s = soundgen(sylLen = 590, 
             pitchAnchors = list(time = c(0, 170, 171, 470, 471, 590),
                                 value = c(260, 280, 750, 700, 280, 260)),
             temperature = 0.001, 
             rolloff = -4 - 4,
             nonlinBalance = 90, subFreq = 80, subDep = 40, jitterDep = 2,
             formants = c(1000, 1700, 3000), 
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222_r-4.wav'))
