setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'roar_025_ut_anger_23-m-roar'
fileIdx = '43'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

# original (closest to chaos)
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                                       value = c(200, 410, 405, 200)),
             rolloff = 0, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             noiseAnchors = -10,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                                       value = c(200, 410, 405, 200)),
             rolloff = 0, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 0, subDep = 0, jitterDep = 2, shimmerDep = 20,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             # noiseAnchors = -10,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, 100, 500, 501, 620, 621, 910, 1040),
                                       value = c(200, 410, 405, 480, 480, 405, 400, 200)),
             rolloff = 0, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 0, subDep = 0, jitterDep = 2, shimmerDep = 20,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             # noiseAnchors = -10,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subh
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                                       value = c(200, 410, 405, 200)),
             rolloff = 0, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 30, subFreq = 100, subDep = 70, jitterDep = 0, shimmerDep = 0,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             # noiseAnchors = -10,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                                       value = c(200, 410, 405, 200)),
             rolloff = 0, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 100, subFreq = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 20,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             noiseAnchors = -10,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r00.wav'))


# chaos rolloff +4
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                                       value = c(200, 410, 405, 200)),
             rolloff = 0 + 4, rolloffOct = 0, invalidArgAction = 'ignore',
             temperature = 0.001,
             nonlinBalance = 100, subFreq = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 20,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             noiseAnchors = -10,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r+4.wav'))


# chaos rolloff -4
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                                       value = c(200, 410, 405, 200)),
             rolloff = 0 - 4, rolloffOct = 0, invalidArgAction = 'ignore',
             temperature = 0.001,
             nonlinBalance = 100, subFreq = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 20,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             noiseAnchors = -10,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001_r-4.wav'))


# psc level 1
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, 100, 500, 501, 620, 621, 910, 1040),
                                       value = c(200, 410, 405, 480, 480, 405, 400, 200)),
             rolloff = 0, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 100, subFreq = 100, subDep = 70, jitterDep = 1, shimmerDep = 10,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             noiseAnchors = -20,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s = soundgen(sylLen = 1040,
             pitchAnchors = data.frame(time = c(0, 100, 500, 501, 620, 621, 910, 1040),
                                       value = c(200, 410, 405, 610, 600, 405, 400, 200)),
             rolloff = 0, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 100, subFreq = 100, subDep = 80, jitterDep = 1.5, shimmerDep = 20,
             formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                             freq = c(400, 1000, 900, 700), 
                                             width = 300, amp = 16),
                             f2 = data.frame(time = c(0, .1, 1), 
                                             freq = c(1900, 1700, 1600), 
                                             width = 350, amp = 18),
                             f3 = data.frame(freq = 2600, width = 400, amp = 25),
                             f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
             noiseAnchors = -10,
             rolloffNoise = 0,
             samplingRate = 22050, play = T, plot = T, osc = T, ylim = c(0, 5))

s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
