setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'roar_034_ut_anger_33-f-roar-possibly-sad'
fileIdx = '45'

# original (closest to sc level 2)
s = soundgen(sylLen = 500, 
             pitchAnchors = data.frame(time = c(0, .4, 1),
                                       value = c(280, 320, 215)),
             rolloff = -2, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 80, subDep = 0, jitterDep = 2, shimmerDep = 30, shortestEpoch = 100,
             formants = list(f1 = data.frame(freq = 660, width = 250, amp = 15),
                             f2 = data.frame(freq = 1500, width = 250, amp = 20),
                             f3 = data.frame(freq = 2700),
                             f4 = data.frame(freq = 3800)),
             mouthAnchors = c(.3, .5),
             noiseAnchors = data.frame(time = c(0, 400, 550),
                                       value = c(-30, -15, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

# no nonlin
s = soundgen(sylLen = 500, 
             pitchAnchors = data.frame(time = c(0, .4, 1),
                                       value = c(280, 320, 215)),
             rolloff = -2, rolloffOct = 0,
             temperature = 0.001,
             # nonlinBalance = 80, subDep = 0, jitterDep = 2, shimmerDep = 30, shortestEpoch = 100,
             formants = list(f1 = data.frame(freq = 660, width = 250, amp = 15),
                             f2 = data.frame(freq = 1500, width = 250, amp = 20),
                             f3 = data.frame(freq = 2700),
                             f4 = data.frame(freq = 3800)),
             mouthAnchors = c(.3, .5),
             noiseAnchors = data.frame(time = c(0, 400, 550),
                                       value = c(-30, -15, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# subh
s = soundgen(sylLen = 500, 
             pitchAnchors = data.frame(time = c(0, .4, 1),
                                       value = c(280, 320, 215)),
             rolloff = -2, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 30, subFreq = 120, subDep = 70, jitterDep = 0, shimmerDep = 0, shortestEpoch = 100,
             formants = list(f1 = data.frame(freq = 660, width = 250, amp = 15),
                             f2 = data.frame(freq = 1500, width = 250, amp = 20),
                             f3 = data.frame(freq = 2700),
                             f4 = data.frame(freq = 3800)),
             mouthAnchors = c(.3, .5),
             noiseAnchors = data.frame(time = c(0, 400, 550),
                                       value = c(-30, -15, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 500, 
             pitchAnchors = data.frame(time = c(0, .4, 1),
                                       value = c(280, 320, 215)),
             rolloff = -2, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 50, subFreq = 120, subDep = 0, jitterDep = 1, shimmerDep = 10, shortestEpoch = 100,
             formants = list(f1 = data.frame(freq = 660, width = 250, amp = 15),
                             f2 = data.frame(freq = 1500, width = 250, amp = 20),
                             f3 = data.frame(freq = 2700),
                             f4 = data.frame(freq = 3800)),
             mouthAnchors = c(.3, .5),
             noiseAnchors = data.frame(time = c(0, 400, 550),
                                       value = c(-30, -15, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# sc level 1
s = soundgen(sylLen = 500, 
             pitchAnchors = data.frame(time = c(0, .4, 1),
                                       value = c(280, 320, 215)),
             rolloff = -2, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 50, subFreq = 120, subDep = 70, jitterDep = 1, shimmerDep = 10, shortestEpoch = 100,
             formants = list(f1 = data.frame(freq = 660, width = 250, amp = 15),
                             f2 = data.frame(freq = 1500, width = 250, amp = 20),
                             f3 = data.frame(freq = 2700),
                             f4 = data.frame(freq = 3800)),
             mouthAnchors = c(.3, .5),
             noiseAnchors = data.frame(time = c(0, 400, 550),
                                       value = c(-30, -15, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_011.wav'))


# sc level 2
s = soundgen(sylLen = 500, 
             pitchAnchors = data.frame(time = c(0, .4, 1),
                                       value = c(280, 320, 215)),
             rolloff = -2, rolloffOct = 0,
             temperature = 0.001,
             nonlinBalance = 80, subFreq = 120, subDep = 70, jitterDep = 2, shimmerDep = 20, shortestEpoch = 100,
             formants = list(f1 = data.frame(freq = 660, width = 250, amp = 15),
                             f2 = data.frame(freq = 1500, width = 250, amp = 20),
                             f3 = data.frame(freq = 2700),
                             f4 = data.frame(freq = 3800)),
             mouthAnchors = c(.3, .5),
             noiseAnchors = data.frame(time = c(0, 400, 550),
                                       value = c(-30, -15, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022_r00.wav'))


# sc level 2 rolloff +4
s = soundgen(sylLen = 500, 
             pitchAnchors = data.frame(time = c(0, .4, 1),
                                       value = c(280, 320, 215)),
             rolloff = -2 + 4, rolloffOct = 0, invalidArgAction = 'ignore',
             temperature = 0.001,
             nonlinBalance = 80, subFreq = 120, subDep = 70, jitterDep = 2, shimmerDep = 20, shortestEpoch = 100,
             formants = list(f1 = data.frame(freq = 660, width = 250, amp = 15),
                             f2 = data.frame(freq = 1500, width = 250, amp = 20),
                             f3 = data.frame(freq = 2700),
                             f4 = data.frame(freq = 3800)),
             mouthAnchors = c(.3, .5),
             noiseAnchors = data.frame(time = c(0, 400, 550),
                                       value = c(-30, -15, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022_r+4.wav'))


# sc level 2 rolloff -4
s = soundgen(sylLen = 500, 
             pitchAnchors = data.frame(time = c(0, .4, 1),
                                       value = c(280, 320, 215)),
             rolloff = -2 - 4, rolloffOct = 0, invalidArgAction = 'ignore',
             temperature = 0.001,
             nonlinBalance = 80, subFreq = 120, subDep = 70, jitterDep = 2, shimmerDep = 20, shortestEpoch = 100,
             formants = list(f1 = data.frame(freq = 660, width = 250, amp = 15),
                             f2 = data.frame(freq = 1500, width = 250, amp = 20),
                             f3 = data.frame(freq = 2700),
                             f4 = data.frame(freq = 3800)),
             mouthAnchors = c(.3, .5),
             noiseAnchors = data.frame(time = c(0, 400, 550),
                                       value = c(-30, -15, -40)),
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_022_r-4.wav'))
