setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli/nonlin')
filename = 'roar_366_ut_pain_80'
fileIdx = '48'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

# original (closest to subh)
s = soundgen(sylLen = 3000, 
             pitchAnchors = data.frame(time = c(0, 2910, 3000),
                                       value = c(315, 258, 200)),
             rolloff = -5, rolloffOct = 0,
             temperature = 0.001, 
             nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .95, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s = soundgen(sylLen = 1000, 
             pitchAnchors = data.frame(time = c(0, 900, 1000),
                                       value = c(315, 280, 200)),
             rolloff = -5, rolloffOct = 0,
             temperature = 0.001, 
             # nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s = soundgen(sylLen = 1000, 
             pitchAnchors = data.frame(time = c(0, 450, 451, 580, 581, 900, 1000),
                                       value = c(315, 302, 455, 450, 295, 280, 200)),
             rolloff = -5, rolloffOct = 0,
             temperature = 0.001, 
             # nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subh
s = soundgen(sylLen = 1000, 
             pitchAnchors = data.frame(time = c(0, 900, 1000),
                                       value = c(315, 280, 200)),
             rolloff = -5, rolloffOct = 0,
             temperature = 0.001, 
             nonlinBalance = 50, subFreq = 75, subDep = 50, jitterDep = 0, shortestEpoch = 200,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r00.wav'))


# subh rolloff +4
s = soundgen(sylLen = 1000, 
             pitchAnchors = data.frame(time = c(0, 900, 1000),
                                       value = c(315, 280, 200)),
             rolloff = -5 + 4, rolloffOct = 0, invalidArgAction = 'ignore',
             temperature = 0.001, 
             nonlinBalance = 50, subFreq = 75, subDep = 50, jitterDep = 0, shortestEpoch = 200,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r+4.wav'))


# subh rolloff -4
s = soundgen(sylLen = 1000, 
             pitchAnchors = data.frame(time = c(0, 900, 1000),
                                       value = c(315, 280, 200)),
             rolloff = -5 - 4, rolloffOct = 0, invalidArgAction = 'ignore',
             temperature = 0.001, 
             nonlinBalance = 50, subFreq = 75, subDep = 50, jitterDep = 0, shortestEpoch = 200,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010_r-4.wav'))


# chaos
s = soundgen(sylLen = 1000, 
             pitchAnchors = data.frame(time = c(0, 900, 1000),
                                       value = c(315, 280, 200)),
             rolloff = -5, rolloffOct = 0,
             temperature = 0.001, 
             nonlinBalance = 70, subDep = 0, subFreq = 75, jitterDep = 3,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s = soundgen(sylLen = 1000, 
             pitchAnchors = data.frame(time = c(0, 450, 451, 580, 581, 900, 1000),
                                       value = c(315, 302, 455, 450, 295, 280, 200)),
             rolloff = -5, rolloffOct = 0,
             temperature = 0.001, 
             nonlinBalance = 60, subFreq = 75, subDep = 40, jitterDep = 1,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s = soundgen(sylLen = 1000, 
             pitchAnchors = data.frame(time = c(0, 450, 451, 580, 581, 900, 1000),
                                       value = c(315, 302, 605, 600, 295, 280, 200)),
             rolloff = -5, rolloffOct = 0,
             temperature = 0.001, 
             nonlinBalance = 70, subFreq = 75, subDep = 50, jitterDep = 3,
             formants = c(700, 1150, 2700, 3900),
             mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
