setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'scream_210_ut_fear_26'
fileIdx = '53'

# original (closest to psc level 1)
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 110, 111, 180, 350, 940, 941, 1100, 1200),
               value = c(700, 1150, 1550, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
             rolloff = 0, rolloffKHz = 0, 
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)


# no nonlin
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 180, 350, 880, 980, 1100, 1200),
               value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             # nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
             rolloff = 0, rolloffKHz = 0, 
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 110, 111, 180, 350, 940, 941, 1100, 1200),
               value = c(700, 1150, 1550, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             # nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
             rolloff = 0, rolloffKHz = 0, 
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subh
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 180, 350, 880, 980, 1100, 1200),
               value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = 0, shimmerDep = 0,
             rolloff = 0, rolloffKHz = 0, 
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 180, 350, 880, 980, 1100, 1200),
               value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             nonlinBalance = 85, subFreq = 850, subDep = 0, jitterDep = .7, shimmerDep = 10,
             rolloff = 0, rolloffKHz = 0, 
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)

playme(s, 22050)
spectrogram(s, 22050, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 110, 111, 180, 350, 940, 941, 1100, 1200),
               value = c(700, 1150, 1550, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
             rolloff = 0, rolloffKHz = 0, 
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r00.wav'))


# psc level 1 rolloff +8
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 110, 111, 180, 350, 940, 941, 1100, 1200),
               value = c(700, 1150, 1550, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
             rolloff = 0 + 8, rolloffKHz = 0, invalidArgAction = 'ignore',
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r+8.wav'))


# psc level 1 rolloff -8
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 110, 111, 180, 350, 940, 941, 1100, 1200),
               value = c(700, 1150, 1550, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
             rolloff = 0 - 8, rolloffKHz = 0, invalidArgAction = 'ignore',
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r-8.wav'))


# psc level 2
s = soundgen(sylLen = 1200, 
             pitchAnchors = list(
               time = c(0, 110, 111, 180, 350, 940, 941, 1100, 1200),
               value = c(700, 1150, 1550, 2000, 2240, 1940, 1180, 900, 500)),
             amplAnchors = data.frame(time = c(0, .8, 1),
                                      value = c(80, 80, 60)),
             temperature = 0.001,
             nonlinBalance = 95, subFreq = 850, subDep = 550, jitterDep = 2, shimmerDep = 20,
             rolloff = 0, rolloffKHz = 0, 
             formants = c(1150, 1700, 3600, 4500, 6000),
             mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
             pitchSamplingRate = 16000,
             samplingRate = 22050, play = T, plot = T, osc = T)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
