setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'scream_213_ut_fear_29-f-scream'
fileIdx = '54'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original - only the second syllable (closest to psc level 2)
s1 = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 50, 520, 521, 920, 980),
    value = c(1000, 1900, 1860, 1720, 1550, 1100)),
  temperature = 0.001, 
  nonlinBalance = 100, subDep = 70, jitterDep = .2,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

s2 = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 80, 81, 230, 231, 385, seq(385, 850, length.out = 500), 851, 1020, 1021, 1085),
    value = c(700, 1130, 1000, 1200, 1860, 1840, sample(c(1200, 1800), size = 500, replace = T), 1620, 1540, 1220, 900)
  ),
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = .3,
  rolloff = 0, rolloffKHz = 0,  
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

s = addVectors(s1, s2, insertionPoint = length(s1) + 22050 * .280)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 385, 851, 1085, 1200),
    value = c(700, 1840, 1620, 1220, 900)
  ),
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 70, jitterDep = .2,
  rolloff = 0, rolloffKHz = 0,  
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 80, 81, 230, 231, 385, 851, 1020, 1021, 1085),
    value = c(700, 1130, 1000, 1200, 1860, 1840, 1620, 1540, 1220, 900)
  ),
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 70, jitterDep = .2,
  rolloff = 0, rolloffKHz = 0,  
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subh
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 385, 851, 1085, 1200),
    value = c(700, 1840, 1620, 1220, 900)
  ),
  temperature = 0.001,
  nonlinBalance = 30, subFreq = 300, subDep = 150, jitterDep = 0, shortestEpoch = 200,
  rolloff = 0, rolloffKHz = 0,  
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 385, 851, 1085, 1200),
    value = c(700, 1840, 1620, 1220, 900)
  ),
  temperature = 0.001,
  nonlinBalance = 60, subDep = 0, jitterDep = 1, shortestEpoch = 200,
  rolloff = 0, rolloffKHz = 0,  
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 80, 81, 230, 231, 385, 851, 1020, 1021, 1085),
    value = c(700, 1130, 1000, 1200, 1860, 1840, 1620, 1540, 1220, 900)
  ),
  temperature = 0.001,
  nonlinBalance = 60, subFreq = 300, subDep = 150, jitterDep = 1, shortestEpoch = 200,
  rolloff = 0, rolloffKHz = 0,  
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 80, 81, 230, 231, 385, 851, 1020, 1021, 1085),
    value = c(700, 1130, 1000, 1200, 1860, 1840, 1620, 1540, 1220, 900)
  ),
  temperature = 0.001,
  nonlinBalance = 80, subFreq = 300, subDep = 180, jitterDep = 2, shortestEpoch = 200,
  rolloff = 0, rolloffKHz = 0,  
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))


# psc level 2 rolloff +4
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 80, 81, 230, 231, 385, 851, 1020, 1021, 1085),
    value = c(700, 1130, 1000, 1200, 1860, 1840, 1620, 1540, 1220, 900)
  ),
  temperature = 0.001,
  nonlinBalance = 80, subFreq = 300, subDep = 180, jitterDep = 2, shortestEpoch = 200,
  rolloff = 0 + 4, rolloffKHz = 0, invalidArgAction = 'ignore',
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222_r+4.wav'))


# psc level 2 rolloff -4
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 80, 81, 230, 231, 385, 851, 1020, 1021, 1085),
    value = c(700, 1130, 1000, 1200, 1860, 1840, 1620, 1540, 1220, 900)
  ),
  temperature = 0.001,
  nonlinBalance = 80, subFreq = 300, subDep = 180, jitterDep = 2, shortestEpoch = 200,
  rolloff = 0 - 4, rolloffKHz = 0, invalidArgAction = 'ignore',
  formants = c(900, 1300, 3300, 4300),
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222_r-4.wav'))
