setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'scream_322_ut_pain_12'
fileIdx = '57'

# original (closest to psc level 1)
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 90, 91, 360, 590, 680),
                value = c(1000, 1120, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10),
              temperature = 0.001,
              nonlinBalance = 80, shortestEpoch = 100, subDep = 0, jitterDep = 1,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s2 = soundgen(sylLen = 55, 
              pitchAnchors = c(620, 600),
              rolloff = -30,
              temperature = 0.001,
              formants = NULL, vocalTract = 13, addSilence = 0,
              samplingRate = 22050, play = T, plot = F, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 150, 360, 590, 680),
                value = c(1000, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10),
              temperature = 0.001,
              # nonlinBalance = 80, shortestEpoch = 100, subDep = 0, jitterDep = 1,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 90, 91, 360, 590, 680),
                value = c(1000, 1120, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10),
              temperature = 0.001,
              # nonlinBalance = 80, shortestEpoch = 100, subDep = 0, jitterDep = 1,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subh
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 150, 360, 590, 680),
                value = c(1000, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10),
              temperature = 0.001,
              nonlinBalance = 30, shortestEpoch = 100, subFreq = 300, subDep = 170, jitterDep = 0,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 150, 360, 590, 680),
                value = c(1000, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10),
              temperature = 0.001,
              nonlinBalance = 60, shortestEpoch = 100, subFreq = 300, subDep = 0, jitterDep = 1,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))


# psc level 1
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 90, 91, 360, 590, 680),
                value = c(1000, 1120, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10),
              temperature = 0.001,
              nonlinBalance = 60, shortestEpoch = 100, subFreq = 300, subDep = 170, jitterDep = 1,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r00.wav'))


# psc level 1 rolloff +10
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 90, 91, 360, 590, 680),
                value = c(1000, 1120, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10) + 10, invalidArgAction = 'ignore',
              temperature = 0.001,
              nonlinBalance = 60, shortestEpoch = 100, subFreq = 300, subDep = 170, jitterDep = 1,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r+10.wav'))


# psc level 1 rolloff -10
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 90, 91, 360, 590, 680),
                value = c(1000, 1120, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10) - 10, invalidArgAction = 'ignore',
              temperature = 0.001,
              nonlinBalance = 60, shortestEpoch = 100, subFreq = 300, subDep = 170, jitterDep = 1,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111_r-10.wav'))


# psc level 2
s1 = soundgen(sylLen = 680, 
              pitchAnchors = list(
                time = c(0, 90, 91, 360, 590, 680),
                value = c(1000, 1120, 1900, 2300, 2040, 1240)),
              rolloff = c(-10, -5, -5, -10),
              temperature = 0.001,
              nonlinBalance = 90, shortestEpoch = 100, subFreq = 300, subDep = 220, jitterDep = 2,
              formants = c(900, 2100, 3500, 4500), 
              mouthAnchors = c(.4, .6, .4),
              addSilence = 0,
              samplingRate = 22050, play = T, plot = T, osc = T)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) + 22050 * .04)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222.wav'))
