setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_ac-cor-em/stimuli')
filename = 'scream_332_ut_pain_31-birth-2-scream'
fileIdx = '58'
# nonlin codes: psc for "pitch jumps", "subharmonics", "chaos", eg 000 = nothing, 010 = only subh, etc

## original (closest to psc level 2)
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 161, 450, 451, 630, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 75, subFreq = 200, subDep = 120, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 450, 630, 645, 770),
    value = c(1400, 2000, 1890, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 0, subFreq = 200, subDep = 120, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_000.wav'))


# pitch jump
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 161, 450, 451, 630, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 0, subFreq = 200, subDep = 120, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_100.wav'))


# subh
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 450, 630, 645, 770),
    value = c(1400, 2000, 1890, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 30, subFreq = 200, subDep = 90, jitterDep = 0, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_010.wav'))


# chaos
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 450, 630, 645, 770),
    value = c(1400, 2000, 1890, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 60, subFreq = 200, subDep = 0, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_001.wav'))



# psc level 1
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 161, 450, 451, 630, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 50, subFreq = 200, subDep = 90, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_111.wav'))


# psc level 2
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 161, 450, 451, 630, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 100, subFreq = 200, subDep = 120, jitterDep = 1.5, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222_r00.wav'))


# psc level 2 rolloff +6
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 161, 450, 451, 630, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10) + 6, rolloffKHz = 0, invalidArgAction = 'ignore',
  temperature = 0.001,
  nonlinBalance = 100, subFreq = 200, subDep = 120, jitterDep = 1.5, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222_r+6.wav'))


# psc level 2 rolloff -6
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 161, 450, 451, 630, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10) - 6, rolloffKHz = 0, invalidArgAction = 'ignore',
  temperature = 0.001,
  nonlinBalance = 100, subFreq = 200, subDep = 120, jitterDep = 1.5, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  samplingRate = 22050, play = T, plot = T, osc = T
)

playme(s, 22050)
spectrogram(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(fileIdx, '_222_r-6.wav'))
