setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_117'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 1), priorMean = 100, priorSD = 10, domThres = .01, domSmooth = 50, pitchMethods = c('dom', 'autocor'), windowLength = 100, minVoicedCands = 1)
# a$pitch

# original (closest to 000)
s = soundgen(
  sylLen = 520,
  pitchAnchors = data.frame(
    time = c(0, 70, 155, 225, 520), 
    value = c(130, 137, 160, 120, 80)
  ),
  amplAnchors = c(75, 80, 70, 50),
  rolloff = c(-15, -11, -17),
  temperature = 0.001,
  formants = c(700, 1100, 2850, 3550, 4600),
  formantsNoise = c(650, 950, 1150, 2750, 3100, 3560, 4600, 6000),
  noiseAnchors = data.frame(
    time = c(0, 450, 600),
    value = c(-40, -30, -50)
  ),
  mouthAnchors = data.frame(time = c(0, 200, 535), value = c(.35, .5, .6)),
  rolloffNoise = c(-8, -2),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

playme(s, 22050)
seewave::meanspec(s, f = 22050, dB = 'max0', alim = c(-80, 0))

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))

## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 520,
  pitchAnchors = data.frame(
    time = c(0, 70, 155, 225, 520), 
    value = c(130, 137, 160, 120, 80)
  ),
  amplAnchors = c(75, 80, 70, 50),
  rolloff = c(-15, -11, -17) + 6,
  temperature = 0.001,
  formants = c(700, 1100, 2850, 3550, 4600),
  formantsNoise = c(650, 950, 1150, 2750, 3100, 3560, 4600, 6000),
  noiseAnchors = data.frame(
    time = c(0, 450, 600),
    value = c(-40, -30, -50)
  ),
  mouthAnchors = data.frame(time = c(0, 200, 535), value = c(.35, .5, .6)),
  rolloffNoise = c(-8, -2),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 520,
  pitchAnchors = data.frame(
    time = c(0, 70, 155, 225, 520), 
    value = c(130, 137, 160, 120, 80)
  ),
  amplAnchors = c(75, 80, 70, 50),
  rolloff = c(-15, -11, -17) - 6,
  temperature = 0.001,
  formants = c(700, 1100, 2850, 3550, 4600),
  formantsNoise = c(650, 950, 1150, 2750, 3100, 3560, 4600, 6000),
  noiseAnchors = data.frame(
    time = c(0, 450, 600),
    value = c(-40, -30, -50)
  ),
  mouthAnchors = data.frame(time = c(0, 200, 535), value = c(.35, .5, .6)),
  rolloffNoise = c(-8, -2),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
# subh 150 ms, freq 70, depth .17
pitchMedian = 130
subFreq = 70
subDep = 45
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)  # ~0.17 (variable pitch, so it's an approximation)

s = soundgen(
  sylLen = 520,
  pitchAnchors = data.frame(
    time = c(0, 70, 155, 225, 520), 
    value = c(130, 137, 160, 120, 80)
  ),
  amplAnchors = c(75, 80, 70, 50),
  rolloff = c(-15, -11, -17),
  nonlinRandomWalk = c(rep(0, 20), rep(1, 30), rep(0, 50)), 
  subFreq = 70, subDep = 45, jitterDep = 0,
  temperature = 0.001,
  formants = c(650, 1100, 2850, 3550, 4600),
  formantsNoise = c(650, 950, 1150, 2750, 3100, 3560, 4600, 6000),
  noiseAnchors = data.frame(
    time = c(0, 450, 600),
    value = c(-40, -30, -50)
  ),
  mouthAnchors = data.frame(time = c(0, 200, 535), value = c(.35, .5, .6)),
  rolloffNoise = c(-8, -2),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_150_70_35.wav'))


## CHAOS
s = soundgen(
  sylLen = 520,
  pitchAnchors = data.frame(
    time = c(0, 70, 155, 225, 520), 
    value = c(130, 137, 160, 120, 80)
  ),
  amplAnchors = c(75, 80, 70, 50),
  rolloff = c(-15, -11, -17),
  nonlinRandomWalk =  c(rep(0, 20), rep(2, 30), rep(0, 50)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = c(650, 1100, 2850, 3550, 4600),
  formantsNoise = c(650, 950, 1150, 2750, 3100, 3560, 4600, 6000),
  noiseAnchors = data.frame(
    time = c(0, 450, 600),
    value = c(-40, -30, -50)
  ),
  mouthAnchors = data.frame(time = c(0, 200, 535), value = c(.35, .5, .6)),
  rolloffNoise = c(-8, -2),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_150.wav'))
