setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_160'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4))
# a$pitch

# original (closest to 000)
s = soundgen(
  sylLen = 230,
  pitchAnchors = c(305, 280),
  amplAnchors = c(70, 80, 50),
  rolloff = -30, 
  temperature = 0.001,
  formants = c(260, 960, 1500, 2200, 2600, 3600, 4200, 4500),
  noiseAnchors = data.frame(
    time = c(-50, 120, 700),
    value = c(-25, -15, -60)
  ),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

playme(s, 22050)
seewave::meanspec(s, f = 22050, dB = 'max0', alim = c(-80, 0))

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))

## ROLLOFF
# no nonlin rolloff +15
s = soundgen(
  sylLen = 230,
  pitchAnchors = c(305, 280),
  amplAnchors = c(70, 80, 50),
  rolloff = -30 + 15, 
  temperature = 0.001,
  formants = c(260, 960, 1500, 2200, 2600, 3600, 4200, 4500),
  noiseAnchors = data.frame(
    time = c(-50, 120, 700),
    value = c(-25, -15, -60)
  ),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+15.wav'))

# no nonlin rolloff -15
s = soundgen(
  sylLen = 230,
  pitchAnchors = c(305, 280),
  amplAnchors = c(70, 80, 50),
  rolloff = -30 - 15, invalidArgAction = 'ignore', 
  temperature = 0.001,
  formants = c(260, 960, 1500, 2200, 2600, 3600, 4200, 4500),
  noiseAnchors = data.frame(
    time = c(-50, 120, 700),
    value = c(-25, -15, -60)
  ),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-15.wav'))


## SUBHARMONICS
pitchMedian = 290
subFreq = 140
subDep = 90
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 230,
  pitchAnchors = c(305, 280),
  amplAnchors = c(70, 80, 50),
  rolloff = -30, 
  nonlinBalance = 100, subFreq = 140, subDep = 90, jitterDep = 0,
  temperature = 0.001,
  formants = c(260, 960, 1500, 2200, 2600, 3600, 4200, 4500),
  noiseAnchors = data.frame(
    time = c(-50, 120, 700),
    value = c(-25, -15, -60)
  ),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_230_140_27.wav'))

# subh2
pitchMedian = 290
subFreq = 80
subDep = 45
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 230,
  pitchAnchors = c(305, 280),
  amplAnchors = c(70, 80, 50),
  rolloff = -30, 
  nonlinBalance = 100, subFreq = 80, subDep = 45, jitterDep = 0,
  temperature = 0.001,
  formants = c(260, 960, 1500, 2200, 2600, 3600, 4200, 4500),
  noiseAnchors = data.frame(
    time = c(-50, 120, 700),
    value = c(-25, -15, -60)
  ),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_230_80_27.wav'))


## CHAOS
s = soundgen(
  sylLen = 230,
  pitchAnchors = c(305, 280),
  amplAnchors = c(70, 80, 50),
  rolloff = -30, 
  nonlinBalance = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 1.5,
  temperature = 0.001,
  formants = c(260, 960, 1500, 2200, 2600, 3600, 4200, 4500),
  noiseAnchors = data.frame(
    time = c(-50, 120, 700),
    value = c(-25, -15, -60)
  ),
  rolloffNoise = 0,
  addSilence = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_230.wav'))

