setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_176'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4))
# a$pitch
# a$dom 

# original (closest to 000)
s = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 100, 430), value = c(225, 240, 140)),
  rolloff = c(-11, -17), 
  temperature = 0.001,
  formants = c(750, 1100, 2200, 3500, 4700, 5600),
  formantsNoise = c(750, 1200, 2200, 3500, 4700, 5600, 
                    6500, 7200, 8900, 10000, 11000, 12000),
  noiseAnchors = data.frame(
    time = c(0, 350, 550),
    value = c(-35, -15, -40)
  ),
  mouthAnchors = data.frame(
    time = c(0, 100, 550),
    value = c(.4, .6, .5)
  ),
  rolloffNoise = 0, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

playme(s, 22050)
seewave::meanspec(s, f = 22050, dB = 'max0', alim = c(-80, 0), flim = c(0, 8))

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))

## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 100, 430), value = c(225, 240, 140)),
  rolloff = c(-11, -17) + 6, 
  temperature = 0.001,
  formants = c(750, 1100, 2200, 3500, 4700, 5600),
  formantsNoise = c(750, 1200, 2200, 3500, 4700, 5600, 
                    6500, 7200, 8900, 10000, 11000, 12000),
  noiseAnchors = data.frame(
    time = c(0, 350, 550),
    value = c(-35, -15, -40)
  ),
  mouthAnchors = data.frame(
    time = c(0, 100, 550),
    value = c(.4, .6, .5)
  ),
  rolloffNoise = 0, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff +8
s = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 100, 430), value = c(225, 240, 140)),
  rolloff = c(-11, -17) - 6, 
  temperature = 0.001,
  formants = c(750, 1100, 2200, 3500, 4700, 5600),
  formantsNoise = c(750, 1200, 2200, 3500, 4700, 5600, 
                    6500, 7200, 8900, 10000, 11000, 12000),
  noiseAnchors = data.frame(
    time = c(0, 350, 550),
    value = c(-35, -15, -40)
  ),
  mouthAnchors = data.frame(
    time = c(0, 100, 550),
    value = c(.4, .6, .5)
  ),
  rolloffNoise = 0, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 200
subFreq = 80
subDep = 55
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 100, 430), value = c(225, 240, 140)),
  rolloff = c(-11, -17), 
  nonlinRandomWalk = c(rep(0, 20), rep(1, 30), rep(0, 50)), 
  subFreq = 80, subDep = 55, jitterDep = 0,
  temperature = 0.001,
  formants = c(750, 1100, 2200, 3500, 4700, 5600),
  formantsNoise = c(750, 1200, 2200, 3500, 4700, 5600, 
                    6500, 7200, 8900, 10000, 11000, 12000),
  noiseAnchors = data.frame(
    time = c(0, 350, 550),
    value = c(-35, -15, -40)
  ),
  mouthAnchors = data.frame(
    time = c(0, 100, 550),
    value = c(.4, .6, .5)
  ),
  rolloffNoise = 0, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_130_80_19.wav'))


## CHAOS
s = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 100, 430), value = c(225, 240, 140)),
  rolloff = c(-11, -17), 
  nonlinRandomWalk = c(rep(0, 20), rep(2, 30), rep(0, 50)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 1.5, 
  temperature = 0.001,
  formants = c(750, 1100, 2200, 3500, 4700, 5600),
  formantsNoise = c(750, 1200, 2200, 3500, 4700, 5600, 
                    6500, 7200, 8900, 10000, 11000, 12000),
  noiseAnchors = data.frame(
    time = c(0, 350, 550),
    value = c(-35, -15, -40)
  ),
  mouthAnchors = data.frame(
    time = c(0, 100, 550),
    value = c(.4, .6, .5)
  ),
  rolloffNoise = 0, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001.wav'))
