setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_192'

# original (closest to 000)
s = soundgen(
  sylLen = 990,
  pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
  amplAnchors = c(80, 80, 75),
  rolloff = -15,
  temperature = 0.001,
  formants = c(1000, 1400, 3100, 4200),
  mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
  noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
  rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))

## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 990,
  pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
  amplAnchors = c(80, 80, 75),
  rolloff = -15 + 8,
  temperature = 0.001,
  formants = c(1000, 1400, 3100, 4200),
  mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
  noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
  rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))


# no nonlin rolloff -8
s = soundgen(
  sylLen = 990,
  pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
  amplAnchors = c(80, 80, 75),
  rolloff = -15 - 8,
  temperature = 0.001,
  formants = c(1000, 1400, 3100, 4200),
  mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
  noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
  rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
pitchMedian = 400
subFreq = 150
subDep = 115
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 990,
  pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
  amplAnchors = c(80, 80, 75),
  rolloff = -15 - 8,
  nonlinRandomWalk = c(rep(0, 10), rep(1, 20), rep(0, 70)), 
  subFreq = 150, subDep = 115, jitterDep = 0,
  temperature = 0.001,
  formants = c(1000, 1400, 3100, 4200),
  mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
  noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
  rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_200_150_50.wav'))

# subh2
pitchMedian = 400
subFreq = 80
subDep = 68
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 990,
  pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
  amplAnchors = c(80, 80, 75),
  rolloff = -15 - 8,
  nonlinRandomWalk = c(rep(0, 10), rep(1, 20), rep(0, 70)), 
  subFreq = 80, subDep = 68, jitterDep = 0,
  temperature = 0.001,
  formants = c(1000, 1400, 3100, 4200),
  mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
  noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
  rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_200_80_50.wav'))


## CHAOS
s = soundgen(
  sylLen = 990,
  pitchAnchors = data.frame(time = c(0, .2, 1), value = c(280, 460, 340)),
  amplAnchors = c(80, 80, 75),
  rolloff = -15 - 8,
  nonlinRandomWalk = c(rep(0, 10), rep(2, 20), rep(0, 70)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = c(1000, 1400, 3100, 4200),
  mouthAnchors = data.frame(time = c(0, .2, 1), value = c(.4, .6, .5)),
  noiseAnchors = data.frame(time = c(-100, 300, 900, 1100), value = c(-15, -25, -25, -40)),
  rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_200.wav'))
