setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_193'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch
# a$pitchAutocor 

# original
s = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 230, 420), 
                            value = c(410, 600, 470)),
  amplAnchors = c(80, 60),
  rolloff = -17,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 10,
  formants = list(f1 = 1100, 
                  f2 = data.frame(time = c(0, 100, 420), freq = c(2700, 1800, 1700)), 
                  f3 = 3200, f4 = 4300),
  mouthAnchors = data.frame(time = c(0, 230, 420), value = c(.4, .5, .5)),
  noiseAnchors = data.frame(time = c(0, 230, 420, 500), value = c(-25, -15, -35, -45)),
  rolloffNoise = -6,
  attackLen = 10, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

# no nonlin
s = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 230, 420), value = c(410, 600, 470)),
  amplAnchors = c(80, 60),
  rolloff = -17,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 10,
  formants = list(f1 = 1100, 
                  f2 = data.frame(time = c(0, 100, 420), freq = c(2700, 1800, 1700)), 
                  f3 = 3200, f4 = 4300),
  mouthAnchors = data.frame(time = c(0, 230, 420), value = c(.4, .5, .5)),
  noiseAnchors = data.frame(time = c(0, 230, 420, 500), value = c(-25, -15, -35, -45)),
  rolloffNoise = -6,
  attackLen = 10, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 230, 420), value = c(410, 600, 470)),
  amplAnchors = c(80, 60),
  rolloff = -17 + 8,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 10,
  formants = list(f1 = 1100, 
                  f2 = data.frame(time = c(0, 100, 420), freq = c(2700, 1800, 1700)), 
                  f3 = 3200, f4 = 4300),
  mouthAnchors = data.frame(time = c(0, 230, 420), value = c(.4, .5, .5)),
  noiseAnchors = data.frame(time = c(0, 230, 420, 500), value = c(-25, -15, -35, -45)),
  rolloffNoise = -6,
  attackLen = 10, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))


# no nonlin rolloff -8
s = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 230, 420), value = c(410, 600, 470)),
  amplAnchors = c(80, 60),
  rolloff = -17 - 8,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 10,
  formants = list(f1 = 1100, 
                  f2 = data.frame(time = c(0, 100, 420), freq = c(2700, 1800, 1700)), 
                  f3 = 3200, f4 = 4300),
  mouthAnchors = data.frame(time = c(0, 230, 420), value = c(.4, .5, .5)),
  noiseAnchors = data.frame(time = c(0, 230, 420, 500), value = c(-25, -15, -35, -45)),
  rolloffNoise = -6,
  attackLen = 10,   
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
pitchMedian = 500
subFreq = 200
subDep = 195
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 230, 420), value = c(410, 600, 470)),
  amplAnchors = c(80, 60),
  rolloff = -17,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 50), rep(0, 30)), 
  subFreq = 200, subDep = 195, jitterDep = 0,
  formants = list(f1 = 1100, 
                  f2 = data.frame(time = c(0, 100, 420), freq = c(2700, 1800, 1700)), 
                  f3 = 3200, f4 = 4300),
  mouthAnchors = data.frame(time = c(0, 230, 420), value = c(.4, .5, .5)),
  noiseAnchors = data.frame(time = c(0, 230, 420, 500), value = c(-25, -15, -35, -45)),
  rolloffNoise = -6,
  attackLen = 10, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_210_200_44.wav'))

# subh2
pitchMedian = 500
subFreq = 80
subDep = 65
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 230, 420), value = c(410, 600, 470)),
  amplAnchors = c(80, 60),
  rolloff = -17,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 50), rep(0, 30)), 
  subFreq = 80, subDep = 65, jitterDep = 0,
  formants = list(f1 = 1100, 
                  f2 = data.frame(time = c(0, 100, 420), freq = c(2700, 1800, 1700)), 
                  f3 = 3200, f4 = 4300),
  mouthAnchors = data.frame(time = c(0, 230, 420), value = c(.4, .5, .5)),
  noiseAnchors = data.frame(time = c(0, 230, 420, 500), value = c(-25, -15, -35, -45)),
  rolloffNoise = -6,
  attackLen = 10, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_210_80_44.wav'))


## CHAOS
s = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 230, 420), value = c(410, 600, 470)),
  amplAnchors = c(80, 60),
  rolloff = -17,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(2, 50), rep(0, 30)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = list(f1 = 1100, 
                  f2 = data.frame(time = c(0, 100, 420), freq = c(2700, 1800, 1700)), 
                  f3 = 3200, f4 = 4300),
  mouthAnchors = data.frame(time = c(0, 230, 420), value = c(.4, .5, .5)),
  noiseAnchors = data.frame(time = c(0, 230, 420, 500), value = c(-25, -15, -35, -45)),
  rolloffNoise = -6,
  attackLen = 10, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_210.wav'))
