setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_404'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 250,
  pitchAnchors = data.frame(time = c(0, 50, 250), 
                            value = c(600, 650, 620)),
  amplAnchors = c(80, 50),
  rolloff = -17,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 10,
  formants = list(f1 = 1000, f2 = c(1800, 1400),
                  f3 = 3400, f4 = 4600, f5 = 5300), 
  mouthAnchors = data.frame(time = c(0, 100, 500), 
                            value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(50, 100, 500), 
                            value = c(-25, -15, -45)),
  rolloffNoise = -6,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

# no nonlin
s = soundgen(
  sylLen = 250,
  pitchAnchors = data.frame(time = c(0, 50, 250), 
                            value = c(600, 650, 620)),
  amplAnchors = c(80, 50),
  rolloff = -17,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 10,
  formants = list(f1 = 1000, f2 = c(1800, 1400),
                  f3 = 3400, f4 = 4600, f5 = 5300), 
  mouthAnchors = data.frame(time = c(0, 100, 500), 
                            value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(50, 100, 500), 
                            value = c(-25, -15, -45)),
  rolloffNoise = -6,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 250,
  pitchAnchors = data.frame(time = c(0, 50, 250), 
                            value = c(600, 650, 620)),
  amplAnchors = c(80, 50),
  rolloff = -17 + 6,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 10,
  formants = list(f1 = 1000, f2 = c(1800, 1400),
                  f3 = 3400, f4 = 4600, f5 = 5300), 
  mouthAnchors = data.frame(time = c(0, 100, 500), 
                            value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(50, 100, 500), 
                            value = c(-25, -15, -45)),
  rolloffNoise = -6,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))


# no nonlin rolloff -6
s = soundgen(
  sylLen = 250,
  pitchAnchors = data.frame(time = c(0, 50, 250), 
                            value = c(600, 650, 620)),
  amplAnchors = c(80, 50),
  rolloff = -17 - 6,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 10,
  formants = list(f1 = 1000, f2 = c(1800, 1400),
                  f3 = 3400, f4 = 4600, f5 = 5300), 
  mouthAnchors = data.frame(time = c(0, 100, 500), 
                            value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(50, 100, 500), 
                            value = c(-25, -15, -45)),
  rolloffNoise = -6,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
rw = c(rep(0, 20), rep(1, 40), rep(0, 40))

pitchMedian = 600
subFreq = 140
subDep = 90
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 250,
  pitchAnchors = data.frame(time = c(0, 50, 250), 
                            value = c(600, 650, 620)),
  amplAnchors = c(80, 50),
  rolloff = -17,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)), 
  subFreq = 140, subDep = 90, jitterDep = 0, shortestEpoch = 50,
  formants = list(f1 = 1000, f2 = c(1800, 1400),
                  f3 = 3400, f4 = 4600, f5 = 5300), 
  mouthAnchors = data.frame(time = c(0, 100, 500), 
                            value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(50, 100, 500), 
                            value = c(-25, -15, -45)),
  rolloffNoise = -6,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_100_140_38.wav'))

# subh2
pitchMedian = 600
subFreq = 300
subDep = 180
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 250,
  pitchAnchors = data.frame(time = c(0, 50, 250), 
                            value = c(600, 650, 620)),
  amplAnchors = c(80, 50),
  rolloff = -17,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)), 
  subFreq = 300, subDep = 180, jitterDep = 0,
  formants = list(f1 = 1000, f2 = c(1800, 1400),
                  f3 = 3400, f4 = 4600, f5 = 5300), 
  mouthAnchors = data.frame(time = c(0, 100, 500), 
                            value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(50, 100, 500), 
                            value = c(-25, -15, -45)),
  rolloffNoise = -6,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_100_300_38.wav'))


## CHAOS
rw = c(rep(0, 20), rep(2, 40), rep(0, 40))

s = soundgen(
  sylLen = 250,
  pitchAnchors = data.frame(time = c(0, 50, 250), 
                            value = c(600, 650, 620)),
  amplAnchors = c(80, 50),
  rolloff = -17,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(2, 40), rep(0, 40)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = list(f1 = 1000, f2 = c(1800, 1400),
                  f3 = 3400, f4 = 4600, f5 = 5300), 
  mouthAnchors = data.frame(time = c(0, 100, 500), 
                            value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(50, 100, 500), 
                            value = c(-25, -15, -45)),
  rolloffNoise = -6,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_100.wav'))
