setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_426'

## original (closest to 000)
s = soundgen(
  sylLen = 650,
  pitchAnchors = data.frame(time = c(0, .4, 1), 
                            value = c(520, 510, 350)),
  nonlinBalance = 100, subDep = 0, jitterDep = 0.1, shimmerDep = 15,
  rolloff = -15,
  temperature = 0.001,
  formants = c(800, 1500, 2900),
  noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), 
                            value = c(-30, -10, -10, -50)),
  rolloffNoise = 0,
  mouthAnchors = c(0, .5, .5, .5, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))

## ROLLOFF
# no nonlin effects rolloff +8
s = soundgen(
  sylLen = 650,
  pitchAnchors = data.frame(time = c(0, .4, 1), 
                            value = c(520, 510, 350)),
  nonlinBalance = 100, subDep = 0, jitterDep = 0.1, shimmerDep = 15,
  rolloff = -15 + 8,
  temperature = 0.001,
  formants = c(800, 1500, 2900),
  noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), 
                            value = c(-30, -10, -10, -50)),
  rolloffNoise = 0,
  mouthAnchors = c(0, .5, .5, .5, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))


# no nonlin effects rolloff -8
s = soundgen(
  sylLen = 650,
  pitchAnchors = data.frame(time = c(0, .4, 1), 
                            value = c(520, 510, 350)),
  nonlinBalance = 100, subDep = 0, jitterDep = 0.1, shimmerDep = 15,
  rolloff = -15 - 8,
  temperature = 0.001,
  formants = c(800, 1500, 2900),
  noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), 
                            value = c(-30, -10, -10, -50)),
  rolloffNoise = 0,
  mouthAnchors = c(0, .5, .5, .5, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
pitchMedian = 500
subFreq = 90
subDep = 70
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 650,
  pitchAnchors = data.frame(time = c(0, .4, 1), 
                            value = c(520, 510, 350)),
  nonlinRandomWalk = c(rep(0, 10), rep(1, 30), rep(0, 60)), 
  subFreq = 90, subDep = 70, jitterDep = 0,
  rolloff = -15 - 8,
  temperature = 0.001,
  formants = c(800, 1500, 2900),
  noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), 
                            value = c(-30, -10, -10, -50)),
  rolloffNoise = 0,
  mouthAnchors = c(0, .5, .5, .5, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_200_90_40.wav'))

# subh2
pitchMedian = 500
subFreq = 160
subDep = 124
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 650,
  pitchAnchors = data.frame(time = c(0, .4, 1), 
                            value = c(520, 510, 350)),
  nonlinRandomWalk = c(rep(0, 10), rep(1, 30), rep(0, 60)), 
  subFreq = 160, subDep = 124, jitterDep = 0,
  rolloff = -15 - 8,
  temperature = 0.001,
  formants = c(800, 1500, 2900),
  noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), 
                            value = c(-30, -10, -10, -50)),
  rolloffNoise = 0,
  mouthAnchors = c(0, .5, .5, .5, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_200_160_40.wav'))

## CHAOS
s = soundgen(
  sylLen = 650,
  pitchAnchors = data.frame(time = c(0, .4, 1), 
                            value = c(520, 510, 350)),
  nonlinRandomWalk = c(rep(0, 10), rep(2, 30), rep(0, 60)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  rolloff = -15 - 8,
  temperature = 0.001,
  formants = c(800, 1500, 2900),
  noiseAnchors = data.frame(time = c(-215, 200, 300, 1000), 
                            value = c(-30, -10, -10, -50)),
  rolloffNoise = 0,
  mouthAnchors = c(0, .5, .5, .5, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_200.wav'))