setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_435'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 490,
  pitchAnchors = data.frame(time = c(0, 250, 490), value = c(217, 250, 220)),
  amplAnchors = c(80, 75, 65),
  rolloff = c(-10, -15), rolloffOct = 0,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = .05, shimmerDep = 10,
  formants = c(600, 1000, 2500, 3100, 4000),
  mouthAnchors = data.frame(time = c(0, 100, 490), value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(0, 100, 510), value = c(-25, -20, -65)),
  rolloffNoise = -5,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 490,
  pitchAnchors = data.frame(time = c(0, 250, 490), value = c(217, 250, 220)),
  amplAnchors = c(80, 75, 65),
  rolloff = c(-10, -15), rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .05, shimmerDep = 10,
  formants = c(600, 1000, 2500, 3100, 4000),
  mouthAnchors = data.frame(time = c(0, 100, 490), value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(0, 100, 510), value = c(-25, -20, -65)),
  rolloffNoise = -5,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 490,
  pitchAnchors = data.frame(time = c(0, 250, 490), value = c(217, 250, 220)),
  amplAnchors = c(80, 75, 65),
  rolloff = c(-10, -15) + 4, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .05, shimmerDep = 10,
  formants = c(600, 1000, 2500, 3100, 4000),
  mouthAnchors = data.frame(time = c(0, 100, 490), value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(0, 100, 510), value = c(-25, -20, -65)),
  rolloffNoise = -5,
  attackLen = 50,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 490,
  pitchAnchors = data.frame(time = c(0, 250, 490), value = c(217, 250, 220)),
  amplAnchors = c(80, 75, 65),
  rolloff = c(-10, -15) - 4, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .05, shimmerDep = 10,
  formants = c(600, 1000, 2500, 3100, 4000),
  mouthAnchors = data.frame(time = c(0, 100, 490), value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(0, 100, 510), value = c(-25, -20, -65)),
  rolloffNoise = -5,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 230
subFreq = 120
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 490,
  pitchAnchors = data.frame(time = c(0, 250, 490), value = c(217, 250, 220)),
  amplAnchors = c(80, 75, 65),
  rolloff = c(-10, -15), rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 50), rep(0, 20)), 
  subFreq = 120, subDep = 60, jitterDep = 0,
  formants = c(600, 1000, 2500, 3100, 4000),
  mouthAnchors = data.frame(time = c(0, 100, 490), value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(0, 100, 510), value = c(-25, -20, -65)),
  rolloffNoise = -5,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_240_120_15.wav'))

## CHAOS
s = soundgen(
  sylLen = 490,
  pitchAnchors = data.frame(time = c(0, 250, 490), value = c(217, 250, 220)),
  amplAnchors = c(80, 75, 65),
  rolloff = c(-10, -15), rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(2, 50), rep(0, 20)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(600, 1000, 2500, 3100, 4000),
  mouthAnchors = data.frame(time = c(0, 100, 490), value = c(.4, .55, .45)),
  noiseAnchors = data.frame(time = c(0, 100, 510), value = c(-25, -20, -65)),
  rolloffNoise = -5,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_240.wav'))
