setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_443'

## original with temp = 0.001
s = soundgen(
  sylLen = 1040,
  pitchAnchors = c(230, 315, 295),
  rolloff = c(-17, -13, -13, -13, -17), rolloffOct = 0, 
  temperature = 0.001,
  formants = c(850, 1500, 2800, 3800, 4700, 6400),
  noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                            value = c(0, -5, -20, -20)),
  rolloffNoise = -1, 
  mouthAnchors = c(.4, .5, .5, .45),
  attackLen = 200, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

playme(s, 22050)
spectrogram(s, 22050)


# no nonlin effects
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))

## ROLLOFF
# no nonlin effects rolloff +6
s = soundgen(
  sylLen = 1040,
  pitchAnchors = c(230, 315, 295),
  rolloff = c(-17, -13, -13, -13, -17) + 6, rolloffOct = 0, 
  temperature = 0.001,
  formants = c(850, 1500, 2800, 3800, 4700, 6400),
  noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                            value = c(0, -5, -20, -20)),
  rolloffNoise = -1, 
  mouthAnchors = c(.4, .5, .5, .45),
  attackLen = 200, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))


# no nonlin effects rolloff -6
s = soundgen(
  sylLen = 1040,
  pitchAnchors = c(230, 315, 295),
  rolloff = c(-17, -13, -13, -13, -17) - 6, rolloffOct = 0, 
  temperature = 0.001,
  formants = c(850, 1500, 2800, 3800, 4700, 6400),
  noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                            value = c(0, -5, -20, -20)),
  rolloffNoise = -1, 
  mouthAnchors = c(.4, .5, .5, .45),
  attackLen = 200, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 300
subFreq = 100  # 1/3 of 300
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1040,
  pitchAnchors = c(230, 315, 295),
  rolloff = c(-17, -13, -13, -13, -17), rolloffOct = 0, 
  nonlinRandomWalk = c(rep(0, 50), rep(1, 20), rep(0, 30)), 
  subFreq = 120, subDep = 60, jitterDep = 0,
  temperature = 0.001,
  formants = c(850, 1500, 2800, 3800, 4700, 6400),
  noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                            value = c(0, -5, -20, -20)),
  rolloffNoise = -1, 
  mouthAnchors = c(.4, .5, .5, .45),
  attackLen = 200, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_210_120_25.wav'))

## CHAOS
s = soundgen(
  sylLen = 1040,
  pitchAnchors = c(230, 315, 295),
  rolloff = c(-17, -13, -13, -13, -17), rolloffOct = 0, 
  nonlinRandomWalk = c(rep(0, 50), rep(2, 20), rep(0, 30)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = c(850, 1500, 2800, 3800, 4700, 6400),
  noiseAnchors = data.frame(time = c(-50, 110, 260, 1100), 
                            value = c(0, -5, -20, -20)),
  rolloffNoise = -1, 
  mouthAnchors = c(.4, .5, .5, .45),
  attackLen = 200, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_210.wav'))