setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'gs_449'

# rolloff original (closest to 000)
s = soundgen(
  sylLen = 1200,
  pitchAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(260, 285, 200)),
  amplAnchors = data.frame(time = c(0, 200, 800, 1200), 
                           value = c(70, 80, 70, 60)),
  rolloff = -20,
  temperature = 0.001,
  formants = c(750, 1400, 2800, 4400, 6300, 7800),
  noiseAnchors = data.frame(time = c(-50, 0, 1400), 
                            value = c(-30, -10, -40)),
  rolloffNoise = 0,
  mouthAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(.4, .6, .5)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, dB = 'max0', alim = c(-80, 0))

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


# no nonlin rolloff +8
s = soundgen(
  sylLen = 1200,
  pitchAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(260, 285, 200)),
  amplAnchors = data.frame(time = c(0, 200, 800, 1200), 
                           value = c(70, 80, 70, 60)),
  rolloff = -20 + 8,
  temperature = 0.001,
  formants = c(750, 1400, 2800, 4400, 6300, 7800),
  noiseAnchors = data.frame(time = c(-50, 0, 1400), 
                            value = c(-30, -10, -40)),
  rolloffNoise = 0,
  mouthAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(.4, .6, .5)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))


# no nonlin rolloff -8
s = soundgen(
  sylLen = 1200,
  pitchAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(260, 285, 200)),
  amplAnchors = data.frame(time = c(0, 200, 800, 1200), 
                           value = c(70, 80, 70, 60)),
  rolloff = -20 - 8,
  temperature = 0.001,
  formants = c(750, 1400, 2800, 4400, 6300, 7800),
  noiseAnchors = data.frame(time = c(-50, 0, 1400), 
                            value = c(-30, -10, -40)),
  rolloffNoise = 0,
  mouthAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(.4, .6, .5)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
rw = c(rep(0, 30), rep(1, 20), rep(0, 50))

pitchMedian = 300
subFreq = 140 
subDep = 90
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1200,
  pitchAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(260, 285, 200)),
  amplAnchors = data.frame(time = c(0, 200, 800, 1200), 
                           value = c(70, 80, 70, 60)),
  rolloff = -20,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 20), rep(0, 50)), 
  subFreq = 140, subDep = 90, jitterDep = 0,
  temperature = 0.001,
  formants = c(750, 1400, 2800, 4400, 6300, 7800),
  noiseAnchors = data.frame(time = c(-50, 0, 1400), 
                            value = c(-30, -10, -40)),
  rolloffNoise = 0,
  mouthAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(.4, .6, .5)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_240_140_25.wav'))

# subh 2
rw = c(rep(0, 30), rep(1, 20), rep(0, 50))

pitchMedian = 300
subFreq = 80  # 1/3 of 300
subDep = 45
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1200,
  pitchAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(260, 285, 200)),
  amplAnchors = data.frame(time = c(0, 200, 800, 1200), 
                           value = c(70, 80, 70, 60)),
  rolloff = -20,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 20), rep(0, 50)), 
  subFreq = 80, subDep = 45, jitterDep = 0,
  temperature = 0.001,
  formants = c(750, 1400, 2800, 4400, 6300, 7800),
  noiseAnchors = data.frame(time = c(-50, 0, 1400), 
                            value = c(-30, -10, -40)),
  rolloffNoise = 0,
  mouthAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(.4, .6, .5)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_240_80_25.wav'))

## CHAOS
rw = c(rep(0, 30), rep(2, 20), rep(0, 50))

s = soundgen(
  sylLen = 1200,
  pitchAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(260, 285, 200)),
  amplAnchors = data.frame(time = c(0, 200, 800, 1200), 
                           value = c(70, 80, 70, 60)),
  rolloff = -20,
  nonlinRandomWalk = c(rep(0, 30), rep(2, 20), rep(0, 50)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = c(750, 1400, 2800, 4400, 6300, 7800),
  noiseAnchors = data.frame(time = c(-50, 0, 1400), 
                            value = c(-30, -10, -40)),
  rolloffNoise = 0,
  mouthAnchors = data.frame(time = c(0, 200, 1200), 
                            value = c(.4, .6, .5)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_240.wav'))