setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_253'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 250, 420),
                            value = c(535, 541, 470)),
  amplAnchors = data.frame(time = c(0, 250, 420),
                           value = c(70, 80, 75)),
  rolloff = c(-13, -13, -8, -6), rolloffOct = -2,
  nonlinBalance = 100, subDep = 0, shimmerDep = 5, jitterDep = 0,
  temperature = 0.001,
  formants = list(f1 = c(850, 1050, 1100),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 400,
  pitchAnchors = 1050,
  amplAnchors = c(80, 50),
  nonlinBalance = 100, subDep = 0, jitterDep = .5, jitterLen = 75, shimmerDep = 20,
  rolloff = -10,
  temperature = 0.001,
  formants = list(f1 = c(1100, 850),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  noiseAnchors = data.frame(time = c(-470, 0, 700), 
                            value = c(-55, -40, -65)),
  rolloffNoise = -4,
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3, sylLen = c(35, 45, 65), pauseLen = 115,
  pitchAnchors = c(520, 530, 510),
  amplAnchorsGlobal = c(75, 80, 75),
  rolloff = c(-6, -10),
  temperature = 0.001,
  formants = c(850, 1700, 3400, 4500),
  attackLen = c(5, 20),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s4 = soundgen(
  sylLen = 210,
  pitchAnchors = data.frame(time = c(0, 150, 210),
                            value = c(525, 360, 400)),
  amplAnchors = c(80, 65, 50),
  rolloff = c(-10, -16),
  temperature = 0.001,
  formants = c(750, 1700, 2900, 4200),
  mouthAnchors = c(.5, .45),
  noiseAnchors = data.frame(time = c(0, 300), 
                            value = c(-80, -80)),
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 4)
s = addVectors(s, s3, insertionPoint = length(s1) + 22000 * .11)
s = addVectors(s, s4 / 1.5, insertionPoint = length(s1) + length(s3) + 22000* .11 + 22000 * .09)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 5))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s1 = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 250, 420),
                            value = c(535, 541, 470)),
  amplAnchors = data.frame(time = c(0, 250, 420),
                           value = c(70, 80, 75)),
  rolloff = c(-13, -13, -8, -6), rolloffOct = -2,
  # nonlinBalance = 100, subDep = 0, shimmerDep = 5, jitterDep = 0,
  temperature = 0.001,
  formants = list(f1 = c(850, 1050, 1100),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 4)
s = addVectors(s, s3, insertionPoint = length(s1) + 22000 * .11)
s = addVectors(s, s4 / 1.5, insertionPoint = length(s1) + length(s3) + 22000* .11 + 22000 * .09)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s1 = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 250, 420),
                            value = c(535, 541, 470)),
  amplAnchors = data.frame(time = c(0, 250, 420),
                           value = c(70, 80, 75)),
  rolloff = c(-13, -13, -8, -6) + 6, rolloffOct = -2,
  # nonlinBalance = 100, subDep = 0, shimmerDep = 5, jitterDep = 0,
  temperature = 0.001,
  formants = list(f1 = c(850, 1050, 1100),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3, sylLen = c(35, 45, 65), pauseLen = 115,
  pitchAnchors = c(520, 530, 510),
  amplAnchorsGlobal = c(75, 80, 75),
  rolloff = c(-6, -10) + 6,
  temperature = 0.001,
  formants = c(850, 1700, 3400, 4500),
  attackLen = c(5, 20),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s4 = soundgen(
  sylLen = 210,
  pitchAnchors = data.frame(time = c(0, 150, 210),
                            value = c(525, 360, 400)),
  amplAnchors = c(80, 65, 50),
  rolloff = c(-10, -16) + 6,
  temperature = 0.001,
  formants = c(750, 1700, 2900, 4200),
  mouthAnchors = c(.5, .45),
  noiseAnchors = data.frame(time = c(0, 300), 
                            value = c(-80, -80)),
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 4)
s = addVectors(s, s3, insertionPoint = length(s1) + 22000 * .11)
s = addVectors(s, s4 / 1.5, insertionPoint = length(s1) + length(s3) + 22000* .11 + 22000 * .09)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s1 = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 250, 420),
                            value = c(535, 541, 470)),
  amplAnchors = data.frame(time = c(0, 250, 420),
                           value = c(70, 80, 75)),
  rolloff = c(-13, -13, -8, -6) - 6, rolloffOct = -2,
  # nonlinBalance = 100, subDep = 0, shimmerDep = 5, jitterDep = 0,
  temperature = 0.001,
  formants = list(f1 = c(850, 1050, 1100),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3, sylLen = c(35, 45, 65), pauseLen = 115,
  pitchAnchors = c(520, 530, 510),
  amplAnchorsGlobal = c(75, 80, 75),
  rolloff = c(-6, -10) - 6,
  temperature = 0.001,
  formants = c(850, 1700, 3400, 4500),
  attackLen = c(5, 20),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s4 = soundgen(
  sylLen = 210,
  pitchAnchors = data.frame(time = c(0, 150, 210),
                            value = c(525, 360, 400)),
  amplAnchors = c(80, 65, 50),
  rolloff = c(-10, -16) - 6,
  temperature = 0.001,
  formants = c(750, 1700, 2900, 4200),
  mouthAnchors = c(.5, .45),
  noiseAnchors = data.frame(time = c(0, 300), 
                            value = c(-80, -80)),
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 4)
s = addVectors(s, s3, insertionPoint = length(s1) + 22000 * .11)
s = addVectors(s, s4 / 1.5, insertionPoint = length(s1) + length(s3) + 22000* .11 + 22000 * .09)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS (affects only s1)
pitchMedian = 500
subFreq = 120  
subDep = 90
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 250, 420),
                            value = c(535, 541, 470)),
  amplAnchors = data.frame(time = c(0, 250, 420),
                           value = c(70, 80, 75)),
  rolloff = c(-13, -13, -8, -6), rolloffOct = -2,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 50), rep(0, 20)), 
  subFreq = 120, subDep = c(60, 90), # shimmerDep = 5, jitterDep = 0,
  temperature = 0.001,
  formants = list(f1 = c(850, 1050, 1100),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 400,
  pitchAnchors = 1050,
  amplAnchors = c(80, 50),
  nonlinBalance = 100, subDep = 0, jitterDep = .5, jitterLen = 75, shimmerDep = 20,
  rolloff = -10,
  temperature = 0.001,
  formants = list(f1 = c(1100, 850),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  noiseAnchors = data.frame(time = c(-470, 0, 700), 
                            value = c(-55, -40, -65)),
  rolloffNoise = -4,
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3, sylLen = c(35, 45, 65), pauseLen = 115,
  pitchAnchors = c(520, 530, 510),
  amplAnchorsGlobal = c(75, 80, 75),
  rolloff = c(-6, -10),
  temperature = 0.001,
  formants = c(850, 1700, 3400, 4500),
  attackLen = c(5, 20),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s4 = soundgen(
  sylLen = 210,
  pitchAnchors = data.frame(time = c(0, 150, 210),
                            value = c(525, 360, 400)),
  amplAnchors = c(80, 65, 50),
  rolloff = c(-10, -16),
  temperature = 0.001,
  formants = c(750, 1700, 2900, 4200),
  mouthAnchors = c(.5, .45),
  noiseAnchors = data.frame(time = c(0, 300), 
                            value = c(-80, -80)),
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 4)
s = addVectors(s, s3, insertionPoint = length(s1) + 22000 * .11)
s = addVectors(s, s4 / 1.5, insertionPoint = length(s1) + length(s3) + 22000* .11 + 22000 * .09)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_210_120_38.wav'))

# subh2
pitchMedian = 500
subFreq = 240  
subDep = 180
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 250, 420),
                            value = c(535, 541, 470)),
  amplAnchors = data.frame(time = c(0, 250, 420),
                           value = c(70, 80, 75)),
  rolloff = c(-13, -13, -8, -6), rolloffOct = -2,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 50), rep(0, 20)), 
  subFreq = 240, subDep = c(140, 180), # shimmerDep = 5, jitterDep = 0,
  temperature = 0.001,
  formants = list(f1 = c(850, 1050, 1100),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 4)
s = addVectors(s, s3, insertionPoint = length(s1) + 22000 * .11)
s = addVectors(s, s4 / 1.5, insertionPoint = length(s1) + length(s3) + 22000* .11 + 22000 * .09)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_210_240_38.wav'))


## CHAOS
s1 = soundgen(
  sylLen = 420,
  pitchAnchors = data.frame(time = c(0, 250, 420),
                            value = c(535, 541, 470)),
  amplAnchors = data.frame(time = c(0, 250, 420),
                           value = c(70, 80, 75)),
  rolloff = c(-13, -13, -8, -6), rolloffOct = -2,
  nonlinRandomWalk = c(rep(0, 30), rep(2, 50), rep(0, 20)), 
  subDep = 0, jitterDep = c(0, 1.5), shimmerDep = c(0, 15), 
  temperature = 0.001,
  formants = list(f1 = c(850, 1050, 1100),
                  f2 = 1700, f3 = 3400, f4 = 4500), 
  attackLen = 20, 
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 4)
s = addVectors(s, s3, insertionPoint = length(s1) + 22000 * .11)
s = addVectors(s, s4 / 1.5, insertionPoint = length(s1) + length(s3) + 22000* .11 + 22000 * .09)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_210.wav'))
