setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_257'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 100,
  pitchAnchors = c(314, 320, 260),
  rolloff = c(-10, -25),
  nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(540, 1700, 2900, 3900, 5000),
  attackLen = c(50, 60), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  pitchAnchors = NULL,
  noiseAnchors = data.frame(time = c(0, 100, 300, 930, 1100),
                            value = c(-30, -10, -20, -30, -60)),
  formantsNoise = list(f1 = c(540, 1000), f2 = c(1700, 1800),
                       f3 = c(2900, 3000), f4 = c(4100, 3900)),
  mouthAnchors = c(.5, .55),
  rolloffNoise = -12,
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 4, 
  sylLen = c(170, 120, 107, 130), pauseLen = c(80, 80, 100),
  pitchAnchors = 380, 
  vibratoDep = 1, vibratoFreq = 10,
  pitchAnchorsGlobal = c(0, 3),
  rolloff = c(-30, -10, -30),
  nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(540, 1000), f2 = c(1700, 1800),
                  f3 = c(2900, 3000), f4 = c(4100, 3900)),
  noiseAnchors = c(-20, -35, -20), 
  rolloffNoise = -4,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s3, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s4 = soundgen(
  sylLen = 230,
  pitchAnchors = data.frame(time = c(0, 118, 146, 230),
                            value = c(480, 475, 415, 411)),
  rolloff = c(-18),
  nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(1000, 1800, 3000, 3900),
  mouthAnchors = c(.5, .3),
  noiseAnchors = c(-35, -50),
  attackLen = c(20, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s4, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s = addVectors(s1 / 4, s3, insertionPoint = length(s1) + 22050 * .05)
s = addVectors(s, s4 / 2, insertionPoint = length(s) + 22050 * .05)
s = addVectors(s, s2 / 30, insertionPoint = 1)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 5))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s1 = soundgen(
  sylLen = 100,
  pitchAnchors = c(314, 320, 260),
  rolloff = c(-10, -25),
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(540, 1700, 2900, 3900, 5000),
  attackLen = c(50, 60), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 4, 
  sylLen = c(170, 120, 107, 130), pauseLen = c(80, 80, 100),
  pitchAnchors = 380, 
  vibratoDep = 1, vibratoFreq = 10,
  pitchAnchorsGlobal = c(0, 3),
  rolloff = c(-30, -10, -30),
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(540, 1000), f2 = c(1700, 1800),
                  f3 = c(2900, 3000), f4 = c(4100, 3900)),
  noiseAnchors = c(-20, -35, -20), 
  rolloffNoise = -4,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s4 = soundgen(
  sylLen = 230,
  pitchAnchors = data.frame(time = c(0, 118, 146, 230),
                            value = c(480, 475, 415, 411)),
  rolloff = c(-18),
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(1000, 1800, 3000, 3900),
  mouthAnchors = c(.5, .3),
  noiseAnchors = c(-35, -50),
  attackLen = c(20, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1 / 4, s3, insertionPoint = length(s1) + 22050 * .05)
s = addVectors(s, s4 / 2, insertionPoint = length(s) + 22050 * .05)
s = addVectors(s, s2 / 30, insertionPoint = 1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s1 = soundgen(
  sylLen = 100,
  pitchAnchors = c(314, 320, 260),
  rolloff = c(-10, -25) + 6,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(540, 1700, 2900, 3900, 5000),
  attackLen = c(50, 60), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 4, 
  sylLen = c(170, 120, 107, 130), pauseLen = c(80, 80, 100),
  pitchAnchors = 380, 
  vibratoDep = 1, vibratoFreq = 10,
  pitchAnchorsGlobal = c(0, 3),
  rolloff = c(-30, -10, -30) + 6,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(540, 1000), f2 = c(1700, 1800),
                  f3 = c(2900, 3000), f4 = c(4100, 3900)),
  noiseAnchors = c(-20, -35, -20), 
  rolloffNoise = -4,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s4 = soundgen(
  sylLen = 230,
  pitchAnchors = data.frame(time = c(0, 118, 146, 230),
                            value = c(480, 475, 415, 411)),
  rolloff = c(-18) + 6,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(1000, 1800, 3000, 3900),
  mouthAnchors = c(.5, .3),
  noiseAnchors = c(-35, -50),
  attackLen = c(20, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1 / 4, s3, insertionPoint = length(s1) + 22050 * .05)
s = addVectors(s, s4 / 2, insertionPoint = length(s) + 22050 * .05)
s = addVectors(s, s2 / 30, insertionPoint = 1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s1 = soundgen(
  sylLen = 100,
  pitchAnchors = c(314, 320, 260),
  rolloff = c(-10, -25) - 6, invalidArgAction = 'ignore',
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(540, 1700, 2900, 3900, 5000),
  attackLen = c(50, 60), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 4, 
  sylLen = c(170, 120, 107, 130), pauseLen = c(80, 80, 100),
  pitchAnchors = 380, 
  vibratoDep = 1, vibratoFreq = 10,
  pitchAnchorsGlobal = c(0, 3),
  rolloff = c(-30, -10, -30) - 6, invalidArgAction = 'ignore',
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(540, 1000), f2 = c(1700, 1800),
                  f3 = c(2900, 3000), f4 = c(4100, 3900)),
  noiseAnchors = c(-20, -35, -20), 
  rolloffNoise = -4,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s4 = soundgen(
  sylLen = 230,
  pitchAnchors = data.frame(time = c(0, 118, 146, 230),
                            value = c(480, 475, 415, 411)),
  rolloff = c(-18) - 6,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(1000, 1800, 3000, 3900),
  mouthAnchors = c(.5, .3),
  noiseAnchors = c(-35, -50),
  attackLen = c(20, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1 / 4, s3, insertionPoint = length(s1) + 22050 * .05)
s = addVectors(s, s4 / 2, insertionPoint = length(s) + 22050 * .05)
s = addVectors(s, s2 / 30, insertionPoint = 1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 380
subFreq = 120  
subDep = 100
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 100,
  pitchAnchors = c(314, 320, 260),
  rolloff = c(-10, -25),
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(540, 1700, 2900, 3900, 5000),
  attackLen = c(50, 60), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 4, 
  sylLen = c(170, 120, 107, 130), pauseLen = c(80, 80, 100),
  pitchAnchors = 380, 
  vibratoDep = 1, vibratoFreq = 10,
  pitchAnchorsGlobal = c(0, 3),
  rolloff = c(-30, -10, -30),
  nonlinBalance = 100, subFreq = 120, subDep = c(0, 100),
  temperature = 0.001,
  formants = list(f1 = c(540, 1000), f2 = c(1700, 1800),
                  f3 = c(2900, 3000), f4 = c(4100, 3900)),
  noiseAnchors = c(-20, -35, -20), 
  rolloffNoise = -4,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s4 = soundgen(
  sylLen = 230,
  pitchAnchors = data.frame(time = c(0, 118, 146, 230),
                            value = c(480, 475, 415, 411)),
  rolloff = c(-18),
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = c(1000, 1800, 3000, 3900),
  mouthAnchors = c(.5, .3),
  noiseAnchors = c(-35, -50),
  attackLen = c(20, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1 / 4, s3, insertionPoint = length(s1) + 22050 * .05)
s = addVectors(s, s4 / 2, insertionPoint = length(s) + 22050 * .05)
s = addVectors(s, s2 / 20, insertionPoint = 1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_120_45.wav'))


## CHAOS
s3 = soundgen(
  nSyl = 4, 
  sylLen = c(170, 120, 107, 130), pauseLen = c(80, 80, 100),
  pitchAnchors = 380, 
  vibratoDep = 1, vibratoFreq = 10,
  pitchAnchorsGlobal = c(0, 3),
  rolloff = c(-30, -10, -30),
  nonlinBalance = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = list(f1 = c(540, 1000), f2 = c(1700, 1800),
                  f3 = c(2900, 3000), f4 = c(4100, 3900)),
  noiseAnchors = c(-20, -35, -20), 
  rolloffNoise = -4,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1 / 4, s3, insertionPoint = length(s1) + 22050 * .05)
s = addVectors(s, s4 / 2, insertionPoint = length(s) + 22050 * .05)
s = addVectors(s, s2 / 20, insertionPoint = 1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_500.wav'))
