setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_261'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 240,
  pitchAnchors = c(150, 180),
  rolloff = c(-10, -7),
  nonlinRandomWalk = c(rep(1, 50), rep(2, 50)),
  subFreq = 75, subDep = c(30, 50), jitterDep = 1, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(550, 600), f2 = c(1600, 2200),
                  f3 = c(2500, 2400), f4 = 3700, f5 = 4400),
  noiseAnchors = data.frame(time = c(0, 320),
                            value = c(-40, -30)),
  rolloffNoise = 0,
  attackLen = 50, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  nSyl = 2, sylLen = c(75, 170), pauseLen = 50,
  pitchAnchors = c(180, 270, 170), 
  vibratoDep = 2, vibratoFreq = 8,
  pitchAnchorsGlobal = c(0, 3),
  amplAnchorsGlobal = c(75, 80),
  rolloff = -10,
  nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = c(400, 400, 650), 
    f2 = c(2200, 2200, 2100, 1900),
    f3 = c(2900, 3000), f4 = c(3900, 3700), f5 = 4400),
  noiseAnchors = data.frame(time = c(-100, 10, 20, 65, 75, 100, 220),
                            value = c(-50, -30, -40, -40, -30, -40, -50)),
  formantsNoise = list(
    f1 = c(450, 450, 600), 
    f2 = c(2200, 2200, 2100, 1600),
    f3 = c(2900, 3000, 2800), f4 = c(3900, 3700), f5 = 4400),
  rolloffNoise = 0,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s3 = soundgen(
  nSyl = 3, sylLen = 140, pauseLen = 95,
  pitchAnchors = c(155, 163, 155),
  pitchAnchorsGlobal = c(0, 1),
  rolloff = -9,
  nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = data.frame(time = c(0, 40, 570),
                    freq = c(700, 750, 950)),
    f2 = data.frame(time = c(0, 40, 570),
                    freq = c(1600, 1100, 1550)),
    f3 = c(2500, 2700, 2500), f4 = 3600),
  noiseAnchors = data.frame(time = c(-10, 0, 120, 140, 220),
                            value = c(-40, -30, -30, -25, -50) - 5),
  rolloffNoise = 0,
  attackLen = c(20, 100), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s3, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .1)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .1)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 10))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s1 = soundgen(
  sylLen = 240,
  pitchAnchors = c(150, 180),
  rolloff = c(-10, -7),
  # nonlinRandomWalk = c(rep(1, 50), rep(2, 50)),
  subFreq = 75, subDep = c(30, 50), jitterDep = 1, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(550, 600), f2 = c(1600, 2200),
                  f3 = c(2500, 2400), f4 = 3700, f5 = 4400),
  noiseAnchors = data.frame(time = c(0, 320),
                            value = c(-40, -30)),
  rolloffNoise = 0,
  attackLen = 50, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s2 = soundgen(
  nSyl = 2, sylLen = c(75, 170), pauseLen = 50,
  pitchAnchors = c(180, 270, 170), 
  vibratoDep = 2, vibratoFreq = 8,
  pitchAnchorsGlobal = c(0, 3),
  amplAnchorsGlobal = c(75, 80),
  rolloff = -10,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = c(400, 400, 650), 
    f2 = c(2200, 2200, 2100, 1900),
    f3 = c(2900, 3000), f4 = c(3900, 3700), f5 = 4400),
  noiseAnchors = data.frame(time = c(-100, 10, 20, 65, 75, 100, 220),
                            value = c(-50, -30, -40, -40, -30, -40, -50)),
  formantsNoise = list(
    f1 = c(450, 450, 600), 
    f2 = c(2200, 2200, 2100, 1600),
    f3 = c(2900, 3000, 2800), f4 = c(3900, 3700), f5 = 4400),
  rolloffNoise = 0,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 3, sylLen = 140, pauseLen = 95,
  pitchAnchors = c(155, 163, 155),
  pitchAnchorsGlobal = c(0, 1),
  rolloff = -9,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = data.frame(time = c(0, 40, 570),
                    freq = c(700, 750, 950)),
    f2 = data.frame(time = c(0, 40, 570),
                    freq = c(1600, 1100, 1550)),
    f3 = c(2500, 2700, 2500), f4 = 3600),
  noiseAnchors = data.frame(time = c(-10, 0, 120, 140, 220),
                            value = c(-40, -30, -30, -25, -50) - 5),
  rolloffNoise = 0,
  attackLen = c(20, 100), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .1)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  sylLen = 240,
  pitchAnchors = c(150, 180),
  rolloff = c(-10, -7) + 4,
  # nonlinRandomWalk = c(rep(1, 50), rep(2, 50)),
  subFreq = 75, subDep = c(30, 50), jitterDep = 1, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(550, 600), f2 = c(1600, 2200),
                  f3 = c(2500, 2400), f4 = 3700, f5 = 4400),
  noiseAnchors = data.frame(time = c(0, 320),
                            value = c(-40, -30)),
  rolloffNoise = 0,
  attackLen = 50, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s2 = soundgen(
  nSyl = 2, sylLen = c(75, 170), pauseLen = 50,
  pitchAnchors = c(180, 270, 170), 
  vibratoDep = 2, vibratoFreq = 8,
  pitchAnchorsGlobal = c(0, 3),
  amplAnchorsGlobal = c(75, 80),
  rolloff = -10 + 4,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = c(400, 400, 650), 
    f2 = c(2200, 2200, 2100, 1900),
    f3 = c(2900, 3000), f4 = c(3900, 3700), f5 = 4400),
  noiseAnchors = data.frame(time = c(-100, 10, 20, 65, 75, 100, 220),
                            value = c(-50, -30, -40, -40, -30, -40, -50)),
  formantsNoise = list(
    f1 = c(450, 450, 600), 
    f2 = c(2200, 2200, 2100, 1600),
    f3 = c(2900, 3000, 2800), f4 = c(3900, 3700), f5 = 4400),
  rolloffNoise = 0,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 3, sylLen = 140, pauseLen = 95,
  pitchAnchors = c(155, 163, 155),
  pitchAnchorsGlobal = c(0, 1),
  rolloff = -9 + 4,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = data.frame(time = c(0, 40, 570),
                    freq = c(700, 750, 950)),
    f2 = data.frame(time = c(0, 40, 570),
                    freq = c(1600, 1100, 1550)),
    f3 = c(2500, 2700, 2500), f4 = 3600),
  noiseAnchors = data.frame(time = c(-10, 0, 120, 140, 220),
                            value = c(-40, -30, -30, -25, -50) - 5),
  rolloffNoise = 0,
  attackLen = c(20, 100), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .1)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s1 = soundgen(
  sylLen = 240,
  pitchAnchors = c(150, 180),
  rolloff = c(-10, -7) - 4,
  # nonlinRandomWalk = c(rep(1, 50), rep(2, 50)),
  subFreq = 75, subDep = c(30, 50), jitterDep = 1, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(550, 600), f2 = c(1600, 2200),
                  f3 = c(2500, 2400), f4 = 3700, f5 = 4400),
  noiseAnchors = data.frame(time = c(0, 320),
                            value = c(-40, -30)),
  rolloffNoise = 0,
  attackLen = 50, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s2 = soundgen(
  nSyl = 2, sylLen = c(75, 170), pauseLen = 50,
  pitchAnchors = c(180, 270, 170), 
  vibratoDep = 2, vibratoFreq = 8,
  pitchAnchorsGlobal = c(0, 3),
  amplAnchorsGlobal = c(75, 80),
  rolloff = -10 - 4,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = c(400, 400, 650), 
    f2 = c(2200, 2200, 2100, 1900),
    f3 = c(2900, 3000), f4 = c(3900, 3700), f5 = 4400),
  noiseAnchors = data.frame(time = c(-100, 10, 20, 65, 75, 100, 220),
                            value = c(-50, -30, -40, -40, -30, -40, -50)),
  formantsNoise = list(
    f1 = c(450, 450, 600), 
    f2 = c(2200, 2200, 2100, 1600),
    f3 = c(2900, 3000, 2800), f4 = c(3900, 3700), f5 = 4400),
  rolloffNoise = 0,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 3, sylLen = 140, pauseLen = 95,
  pitchAnchors = c(155, 163, 155),
  pitchAnchorsGlobal = c(0, 1),
  rolloff = -9 - 4,
  # nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = data.frame(time = c(0, 40, 570),
                    freq = c(700, 750, 950)),
    f2 = data.frame(time = c(0, 40, 570),
                    freq = c(1600, 1100, 1550)),
    f3 = c(2500, 2700, 2500), f4 = 3600),
  noiseAnchors = data.frame(time = c(-10, 0, 120, 140, 220),
                            value = c(-40, -30, -30, -25, -50) - 5),
  rolloffNoise = 0,
  attackLen = c(20, 100), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .1)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
# added to s1 and s3
pitchMedian = 160
subFreq = 75  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 240,
  pitchAnchors = c(150, 180),
  rolloff = c(-10, -7),
  nonlinRandomWalk = c(rep(1, 50), rep(2, 50)),
  subFreq = 75, subDep = c(30, 50), # jitterDep = 1, shimmerDep = 10,
  temperature = 0.001,
  formants = list(f1 = c(550, 600), f2 = c(1600, 2200),
                  f3 = c(2500, 2400), f4 = 3700, f5 = 4400),
  noiseAnchors = data.frame(time = c(0, 320),
                            value = c(-40, -30)),
  rolloffNoise = 0,
  attackLen = 50, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s2 = soundgen(
  nSyl = 2, sylLen = c(75, 170), pauseLen = 50,
  pitchAnchors = c(180, 270, 170), 
  vibratoDep = 2, vibratoFreq = 8,
  pitchAnchorsGlobal = c(0, 3),
  amplAnchorsGlobal = c(75, 80),
  rolloff = -10,
  nonlinBalance = 100, subDep = 0, jitterDep = .2, shimmerDep = 10,
  temperature = 0.001,
  formants = list(
    f1 = c(400, 400, 650), 
    f2 = c(2200, 2200, 2100, 1900),
    f3 = c(2900, 3000), f4 = c(3900, 3700), f5 = 4400),
  noiseAnchors = data.frame(time = c(-100, 10, 20, 65, 75, 100, 220),
                            value = c(-50, -30, -40, -40, -30, -40, -50)),
  formantsNoise = list(
    f1 = c(450, 450, 600), 
    f2 = c(2200, 2200, 2100, 1600),
    f3 = c(2900, 3000, 2800), f4 = c(3900, 3700), f5 = 4400),
  rolloffNoise = 0,
  attackLen = c(5, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 3, sylLen = 140, pauseLen = 95,
  pitchAnchors = c(155, 163, 155),
  pitchAnchorsGlobal = c(0, 1),
  rolloff = -9,
  nonlinBalance = 100, subFreq = 75, subDep = c(40, 0),
  temperature = 0.001,
  formants = list(
    f1 = data.frame(time = c(0, 40, 570),
                    freq = c(700, 750, 950)),
    f2 = data.frame(time = c(0, 40, 570),
                    freq = c(1600, 1100, 1550)),
    f3 = c(2500, 2700, 2500), f4 = 3600),
  noiseAnchors = data.frame(time = c(-10, 0, 120, 140, 220),
                            value = c(-40, -30, -30, -25, -50) - 5),
  rolloffNoise = 0,
  attackLen = c(20, 100), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .1)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_660_75_28.wav'))


## CHAOS
# affects s1 and s3
s1 = soundgen(
  sylLen = 240,
  pitchAnchors = c(150, 180),
  rolloff = c(-10, -7),
  nonlinRandomWalk = c(rep(1, 50), rep(2, 50)),
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = list(f1 = c(550, 600), f2 = c(1600, 2200),
                  f3 = c(2500, 2400), f4 = 3700, f5 = 4400),
  noiseAnchors = data.frame(time = c(0, 320),
                            value = c(-40, -30)),
  rolloffNoise = 0,
  attackLen = 50, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 3, sylLen = 140, pauseLen = 95,
  pitchAnchors = c(155, 163, 155),
  pitchAnchorsGlobal = c(0, 1),
  rolloff = -9,
  nonlinBalance = 100, subDep = 0, jitterDep = c(0, 1.5), shimmerDep = c(0, 15),
  temperature = 0.001,
  formants = list(
    f1 = data.frame(time = c(0, 40, 570),
                    freq = c(700, 750, 950)),
    f2 = data.frame(time = c(0, 40, 570),
                    freq = c(1600, 1100, 1550)),
    f3 = c(2500, 2700, 2500), f4 = 3600),
  noiseAnchors = data.frame(time = c(-10, 0, 120, 140, 220),
                            value = c(-40, -30, -30, -25, -50) - 5),
  rolloffNoise = 0,
  attackLen = c(20, 100), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * .1)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_660.wav'))
