setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_280'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 100,
  pitchAnchors = data.frame(time = c(0, 65, 100),
                            value = c(760, 960, 850)),
  rolloff = c(-20, -10, -30),
  temperature = 0.001,
  formants = c(600, 1700, 3800, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 50, 90, 130, 180),
                            value = c(-50, -30, -20, -30, -35) + 0),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  sylLen = 120,
  pitchAnchors = data.frame(time = c(0, 30, 50, 75, 120),
                            value = c(720, 700, 620, 790, 785)),
  rolloff = c(-20, -10, -15),
  temperature = 0.001,
  formants = c(600, 1700, 3700, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 90, 130, 180),
                            value = c(-30, -20, -30, -50) + 0),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s3 = soundgen(
  nSyl = 4, sylLen = c(65, 75, 70, 75), pauseLen = c(35, 45),
  pitchAnchors = 750,
  pitchAnchorsGlobal = c(0, .5, .5, -.5),
  vibratoDep = 1, vibratoFreq = 12, invalidArgAction = 'ignore',
  rolloff = c(-15, -9, -15),
  temperature = 0.001,
  formants = c(600, 1700, 3700, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 65, 100),
                            value = c(-35, -35, -80) + 15),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s3, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s4 = soundgen(
  nSyl = 2, sylLen = c(100, 120), pauseLen =35,
  pitchAnchors = data.frame(time = c(0, 50, 85, 100),
                            value = c(660, 600, 780, 760)),
  pitchAnchorsGlobal = c(0, -.5),
  rolloff = c(-13, -7) + 5,
  temperature = 0.001,
  # formants = c(600, 1700, 3700, 4800, 5900),
  formants = list(
    f1 = c(600, 900),
    f2 = c(1700, 1800),
    f3 = 3700, f4 = 4400, f5 = 5900
  ),
  mouthAnchors = c(.6, .7),
  noiseAnchors = data.frame(time = c(0, 100, 150),
                            value = c(-35, -35, -40) + 5),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s4, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s5 = soundgen(
  sylLen = 220,
  pitchAnchors = c(720, 560, 870),
  vibratoDep = 1, vibratoFreq = 10, invalidArgAction = 'ignore',
  rolloff = c(-15, -8, -4, -2),
  nonlinBalance = 100, subDep = 0, jitterDep = c(0, .3),
  temperature = 0.001,
  formants = list(
    f1 = c(900, 1200),
    f2 = c(1600, 1800),
    f3 = c(3700, 4000),
    f4 = 4400, f5 = 5900
  ),
  attackLen = c(10, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s4, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) + 22050 * .03)
s = addVectors(s, s4, insertionPoint = length(s) + 22050 * .01)
s = addVectors(s, s5, insertionPoint = length(s) - 22050 * .04)

amplEnv = rep(.7, length(s))
amplEnv = fade(amplEnv, fadeIn = 500, fadeOut = 800, shape = 'logistic', samplingRate = 22050)
s = s * (amplEnv + .3)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 5))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s5 = soundgen(
  sylLen = 220,
  pitchAnchors = c(720, 560, 870),
  vibratoDep = 1, vibratoFreq = 10, invalidArgAction = 'ignore',
  rolloff = c(-15, -8, -4, -2),
  # nonlinBalance = 100, subDep = 0, jitterDep = c(0, .3),
  temperature = 0.001,
  formants = list(
    f1 = c(900, 1200),
    f2 = c(1600, 1800),
    f3 = c(3700, 4000),
    f4 = 4400, f5 = 5900
  ),
  attackLen = c(10, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) + 22050 * .03)
s = addVectors(s, s4, insertionPoint = length(s) + 22050 * .01)
s = addVectors(s, s5, insertionPoint = length(s) - 22050 * .04)
amplEnv = rep(.7, length(s))
amplEnv = fade(amplEnv, fadeIn = 500, fadeOut = 800, shape = 'logistic', samplingRate = 22050)
s = s * (amplEnv + .3)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  sylLen = 100,
  pitchAnchors = data.frame(time = c(0, 65, 100),
                            value = c(760, 960, 850)),
  rolloff = c(-20, -10, -30) + 4,
  temperature = 0.001,
  formants = c(600, 1700, 3800, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 50, 90, 130, 180),
                            value = c(-50, -30, -20, -30, -35) + 0),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  sylLen = 120,
  pitchAnchors = data.frame(time = c(0, 30, 50, 75, 120),
                            value = c(720, 700, 620, 790, 785)),
  rolloff = c(-20, -10, -15) + 4,
  temperature = 0.001,
  formants = c(600, 1700, 3700, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 90, 130, 180),
                            value = c(-30, -20, -30, -50) + 0),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 4, sylLen = c(65, 75, 70, 75), pauseLen = c(35, 45),
  pitchAnchors = 750,
  pitchAnchorsGlobal = c(0, .5, .5, -.5),
  vibratoDep = 1, vibratoFreq = 12, invalidArgAction = 'ignore',
  rolloff = c(-15, -9, -15) + 4,
  temperature = 0.001,
  formants = c(600, 1700, 3700, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 65, 100),
                            value = c(-35, -35, -80) + 15),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s3, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s4 = soundgen(
  nSyl = 2, sylLen = c(100, 120), pauseLen =35,
  pitchAnchors = data.frame(time = c(0, 50, 85, 100),
                            value = c(660, 600, 780, 760)),
  pitchAnchorsGlobal = c(0, -.5),
  rolloff = c(-13, -7) + 5 + 4, invalidArgAction = 'ignore',
  temperature = 0.001,
  # formants = c(600, 1700, 3700, 4800, 5900),
  formants = list(
    f1 = c(600, 900),
    f2 = c(1700, 1800),
    f3 = 3700, f4 = 4400, f5 = 5900
  ),
  mouthAnchors = c(.6, .7),
  noiseAnchors = data.frame(time = c(0, 100, 150),
                            value = c(-35, -35, -40) + 5),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s5 = soundgen(
  sylLen = 220,
  pitchAnchors = c(720, 560, 870),
  vibratoDep = 1, vibratoFreq = 10, invalidArgAction = 'ignore',
  rolloff = c(-15, -8, -4, -2) + 4,
  # nonlinBalance = 100, subDep = 0, jitterDep = c(0, .3),
  temperature = 0.001,
  formants = list(
    f1 = c(900, 1200),
    f2 = c(1600, 1800),
    f3 = c(3700, 4000),
    f4 = 4400, f5 = 5900
  ),
  attackLen = c(10, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) + 22050 * .03)
s = addVectors(s, s4, insertionPoint = length(s) + 22050 * .01)
s = addVectors(s, s5, insertionPoint = length(s) - 22050 * .04)
amplEnv = rep(.7, length(s))
amplEnv = fade(amplEnv, fadeIn = 500, fadeOut = 800, shape = 'logistic', samplingRate = 22050)
s = s * (amplEnv + .3)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s1 = soundgen(
  sylLen = 100,
  pitchAnchors = data.frame(time = c(0, 65, 100),
                            value = c(760, 960, 850)),
  rolloff = c(-20, -10, -30) - 4, invalidArgAction = 'ignore',
  temperature = 0.001,
  formants = c(600, 1700, 3800, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 50, 90, 130, 180),
                            value = c(-50, -30, -20, -30, -35) + 0),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  sylLen = 120,
  pitchAnchors = data.frame(time = c(0, 30, 50, 75, 120),
                            value = c(720, 700, 620, 790, 785)),
  rolloff = c(-20, -10, -15) - 4,
  temperature = 0.001,
  formants = c(600, 1700, 3700, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 90, 130, 180),
                            value = c(-30, -20, -30, -50) + 0),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 4, sylLen = c(65, 75, 70, 75), pauseLen = c(35, 45),
  pitchAnchors = 750,
  pitchAnchorsGlobal = c(0, .5, .5, -.5),
  vibratoDep = 1, vibratoFreq = 12, invalidArgAction = 'ignore',
  rolloff = c(-15, -9, -15) - 4,
  temperature = 0.001,
  formants = c(600, 1700, 3700, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 65, 100),
                            value = c(-35, -35, -80) + 15),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s3, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s4 = soundgen(
  nSyl = 2, sylLen = c(100, 120), pauseLen =35,
  pitchAnchors = data.frame(time = c(0, 50, 85, 100),
                            value = c(660, 600, 780, 760)),
  pitchAnchorsGlobal = c(0, -.5),
  rolloff = c(-13, -7) + 5 - 4,
  temperature = 0.001,
  # formants = c(600, 1700, 3700, 4800, 5900),
  formants = list(
    f1 = c(600, 900),
    f2 = c(1700, 1800),
    f3 = 3700, f4 = 4400, f5 = 5900
  ),
  mouthAnchors = c(.6, .7),
  noiseAnchors = data.frame(time = c(0, 100, 150),
                            value = c(-35, -35, -40) + 5),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s5 = soundgen(
  sylLen = 220,
  pitchAnchors = c(720, 560, 870),
  vibratoDep = 1, vibratoFreq = 10, invalidArgAction = 'ignore',
  rolloff = c(-15, -8, -4, -2) - 4,
  # nonlinBalance = 100, subDep = 0, jitterDep = c(0, .3),
  temperature = 0.001,
  formants = list(
    f1 = c(900, 1200),
    f2 = c(1600, 1800),
    f3 = c(3700, 4000),
    f4 = 4400, f5 = 5900
  ),
  attackLen = c(10, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) + 22050 * .03)
s = addVectors(s, s4, insertionPoint = length(s) + 22050 * .01)
s = addVectors(s, s5, insertionPoint = length(s) - 22050 * .04)
amplEnv = rep(.7, length(s))
amplEnv = fade(amplEnv, fadeIn = 500, fadeOut = 800, shape = 'logistic', samplingRate = 22050)
s = s * (amplEnv + .3)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
# added to s4 & s5
s1 = soundgen(
  sylLen = 100,
  pitchAnchors = data.frame(time = c(0, 65, 100),
                            value = c(760, 960, 850)),
  rolloff = c(-20, -10, -30),
  temperature = 0.001,
  formants = c(600, 1700, 3800, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 50, 90, 130, 180),
                            value = c(-50, -30, -20, -30, -35) + 0),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s2 = soundgen(
  sylLen = 120,
  pitchAnchors = data.frame(time = c(0, 30, 50, 75, 120),
                            value = c(720, 700, 620, 790, 785)),
  rolloff = c(-20, -10, -15),
  temperature = 0.001,
  formants = c(600, 1700, 3700, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 90, 130, 180),
                            value = c(-30, -20, -30, -50) + 0),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 4, sylLen = c(65, 75, 70, 75), pauseLen = c(35, 45),
  pitchAnchors = 750,
  pitchAnchorsGlobal = c(0, .5, .5, -.5),
  vibratoDep = 1, vibratoFreq = 12, invalidArgAction = 'ignore',
  rolloff = c(-15, -9, -15),
  temperature = 0.001,
  formants = c(600, 1700, 3700, 4800, 5900),
  noiseAnchors = data.frame(time = c(0, 65, 100),
                            value = c(-35, -35, -80) + 15),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s4 = soundgen(
  nSyl = 2, sylLen = c(100, 120), pauseLen =35,
  pitchAnchors = data.frame(time = c(0, 50, 85, 100),
                            value = c(660, 600, 780, 760)),
  pitchAnchorsGlobal = c(0, -.5),
  rolloff = c(-13, -7) + 5,
  temperature = 0.001,
  nonlinBalance = 100, subFreq = 120, subDep = c(50, 80), jitterDep = 0,
  formants = list(
    f1 = c(600, 900),
    f2 = c(1700, 1800),
    f3 = 3700, f4 = 4400, f5 = 5900
  ),
  mouthAnchors = c(.6, .7),
  noiseAnchors = data.frame(time = c(0, 100, 150),
                            value = c(-35, -35, -40) + 5),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s5 = soundgen(
  sylLen = 220,
  pitchAnchors = c(720, 560, 870),
  vibratoDep = 1, vibratoFreq = 10, invalidArgAction = 'ignore',
  rolloff = c(-15, -8, -4, -2),
  nonlinBalance = 100, subFreq = 120, subDep = c(50, 80), jitterDep = 0,
  temperature = 0.001,
  formants = list(
    f1 = c(900, 1200),
    f2 = c(1600, 1800),
    f3 = c(3700, 4000),
    f4 = 4400, f5 = 5900
  ),
  attackLen = c(10, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) + 22050 * .03)
s = addVectors(s, s4, insertionPoint = length(s) + 22050 * .01)
s = addVectors(s, s5, insertionPoint = length(s) - 22050 * .04)

amplEnv = rep(.7, length(s))
amplEnv = fade(amplEnv, fadeIn = 500, fadeOut = 800, shape = 'logistic', samplingRate = 22050)
s = s * (amplEnv + .3)

playme(s, 22050)

pitchMedian = 700
subFreq = 120  
subDep = 80
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_440_120_35.wav'))


## CHAOS
# affects s4 and s5
s4 = soundgen(
  nSyl = 2, sylLen = c(100, 120), pauseLen =35,
  pitchAnchors = data.frame(time = c(0, 50, 85, 100),
                            value = c(660, 600, 780, 760)),
  pitchAnchorsGlobal = c(0, -.5),
  rolloff = c(-13, -7) + 5,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = c(0, 1.5), shimmerDep = c(0, 15),
  formants = list(
    f1 = c(600, 900),
    f2 = c(1700, 1800),
    f3 = 3700, f4 = 4400, f5 = 5900
  ),
  mouthAnchors = c(.6, .7),
  noiseAnchors = data.frame(time = c(0, 100, 150),
                            value = c(-35, -35, -40) + 5),
  attackLen = 10, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s5 = soundgen(
  sylLen = 220,
  pitchAnchors = c(720, 560, 870),
  vibratoDep = 1, vibratoFreq = 10, invalidArgAction = 'ignore',
  rolloff = c(-15, -8, -4, -2),
  nonlinBalance = 100, subDep = 0, jitterDep = c(0, 1.5), shimmerDep = c(0, 15),
  temperature = 0.001,
  formants = list(
    f1 = c(900, 1200),
    f2 = c(1600, 1800),
    f3 = c(3700, 4000),
    f4 = 4400, f5 = 5900
  ),
  attackLen = c(10, 50), 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) + 22050 * .03)
s = addVectors(s, s4, insertionPoint = length(s) + 22050 * .01)
s = addVectors(s, s5, insertionPoint = length(s) - 22050 * .04)

amplEnv = rep(.7, length(s))
amplEnv = fade(amplEnv, fadeIn = 500, fadeOut = 800, shape = 'logistic', samplingRate = 22050)
s = s * (amplEnv + .3)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_440.wav'))
