setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_283'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  nSyl = 3, sylLen = c(75, 90, 130), pauseLen = c(135, 125),
  pitchAnchors = 260,
  pitchAnchorsGlobal = c(0, -2.5),
  amplAnchorsGlobal = c(80, 78, 73),
  vibratoDep = .75, vibratoFreq = 13, invalidArgAction = 'ignore',
  rolloff = c(-10, -7, -15) , rolloffOct = 0,
  nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = list(f1 = c(700, 1200),
                  f2 = 1700, f3 = 2900,
                  f4 = 3400, f5 = 5000, f6 = 5800), 
  noiseAnchors = data.frame(time = c(0, 75, 160),
                            value = c(-40, -40, -60)),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  sylLen = 200,
  pitchAnchors = data.frame(time = c(0, 190, 235),
                            value = c(390, 675, 450)),
  rolloff = -2,
  nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001,
  formants = c(600, 1700, 2900, 3600, 5000, 5800),
  noiseAnchors = data.frame(time = c(0, 235, 380),
                            value = c(-20, -10, -40) + 10),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s3 = soundgen(
  nSyl = 5, sylLen = c(110, 90, 90, 85, 100), pauseLen = c(115, 145),
  pitchAnchors = 340,
  pitchAnchorsGlobal = c(0, -7),
  amplAnchorsGlobal = c(80, 78, 70),
  vibratoDep = 1.5, vibratoFreq = 17, invalidArgAction = 'ignore',
  rolloff = c(-7, -25), 
  nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = c(1200, 1800, 2900, 3600, 5000, 5800),
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(0, 75, 110, 250),
                            value = c(-40, -25, -40, -55) ),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s3, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .02)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 5))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s1 = soundgen(
  nSyl = 3, sylLen = c(75, 90, 130), pauseLen = c(135, 125),
  pitchAnchors = 260,
  pitchAnchorsGlobal = c(0, -2.5),
  amplAnchorsGlobal = c(80, 78, 73),
  vibratoDep = .75, vibratoFreq = 13, invalidArgAction = 'ignore',
  rolloff = c(-10, -7, -15) , rolloffOct = 0,
  # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = list(f1 = c(700, 1200),
                  f2 = 1700, f3 = 2900,
                  f4 = 3400, f5 = 5000, f6 = 5800), 
  noiseAnchors = data.frame(time = c(0, 75, 160),
                            value = c(-40, -40, -60)),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 200,
  pitchAnchors = data.frame(time = c(0, 190, 235),
                            value = c(390, 675, 450)),
  rolloff = -2,
  # nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001,
  formants = c(600, 1700, 2900, 3600, 5000, 5800),
  noiseAnchors = data.frame(time = c(0, 235, 380),
                            value = c(-20, -10, -40) + 10),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 5, sylLen = c(110, 90, 90, 85, 100), pauseLen = c(115, 145),
  pitchAnchors = 340,
  pitchAnchorsGlobal = c(0, -7),
  amplAnchorsGlobal = c(80, 78, 70),
  vibratoDep = 1.5, vibratoFreq = 17, invalidArgAction = 'ignore',
  rolloff = c(-7, -25), 
  # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = c(1200, 1800, 2900, 3600, 5000, 5800),
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(0, 75, 110, 250),
                            value = c(-40, -25, -40, -55) ),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .02)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  nSyl = 3, sylLen = c(75, 90, 130), pauseLen = c(135, 125),
  pitchAnchors = 260,
  pitchAnchorsGlobal = c(0, -2.5),
  amplAnchorsGlobal = c(80, 78, 73),
  vibratoDep = .75, vibratoFreq = 13, invalidArgAction = 'ignore',
  rolloff = c(-10, -7, -15) + 4, rolloffOct = 0,
  # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = list(f1 = c(700, 1200),
                  f2 = 1700, f3 = 2900,
                  f4 = 3400, f5 = 5000, f6 = 5800), 
  noiseAnchors = data.frame(time = c(0, 75, 160),
                            value = c(-40, -40, -60)),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 200,
  pitchAnchors = data.frame(time = c(0, 190, 235),
                            value = c(390, 675, 450)),
  rolloff = -2 + 4, invalidArgAction = 'ignore',
  # nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001,
  formants = c(600, 1700, 2900, 3600, 5000, 5800),
  noiseAnchors = data.frame(time = c(0, 235, 380),
                            value = c(-20, -10, -40) + 10),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 5, sylLen = c(110, 90, 90, 85, 100), pauseLen = c(115, 145),
  pitchAnchors = 340,
  pitchAnchorsGlobal = c(0, -7),
  amplAnchorsGlobal = c(80, 78, 70),
  vibratoDep = 1.5, vibratoFreq = 17, invalidArgAction = 'ignore',
  rolloff = c(-7, -25) + 4, 
  # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = c(1200, 1800, 2900, 3600, 5000, 5800),
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(0, 75, 110, 250),
                            value = c(-40, -25, -40, -55) ),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .02)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s1 = soundgen(
  nSyl = 3, sylLen = c(75, 90, 130), pauseLen = c(135, 125),
  pitchAnchors = 260,
  pitchAnchorsGlobal = c(0, -2.5),
  amplAnchorsGlobal = c(80, 78, 73),
  vibratoDep = .75, vibratoFreq = 13, invalidArgAction = 'ignore',
  rolloff = c(-10, -7, -15) - 4, rolloffOct = 0,
  # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = list(f1 = c(700, 1200),
                  f2 = 1700, f3 = 2900,
                  f4 = 3400, f5 = 5000, f6 = 5800), 
  noiseAnchors = data.frame(time = c(0, 75, 160),
                            value = c(-40, -40, -60)),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 200,
  pitchAnchors = data.frame(time = c(0, 190, 235),
                            value = c(390, 675, 450)),
  rolloff = -2 - 4,
  # nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001,
  formants = c(600, 1700, 2900, 3600, 5000, 5800),
  noiseAnchors = data.frame(time = c(0, 235, 380),
                            value = c(-20, -10, -40) + 10),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 5, sylLen = c(110, 90, 90, 85, 100), pauseLen = c(115, 145),
  pitchAnchors = 340,
  pitchAnchorsGlobal = c(0, -7),
  amplAnchorsGlobal = c(80, 78, 70),
  vibratoDep = 1.5, vibratoFreq = 17, invalidArgAction = 'ignore',
  rolloff = c(-7, -25) - 4, 
  # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = c(1200, 1800, 2900, 3600, 5000, 5800),
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(0, 75, 110, 250),
                            value = c(-40, -25, -40, -55) ),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .02)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
# added to s1
pitchMedian = 260
subFreq = 90  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  nSyl = 3, sylLen = c(75, 90, 130), pauseLen = c(135, 125),
  pitchAnchors = 260,
  pitchAnchorsGlobal = c(0, -2.5),
  amplAnchorsGlobal = c(80, 78, 73),
  vibratoDep = .75, vibratoFreq = 13, invalidArgAction = 'ignore',
  rolloff = c(-10, -7, -15) , rolloffOct = 0,
  nonlinBalance = 100, subFreq = 90, subDep = c(50, 30), # jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = list(f1 = c(700, 1200),
                  f2 = 1700, f3 = 2900,
                  f4 = 3400, f5 = 5000, f6 = 5800), 
  noiseAnchors = data.frame(time = c(0, 75, 160),
                            value = c(-40, -40, -60)),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 200,
  pitchAnchors = data.frame(time = c(0, 190, 235),
                            value = c(390, 675, 450)),
  rolloff = -2,
  # nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001,
  formants = c(600, 1700, 2900, 3600, 5000, 5800),
  noiseAnchors = data.frame(time = c(0, 235, 380),
                            value = c(-20, -10, -40) + 10),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s3 = soundgen(
  nSyl = 5, sylLen = c(110, 90, 90, 85, 100), pauseLen = c(115, 145),
  pitchAnchors = 340,
  pitchAnchorsGlobal = c(0, -7),
  amplAnchorsGlobal = c(80, 78, 70),
  vibratoDep = 1.5, vibratoFreq = 17, invalidArgAction = 'ignore',
  rolloff = c(-7, -25), 
  # nonlinBalance = 100, subDep = 0, jitterDep = .5, shimmerDep = 5,
  temperature = 0.001,
  formants = c(1200, 1800, 2900, 3600, 5000, 5800),
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(0, 75, 110, 250),
                            value = c(-40, -25, -40, -55) ),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .02)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_300_90_25.wav'))


## CHAOS
# affects s4 and s5
s1 = soundgen(
  nSyl = 3, sylLen = c(75, 90, 130), pauseLen = c(135, 125),
  pitchAnchors = 260,
  pitchAnchorsGlobal = c(0, -2.5),
  amplAnchorsGlobal = c(80, 78, 73),
  vibratoDep = .75, vibratoFreq = 13, invalidArgAction = 'ignore',
  rolloff = c(-10, -7, -15) , rolloffOct = 0,
  nonlinBalance = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = list(f1 = c(700, 1200),
                  f2 = 1700, f3 = 2900,
                  f4 = 3400, f5 = 5000, f6 = 5800), 
  noiseAnchors = data.frame(time = c(0, 75, 160),
                            value = c(-40, -40, -60)),
  rolloffNoise = 0,
  attackLen = 15, 
  addSilence = 0, throwaway = -120,
  samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0)
s = addVectors(s, s3, insertionPoint = length(s) - 22050 * .02)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_300.wav'))
