setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_289'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(nSyl = 2, sylLen = 120, pauseLen = 100,
              pitchAnchors = 550,
              amplAnchorsGlobal = c(80, 75),
              rolloff = -20, 
              nonlinBalance = 100,  subDep = 0, shimmerDep = 10, jitterDep = .3,
              temperature = 0.001,
              formants = c(500, 2200, 2500, 4900, 5100, 6800, 7800),
              noiseAnchors = data.frame(time = c(0, 110, 150, 250),
                                        value = c(5, 5, -30, -40) - 0),
              rolloffNoise = -2,
              attackLen = 50, 
              addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050, 
              play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  nSyl = 6, 
  sylLen = c(60, 85, 105, 130, 130, 120), pauseLen = c(130, 115),
  pitchAnchors = c(600, 850),
  pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
  amplAnchorsGlobal = c(70, 80, 75, 55),
  rolloff = -10,
  temperature = 0.001,
  formants = c(500, 2200, 2600, 4500, 5500), 
  noiseAnchors = data.frame(time = c(50, 70, 100, 130),
                            value = c(-25, -20, -20, -40)),
  formantsNoise = list(f1 = 800, f2 = 2100, f3 = 2600,
                       f4 = c(4800, 4400),
                       f5 = c(5400, 5600, 5400, 5100),
                       f6 = 6800, f7 = 7800), 
  attackLen = c(10, 25),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s = addVectors(s1, s2 * 3, insertionPoint = length(s1) - 22050 * .05)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s2 = soundgen(
  nSyl = 6, 
  sylLen = c(60, 85, 105, 130, 130, 120), pauseLen = c(130, 115),
  pitchAnchors = c(600, 850),
  pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
  amplAnchorsGlobal = c(70, 80, 75, 55),
  rolloff = -10 + 6,
  temperature = 0.001,
  formants = c(500, 2200, 2600, 4500, 5500), 
  noiseAnchors = data.frame(time = c(50, 70, 100, 130),
                            value = c(-25, -20, -20, -40)),
  formantsNoise = list(f1 = 800, f2 = 2100, f3 = 2600,
                       f4 = c(4800, 4400),
                       f5 = c(5400, 5600, 5400, 5100),
                       f6 = 6800, f7 = 7800), 
  attackLen = c(10, 25),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2 * 3, insertionPoint = length(s1) - 22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))


# no nonlin rolloff -4
s2 = soundgen(
  nSyl = 6, 
  sylLen = c(60, 85, 105, 130, 130, 120), pauseLen = c(130, 115),
  pitchAnchors = c(600, 850),
  pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
  amplAnchorsGlobal = c(70, 80, 75, 55),
  rolloff = -10 - 6,
  temperature = 0.001,
  formants = c(500, 2200, 2600, 4500, 5500), 
  noiseAnchors = data.frame(time = c(50, 70, 100, 130),
                            value = c(-25, -20, -20, -40)),
  formantsNoise = list(f1 = 800, f2 = 2100, f3 = 2600,
                       f4 = c(4800, 4400),
                       f5 = c(5400, 5600, 5400, 5100),
                       f6 = 6800, f7 = 7800), 
  attackLen = c(10, 25),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2 * 3, insertionPoint = length(s1) - 22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 700
subFreq = 300  
subDep = 200
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s2 = soundgen(
  nSyl = 6, 
  sylLen = c(60, 85, 105, 130, 130, 120), pauseLen = c(130, 115),
  pitchAnchors = c(600, 850),
  pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
  amplAnchorsGlobal = c(70, 80, 75, 55),
  rolloff = -10,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(1, 40), rep(0, 60)),
  subFreq = 300, subDep = 200, jitterDep = 0,
  formants = c(500, 2200, 2600, 4500, 5500), 
  noiseAnchors = data.frame(time = c(50, 70, 100, 130),
                            value = c(-25, -20, -20, -40)),
  formantsNoise = list(f1 = 800, f2 = 2100, f3 = 2600,
                       f4 = c(4800, 4400),
                       f5 = c(5400, 5600, 5400, 5100),
                       f6 = 6800, f7 = 7800), 
  attackLen = c(10, 25),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2 * 3, insertionPoint = length(s1) - 22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_250_300_22.wav'))

# subh2
pitchMedian = 700
subFreq = 110  
subDep = 67
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s2 = soundgen(
  nSyl = 6, 
  sylLen = c(60, 85, 105, 130, 130, 120), pauseLen = c(130, 115),
  pitchAnchors = c(600, 850),
  pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
  amplAnchorsGlobal = c(70, 80, 75, 55),
  rolloff = -10,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(1, 40), rep(0, 60)),
  subFreq = 110, subDep = 67, jitterDep = 0,
  formants = c(500, 2200, 2600, 4500, 5500), 
  noiseAnchors = data.frame(time = c(50, 70, 100, 130),
                            value = c(-25, -20, -20, -40)),
  formantsNoise = list(f1 = 800, f2 = 2100, f3 = 2600,
                       f4 = c(4800, 4400),
                       f5 = c(5400, 5600, 5400, 5100),
                       f6 = 6800, f7 = 7800), 
  attackLen = c(10, 25),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2 * 3, insertionPoint = length(s1) - 22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_250_110_22.wav'))

## CHAOS
s2 = soundgen(
  nSyl = 6, 
  sylLen = c(60, 85, 105, 130, 130, 120), pauseLen = c(130, 115),
  pitchAnchors = c(600, 850),
  pitchAnchorsGlobal = c(0, 0, 0, -4, -4, -5),
  amplAnchorsGlobal = c(70, 80, 75, 55),
  rolloff = -10,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(2, 40), rep(0, 60)),
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(500, 2200, 2600, 4500, 5500), 
  noiseAnchors = data.frame(time = c(50, 70, 100, 130),
                            value = c(-25, -20, -20, -40)),
  formantsNoise = list(f1 = 800, f2 = 2100, f3 = 2600,
                       f4 = c(4800, 4400),
                       f5 = c(5400, 5600, 5400, 5100),
                       f6 = 6800, f7 = 7800), 
  attackLen = c(10, 25),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050, 
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

s = addVectors(s1, s2 * 3, insertionPoint = length(s1) - 22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_250.wav'))
