setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_294'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 200,
  pitchAnchors = data.frame(time = c(0, 70, 200),
                            value = c(600, 900, 500)), 
  amplAnchors = c(80, 30),
  rolloff = -10,
  formants = list(f1 = 700, 
                  f2 = data.frame(time = c(0, 70, 200), 
                                  freq = c(1500, 1300, 1250)), 
                  f3 = data.frame(time = c(0, 70, 200), 
                                  freq = c(1600, 1900, 2000)),
                  f4 = 4600, f5 = 5500), 
  mouthAnchors = c(.4, .55),
  noiseAnchors = data.frame(time = c(0, 200),
                            value = c(10, -30)),
  rolloffNoise = -2,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  nSyl = 8, 
  sylLen = c(85, 75, 110), pauseLen = c(100, 95),
  pitchAnchors = 205,
  vibratoFreq = 15, vibratoDep = 1, invalidArgAction = 'ignore',
  pitchAnchorsGlobal = c(0, -3, -4),
  amplAnchorsGlobal = c(80, 77, 70),
  rolloff = c(-15, -6), rolloffOct = 0,
  temperature = 0.001,
  formants = list(f1 = c(650, 550),
                  f2 = c(1250, 1400),
                  f3 = c(2000, 2500),
                  f4 = c(4600, 4500),
                  f5 = c(5500, 5100)), 
  noiseAnchors = data.frame(time = c(0, 40, 80, 100, 250),
                            value = c(-15, -25, -10, -25, -60)),
  rolloffNoise = -2,
  addSilence = 0, attackLen = c(10, 15),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s = addVectors(s2 * 5, s1, insertionPoint = -22050 * .1)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s2 = soundgen(
  nSyl = 8, 
  sylLen = c(85, 75, 110), pauseLen = c(100, 95),
  pitchAnchors = 205,
  vibratoFreq = 15, vibratoDep = 1, invalidArgAction = 'ignore',
  pitchAnchorsGlobal = c(0, -3, -4),
  amplAnchorsGlobal = c(80, 77, 70),
  rolloff = c(-15, -6) + 4, rolloffOct = 0,
  temperature = 0.001,
  formants = list(f1 = c(650, 550),
                  f2 = c(1250, 1400),
                  f3 = c(2000, 2500),
                  f4 = c(4600, 4500),
                  f5 = c(5500, 5100)), 
  noiseAnchors = data.frame(time = c(0, 40, 80, 100, 250),
                            value = c(-15, -25, -10, -25, -60)),
  rolloffNoise = -2,
  addSilence = 0, attackLen = c(10, 15),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s2 * 5, s1, insertionPoint = -22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s2 = soundgen(
  nSyl = 8, 
  sylLen = c(85, 75, 110), pauseLen = c(100, 95),
  pitchAnchors = 205,
  vibratoFreq = 15, vibratoDep = 1, invalidArgAction = 'ignore',
  pitchAnchorsGlobal = c(0, -3, -4),
  amplAnchorsGlobal = c(80, 77, 70),
  rolloff = c(-15, -6) - 4, rolloffOct = 0,
  temperature = 0.001,
  formants = list(f1 = c(650, 550),
                  f2 = c(1250, 1400),
                  f3 = c(2000, 2500),
                  f4 = c(4600, 4500),
                  f5 = c(5500, 5100)), 
  noiseAnchors = data.frame(time = c(0, 40, 80, 100, 250),
                            value = c(-15, -25, -10, -25, -60)),
  rolloffNoise = -2,
  addSilence = 0, attackLen = c(10, 15),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s2 * 5, s1, insertionPoint = -22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 180
subFreq = 70  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s2 = soundgen(
  nSyl = 8, 
  sylLen = c(85, 75, 110), pauseLen = c(100, 95),
  pitchAnchors = 205,
  vibratoFreq = 15, vibratoDep = 1, invalidArgAction = 'ignore',
  pitchAnchorsGlobal = c(0, -3, -4),
  amplAnchorsGlobal = c(80, 77, 70),
  rolloff = c(-15, -6), rolloffOct = 0,
  nonlinBalance = 100, subFreq = 70, subDep = c(50, 30), 
  jitterDep = 0, shortestEpoch = 25,
  temperature = 0.001,
  formants = list(f1 = c(650, 550),
                  f2 = c(1250, 1400),
                  f3 = c(2000, 2500),
                  f4 = c(4600, 4500),
                  f5 = c(5500, 5100)), 
  noiseAnchors = data.frame(time = c(0, 40, 80, 100, 250),
                            value = c(-15, -25, -10, -25, -60)),
  rolloffNoise = -2,
  addSilence = 0, attackLen = c(10, 15),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s2 * 5, s1, insertionPoint = -22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_700_70_48.wav'))


## CHAOS
s2 = soundgen(
  nSyl = 8, 
  sylLen = c(85, 75, 110), pauseLen = c(100, 95),
  pitchAnchors = 205,
  vibratoFreq = 15, vibratoDep = 1, invalidArgAction = 'ignore',
  pitchAnchorsGlobal = c(0, -3, -4),
  amplAnchorsGlobal = c(80, 77, 70),
  rolloff = c(-15, -6), rolloffOct = 0,
  nonlinBalance = 100, subDep = 0, 
  jitterDep = c(1.5, .5), shimmerDep = c(15, 5), shortestEpoch = 25,
  temperature = 0.001,
  formants = list(f1 = c(650, 550),
                  f2 = c(1250, 1400),
                  f3 = c(2000, 2500),
                  f4 = c(4600, 4500),
                  f5 = c(5500, 5100)), 
  noiseAnchors = data.frame(time = c(0, 40, 80, 100, 250),
                            value = c(-15, -25, -10, -25, -60)),
  rolloffNoise = -2,
  addSilence = 0, attackLen = c(10, 15),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s2 * 5, s1, insertionPoint = -22050 * .1)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_700.wav'))
