setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_301'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 460,
  pitchAnchors = data.frame(time = c(0, 140, 400, 460), value = c(1045, 760, 890, 1200)),
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = c(-40, -10),
  addSilence = 0, attackLen = 150,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 350,
  pitchAnchors = c(1050, 1050, 750, 1050), vibratoDep = 2, vibratoFreq = 5, 
  amplAnchors = data.frame(time = c(0, .3, .7, 1), value = c(65, 80, 50, 25)),
  rolloff = -6,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = data.frame(time = c(0, 350), value = c(-45, -25)),
  addSilence = 0, attackLen = 10,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 13, 
  sylLen = c(44, 23), pauseLen = c(110, 150), invalidArgAction = 'ignore',
  pitchAnchors = c(1100, 850),
  pitchAnchorsGlobal = c(-2, 0, -3, -6),
  amplAnchorsGlobal = c(80, 55, seq(78, 60, length.out = 11)),
  rolloff = -6,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  mouthAnchors = c(.5, .2),
  attackLen = c(10, 30),
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) + 22000 * .3)
s = addVectors(s, s3, insertionPoint = length(s) - 22000 * .05)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  sylLen = 460,
  pitchAnchors = data.frame(time = c(0, 140, 400, 460), value = c(1045, 760, 890, 1200)),
  rolloff = -9 + 4,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = c(-40, -10),
  addSilence = 0, attackLen = 150,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 350,
  pitchAnchors = c(1050, 1050, 750, 1050), vibratoDep = 2, vibratoFreq = 5, 
  amplAnchors = data.frame(time = c(0, .3, .7, 1), value = c(65, 80, 50, 25)),
  rolloff = -6 + 4,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = data.frame(time = c(0, 350), value = c(-45, -25)),
  addSilence = 0, attackLen = 10,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 13, 
  sylLen = c(44, 23), pauseLen = c(110, 150), invalidArgAction = 'ignore',
  pitchAnchors = c(1100, 850),
  pitchAnchorsGlobal = c(-2, 0, -3, -6),
  amplAnchorsGlobal = c(80, 55, seq(78, 60, length.out = 11)),
  rolloff = -6 + 4,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  mouthAnchors = c(.5, .2),
  attackLen = c(10, 30),
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) + 22000 * .3)
s = addVectors(s, s3, insertionPoint = length(s) - 22000 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s1 = soundgen(
  sylLen = 460,
  pitchAnchors = data.frame(time = c(0, 140, 400, 460), value = c(1045, 760, 890, 1200)),
  rolloff = -9 - 4,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = c(-40, -10),
  addSilence = 0, attackLen = 150,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 350,
  pitchAnchors = c(1050, 1050, 750, 1050), vibratoDep = 2, vibratoFreq = 5, 
  amplAnchors = data.frame(time = c(0, .3, .7, 1), value = c(65, 80, 50, 25)),
  rolloff = -6 - 4,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = data.frame(time = c(0, 350), value = c(-45, -25)),
  addSilence = 0, attackLen = 10,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 13, 
  sylLen = c(44, 23), pauseLen = c(110, 150), invalidArgAction = 'ignore',
  pitchAnchors = c(1100, 850),
  pitchAnchorsGlobal = c(-2, 0, -3, -6),
  amplAnchorsGlobal = c(80, 55, seq(78, 60, length.out = 11)),
  rolloff = -6 - 4,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  mouthAnchors = c(.5, .2),
  attackLen = c(10, 30),
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) + 22000 * .3)
s = addVectors(s, s3, insertionPoint = length(s) - 22000 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 850
subFreq = 140  
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 460,
  pitchAnchors = data.frame(time = c(0, 140, 400, 460), 
                            value = c(1045, 760, 890, 1200)),
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)),
  subFreq = 140, subDep = 60,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = c(-40, -10),
  addSilence = 0, attackLen = 150,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 350,
  pitchAnchors = c(1050, 1050, 750, 1050), vibratoDep = 2, vibratoFreq = 5, 
  amplAnchors = data.frame(time = c(0, .3, .7, 1), value = c(65, 80, 50, 25)),
  rolloff = -6,
  nonlinRandomWalk = c(rep(1, 30), rep(0, 70)),
  subFreq = 140, subDep = 80,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = data.frame(time = c(0, 350), value = c(-45, -25)),
  addSilence = 0, attackLen = 10,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 13, 
  sylLen = c(44, 23), pauseLen = c(110, 150), invalidArgAction = 'ignore',
  pitchAnchors = c(1100, 850),
  pitchAnchorsGlobal = c(-2, 0, -3, -6),
  amplAnchorsGlobal = c(80, 55, seq(78, 60, length.out = 11)),
  rolloff = -6,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  mouthAnchors = c(.5, .2),
  attackLen = c(10, 30),
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) + 22000 * .3)
s = addVectors(s, s3, insertionPoint = length(s) - 22000 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_300_140_6.wav'))

# subh2
pitchMedian = 850
subFreq = 300  
subDep = 120
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 460,
  pitchAnchors = data.frame(time = c(0, 140, 400, 460), 
                            value = c(1045, 760, 890, 1200)),
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)),
  subFreq = 300, subDep = 120,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = c(-40, -10),
  addSilence = 0, attackLen = 150,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 350,
  pitchAnchors = c(1050, 1050, 750, 1050), vibratoDep = 2, vibratoFreq = 5, 
  amplAnchors = data.frame(time = c(0, .3, .7, 1), value = c(65, 80, 50, 25)),
  rolloff = -6,
  nonlinRandomWalk = c(rep(1, 30), rep(0, 70)),
  subFreq = 300, subDep = 120,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = data.frame(time = c(0, 350), value = c(-45, -25)),
  addSilence = 0, attackLen = 10,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) + 22000 * .3)
s = addVectors(s, s3, insertionPoint = length(s) - 22000 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_300_300_6.wav'))


## CHAOS
s1 = soundgen(
  sylLen = 460,
  pitchAnchors = data.frame(time = c(0, 140, 400, 460), 
                            value = c(1045, 760, 890, 1200)),
  nonlinRandomWalk = c(rep(0, 20), rep(2, 40), rep(0, 40)),
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = c(-40, -10),
  addSilence = 0, attackLen = 150,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 350,
  pitchAnchors = c(1050, 1050, 750, 1050), vibratoDep = 2, vibratoFreq = 5, 
  amplAnchors = data.frame(time = c(0, .3, .7, 1), value = c(65, 80, 50, 25)),
  rolloff = -6,
  nonlinRandomWalk = c(rep(2, 30), rep(0, 70)),
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = c(800, 1700, 3300),
  noiseAnchors = data.frame(time = c(0, 350), value = c(-45, -25)),
  addSilence = 0, attackLen = 10,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) + 22000 * .3)
s = addVectors(s, s3, insertionPoint = length(s) - 22000 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_300.wav'))
