setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_302a'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  nSyl = 3,
  sylLen = c(100, 170, 390), pauseLen = c(60, 0),
  pitchAnchors = data.frame(time = c(0, .2, 1),
                            value = c(365, 470, 430)), 
  vibratoDep = .25,
  rolloff = c(-15, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(75, 80, 77),
  formants = c(1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800), 
  mouthAnchors = c(.5, .5, .4),
  noiseAnchors = data.frame(time = c(-50, 20, 40, 70, 90, 150),
                            value = c(-20, -5, -15, -15, -5, -40) + 0),
  formantsNoise = c(400, 1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800),
  rolloffNoise = 0,
  attackLen = 40,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 10), dB = 'max0')

s2 = soundgen(
  sylLen = 130, 
  pitchAnchors = data.frame(time = c(0, 30, 85, 130),
                            value = c(600, 300, 370, 300)), 
  rolloff = c(-15, -15, -8, -10),
  formants = c(400, 2200, 2500, 3600, 4700, 5600, 7300, 7800), 
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 10), dB = 'max0')

s3 = soundgen(
  sylLen = 250, 
  pitchAnchors = data.frame(time = c(0, 115, 175, 250),
                            value = c(1800, 800, 370, 700)), 
  interpol = 'approx',
  amplAnchors = data.frame(time = c(0, 100, 110, 160, 165, 250),
                           value = c(75, 70, 20, 20, 80, 77)),
  rolloff = -30,
  formants = c(400, 2200, 2500, 3600, 4700, 5600, 7300, 7800), 
  noiseAnchors = data.frame(time = c(0, 100, 110, 160, 165, 250, 300),
                            value = c(-20, -20, -50, -50, 0, -5, -40)),
  rolloffNoise = c(.6, -12, -6),
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s3, f = 22050, alim = c(-80, 0), flim = c(0, 10), dB = 'max0')

s = addVectors(s1 * 5, s2, insertionPoint = length(s1) -22050 * .05)
s = addVectors(s, s3 / 3, insertionPoint = length(s1) -22050 * .05)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  nSyl = 3,
  sylLen = c(100, 170, 390), pauseLen = c(60, 0),
  pitchAnchors = data.frame(time = c(0, .2, 1),
                            value = c(365, 470, 430)), 
  vibratoDep = .25,
  rolloff = c(-15, -12) + 4, rolloffOct = 0,
  amplAnchorsGlobal = c(75, 80, 77),
  formants = c(1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800), 
  mouthAnchors = c(.5, .5, .4),
  noiseAnchors = data.frame(time = c(-50, 20, 40, 70, 90, 150),
                            value = c(-20, -5, -15, -15, -5, -40) + 0),
  formantsNoise = c(400, 1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800),
  rolloffNoise = 0,
  attackLen = 40,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 130, 
  pitchAnchors = data.frame(time = c(0, 30, 85, 130),
                            value = c(600, 300, 370, 300)), 
  rolloff = c(-15, -15, -8, -10) + 4,
  formants = c(400, 2200, 2500, 3600, 4700, 5600, 7300, 7800), 
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1 * 5, s2, insertionPoint = length(s1) -22050 * .05)
s = addVectors(s, s3 / 3, insertionPoint = length(s1) -22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s1 = soundgen(
  nSyl = 3,
  sylLen = c(100, 170, 390), pauseLen = c(60, 0),
  pitchAnchors = data.frame(time = c(0, .2, 1),
                            value = c(365, 470, 430)), 
  vibratoDep = .25,
  rolloff = c(-15, -12) - 4, rolloffOct = 0,
  amplAnchorsGlobal = c(75, 80, 77),
  formants = c(1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800), 
  mouthAnchors = c(.5, .5, .4),
  noiseAnchors = data.frame(time = c(-50, 20, 40, 70, 90, 150),
                            value = c(-20, -5, -15, -15, -5, -40) + 0),
  formantsNoise = c(400, 1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800),
  rolloffNoise = 0,
  attackLen = 40,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 130, 
  pitchAnchors = data.frame(time = c(0, 30, 85, 130),
                            value = c(600, 300, 370, 300)), 
  rolloff = c(-15, -15, -8, -10) - 4,
  formants = c(400, 2200, 2500, 3600, 4700, 5600, 7300, 7800), 
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1 * 5, s2, insertionPoint = length(s1) -22050 * .05)
s = addVectors(s, s3 / 3, insertionPoint = length(s1) -22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 430
subFreq = 110  
subDep = 75
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  nSyl = 3,
  sylLen = c(100, 170, 390), pauseLen = c(60, 0),
  pitchAnchors = data.frame(time = c(0, .2, 1),
                            value = c(365, 470, 430)), 
  vibratoDep = .25,
  rolloff = c(-15, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(75, 80, 77),
  nonlinRandomWalk = c(rep(1, 60), rep(0, 40)),
  subFreq = 110, subDep = 75, jitterDep = 0,
  formants = c(1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800), 
  mouthAnchors = c(.5, .5, .4),
  noiseAnchors = data.frame(time = c(-50, 20, 40, 70, 90, 150),
                            value = c(-20, -5, -15, -15, -5, -40) + 0),
  formantsNoise = c(400, 1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800),
  rolloffNoise = 0,
  attackLen = 40,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 10), dB = 'max0')

s2 = soundgen(
  sylLen = 130, 
  pitchAnchors = data.frame(time = c(0, 30, 85, 130),
                            value = c(600, 300, 370, 300)), 
  rolloff = c(-15, -15, -8, -10),
  formants = c(400, 2200, 2500, 3600, 4700, 5600, 7300, 7800), 
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1 * 5, s2, insertionPoint = length(s1) -22050 * .05)
s = addVectors(s, s3 / 3, insertionPoint = length(s1) -22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_260_110_35.wav'))

# subh2
pitchMedian = 430
subFreq = 220  
subDep = 150
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  nSyl = 3,
  sylLen = c(100, 170, 390), pauseLen = c(60, 0),
  pitchAnchors = data.frame(time = c(0, .2, 1),
                            value = c(365, 470, 430)), 
  vibratoDep = .25,
  rolloff = c(-15, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(75, 80, 77),
  nonlinRandomWalk = c(rep(1, 60), rep(0, 40)),
  subFreq = 220, subDep = 150, jitterDep = 0,
  formants = c(1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800), 
  mouthAnchors = c(.5, .5, .4),
  noiseAnchors = data.frame(time = c(-50, 20, 40, 70, 90, 150),
                            value = c(-20, -5, -15, -15, -5, -40) + 0),
  formantsNoise = c(400, 1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800),
  rolloffNoise = 0,
  attackLen = 40,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1 * 5, s2, insertionPoint = length(s1) -22050 * .05)
s = addVectors(s, s3 / 3, insertionPoint = length(s1) -22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_260_220_35.wav'))


## CHAOS
s1 = soundgen(
  nSyl = 3,
  sylLen = c(100, 170, 390), pauseLen = c(60, 0),
  pitchAnchors = data.frame(time = c(0, .2, 1),
                            value = c(365, 470, 430)), 
  vibratoDep = .25,
  rolloff = c(-15, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(75, 80, 77),
  nonlinRandomWalk = c(rep(2, 60), rep(0, 40)),
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800), 
  mouthAnchors = c(.5, .5, .4),
  noiseAnchors = data.frame(time = c(-50, 20, 40, 70, 90, 150),
                            value = c(-20, -5, -15, -15, -5, -40) + 0),
  formantsNoise = c(400, 1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800),
  rolloffNoise = 0,
  attackLen = 40,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1 * 5, s2, insertionPoint = length(s1) -22050 * .05)
s = addVectors(s, s3 / 3, insertionPoint = length(s1) -22050 * .05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_260.wav'))
