setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_302b'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  nSyl = 5,
  sylLen = c(125, 120, 160, 160, 140), pauseLen = c(100, 90, 75, 85),
  pitchAnchors = data.frame(time = c(0, .4, 1),
                            value = c(380, 480, 430)), 
  pitchAnchorsGlobal = c(0, -.5),
  vibratoDep = .5, vibratoFreq = 7,
  rolloff = c(-8, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(80, 75),
  nonlinBalance = 100, subFreq = 150, subDep = c(0, 90), 
  jitterDep = c(0, .3, 1), shimmerDep = 5,
  formants = list(f1 = data.frame(time = c(0, 100, 1000),
                                  freq = c(600, 900, 1000)),
                  f2 = data.frame(time = c(0, 100, 1000),
                                  freq = c(1250, 1550, 1600)), 
                  f3 = 2400, f4 = 4000, f5 = 4700, 
                  f6 = 5600, f7 = 7300, f8 = 7800), 
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(-50, 125),
                            value = c(-20, -10) + 0),
  rolloffNoise = -6,
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 10), dB = 'max0')

s2 = soundgen(
  sylLen = 1200, 
  pitchAnchors = data.frame(time = c(0, 70, 150, 1200),
                            value = c(600, 800, 1600, 1400)), 
  amplAnchors = data.frame(time = c(0, 70, 150, 1200),
                           value = c(80, 55, 40, 36)), 
  vibratoDep = 1, vibratoFreq = 3,
  rolloff = c(-15, rep(-30, 20)),
  nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 10,
  formants = c(1000, 1600, 2400, 4000, 4700, 5600, 7300, 7800), 
  noiseAnchors = data.frame(time = c(0, 50, 150, 500, 1200),
                            value = c(-40, -20, -35, -30, -50)),
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 10), dB = 'max0')

s = addVectors(s2, s1 * 3, insertionPoint = 22050 * 0.05)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s1 = soundgen(
  nSyl = 5,
  sylLen = c(125, 120, 160, 160, 140), pauseLen = c(100, 90, 75, 85),
  pitchAnchors = data.frame(time = c(0, .4, 1),
                            value = c(380, 480, 430)), 
  pitchAnchorsGlobal = c(0, -.5),
  vibratoDep = .5, vibratoFreq = 7,
  rolloff = c(-8, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(80, 75),
  # nonlinBalance = 100, subFreq = 150, subDep = c(0, 90), 
  # jitterDep = c(0, .3, 1), shimmerDep = 5,
  formants = list(f1 = data.frame(time = c(0, 100, 1000),
                                  freq = c(600, 900, 1000)),
                  f2 = data.frame(time = c(0, 100, 1000),
                                  freq = c(1250, 1550, 1600)), 
                  f3 = 2400, f4 = 4000, f5 = 4700,
                  f6 = 5600, f7 = 7300, f8 = 7800), 
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(-50, 125),
                            value = c(-20, -10) + 0),
  rolloffNoise = -6,
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s2, s1 * 3, insertionPoint = 22050 * 0.05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  nSyl = 5,
  sylLen = c(125, 120, 160, 160, 140), pauseLen = c(100, 90, 75, 85),
  pitchAnchors = data.frame(time = c(0, .4, 1),
                            value = c(380, 480, 430)), 
  pitchAnchorsGlobal = c(0, -.5),
  vibratoDep = .5, vibratoFreq = 7,
  rolloff = c(-8, -12) + 4, rolloffOct = 0,
  amplAnchorsGlobal = c(80, 75),
  # nonlinBalance = 100, subFreq = 150, subDep = c(0, 90), 
  # jitterDep = c(0, .3, 1), shimmerDep = 5,
  formants = list(f1 = data.frame(time = c(0, 100, 1000),
                                  freq = c(600, 900, 1000)),
                  f2 = data.frame(time = c(0, 100, 1000),
                                  freq = c(1250, 1550, 1600)), 
                  f3 = 2400, f4 = 4000, f5 = 4700,
                  f6 = 5600, f7 = 7300, f8 = 7800), 
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(-50, 125),
                            value = c(-20, -10) + 0),
  rolloffNoise = -6,
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s2, s1 * 3, insertionPoint = 22050 * 0.05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s1 = soundgen(
  nSyl = 5,
  sylLen = c(125, 120, 160, 160, 140), pauseLen = c(100, 90, 75, 85),
  pitchAnchors = data.frame(time = c(0, .4, 1),
                            value = c(380, 480, 430)), 
  pitchAnchorsGlobal = c(0, -.5),
  vibratoDep = .5, vibratoFreq = 7,
  rolloff = c(-8, -12) - 4, rolloffOct = 0,
  amplAnchorsGlobal = c(80, 75),
  # nonlinBalance = 100, subFreq = 150, subDep = c(0, 90), 
  # jitterDep = c(0, .3, 1), shimmerDep = 5,
  formants = list(f1 = data.frame(time = c(0, 100, 1000),
                                  freq = c(600, 900, 1000)),
                  f2 = data.frame(time = c(0, 100, 1000),
                                  freq = c(1250, 1550, 1600)), 
                  f3 = 2400, f4 = 4000, f5 = 4700,
                  f6 = 5600, f7 = 7300, f8 = 7800), 
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(-50, 125),
                            value = c(-20, -10) + 0),
  rolloffNoise = -6,
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s2, s1 * 3, insertionPoint = 22050 * 0.05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 430
subFreq = 150  
subDep = 90
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  nSyl = 5,
  sylLen = c(125, 120, 160, 160, 140), pauseLen = c(100, 90, 75, 85),
  pitchAnchors = data.frame(time = c(0, .4, 1),
                            value = c(380, 480, 430)), 
  pitchAnchorsGlobal = c(0, -.5),
  vibratoDep = .5, vibratoFreq = 7,
  rolloff = c(-8, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(80, 75),
  nonlinBalance = 100, subFreq = 150, subDep = c(0, 90),
  jitterDep = 0,
  formants = list(f1 = data.frame(time = c(0, 100, 1000),
                                  freq = c(600, 900, 1000)),
                  f2 = data.frame(time = c(0, 100, 1000),
                                  freq = c(1250, 1550, 1600)), 
                  f3 = 2400, f4 = 4000, f5 = 4700,
                  f6 = 5600, f7 = 7300, f8 = 7800), 
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(-50, 125),
                            value = c(-20, -10) + 0),
  rolloffNoise = -6,
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s2, s1 * 3, insertionPoint = 22050 * 0.05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_180_150_28.wav'))

# subh2
pitchMedian = 430
subFreq = 75  
subDep = 45
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  nSyl = 5,
  sylLen = c(125, 120, 160, 160, 140), pauseLen = c(100, 90, 75, 85),
  pitchAnchors = data.frame(time = c(0, .4, 1),
                            value = c(380, 480, 430)), 
  pitchAnchorsGlobal = c(0, -.5),
  vibratoDep = .5, vibratoFreq = 7,
  rolloff = c(-8, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(80, 75),
  nonlinBalance = 100, subFreq = 75, subDep = c(0, 45),
  jitterDep = 0,
  formants = list(f1 = data.frame(time = c(0, 100, 1000),
                                  freq = c(600, 900, 1000)),
                  f2 = data.frame(time = c(0, 100, 1000),
                                  freq = c(1250, 1550, 1600)), 
                  f3 = 2400, f4 = 4000, f5 = 4700,
                  f6 = 5600, f7 = 7300, f8 = 7800), 
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(-50, 125),
                            value = c(-20, -10) + 0),
  rolloffNoise = -6,
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s2, s1 * 3, insertionPoint = 22050 * 0.05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_180_75_28.wav'))


## CHAOS
s1 = soundgen(
  nSyl = 5,
  sylLen = c(125, 120, 160, 160, 140), pauseLen = c(100, 90, 75, 85),
  pitchAnchors = data.frame(time = c(0, .4, 1),
                            value = c(380, 480, 430)), 
  pitchAnchorsGlobal = c(0, -.5),
  vibratoDep = .5, vibratoFreq = 7,
  rolloff = c(-8, -12), rolloffOct = 0,
  amplAnchorsGlobal = c(80, 75),
  nonlinBalance = 100, subDep = 0, 
  jitterDep = c(0, .5, 1.5), shimmerDep = c(0, 5, 15),
  formants = list(f1 = data.frame(time = c(0, 100, 1000),
                                  freq = c(600, 900, 1000)),
                  f2 = data.frame(time = c(0, 100, 1000),
                                  freq = c(1250, 1550, 1600)), 
                  f3 = 2400, f4 = 4000, f5 = 4700, 
                  f6 = 5600, f7 = 7300, f8 = 7800), 
  mouthAnchors = c(.5, .4),
  noiseAnchors = data.frame(time = c(-50, 125),
                            value = c(-20, -10) + 0),
  rolloffNoise = -6,
  attackLen = 20,
  temperature = 0.001,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s2, s1 * 3, insertionPoint = 22050 * 0.05)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_180.wav'))
