setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_309'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  nSyl = 7, 
  sylLen = c(55, 60, 55, 55, 60, 60, 80), 
  pauseLen = c(125, 140, 170, 160, 160, 175),
  pitchAnchors = c(280, 380, 280),
  pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
  nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
  rolloff = -12, rolloffOct = 0,
  temperature = 0.001, 
  formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
  noiseAnchors = data.frame(time = c(-160, -80, -10, 10, 45, 55, 230),
                            value = c(-40, -20, -40, -30, -30, -40, -50) - 10),
  formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
  rolloffNoise = -6,
  mouthAnchors = c(.2, .6, .5, .4, .3),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 10), dB = 'max0')

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s = soundgen(
  nSyl = 7, 
  sylLen = c(55, 60, 55, 55, 60, 60, 80), 
  pauseLen = c(125, 140, 170, 160, 160, 175),
  pitchAnchors = c(280, 380, 280),
  pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
  # nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
  rolloff = -12, rolloffOct = 0,
  temperature = 0.001, 
  formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
  noiseAnchors = data.frame(time = c(-160, -80, -10, 10, 45, 55, 230),
                            value = c(-40, -20, -40, -30, -30, -40, -50) - 10),
  formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
  rolloffNoise = -6,
  mouthAnchors = c(.2, .6, .5, .4, .3),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  nSyl = 7, 
  sylLen = c(55, 60, 55, 55, 60, 60, 80), 
  pauseLen = c(125, 140, 170, 160, 160, 175),
  pitchAnchors = c(280, 380, 280),
  pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
  # nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
  rolloff = -12 + 4, rolloffOct = 0,
  temperature = 0.001, 
  formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
  noiseAnchors = data.frame(time = c(-160, -80, -10, 10, 45, 55, 230),
                            value = c(-40, -20, -40, -30, -30, -40, -50) - 10),
  formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
  rolloffNoise = -6,
  mouthAnchors = c(.2, .6, .5, .4, .3),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s = soundgen(
  nSyl = 7, 
  sylLen = c(55, 60, 55, 55, 60, 60, 80), 
  pauseLen = c(125, 140, 170, 160, 160, 175),
  pitchAnchors = c(280, 380, 280),
  pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
  # nonlinBalance = 100, subDep = 0, jitterDep = 1, shimmerDep = 35,
  rolloff = -12 - 4, rolloffOct = 0,
  temperature = 0.001, 
  formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
  noiseAnchors = data.frame(time = c(-160, -80, -10, 10, 45, 55, 230),
                            value = c(-40, -20, -40, -30, -30, -40, -50) - 10),
  formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
  rolloffNoise = -6,
  mouthAnchors = c(.2, .6, .5, .4, .3),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 340
subFreq = 80  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  nSyl = 7, 
  sylLen = c(55, 60, 55, 55, 60, 60, 80), 
  pauseLen = c(125, 140, 170, 160, 160, 175),
  pitchAnchors = c(280, 380, 280),
  pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
  nonlinBalance = 100, subFreq = 80, subDep = 50, jitterDep = 0,
  rolloff = -12, rolloffOct = 0,
  temperature = 0.001, 
  formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
  noiseAnchors = data.frame(time = c(-160, -80, -10, 10, 45, 55, 230),
                            value = c(-40, -20, -40, -30, -30, -40, -50) - 10),
  formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
  rolloffNoise = -6,
  mouthAnchors = c(.2, .6, .5, .4, .3),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_420_80_23.wav'))


## CHAOS
s = soundgen(
  nSyl = 7, 
  sylLen = c(55, 60, 55, 55, 60, 60, 80), 
  pauseLen = c(125, 140, 170, 160, 160, 175),
  pitchAnchors = c(280, 380, 280),
  pitchAnchorsGlobal = c(-2, 0, 0, 0, -1),
  nonlinBalance = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  rolloff = -12, rolloffOct = 0,
  temperature = 0.001, 
  formants = c(1200, 1850, 2600, 4200, 4900, 6000, 6800, 8300),
  noiseAnchors = data.frame(time = c(-160, -80, -10, 10, 45, 55, 230),
                            value = c(-40, -20, -40, -30, -30, -40, -50) - 10),
  formantsNoise = c(1200, 2300, 2650, 4200, 4900, 6000, 6800, 8300),
  rolloffNoise = -6,
  mouthAnchors = c(.2, .6, .5, .4, .3),
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_420.wav'))
