setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_315'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
  rolloff = -6, rolloffOct = 0,
  nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = .1, shortestEpoch = 100,
  temperature = 0.001,
  formants = c(800, 1300, 2700, 3800, 5000),
  mouthAnchors = c(.3, .5),
  noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2_1 = soundgen(
  sylLen = 420,
  pitchAnchors = c(1440, 1050),
  rolloff = -20,
  formants = c(1200, 1500, 2700, 3800),
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s2_2 = soundgen(
  sylLen = 1300,
  pitchAnchors = c(1450, 1000), vibratoDep = .5,
  amplAnchors = c(80, 20),
  rolloff = -20,
  formants = c(1200, 1500, 2700, 3800),
  mouthAnchors = c(.4, .55),
  noiseAnchors = c(10, -40),
  rolloffNoise = 0,
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s2 = addVectors(s2_1 / 2, s2_2)
# playme(s2, 22050)

s3 = soundgen(
  nSyl = 6, 
  sylLen = 180, pauseLen = 100,
  pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
  pitchAnchorsGlobal = c(0, -9),
  rolloff = -5,
  nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = .5,
  temperature = 0.001,
  formants = c(800, 1400, 2700, 3800),
  mouthAnchors = c(.4, .7),
  noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                           value = c(-30, -10, -30, -10, -30) + 5),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s1 = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
  rolloff = -6, rolloffOct = 0,
  # nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = .1, shortestEpoch = 100,
  temperature = 0.001,
  formants = c(800, 1300, 2700, 3800, 5000),
  mouthAnchors = c(.3, .5),
  noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 6, 
  sylLen = 180, pauseLen = 100,
  pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
  pitchAnchorsGlobal = c(0, -9),
  rolloff = -5,
  # nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = .5,
  temperature = 0.001,
  formants = c(800, 1400, 2700, 3800),
  mouthAnchors = c(.4, .7),
  noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                           value = c(-30, -10, -30, -10, -30) + 5),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
  rolloff = -6 + 4, rolloffOct = 0,
  # nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = .1, shortestEpoch = 100,
  temperature = 0.001,
  formants = c(800, 1300, 2700, 3800, 5000),
  mouthAnchors = c(.3, .5),
  noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 6, 
  sylLen = 180, pauseLen = 100,
  pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
  pitchAnchorsGlobal = c(0, -9),
  rolloff = -5 + 4,
  # nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = .5,
  temperature = 0.001,
  formants = c(800, 1400, 2700, 3800),
  mouthAnchors = c(.4, .7),
  noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                           value = c(-30, -10, -30, -10, -30) + 5),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s1 = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 90, 430), value = c(200, 350, 350)),
  rolloff = -6 - 4, rolloffOct = 0,
  # nonlinBalance = 60, subFreq = 80, subDep = 40, jitterDep = .1, shortestEpoch = 100,
  temperature = 0.001,
  formants = c(800, 1300, 2700, 3800, 5000),
  mouthAnchors = c(.3, .5),
  noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 6, 
  sylLen = 180, pauseLen = 100,
  pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
  pitchAnchorsGlobal = c(0, -9),
  rolloff = -5 - 4,
  # nonlinBalance = 50, subFreq = 170, subDep = 70, jitterDep = .5,
  temperature = 0.001,
  formants = c(800, 1400, 2700, 3800),
  mouthAnchors = c(.4, .7),
  noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                           value = c(-30, -10, -30, -10, -30) + 5),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 350
subFreq = 170  
subDep = 100
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 90, 430), 
                            value = c(200, 350, 350)),
  rolloff = -6, rolloffOct = 0,
  nonlinRandomWalk = c(rep(1, 75), rep(0, 25)),
  subFreq = 170, subDep = 100, jitterDep = 0, shortestEpoch = 50,
  temperature = 0.001,
  formants = c(800, 1300, 2700, 3800, 5000),
  mouthAnchors = c(.3, .5),
  noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 6, 
  sylLen = 180, pauseLen = 100,
  pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
  pitchAnchorsGlobal = c(0, -9),
  rolloff = -5,
  nonlinRandomWalk = c(rep(1, 50), rep(0, 50)),
  subFreq = 170, subDep = 100, jitterDep = 0,
  temperature = 0.001,
  formants = c(800, 1400, 2700, 3800),
  mouthAnchors = c(.4, .7),
  noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                           value = c(-30, -10, -30, -10, -30) + 5),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_800_170_22.wav'))

# subh2
pitchMedian = 350
subFreq = 80  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 90, 430), 
                            value = c(200, 350, 350)),
  rolloff = -6, rolloffOct = 0,
  nonlinRandomWalk = c(rep(1, 75), rep(0, 25)),
  subFreq = 80, subDep = 50, jitterDep = 0, shortestEpoch = 50,
  temperature = 0.001,
  formants = c(800, 1300, 2700, 3800, 5000),
  mouthAnchors = c(.3, .5),
  noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 6, 
  sylLen = 180, pauseLen = 100,
  pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
  pitchAnchorsGlobal = c(0, -9),
  rolloff = -5,
  nonlinRandomWalk = c(rep(1, 50), rep(0, 50)),
  subFreq = 80, subDep = 50, jitterDep = 0,
  temperature = 0.001,
  formants = c(800, 1400, 2700, 3800),
  mouthAnchors = c(.4, .7),
  noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                           value = c(-30, -10, -30, -10, -30) + 5),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_800_80_22.wav'))


## CHAOS
s1 = soundgen(
  sylLen = 430,
  pitchAnchors = data.frame(time = c(0, 90, 430), 
                            value = c(200, 350, 350)),
  rolloff = -6, rolloffOct = 0,
  nonlinRandomWalk = c(rep(2, 75), rep(0, 25)),
  subDep = 0, jitterDep = c(.5, 1.5), shimmerDep = c(5, 15), shortestEpoch = 50,
  temperature = 0.001,
  formants = c(800, 1300, 2700, 3800, 5000),
  mouthAnchors = c(.3, .5),
  noiseAnchors = data.frame(time = c(0, 400, 470), value = c(-40, -40, -20)),
  attackLen = 10,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 6, 
  sylLen = 180, pauseLen = 100,
  pitchAnchors = c(600, 750, 550), vibratoFreq = 9, vibratoDep = 1,
  pitchAnchorsGlobal = c(0, -9),
  rolloff = -5,
  nonlinRandomWalk = c(rep(2, 50), rep(0, 50)),
  subDep = 0, jitterDep = c(.5, 1.5), shimmerDep = c(5, 15), shortestEpoch = 50,
  temperature = 0.001,
  formants = c(800, 1400, 2700, 3800),
  mouthAnchors = c(.4, .7),
  noiseAnchors =data.frame(time = c(0, 35, 105, 140, 220),
                           value = c(-30, -10, -30, -10, -30) + 5),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) - 22050 * 0.05)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .42)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_800.wav'))
