setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_316'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 315,
  pitchAnchors = c(350, 320),
  rolloff = c(-5, -3),
  nonlinBalance = 100, subDep = 0, jitterDep = c(0, .3, .6),
  temperature = 0.001,
  formants = list(
    f1 = c(850, 700, 850),
    f2 = c(1700, 1000, 1300),
    f3 = c(2400, 3100),
    f4 = 3800, f5 = 5000, f6 = 5700, f7 = 6500
  ),
  noiseAnchors = data.frame(time = c(0, 200, 370), 
                            value = c(-40, -30, -25)),
  attackLen = c(20, 50),
  addSilence = 0, 
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  sylLen = 1000,
  pitchAnchors = data.frame(time = c(0, .1, 1), value = c(500, 970, 770)), vibratoDep = .5,
  amplAnchors = data.frame(time = c(0, .1, 1), value = c(50, 80, 20)),
  rolloff = -25,
  nonlinBalance = 100, subFreq = 230, subDep = 150, jitterDep = 1, shimmerDep = 20,
  formants = c(850, 1400, 2300, 3200),
  mouthAnchors = c(.4, .55),
  noiseAnchors = c(0, -30, -50),
  formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 4, sylLen = 120, pauseLen = 120,
  pitchAnchors = data.frame(time = c(0, .2, .3, .31, 1), 
                            value = c(330, 510, 470, 350, 320)), 
  vibratoFreq = 9, vibratoDep = 1,
  amplAnchorsGlobal = c(80, 70),
  pitchAnchorsGlobal = c(0, -3), 
  rolloff = -8, 
  temperature = 0.001,
  formants = c(900, 1350, 3000, 4100, 4900),
  mouthAnchors = c(.4, .6),
  noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                            value = c(-30, -20, -30, -20, -30) + 10),
  formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s1 = soundgen(
  sylLen = 315,
  pitchAnchors = c(350, 320),
  rolloff = c(-5, -3),
  # nonlinBalance = 100, subDep = 0, jitterDep = c(0, .3, .6),
  temperature = 0.001,
  formants = list(
    f1 = c(850, 700, 850),
    f2 = c(1700, 1000, 1300),
    f3 = c(2400, 3100),
    f4 = 3800, f5 = 5000, f6 = 5700, f7 = 6500
  ),
  noiseAnchors = data.frame(time = c(0, 200, 370), 
                            value = c(-40, -30, -25)),
  attackLen = c(20, 50),
  addSilence = 0, 
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 4, sylLen = 120, pauseLen = 120,
  pitchAnchors = data.frame(time = c(0, .2, .31, 1), 
                            value = c(330, 510, 350, 320)), 
  vibratoFreq = 9, vibratoDep = 1,
  amplAnchorsGlobal = c(80, 70),
  pitchAnchorsGlobal = c(0, -3), 
  rolloff = -8, 
  temperature = 0.001,
  formants = c(900, 1350, 3000, 4100, 4900),
  mouthAnchors = c(.4, .6),
  noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                            value = c(-30, -20, -30, -20, -30) + 10),
  formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  sylLen = 315,
  pitchAnchors = c(350, 320),
  rolloff = c(-5, -3) + 4, invalidArgAction = 'ignore',
  nonlinBalance = 100, subDep = 0, jitterDep = c(0, .3, .6),
  temperature = 0.001,
  formants = list(
    f1 = c(850, 700, 850),
    f2 = c(1700, 1000, 1300),
    f3 = c(2400, 3100),
    f4 = 3800, f5 = 5000, f6 = 5700, f7 = 6500
  ),
  noiseAnchors = data.frame(time = c(0, 200, 370), 
                            value = c(-40, -30, -25)),
  attackLen = c(20, 50),
  addSilence = 0, 
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 4, sylLen = 120, pauseLen = 120,
  pitchAnchors = data.frame(time = c(0, .2, .31, 1), 
                            value = c(330, 510, 350, 320)), 
  vibratoFreq = 9, vibratoDep = 1,
  amplAnchorsGlobal = c(80, 70),
  pitchAnchorsGlobal = c(0, -3), 
  rolloff = -8 + 4, 
  temperature = 0.001,
  formants = c(900, 1350, 3000, 4100, 4900),
  mouthAnchors = c(.4, .6),
  noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                            value = c(-30, -20, -30, -20, -30) + 10),
  formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s1 = soundgen(
  sylLen = 315,
  pitchAnchors = c(350, 320),
  rolloff = c(-5, -3) - 4,
  nonlinBalance = 100, subDep = 0, jitterDep = c(0, .3, .6),
  temperature = 0.001,
  formants = list(
    f1 = c(850, 700, 850),
    f2 = c(1700, 1000, 1300),
    f3 = c(2400, 3100),
    f4 = 3800, f5 = 5000, f6 = 5700, f7 = 6500
  ),
  noiseAnchors = data.frame(time = c(0, 200, 370), 
                            value = c(-40, -30, -25)),
  attackLen = c(20, 50),
  addSilence = 0, 
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 4, sylLen = 120, pauseLen = 120,
  pitchAnchors = data.frame(time = c(0, .2, .31, 1), 
                            value = c(330, 510, 350, 320)), 
  vibratoFreq = 9, vibratoDep = 1,
  amplAnchorsGlobal = c(80, 70),
  pitchAnchorsGlobal = c(0, -3), 
  rolloff = -8 - 4, 
  temperature = 0.001,
  formants = c(900, 1350, 3000, 4100, 4900),
  mouthAnchors = c(.4, .6),
  noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                            value = c(-30, -20, -30, -20, -30) + 10),
  formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 330
subFreq = 80  
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 315,
  pitchAnchors = c(350, 320),
  rolloff = c(-5, -3),
  nonlinBalance = 100, 
  subFreq = 80, subDep = c(40, 60), jitterDep = 0,
  temperature = 0.001,
  formants = list(
    f1 = c(850, 700, 850),
    f2 = c(1700, 1000, 1300),
    f3 = c(2400, 3100),
    f4 = 3800, f5 = 5000, f6 = 5700, f7 = 6500
  ),
  noiseAnchors = data.frame(time = c(0, 200, 370), 
                            value = c(-40, -30, -25)),
  attackLen = c(20, 50),
  addSilence = 0, 
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 4, sylLen = 120, pauseLen = 120,
  pitchAnchors = data.frame(time = c(0, .2, .31, 1), 
                            value = c(330, 510, 350, 320)), 
  vibratoFreq = 9, vibratoDep = 1,
  amplAnchorsGlobal = c(80, 70),
  pitchAnchorsGlobal = c(0, -3), 
  rolloff = -8, 
  temperature = 0.001,
  formants = c(900, 1350, 3000, 4100, 4900),
  mouthAnchors = c(.4, .6),
  noiseAnchors = data.frame(time = c(0, 15, 30, 120, 140),
                            value = c(-30, -20, -30, -20, -30) + 10),
  formantsNoise = c(1000, 1300, 3200, 4000, 5000, 6000, 7000, 8000),
  rolloffNoise = 0,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_350_80_39.wav'))


## CHAOS
s1 = soundgen(
  sylLen = 315,
  pitchAnchors = c(350, 320),
  rolloff = c(-5, -3),
  nonlinBalance = 100, 
  subDep = 0, jitterDep = c(.5, 1.5), shimmerDep = c(5, 15),
  temperature = 0.001,
  formants = list(
    f1 = c(850, 700, 850),
    f2 = c(1700, 1000, 1300),
    f3 = c(2400, 3100),
    f4 = 3800, f5 = 5000, f6 = 5700, f7 = 6500
  ),
  noiseAnchors = data.frame(time = c(0, 200, 370), 
                            value = c(-40, -30, -25)),
  attackLen = c(20, 50),
  addSilence = 0, 
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.15)
s = addVectors(s, s3, insertionPoint = length(s1) + 22050 * .14)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_350.wav'))
