setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'l_412'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  nSyl = 4,
  sylLen = c(80, 50, 70, 60), pauseLen = c(160, 90, 150),
  pitchAnchors = c(770, 860, 790),
  pitchAnchorsGlobal = c(0, -2, -2, -4),
  rolloff = c(-2, -8), rolloffOct = -3, rolloffKHz = 0,
  temperature = 0.001,
  formants = c(600, 1600, 3600, 4100, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(0, 80, 230),
                            value = c(-20, -30, -50) + 10),
  rolloffNoise = -6,
  attackLen = 15,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  nSyl = 3,
  sylLen = 30, pauseLen = c(410, 500),
  pitchAnchors = 570,
  pitchAnchorsGlobal = c(0, -1, 2),
  rolloff = -20,
  temperature = 0.001,
  formants = c(600, 1900, 3700, 4400, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(0, 140),
                            value = c(-30, -50)),
  rolloffNoise = -6,
  attackLen = 100,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3,
  sylLen = c(200, 215, 170), pauseLen = c(360, 370),
  pitchAnchors = data.frame(time = c(0, .3, 1),
                            value = c(500, 800, 700)),
  pitchAnchorsGlobal = c(0, 1, 2),
  amplAnchorsGlobal = c(0, -5),
  rolloff = c(-12, -8, -12),
  nonlinBalance = 100, subDep = 0,
  jitterDep = .7, shimmerDep = 15,
  temperature = 0.001,
  formants = c(600, 1900, 3700, 4400, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(-20, 100, 200, 400),
                            value = c(-30, -10, -30, -50) + 0),
  rolloffNoise = -6,
  attackLen = 100,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.01)
s = addVectors(s * 1.5, s3, insertionPoint = length(s1) + 22050 * 0.08)

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 8))
seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s3 = soundgen(
  nSyl = 3,
  sylLen = c(200, 215, 170), pauseLen = c(360, 370),
  pitchAnchors = data.frame(time = c(0, .3, 1),
                            value = c(500, 800, 700)),
  pitchAnchorsGlobal = c(0, 1, 2),
  amplAnchorsGlobal = c(80, 75),
  rolloff = c(-12, -8, -12),
  # nonlinBalance = 100, subDep = 0,
  # jitterDep = .7, shimmerDep = 15,
  temperature = 0.001,
  formants = c(600, 1900, 3700, 4400, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(-20, 100, 200, 400),
                            value = c(-30, -10, -30, -50) + 0),
  rolloffNoise = -6,
  attackLen = 100,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.01)
s = addVectors(s * 1.5, s3, insertionPoint = length(s1) + 22050 * 0.08)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s1 = soundgen(
  nSyl = 4,
  sylLen = c(80, 50, 70, 60), pauseLen = c(160, 90, 150),
  pitchAnchors = c(770, 860, 790),
  pitchAnchorsGlobal = c(0, -2, -2, -4),
  rolloff = c(-2, -8) + 4, invalidArgAction = 'ignore',
  rolloffOct = -3, rolloffKHz = 0,
  temperature = 0.001,
  formants = c(600, 1600, 3600, 4100, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(0, 80, 230),
                            value = c(-20, -30, -50) + 10),
  rolloffNoise = -6,
  attackLen = 15,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3,
  sylLen = c(200, 215, 170), pauseLen = c(360, 370),
  pitchAnchors = data.frame(time = c(0, .3, 1),
                            value = c(500, 800, 700)),
  pitchAnchorsGlobal = c(0, 1, 2),
  amplAnchorsGlobal = c(80, 75),
  rolloff = c(-12, -8, -12) + 4,
  # nonlinBalance = 100, subDep = 0,
  # jitterDep = .7, shimmerDep = 15,
  temperature = 0.001,
  formants = c(600, 1900, 3700, 4400, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(-20, 100, 200, 400),
                            value = c(-30, -10, -30, -50) + 0),
  rolloffNoise = -6,
  attackLen = 100,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.01)
s = addVectors(s * 1.5, s3, insertionPoint = length(s1) + 22050 * 0.08)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))


# no nonlin rolloff -4
s1 = soundgen(
  nSyl = 4,
  sylLen = c(80, 50, 70, 60), pauseLen = c(160, 90, 150),
  pitchAnchors = c(770, 860, 790),
  pitchAnchorsGlobal = c(0, -2, -2, -4),
  rolloff = c(-2, -8) - 4, invalidArgAction = 'ignore',
  rolloffOct = -3, rolloffKHz = 0,
  temperature = 0.001,
  formants = c(600, 1600, 3600, 4100, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(0, 80, 230),
                            value = c(-20, -30, -50) + 10),
  rolloffNoise = -6,
  attackLen = 15,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3,
  sylLen = c(200, 215, 170), pauseLen = c(360, 370),
  pitchAnchors = data.frame(time = c(0, .3, 1),
                            value = c(500, 800, 700)),
  pitchAnchorsGlobal = c(0, 1, 2),
  amplAnchorsGlobal = c(80, 75),
  rolloff = c(-12, -8, -12) - 4,
  # nonlinBalance = 100, subDep = 0,
  # jitterDep = .7, shimmerDep = 15,
  temperature = 0.001,
  formants = c(600, 1900, 3700, 4400, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(-20, 100, 200, 400),
                            value = c(-30, -10, -30, -50) + 0),
  rolloffNoise = -6,
  attackLen = 100,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.01)
s = addVectors(s * 1.5, s3, insertionPoint = length(s1) + 22050 * 0.08)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 750
subFreq = 350
subDep = 200
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  nSyl = 4,
  sylLen = c(80, 50, 70, 60), pauseLen = c(160, 90, 150),
  pitchAnchors = c(770, 860, 790),
  pitchAnchorsGlobal = c(0, -2, -2, -4),
  rolloff = c(-2, -8), rolloffOct = -3, rolloffKHz = 0,
  nonlinRandomWalk = c(rep(1, 60), rep(0, 40)),
  subFreq = 350, subDep = 200,
  temperature = 0.001,
  formants = c(600, 1600, 3600, 4100, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(0, 80, 230),
                            value = c(-20, -30, -50) + 10),
  rolloffNoise = -6,
  attackLen = 15,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3,
  sylLen = c(200, 215, 170), pauseLen = c(360, 370),
  pitchAnchors = data.frame(time = c(0, .3, 1),
                            value = c(500, 800, 700)),
  pitchAnchorsGlobal = c(0, 1, 2),
  amplAnchorsGlobal = c(80, 75),
  rolloff = c(-12, -8, -12),
  nonlinRandomWalk = c(rep(0, 40), rep(1, 60)),
  subFreq = 350, subDep = 200, 
  temperature = 0.001,
  formants = c(600, 1900, 3700, 4400, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(-20, 100, 200, 400),
                            value = c(-30, -10, -30, -50) + 0),
  rolloffNoise = -6,
  attackLen = 100,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.01)
s = addVectors(s * 1.5, s3, insertionPoint = length(s1) + 22050 * 0.08)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_350_17.wav'))

# subh2
pitchMedian = 750
subFreq = 120
subDep = 67
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  nSyl = 4,
  sylLen = c(80, 50, 70, 60), pauseLen = c(160, 90, 150),
  pitchAnchors = c(770, 860, 790),
  pitchAnchorsGlobal = c(0, -2, -2, -4),
  rolloff = c(-2, -8), rolloffOct = -3, rolloffKHz = 0,
  nonlinRandomWalk = c(rep(1, 60), rep(0, 40)),
  subFreq = 120, subDep = 67,
  temperature = 0.001,
  formants = c(600, 1600, 3600, 4100, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(0, 80, 230),
                            value = c(-20, -30, -50) + 10),
  rolloffNoise = -6,
  attackLen = 15,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3,
  sylLen = c(200, 215, 170), pauseLen = c(360, 370),
  pitchAnchors = data.frame(time = c(0, .3, 1),
                            value = c(500, 800, 700)),
  pitchAnchorsGlobal = c(0, 1, 2),
  amplAnchorsGlobal = c(80, 75),
  rolloff = c(-12, -8, -12),
  nonlinRandomWalk = c(rep(0, 40), rep(1, 60)),
  subFreq = 120, subDep = 67, 
  temperature = 0.001,
  formants = c(600, 1900, 3700, 4400, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(-20, 100, 200, 400),
                            value = c(-30, -10, -30, -50) + 0),
  rolloffNoise = -6,
  attackLen = 100,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.01)
s = addVectors(s * 1.5, s3, insertionPoint = length(s1) + 22050 * 0.08)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_120_17.wav'))

## CHAOS
s1 = soundgen(
  nSyl = 4,
  sylLen = c(80, 50, 70, 60), pauseLen = c(160, 90, 150),
  pitchAnchors = c(770, 860, 790),
  pitchAnchorsGlobal = c(0, -2, -2, -4),
  rolloff = c(-2, -8), rolloffOct = -3, rolloffKHz = 0,
  nonlinRandomWalk = c(rep(2, 60), rep(0, 40)),
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = c(600, 1600, 3600, 4100, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(0, 80, 230),
                            value = c(-20, -30, -50) + 10),
  rolloffNoise = -6,
  attackLen = 15,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s3 = soundgen(
  nSyl = 3,
  sylLen = c(200, 215, 170), pauseLen = c(360, 370),
  pitchAnchors = data.frame(time = c(0, .3, 1),
                            value = c(500, 800, 700)),
  pitchAnchorsGlobal = c(0, 1, 2),
  amplAnchorsGlobal = c(80, 75),
  rolloff = c(-12, -8, -12),
  nonlinRandomWalk = c(rep(0, 40), rep(1, 60)),
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  formants = c(600, 1900, 3700, 4400, 6700, 7900, 8200),
  noiseAnchors = data.frame(time = c(-20, 100, 200, 400),
                            value = c(-30, -10, -30, -50) + 0),
  rolloffNoise = -6,
  attackLen = 100,
  addSilence = 0,
  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2 / 5, insertionPoint = length(s1) - 22050 * 0.01)
s = addVectors(s * 1.5, s3, insertionPoint = length(s1) + 22050 * 0.08)

playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_500.wav'))
