setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_085'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# p = a$pitch[!is.na(a$pitch)]
# round(p[seq(1, length(p), 4)])

# original
s = soundgen(
  sylLen = 500,
  pitchAnchors = c(411, 443, 445, 417, 405, 345),
  amplAnchors = c(60, 70, 80, 70),
  rolloff = c(-13, -4, -6, -9),
  nonlinBalance = 100, subDep = 0, jitterDep = 0, shimmerDep = 5,
  temperature = 0.001, 
  formants = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                  f3 = c(4300, 3500, 3200), 
                  f4 = c(5500, 5100, 5000), f5 = 6700), 
  noiseAnchors = data.frame(time = c(0, 400, 500, 600),
                            value = c(-50, -40, -20, -40)),
  formantsNoise = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                       f3 = c(4300, 3500, 3200), 
                       f4 = c(5500, 5100, 5000), 
                       f5 = data.frame(freq = 6000, width = 3000, amp = 30)),
  rolloffNoise = -6,
  attackLen = 30, 
  addSilence = 0,  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
) 

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 500,
  pitchAnchors = c(411, 443, 445, 417, 405, 345),
  amplAnchors = c(60, 70, 80, 70),
  rolloff = c(-13, -4, -6, -9),
  # nonlinBalance = 100, subDep = 0, jitterDep = 0, shimmerDep = 5,
  temperature = 0.001, 
  formants = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                  f3 = c(4300, 3500, 3200), 
                  f4 = c(5500, 5100, 5000), f5 = 6700), 
  noiseAnchors = data.frame(time = c(0, 400, 500, 600),
                            value = c(-50, -40, -20, -40)),
  formantsNoise = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                       f3 = c(4300, 3500, 3200), 
                       f4 = c(5500, 5100, 5000), 
                       f5 = data.frame(freq = 6000, width = 3000, amp = 30)),
  rolloffNoise = -6,
  attackLen = 30, 
  addSilence = 0,  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
) 

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 500,
  pitchAnchors = c(411, 443, 445, 417, 405, 345),
  amplAnchors = c(60, 70, 80, 70),
  rolloff = c(-13, -4, -6, -9) + 4,
  nonlinBalance = 100, subDep = 0, jitterDep = 0, shimmerDep = 5,
  temperature = 0.001, 
  formants = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                  f3 = c(4300, 3500, 3200), 
                  f4 = c(5500, 5100, 5000), f5 = 6700), 
  noiseAnchors = data.frame(time = c(0, 400, 500, 600),
                            value = c(-50, -40, -20, -40)),
  formantsNoise = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                       f3 = c(4300, 3500, 3200), 
                       f4 = c(5500, 5100, 5000), 
                       f5 = data.frame(freq = 6000, width = 3000, amp = 30)),
  rolloffNoise = -6,
  attackLen = 30, 
  addSilence = 0,  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
) 
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 500,
  pitchAnchors = c(411, 443, 445, 417, 405, 345),
  amplAnchors = c(60, 70, 80, 70),
  rolloff = c(-13, -4, -6, -9) - 4,
  nonlinBalance = 100, subDep = 0, jitterDep = 0, shimmerDep = 5,
  temperature = 0.001, 
  formants = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                  f3 = c(4300, 3500, 3200), 
                  f4 = c(5500, 5100, 5000), f5 = 6700), 
  noiseAnchors = data.frame(time = c(0, 400, 500, 600),
                            value = c(-50, -40, -20, -40)),
  formantsNoise = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                       f3 = c(4300, 3500, 3200), 
                       f4 = c(5500, 5100, 5000), 
                       f5 = data.frame(freq = 6000, width = 3000, amp = 30)),
  rolloffNoise = -6,
  attackLen = 30, 
  addSilence = 0,  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
) 
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 420
subFreq = 90  
subDep = 70
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 500,
  pitchAnchors = c(411, 443, 445, 417, 405, 345),
  amplAnchors = c(60, 70, 80, 70),
  rolloff = c(-13, -4, -6, -9),
  nonlinRandomWalk = c(rep(1, 80), rep(0, 20)) , 
  subFreq = 90, subDep = c(20, 70),
  temperature = 0.001, 
  formants = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                  f3 = c(4300, 3500, 3200), 
                  f4 = c(5500, 5100, 5000), f5 = 6700), 
  noiseAnchors = data.frame(time = c(0, 400, 500, 600),
                            value = c(-50, -40, -20, -40)),
  formantsNoise = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                       f3 = c(4300, 3500, 3200), 
                       f4 = c(5500, 5100, 5000), 
                       f5 = data.frame(freq = 6000, width = 3000, amp = 30)),
  rolloffNoise = -6,
  attackLen = 30, 
  addSilence = 0,  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
) 

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_400_90_48.wav'))

# subh2
pitchMedian = 420
subFreq = 150  
subDep = 115
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 500,
  pitchAnchors = c(411, 443, 445, 417, 405, 345),
  amplAnchors = c(60, 70, 80, 70),
  rolloff = c(-13, -4, -6, -9),
  nonlinRandomWalk = c(rep(1, 80), rep(0, 20)) , 
  subFreq = 150, subDep = c(50, 115),
  temperature = 0.001, 
  formants = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                  f3 = c(4300, 3500, 3200), 
                  f4 = c(5500, 5100, 5000), f5 = 6700), 
  noiseAnchors = data.frame(time = c(0, 400, 500, 600),
                            value = c(-50, -40, -20, -40)),
  formantsNoise = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                       f3 = c(4300, 3500, 3200), 
                       f4 = c(5500, 5100, 5000), 
                       f5 = data.frame(freq = 6000, width = 3000, amp = 30)),
  rolloffNoise = -6,
  attackLen = 30, 
  addSilence = 0,  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
) 

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_400_150_48.wav'))


## CHAOS
s = soundgen(
  sylLen = 500,
  pitchAnchors = c(411, 443, 445, 417, 405, 345),
  amplAnchors = c(60, 70, 80, 70),
  rolloff = c(-13, -4, -6, -9),
  nonlinRandomWalk = c(rep(2, 80), rep(0, 20)), 
  subDep = 0, jitterDep = c(0, 1.5), shimmerDep = c(0, 15),
  temperature = 0.001, 
  formants = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                  f3 = c(4300, 3500, 3200), 
                  f4 = c(5500, 5100, 5000), f5 = 6700), 
  noiseAnchors = data.frame(time = c(0, 400, 500, 600),
                            value = c(-50, -40, -20, -40)),
  formantsNoise = list(f1 = c(600, 500), f2 = c(1500, 1300), 
                       f3 = c(4300, 3500, 3200), 
                       f4 = c(5500, 5100, 5000), 
                       f5 = data.frame(freq = 6000, width = 3000, amp = 30)),
  rolloffNoise = -6,
  attackLen = 30, 
  addSilence = 0,  samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
) 

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_400.wav'))
