setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_119'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 620,
  pitchAnchors = c(250, 210),
  rolloff = c(-5, 0, -5),
  nonlinBalance = 100, subFreq = 120, subDep = c(1, 70, 75, 50), 
  jitterDep = 0, shimmerDep = 5,
  temperature = 0.001, 
  formants = c(400, 840, 2800, 3800, 4900),
  noiseAnchors = c(-20, -30),
  attackLen = 100, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 620,
  pitchAnchors = c(250, 210),
  rolloff = c(-5, 0, -5),
  # nonlinBalance = 100, subFreq = 120, subDep = c(1, 70, 75, 50), 
  # jitterDep = 0, shimmerDep = 5,
  temperature = 0.001, 
  formants = c(400, 840, 2800, 3800, 4900),
  noiseAnchors = c(-20, -30),
  attackLen = 100, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 620,
  pitchAnchors = c(250, 210),
  rolloff = c(-5, 0, -5) + 4, invalidArgAction = 'ignore',
  # nonlinBalance = 100, subFreq = 120, subDep = c(1, 70, 75, 50), 
  # jitterDep = 0, shimmerDep = 5,
  temperature = 0.001, 
  formants = c(400, 840, 2800, 3800, 4900),
  noiseAnchors = c(-20, -30),
  attackLen = 100, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 620,
  pitchAnchors = c(250, 210),
  rolloff = c(-5, 0, -5) - 4, 
  # nonlinBalance = 100, subFreq = 120, subDep = c(1, 70, 75, 50), 
  # jitterDep = 0, shimmerDep = 5,
  temperature = 0.001, 
  formants = c(400, 840, 2800, 3800, 4900),
  noiseAnchors = c(-20, -30),
  attackLen = 100, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 220
subFreq = 120  
subDep = 75
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 620,
  pitchAnchors = c(250, 210),
  rolloff = c(-5, 0, -5),
  nonlinRandomWalk = c(rep(0, 20), rep(1, 80)), 
  subFreq = 120, subDep = c(1, 70, 75, 50), 
  jitterDep = 0, shimmerDep = 0,
  temperature = 0.001, 
  formants = c(400, 840, 2800, 3800, 4900),
  noiseAnchors = c(-20, -30),
  attackLen = 100, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_120_34.wav'))


## CHAOS
s = soundgen(
  sylLen = 620,
  pitchAnchors = c(250, 210),
  rolloff = c(-5, 0, -5),
  nonlinRandomWalk = c(rep(0, 20), rep(2, 80)) , 
  subDep = 0, jitterDep = c(0, 1.5, 0), shimmerDep = c(0, 15, 0),
  temperature = 0.001, 
  formants = c(400, 840, 2800, 3800, 4900),
  noiseAnchors = c(-20, -30),
  attackLen = 100, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_500.wav'))
