setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_156'

a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
a$pitch

# original
s = soundgen(
  sylLen = 215,
  pitchAnchors = c(330, 315),
  rolloff = c(-10, -20),
  nonlinBalance = 100, subDep = 0, jitterDep = c(.2, .5), shimmerDep = c(5, 10),
  temperature = 0.001, 
  formants = c(800, 1400, 3000, 4200, 5160, 6200, 7500, 8000, 8300),
  noiseAnchors = data.frame(time = c(-20, 20, 215, 350),
                            value = c(-10, -25, -25, -80) - 10),
  rolloffNoise = c(-4, 0),
  attackLen = c(10, 150), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 215,
  pitchAnchors = c(330, 315),
  rolloff = c(-10, -20),
  # nonlinBalance = 100, subDep = 0, jitterDep = c(.2, .5), shimmerDep = c(5, 10),
  temperature = 0.001, 
  formants = c(800, 1400, 3000, 4200, 5160, 6200, 7500, 8000, 8300),
  noiseAnchors = data.frame(time = c(-20, 20, 215, 350),
                            value = c(-10, -25, -25, -80) - 10),
  rolloffNoise = c(-4, 0),
  attackLen = c(10, 150), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 215,
  pitchAnchors = c(330, 315),
  rolloff = c(-10, -20) + 6,
  # nonlinBalance = 100, subDep = 0, jitterDep = c(.2, .5), shimmerDep = c(5, 10),
  temperature = 0.001, 
  formants = c(800, 1400, 3000, 4200, 5160, 6200, 7500, 8000, 8300),
  noiseAnchors = data.frame(time = c(-20, 20, 215, 350),
                            value = c(-10, -25, -25, -80) - 10),
  rolloffNoise = c(-4, 0),
  attackLen = c(10, 150), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 215,
  pitchAnchors = c(330, 315),
  rolloff = c(-10, -20) - 6,
  # nonlinBalance = 100, subDep = 0, jitterDep = c(.2, .5), shimmerDep = c(5, 10),
  temperature = 0.001, 
  formants = c(800, 1400, 3000, 4200, 5160, 6200, 7500, 8000, 8300),
  noiseAnchors = data.frame(time = c(-20, 20, 215, 350),
                            value = c(-10, -25, -25, -80) - 10),
  rolloffNoise = c(-4, 0),
  attackLen = c(10, 150), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 320
subFreq = 110  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 215,
  pitchAnchors = c(330, 315),
  rolloff = c(-10, -20),
  nonlinBalance = 100, subFreq = 110, subDep = c(50, 40), 
  jitterDep = 0, shimmerDep = 0,
  temperature = 0.001, 
  formants = c(800, 1400, 3000, 4200, 5160, 6200, 7500, 8000, 8300),
  noiseAnchors = data.frame(time = c(-20, 20, 215, 350),
                            value = c(-10, -25, -25, -80) - 10),
  rolloffNoise = c(-4, 0),
  attackLen = c(10, 150), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_200_110_10.wav'))


## CHAOS
s = soundgen(
  sylLen = 215,
  pitchAnchors = c(330, 315),
  rolloff = c(-10, -20),
  nonlinBalance = 100, subDep = 0, jitterDep = c(1.5, .5), shimmerDep = c(15, 5),
  temperature = 0.001, 
  formants = c(800, 1400, 3000, 4200, 5160, 6200, 7500, 8000, 8300),
  noiseAnchors = data.frame(time = c(-20, 20, 215, 350),
                            value = c(-10, -25, -25, -80) - 10),
  rolloffNoise = c(-4, 0),
  attackLen = c(10, 150), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_200.wav'))
