setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_180'

a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
a$pitch

# original
s = soundgen(
  sylLen = 380, 
  pitchAnchors = data.frame(time = c(0, 100, 380),
                            value = c(250, 310, 250)),
  temperature = 0.001, 
  rolloff = c(-8, -9, -14), rolloffParab = 10, rolloffParabHarm = 10,
  formants = c(750, 1250, 2900, 3900, 4900, 6000, 7300), 
  mouthAnchors = c(.5, .6),
  noiseAnchors = data.frame(time = c(0, 250, 400, 720), 
                            value = c(-40, -25, -15, -40)),
  rolloffNoise = -4,
  attackLen = 10,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 380, 
  pitchAnchors = data.frame(time = c(0, 100, 380),
                            value = c(250, 310, 250)),
  temperature = 0.001, 
  rolloff = c(-8, -9, -14) + 6, rolloffParab = 10, rolloffParabHarm = 10,
  formants = c(750, 1250, 2900, 3900, 4900, 6000, 7300), 
  mouthAnchors = c(.5, .6),
  noiseAnchors = data.frame(time = c(0, 250, 400, 720), 
                            value = c(-40, -25, -15, -40)),
  rolloffNoise = -4,
  attackLen = 10,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 380, 
  pitchAnchors = data.frame(time = c(0, 100, 380),
                            value = c(250, 310, 250)),
  temperature = 0.001, 
  rolloff = c(-8, -9, -14) - 6, rolloffParab = 10, rolloffParabHarm = 10,
  formants = c(750, 1250, 2900, 3900, 4900, 6000, 7300), 
  mouthAnchors = c(.5, .6),
  noiseAnchors = data.frame(time = c(0, 250, 400, 720), 
                            value = c(-40, -25, -15, -40)),
  rolloffNoise = -4,
  attackLen = 10,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 280
subFreq = 120  
subDep = 70
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 380, 
  pitchAnchors = data.frame(time = c(0, 100, 380),
                            value = c(250, 310, 250)),
  nonlinRandomWalk = c(rep(0, 20), rep(1, 50), rep(0, 30)), 
  subFreq = 120, subDep = 70,
  temperature = 0.001, 
  rolloff = c(-8, -9, -14), rolloffParab = 10, rolloffParabHarm = 10,
  formants = c(750, 1250, 2900, 3900, 4900, 6000, 7300), 
  mouthAnchors = c(.5, .6),
  noiseAnchors = data.frame(time = c(0, 250, 400, 720), 
                            value = c(-40, -25, -15, -40)),
  rolloffNoise = -4,
  attackLen = 10,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_190_120_14.wav'))


## CHAOS
rw = c(rep(2, 50), rep(0, 50)) 

s = soundgen(
  sylLen = 380, 
  pitchAnchors = data.frame(time = c(0, 100, 380),
                            value = c(250, 310, 250)),
  nonlinRandomWalk = c(rep(0, 20), rep(2, 50), rep(0, 30)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001, 
  rolloff = c(-8, -9, -14), rolloffParab = 10, rolloffParabHarm = 10,
  formants = c(750, 1250, 2900, 3900, 4900, 6000, 7300), 
  mouthAnchors = c(.5, .6),
  noiseAnchors = data.frame(time = c(0, 250, 400, 720), 
                            value = c(-40, -25, -15, -40)),
  rolloffNoise = -4,
  attackLen = 10,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 10)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_190.wav'))
