setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_365'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 490,
  pitchAnchors = data.frame(time = c(0, 90, 300, 430, 490),
                            value = c(370, 405, 360, 270, 100)),
  amplAnchors = c(80, 75, 60),
  rolloff = -6,
  nonlinBalance = 100, subFreq = 95, subDep = c(0, 50, 70, 70, 0), 
  jitterDep = 0.75, shimmerDep = 10,
  temperature = 0.001, 
  formants = c(650, 1000, 2600, 3300, 5000, 5800),
  mouthAnchors = c(.5, .4, .5, .3),
  noiseAnchors = c(-40, -60),
  rolloffNoise = 0,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(sylLen = 490,
             pitchAnchors = data.frame(time = c(0, 90, 300, 430, 490),
                                       value = c(370, 405, 360, 270, 100)),
             amplAnchors = c(80, 75, 60),
             rolloff = -6,
             # nonlinBalance = 100, subFreq = 95, subDep = c(0, 50, 70, 70, 0), 
             # jitterDep = 0.75, shimmerDep = 10,
             temperature = 0.001, 
             formants = c(650, 1000, 2600, 3300, 5000, 5800),
             mouthAnchors = c(.5, .4, .5, .3),
             noiseAnchors = c(-40, -60),
             rolloffNoise = 0,
             attackLen = 50, addSilence = 0,
             samplingRate = 22050, pitchSamplingRate = 22050,
             play = T, plot = T, osc = T, ylim = c(0, 5))

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(sylLen = 490,
             pitchAnchors = data.frame(time = c(0, 90, 300, 430, 490),
                                       value = c(370, 405, 360, 270, 100)),
             amplAnchors = c(80, 75, 60),
             rolloff = -6 + 6,
             # nonlinBalance = 100, subFreq = 95, subDep = c(0, 50, 70, 70, 0), 
             # jitterDep = 0.75, shimmerDep = 10,
             temperature = 0.001, 
             formants = c(650, 1000, 2600, 3300, 5000, 5800),
             mouthAnchors = c(.5, .4, .5, .3),
             noiseAnchors = c(-40, -60),
             rolloffNoise = 0,
             attackLen = 50, addSilence = 0,
             samplingRate = 22050, pitchSamplingRate = 22050,
             play = T, plot = T, osc = T, ylim = c(0, 5))
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(sylLen = 490,
             pitchAnchors = data.frame(time = c(0, 90, 300, 430, 490),
                                       value = c(370, 405, 360, 270, 100)),
             amplAnchors = c(80, 75, 60),
             rolloff = -6 - 6,
             # nonlinBalance = 100, subFreq = 95, subDep = c(0, 50, 70, 70, 0), 
             # jitterDep = 0.75, shimmerDep = 10,
             temperature = 0.001, 
             formants = c(650, 1000, 2600, 3300, 5000, 5800),
             mouthAnchors = c(.5, .4, .5, .3),
             noiseAnchors = c(-40, -60),
             rolloffNoise = 0,
             attackLen = 50, addSilence = 0,
             samplingRate = 22050, pitchSamplingRate = 22050,
             play = T, plot = T, osc = T, ylim = c(0, 5))
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 350
subFreq = 95  
subDep = 70
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(sylLen = 490,
             pitchAnchors = data.frame(time = c(0, 90, 300, 430, 490),
                                       value = c(370, 405, 360, 270, 100)),
             amplAnchors = c(80, 75, 60),
             rolloff = -6,
             nonlinBalance = 100, subFreq = 95, subDep = c(0, 50, 70, 70, 0),
             jitterDep = 0, shimmerDep = 0,
             temperature = 0.001, 
             formants = c(650, 1000, 2600, 3300, 5000, 5800),
             mouthAnchors = c(.5, .4, .5, .3),
             noiseAnchors = c(-40, -60),
             rolloffNoise = 0,
             attackLen = 50, addSilence = 0,
             samplingRate = 22050, pitchSamplingRate = 22050,
             play = T, plot = T, osc = T, ylim = c(0, 5))

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_350_110_45.wav'))


## CHAOS
s = soundgen(sylLen = 490,
             pitchAnchors = data.frame(time = c(0, 90, 300, 430, 490),
                                       value = c(370, 405, 360, 270, 100)),
             amplAnchors = c(80, 75, 60),
             rolloff = -6,
             nonlinBalance = 100, subFreq = 95, subDep = 0,
             jitterDep = c(0, .5, 1.5, 1.5, 1.5, .5, 0), shimmerDep = c(0, 2, 15, 15, 15, 2, 0),
             temperature = 0.001, 
             formants = c(650, 1000, 2600, 3300, 5000, 5800),
             mouthAnchors = c(.5, .4, .5, .3),
             noiseAnchors = c(-40, -60),
             rolloffNoise = 0,
             attackLen = 50, addSilence = 0,
             samplingRate = 22050, pitchSamplingRate = 22050,
             play = T, plot = T, osc = T, ylim = c(0, 5))

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_350.wav'))
