setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_381a'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 380,
  pitchAnchors = c(260, 315, 320, 310, 200),
  rolloff = c(-22, -11, -9, -8, -22),
  nonlinBalance = 100, subDep = 0, jitterDep = .1, jitterLen = 20, shimmerDep = 10,
  temperature = 0.001, 
  formants = c(650, 1500, 2500, 3640, 5250),
  mouthAnchors = c(.6, .45, .7),
  noiseAnchors = data.frame(time = c(0, 380, 420, 450),
                            value = c(-30, -30, -25, -40) - 0),
  rolloffNoise = -6,
  attackLen = c(30, 10), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 380,
  pitchAnchors = c(260, 315, 320, 310, 200),
  rolloff = c(-22, -11, -9, -8, -22) + 4,
  nonlinBalance = 100, subDep = 0, jitterDep = .1, jitterLen = 20, shimmerDep = 10,
  temperature = 0.001, 
  formants = c(650, 1500, 2500, 3640, 5250),
  mouthAnchors = c(.6, .45, .7),
  noiseAnchors = data.frame(time = c(0, 380, 420, 450),
                            value = c(-30, -30, -25, -40) - 0),
  rolloffNoise = -6,
  attackLen = c(30, 10), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 380,
  pitchAnchors = c(260, 315, 320, 310, 200),
  rolloff = c(-22, -11, -9, -8, -22) - 4,
  nonlinBalance = 100, subDep = 0, jitterDep = .1, jitterLen = 20, shimmerDep = 10,
  temperature = 0.001, 
  formants = c(650, 1500, 2500, 3640, 5250),
  mouthAnchors = c(.6, .45, .7),
  noiseAnchors = data.frame(time = c(0, 380, 420, 450),
                            value = c(-30, -30, -25, -40) - 0),
  rolloffNoise = -6,
  attackLen = c(30, 10), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 300
subFreq = 100  
subDep = 65
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 380,
  pitchAnchors = c(260, 315, 320, 310, 200),
  rolloff = c(-22, -11, -9, -8, -22),
  nonlinRandomWalk = c(rep(0, 40), rep(1, 50), rep(0, 10)), 
  subFreq = 100, subDep = 65, jitterDep = .1, jitterLen = 20, shimmerDep = 10,
  temperature = 0.001, 
  formants = c(650, 1500, 2500, 3640, 5250),
  mouthAnchors = c(.6, .45, .7),
  noiseAnchors = data.frame(time = c(0, 380, 420, 450),
                            value = c(-30, -30, -25, -40) - 0),
  rolloffNoise = -6,
  attackLen = c(30, 10), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_160_100_30.wav'))


## CHAOS
s = soundgen(
  sylLen = 380,
  pitchAnchors = c(260, 315, 320, 310, 200),
  rolloff = c(-22, -11, -9, -8, -22),
  nonlinRandomWalk = c(rep(0, 40), rep(2, 50), rep(0, 10)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001, 
  formants = c(650, 1500, 2500, 3640, 5250),
  mouthAnchors = c(.6, .45, .7),
  noiseAnchors = data.frame(time = c(0, 380, 420, 450),
                            value = c(-30, -30, -25, -40) - 0),
  rolloffNoise = -6,
  attackLen = c(30, 10), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_160.wav'))
