setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_381b'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 750,
  pitchAnchors = data.frame(time = c(0, 60, 240, 330, 410, 720, 750),
                            value = c(220, 280, 310, 290, 275, 230, 200)),
  amplAnchors = c(60, 70, 80, 75),
  rolloff = -10,
  nonlinRandomWalk = c(rep(0, 70), rep(2, 30)),
  subDep = 0, jitterDep = c(0.2, 2), shimmerDep = c(0, 15),
  temperature = 0.001, 
  formants = list(f1 = 580, f2 = 1350, 
                  f3 = c(2100, 2550),
                  f4 = 3640, f5 = 5250),
  mouthAnchors = c(.5, .4),
  noiseAnchors = -40,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 750,
  pitchAnchors = data.frame(time = c(0, 60, 240, 330, 410, 720, 750),
                            value = c(220, 280, 310, 290, 275, 230, 200)),
  amplAnchors = c(60, 70, 80, 75),
  rolloff = -10,
  # nonlinRandomWalk = c(rep(0, 70), rep(2, 30)),
  # subDep = 0, jitterDep = c(0.2, 2), shimmerDep = c(0, 15),
  temperature = 0.001, 
  formants = list(f1 = 580, f2 = 1350, 
                  f3 = c(2100, 2550),
                  f4 = 3640, f5 = 5250),
  mouthAnchors = c(.5, .4),
  noiseAnchors = -40,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 750,
  pitchAnchors = data.frame(time = c(0, 60, 240, 330, 410, 720, 750),
                            value = c(220, 280, 310, 290, 275, 230, 200)),
  amplAnchors = c(60, 70, 80, 75),
  rolloff = -10 + 4,
  # nonlinRandomWalk = c(rep(0, 70), rep(2, 30)),
  # subDep = 0, jitterDep = c(0.2, 2), shimmerDep = c(0, 15),
  temperature = 0.001, 
  formants = list(f1 = 580, f2 = 1350, 
                  f3 = c(2100, 2550),
                  f4 = 3640, f5 = 5250),
  mouthAnchors = c(.5, .4),
  noiseAnchors = -40,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 750,
  pitchAnchors = data.frame(time = c(0, 60, 240, 330, 410, 720, 750),
                            value = c(220, 280, 310, 290, 275, 230, 200)),
  amplAnchors = c(60, 70, 80, 75),
  rolloff = -10 - 4,
  # nonlinRandomWalk = c(rep(0, 70), rep(2, 30)),
  # subDep = 0, jitterDep = c(0.2, 2), shimmerDep = c(0, 15),
  temperature = 0.001, 
  formants = list(f1 = 580, f2 = 1350, 
                  f3 = c(2100, 2550),
                  f4 = 3640, f5 = 5250),
  mouthAnchors = c(.5, .4),
  noiseAnchors = -40,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 230
subFreq = 150  
subDep = 55
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 750,
  pitchAnchors = data.frame(time = c(0, 60, 240, 330, 410, 720, 750),
                            value = c(220, 280, 310, 290, 275, 230, 200)),
  amplAnchors = c(60, 70, 80, 75),
  rolloff = -10,
  nonlinRandomWalk = c(rep(0, 70), rep(1, 30)),
  subFreq = 150, subDep = 55, 
  temperature = 0.001, 
  formants = list(f1 = 580, f2 = 1350, 
                  f3 = c(2100, 2550),
                  f4 = 3640, f5 = 5250),
  mouthAnchors = c(.5, .4),
  noiseAnchors = -40,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_250_75_11.wav'))


## CHAOS
s = soundgen(
  sylLen = 750,
  pitchAnchors = data.frame(time = c(0, 60, 240, 330, 410, 720, 750),
                            value = c(220, 280, 310, 290, 275, 230, 200)),
  amplAnchors = c(60, 70, 80, 75),
  rolloff = -10,
  nonlinRandomWalk = c(rep(0, 70), rep(2, 30)),
  subFreq = 100, subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001, 
  formants = list(f1 = 580, f2 = 1350, 
                  f3 = c(2100, 2550),
                  f4 = 3640, f5 = 5250),
  mouthAnchors = c(.5, .4),
  noiseAnchors = -40,
  attackLen = 50, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_250.wav'))
