setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_509'

a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
a$pitch

# original
s1 = soundgen(
  nSyl = 2, 
  sylLen = 220, pauseLen = 600, 
  pitchAnchors = c(380, 370, 310),
  pitchAnchorsGlobal = c(0, 1),
  vibratoDep = 1,
  temperature = .001,
  rolloff = -25,
  formants = c(900, 1800, 3200, 4100),
  mouthAnchors = c(.4, .5),
  noiseAnchors = data.frame(time = c(0, 220, 260, 380, 440), 
                            value = c(-55, -32, -24, -30, -50)),
  formantsNoise = c(700, 1700, 2000, 3200, 4000, 6000, 7000, 7500, 8500),
  rolloffNoise = -4, attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  sylLen = 320,
  pitchAnchors = c(440, 370, 360),
  pitchAnchorsGlobal = c(0, 1, 2),
  vibratoDep = 1,
  temperature = .001,
  rolloff = c(-17, -19),
  formants = c(1100, 1700, 3200, 4100),
  mouthAnchors = c(.4, .5),
  noiseAnchors = data.frame(time = c(0, 250, 300, 420, 570), 
                            value = c(-35, -25, -15, -25, -50)),
  formantsNoise = c(700, 1700, 2000, 3200, 4000, 6000, 7000, 7500, 8500),
  rolloffNoise = -4, attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s = addVectors(s1, s2, insertionPoint = length(s1) + 22050 * .35)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 5))

# no nonlin
s = soundgen(
  sylLen = 320,
  pitchAnchors = c(440, 370, 360),
  pitchAnchorsGlobal = c(0, 1, 2),
  vibratoDep = 1,
  temperature = .001,
  rolloff = c(-17, -19),
  formants = c(1100, 1700, 3200, 4100),
  mouthAnchors = c(.4, .5),
  noiseAnchors = data.frame(time = c(0, 250, 300, 420, 570), 
                            value = c(-35, -25, -15, -25, -50)),
  formantsNoise = c(700, 1700, 2000, 3200, 4000, 6000, 7000, 7500, 8500),
  rolloffNoise = -4, attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 320,
  pitchAnchors = c(440, 370, 360),
  pitchAnchorsGlobal = c(0, 1, 2),
  vibratoDep = 1,
  temperature = .001,
  rolloff = c(-17, -19) + 8,
  formants = c(1100, 1700, 3200, 4100),
  mouthAnchors = c(.4, .5),
  noiseAnchors = data.frame(time = c(0, 250, 300, 420, 570), 
                            value = c(-35, -25, -15, -25, -50)),
  formantsNoise = c(700, 1700, 2000, 3200, 4000, 6000, 7000, 7500, 8500),
  rolloffNoise = -4, attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 320,
  pitchAnchors = c(440, 370, 360),
  pitchAnchorsGlobal = c(0, 1, 2),
  vibratoDep = 1,
  temperature = .001,
  rolloff = c(-17, -19) - 8,
  formants = c(1100, 1700, 3200, 4100),
  mouthAnchors = c(.4, .5),
  noiseAnchors = data.frame(time = c(0, 250, 300, 420, 570), 
                            value = c(-35, -25, -15, -25, -50)),
  formantsNoise = c(700, 1700, 2000, 3200, 4000, 6000, 7000, 7500, 8500),
  rolloffNoise = -4, attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
pitchMedian = 400
subFreq = 110  
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 320,
  pitchAnchors = c(440, 370, 360),
  pitchAnchorsGlobal = c(0, 1, 2),
  vibratoDep = 1,
  nonlinRandomWalk = c(rep(0, 10), rep(1, 70), rep(0, 20)), 
  subFreq = 110, subDep = 60,
  temperature = .001,
  rolloff = c(-17, -19),
  formants = c(1100, 1700, 3200, 4100),
  mouthAnchors = c(.4, .5),
  noiseAnchors = data.frame(time = c(0, 250, 300, 420, 570), 
                            value = c(-35, -25, -15, -25, -50)),
  formantsNoise = c(700, 1700, 2000, 3200, 4000, 6000, 7000, 7500, 8500),
  rolloffNoise = -4, attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_220_110_25.wav'))


## CHAOS
rw = c(rep(0, 10), rep(2, 70), rep(0, 20)) 

s = soundgen(
  sylLen = 320,
  pitchAnchors = c(440, 370, 360),
  pitchAnchorsGlobal = c(0, 1, 2),
  vibratoDep = 1,
  nonlinRandomWalk = c(rep(0, 10), rep(2, 70), rep(0, 20)), 
  subDep = 0, jitterDep = c(0.5, 1.5), shimmerDep = c(5, 15),
  temperature = .001,
  rolloff = c(-17, -19),
  formants = c(1100, 1700, 3200, 4100),
  mouthAnchors = c(.4, .5),
  noiseAnchors = data.frame(time = c(0, 250, 300, 420, 570), 
                            value = c(-35, -25, -15, -25, -50)),
  formantsNoise = c(700, 1700, 2000, 3200, 4000, 6000, 7000, 7500, 8500),
  rolloffNoise = -4, attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_220.wav'))
