setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_515a'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 320,
  pitchAnchors = c(340, 330, 300),
  rolloff = c(-18, -16, -30),
  amplAnchors = c(80, 70),
  temperature = 0.001, 
  formants = c(950, 1700, 3700), 
  noiseAnchors = data.frame(time = c(0, 300, 440), 
                            value = c(-30, -20, -60) - 5),
  mouthAnchors = c(.4, .5),
  rolloffNoise = -5,
  attackLen = 30, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 320,
  pitchAnchors = c(340, 330, 300),
  rolloff = c(-18, -16, -30) + 8,
  amplAnchors = c(80, 70),
  temperature = 0.001, 
  formants = c(950, 1700, 3700), 
  noiseAnchors = data.frame(time = c(0, 300, 440), 
                            value = c(-30, -20, -60) - 5),
  mouthAnchors = c(.4, .5),
  rolloffNoise = -5,
  attackLen = 30, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 320,
  pitchAnchors = c(340, 330, 300),
  rolloff = c(-18, -16, -30) - 8, invalidArgAction = 'ignore',
  amplAnchors = c(80, 70),
  temperature = 0.001, 
  formants = c(950, 1700, 3700), 
  noiseAnchors = data.frame(time = c(0, 300, 440), 
                            value = c(-30, -20, -60) - 5),
  mouthAnchors = c(.4, .5),
  rolloffNoise = -5,
  attackLen = 30, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
pitchMedian = 320
subFreq = 130  
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 320,
  pitchAnchors = c(340, 330, 300),
  rolloff = c(-18, -16, -30),
  amplAnchors = c(80, 70),
  nonlinRandomWalk = c(rep(0, 30), rep(1, 50), rep(0, 20)), 
  subFreq = 130, subDep = 60,
  temperature = 0.001, 
  formants = c(950, 1700, 3700), 
  noiseAnchors = data.frame(time = c(0, 300, 440), 
                            value = c(-30, -20, -60) - 5),
  mouthAnchors = c(.4, .5),
  rolloffNoise = -5,
  attackLen = 30, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_160_130_03.wav'))

# subh2
pitchMedian = 320
subFreq = 75  
subDep = 30
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 320,
  pitchAnchors = c(340, 330, 300),
  rolloff = c(-18, -16, -30),
  amplAnchors = c(80, 70),
  nonlinRandomWalk = c(rep(0, 30), rep(1, 50), rep(0, 20)), 
  subFreq = 75, subDep = 30,
  temperature = 0.001, 
  formants = c(950, 1700, 3700), 
  noiseAnchors = data.frame(time = c(0, 300, 440), 
                            value = c(-30, -20, -60) - 5),
  mouthAnchors = c(.4, .5),
  rolloffNoise = -5,
  attackLen = 30, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_160_75_03.wav'))


## CHAOS
s = soundgen(
  sylLen = 320,
  pitchAnchors = c(340, 330, 300),
  rolloff = c(-18, -16, -30),
  amplAnchors = c(80, 70),
  nonlinRandomWalk = c(rep(0, 30), rep(2, 50), rep(0, 20)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001, 
  formants = c(950, 1700, 3700), 
  noiseAnchors = data.frame(time = c(0, 300, 440), 
                            value = c(-30, -20, -60) - 5),
  mouthAnchors = c(.4, .5),
  rolloffNoise = -5,
  attackLen = 30, 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_160.wav'))
