setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_515b'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 520,
  pitchAnchors = c(300, 310, 300),
  amplAnchors = c(80, 50),
  temperature = 0.05, rolloff = c(-15, -30), 
  formants = list(f1 = c(700, 900),
                  f2 = c(1600, 1400),
                  f3 = c(3600, 3500), f4 = c(4300, 4200)),
  mouthAnchors = c(.5, .3),
  noiseAnchors = data.frame(time = c(0, 400, 660),
                            value = c(-40, -30, -60) ),
  rolloffNoise = c(-5, -15),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s2, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 520,
  pitchAnchors = c(300, 310, 300),
  amplAnchors = c(80, 50),
  temperature = 0.05, rolloff = c(-15, -30) + 8, 
  formants = list(f1 = c(700, 900),
                  f2 = c(1600, 1400),
                  f3 = c(3600, 3500), f4 = c(4300, 4200)),
  mouthAnchors = c(.5, .3),
  noiseAnchors = data.frame(time = c(0, 400, 660),
                            value = c(-40, -30, -60) ),
  rolloffNoise = c(-5, -15),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 520,
  pitchAnchors = c(300, 310, 300),
  amplAnchors = c(80, 50),
  temperature = 0.05, rolloff = c(-15, -30) - 8, invalidArgAction = 'ignore', 
  formants = list(f1 = c(700, 900),
                  f2 = c(1600, 1400),
                  f3 = c(3600, 3500), f4 = c(4300, 4200)),
  mouthAnchors = c(.5, .3),
  noiseAnchors = data.frame(time = c(0, 400, 660),
                            value = c(-40, -30, -60) ),
  rolloffNoise = c(-5, -15),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
pitchMedian = 300
subFreq = 90  
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 520,
  pitchAnchors = c(300, 310, 300),
  amplAnchors = c(80, 50),
  nonlinRandomWalk = c(rep(1, 50), rep(0, 50)) , 
  subFreq = 90, subDep = 60,
  temperature = 0.05, rolloff = c(-15, -30), 
  formants = list(f1 = c(700, 900),
                  f2 = c(1600, 1400),
                  f3 = c(3600, 3500), f4 = c(4300, 4200)),
  mouthAnchors = c(.5, .3),
  noiseAnchors = data.frame(time = c(0, 400, 660),
                            value = c(-40, -30, -60) ),
  rolloffNoise = c(-5, -15),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_260_90_25.wav'))


## CHAOS
s = soundgen(
  sylLen = 520,
  pitchAnchors = c(300, 310, 300),
  amplAnchors = c(80, 50),
  nonlinRandomWalk = c(rep(2, 50), rep(0, 50)) , 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.05, rolloff = c(-15, -30), 
  formants = list(f1 = c(700, 900),
                  f2 = c(1600, 1400),
                  f3 = c(3600, 3500), f4 = c(4300, 4200)),
  mouthAnchors = c(.5, .3),
  noiseAnchors = data.frame(time = c(0, 400, 660),
                            value = c(-40, -30, -60) ),
  rolloffNoise = c(-5, -15),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_260.wav'))
