setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_525'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
t = c(0, 360, 430, 770, 820, 1030)
s = soundgen(
  sylLen = 1030, 
  pitchAnchors = data.frame(time = t, 
                            value = c(330, 315, 380, 335, 365, 330)),
  vibratoDep = .1,
  temperature = 0.001,
  rolloff = c(-12, -16), 
  formants = list(f1 = data.frame(time = t,
                                  freq = c(910, 870, 850, 850, 730, 930),
                                  amp = 20),
                  f2 = data.frame(time = t,
                                  freq = c(1250, 1200, 1100, 1150, 1350, 1400),
                                  amp = 30), 
                  f3 = data.frame(freq = 3000, amp = 30),
                  f4 = 4100, f5 = 4700), 
  noiseAnchors = data.frame(time = c(0, 260, 470, 670, 950, 1200, 1300), 
                            value = c(-15, -30, -10, -15, -8, -9, -60)),
  mouthAnchors = data.frame(time = c(0, 1100, 1300),
                            value = c(.4, .6, .2)),
  rolloffNoise = c(-6, -4, 0), 
  attackLen = c(20, 200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 5))

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 1030, 
  pitchAnchors = data.frame(time = t, 
                            value = c(330, 315, 380, 335, 365, 330)),
  vibratoDep = .1,
  temperature = 0.001,
  rolloff = c(-12, -16) + 6, 
  formants = list(f1 = data.frame(time = t,
                                  freq = c(910, 870, 850, 850, 730, 930),
                                  amp = 20),
                  f2 = data.frame(time = t,
                                  freq = c(1250, 1200, 1100, 1150, 1350, 1400),
                                  amp = 30), 
                  f3 = data.frame(freq = 3000, amp = 30),
                  f4 = 4100, f5 = 4700), 
  noiseAnchors = data.frame(time = c(0, 260, 470, 670, 950, 1200, 1300), 
                            value = c(-15, -30, -10, -15, -8, -9, -60)),
  mouthAnchors = data.frame(time = c(0, 1100, 1300),
                            value = c(.4, .6, .2)),
  rolloffNoise = c(-6, -4, 0), 
  attackLen = c(20, 200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 1030, 
  pitchAnchors = data.frame(time = t, 
                            value = c(330, 315, 380, 335, 365, 330)),
  vibratoDep = .1,
  temperature = 0.001,
  rolloff = c(-12, -16) - 6, 
  formants = list(f1 = data.frame(time = t,
                                  freq = c(910, 870, 850, 850, 730, 930),
                                  amp = 20),
                  f2 = data.frame(time = t,
                                  freq = c(1250, 1200, 1100, 1150, 1350, 1400),
                                  amp = 30), 
                  f3 = data.frame(freq = 3000, amp = 30),
                  f4 = 4100, f5 = 4700), 
  noiseAnchors = data.frame(time = c(0, 260, 470, 670, 950, 1200, 1300), 
                            value = c(-15, -30, -10, -15, -8, -9, -60)),
  mouthAnchors = data.frame(time = c(0, 1100, 1300),
                            value = c(.4, .6, .2)),
  rolloffNoise = c(-6, -4, 0), 
  attackLen = c(20, 200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 340
subFreq = 85  
subDep = 55
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1030, 
  pitchAnchors = data.frame(time = t, 
                            value = c(330, 315, 380, 335, 365, 330)),
  vibratoDep = .1,
  nonlinRandomWalk =  c(rep(0, 35), rep(1, 30), rep(0, 35)), 
  subFreq = 85, subDep = 55,
  temperature = 0.001,
  rolloff = c(-12, -16), 
  formants = list(f1 = data.frame(time = t,
                                  freq = c(910, 870, 850, 850, 730, 930),
                                  amp = 20),
                  f2 = data.frame(time = t,
                                  freq = c(1250, 1200, 1100, 1150, 1350, 1400),
                                  amp = 30), 
                  f3 = data.frame(freq = 3000, amp = 30),
                  f4 = 4100, f5 = 4700), 
  noiseAnchors = data.frame(time = c(0, 260, 470, 670, 950, 1200, 1300), 
                            value = c(-15, -30, -10, -15, -8, -9, -60)),
  mouthAnchors = data.frame(time = c(0, 1100, 1300),
                            value = c(.4, .6, .2)),
  rolloffNoise = c(-6, -4, 0), 
  attackLen = c(20, 200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_310_85_30.wav'))


## CHAOS
s = soundgen(
  sylLen = 1030, 
  pitchAnchors = data.frame(time = t, 
                            value = c(330, 315, 380, 335, 365, 330)),
  vibratoDep = .1,
  nonlinRandomWalk = c(rep(0, 35), rep(2, 30), rep(0, 35)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001,
  rolloff = c(-12, -16), 
  formants = list(f1 = data.frame(time = t,
                                  freq = c(910, 870, 850, 850, 730, 930),
                                  amp = 20),
                  f2 = data.frame(time = t,
                                  freq = c(1250, 1200, 1100, 1150, 1350, 1400),
                                  amp = 30), 
                  f3 = data.frame(freq = 3000, amp = 30),
                  f4 = 4100, f5 = 4700), 
  noiseAnchors = data.frame(time = c(0, 260, 470, 670, 950, 1200, 1300), 
                            value = c(-15, -30, -10, -15, -8, -9, -60)),
  mouthAnchors = data.frame(time = c(0, 1100, 1300),
                            value = c(.4, .6, .2)),
  rolloffNoise = c(-6, -4, 0), 
  attackLen = c(20, 200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_310.wav'))
