setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_530'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 600,
  pitchAnchors = data.frame(time = c(0, 80, 115, 600),
                            value = c(158, 135, 175, 145)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)), 
  subFreq = 75, subDep = c(50, 30, 25),
  rolloff = c(-2, -12),
  formants = c(520, 1150, 2600, 3600, 4600, 5400),
  noiseAnchors = data.frame(time = c(0, 600, 950), 
                            value = c(-20, -10, -50)),
  formantsNoise = list(f1 = 520, f2 = 1150, 
                       f3 = data.frame(freq = 2600, amp = c(20, 35)),
                       f4 = data.frame(freq = 3600, amp = c(20, 50)),
                       f5 = data.frame(freq = 4600, amp = c(20, 40)),
                       f6 = data.frame(freq = c(5400, 4800)),
                       f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
  rolloffNoise = c(-4, 0),
  mouthAnchors = c(.5, .8),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 600,
  pitchAnchors = data.frame(time = c(0, 80, 115, 600),
                            value = c(158, 135, 175, 145)),
  temperature = 0.001,
  # nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)), 
  # subFreq = 75, subDep = c(50, 30, 25),
  rolloff = c(-2, -12),
  formants = c(520, 1150, 2600, 3600, 4600, 5400),
  noiseAnchors = data.frame(time = c(0, 600, 950), 
                            value = c(-20, -10, -50)),
  formantsNoise = list(f1 = 520, f2 = 1150, 
                       f3 = data.frame(freq = 2600, amp = c(20, 35)),
                       f4 = data.frame(freq = 3600, amp = c(20, 50)),
                       f5 = data.frame(freq = 4600, amp = c(20, 40)),
                       f6 = data.frame(freq = c(5400, 4800)),
                       f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
  rolloffNoise = c(-4, 0),
  mouthAnchors = c(.5, .8),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 600,
  pitchAnchors = data.frame(time = c(0, 80, 115, 600),
                            value = c(158, 135, 175, 145)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)), 
  subFreq = 75, subDep = c(50, 30, 25),
  rolloff = c(-2, -12) + 4, invalidArgAction = 'ignore',
  formants = c(520, 1150, 2600, 3600, 4600, 5400),
  noiseAnchors = data.frame(time = c(0, 600, 950), 
                            value = c(-20, -10, -50)),
  formantsNoise = list(f1 = 520, f2 = 1150, 
                       f3 = data.frame(freq = 2600, amp = c(20, 35)),
                       f4 = data.frame(freq = 3600, amp = c(20, 50)),
                       f5 = data.frame(freq = 4600, amp = c(20, 40)),
                       f6 = data.frame(freq = c(5400, 4800)),
                       f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
  rolloffNoise = c(-4, 0),
  mouthAnchors = c(.5, .8),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 600,
  pitchAnchors = data.frame(time = c(0, 80, 115, 600),
                            value = c(158, 135, 175, 145)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)), 
  subFreq = 75, subDep = c(50, 30, 25),
  rolloff = c(-2, -12) - 4, invalidArgAction = 'ignore',
  formants = c(520, 1150, 2600, 3600, 4600, 5400),
  noiseAnchors = data.frame(time = c(0, 600, 950), 
                            value = c(-20, -10, -50)),
  formantsNoise = list(f1 = 520, f2 = 1150, 
                       f3 = data.frame(freq = 2600, amp = c(20, 35)),
                       f4 = data.frame(freq = 3600, amp = c(20, 50)),
                       f5 = data.frame(freq = 4600, amp = c(20, 40)),
                       f6 = data.frame(freq = c(5400, 4800)),
                       f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
  rolloffNoise = c(-4, 0),
  mouthAnchors = c(.5, .8),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 150
subFreq = 75  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 600,
  pitchAnchors = data.frame(time = c(0, 80, 115, 600),
                            value = c(158, 135, 175, 145)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)), 
  subFreq = 75, subDep = c(50, 30, 25),
  rolloff = c(-2, -12), invalidArgAction = 'ignore',
  formants = c(520, 1150, 2600, 3600, 4600, 5400),
  noiseAnchors = data.frame(time = c(0, 600, 950), 
                            value = c(-20, -10, -50)),
  formantsNoise = list(f1 = 520, f2 = 1150, 
                       f3 = data.frame(freq = 2600, amp = c(20, 35)),
                       f4 = data.frame(freq = 3600, amp = c(20, 50)),
                       f5 = data.frame(freq = 4600, amp = c(20, 40)),
                       f6 = data.frame(freq = c(5400, 4800)),
                       f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
  rolloffNoise = c(-4, 0),
  mouthAnchors = c(.5, .8),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_240_75_32.wav'))


## CHAOS
s = soundgen(
  sylLen = 600,
  pitchAnchors = data.frame(time = c(0, 80, 115, 600),
                            value = c(158, 135, 175, 145)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(2, 40), rep(0, 40)), 
  subFreq = 75, subDep = 0, jitterDep = 1.5, shimmerDep = 15, 
  rolloff = c(-2, -12), invalidArgAction = 'ignore',
  formants = c(520, 1150, 2600, 3600, 4600, 5400),
  noiseAnchors = data.frame(time = c(0, 600, 950), 
                            value = c(-20, -10, -50)),
  formantsNoise = list(f1 = 520, f2 = 1150, 
                       f3 = data.frame(freq = 2600, amp = c(20, 35)),
                       f4 = data.frame(freq = 3600, amp = c(20, 50)),
                       f5 = data.frame(freq = 4600, amp = c(20, 40)),
                       f6 = data.frame(freq = c(5400, 4800)),
                       f7 = 7000, f8 = 8000, f9 = 9000, f10 = 10000),
  rolloffNoise = c(-4, 0),
  mouthAnchors = c(.5, .8),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 5)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_240.wav'))
