setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_535'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 770,
  pitchAnchors = c(150, 120),
  rolloff = c(-12, -16), 
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = .1, jitterLen = 15, shimmerDep = 15,
  formants = c(500, 1130, 2400, 3400, 4300, 5000, 5400, 6200, 8500),
  noiseAnchors = data.frame(time = c(0, 770, 930), 
                            value = c(-30, -40, -60) + 0),
  rolloffNoise = -8,
  mouthAnchors = c(.5, .6),
  attackLen = c(20, 50),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 770,
  pitchAnchors = c(150, 120),
  rolloff = c(-12, -16),
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .1, jitterLen = 15, shimmerDep = 15,
  formants = c(500, 1130, 2400, 3400, 4300, 5000, 5400, 6200, 8500),
  noiseAnchors = data.frame(time = c(0, 770, 930), 
                            value = c(-30, -40, -60) + 0),
  rolloffNoise = -8,
  mouthAnchors = c(.5, .6),
  attackLen = c(20, 50),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 770,
  pitchAnchors = c(150, 120),
  rolloff = c(-12, -16) + 4, 
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .1, jitterLen = 15, shimmerDep = 15,
  formants = c(500, 1130, 2400, 3400, 4300, 5000, 5400, 6200, 8500),
  noiseAnchors = data.frame(time = c(0, 770, 930), 
                            value = c(-30, -40, -60) + 0),
  rolloffNoise = -8,
  mouthAnchors = c(.5, .6),
  attackLen = c(20, 50),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 770,
  pitchAnchors = c(150, 120),
  rolloff = c(-12, -16) - 4, 
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .1, jitterLen = 15, shimmerDep = 15,
  formants = c(500, 1130, 2400, 3400, 4300, 5000, 5400, 6200, 8500),
  noiseAnchors = data.frame(time = c(0, 770, 930), 
                            value = c(-30, -40, -60) + 0),
  rolloffNoise = -8,
  mouthAnchors = c(.5, .6),
  attackLen = c(20, 50),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 130
subFreq = 75  
subDep = 45
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 770,
  pitchAnchors = c(150, 120),
  rolloff = c(-12, -16), 
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 65), rep(1, 35)), 
  subFreq = 75, subDep = c(45, 25),
  formants = c(500, 1130, 2400, 3400, 4300, 5000, 5400, 6200, 8500),
  noiseAnchors = data.frame(time = c(0, 770, 930), 
                            value = c(-30, -40, -60) + 0),
  rolloffNoise = -8,
  mouthAnchors = c(.5, .6),
  attackLen = c(20, 50),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_270_75_35.wav'))


## CHAOS
s = soundgen(
  sylLen = 770,
  pitchAnchors = c(150, 120),
  rolloff = c(-12, -16), 
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 65), rep(2, 35)), 
  subFreq = 75, subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(500, 1130, 2400, 3400, 4300, 5000, 5400, 6200, 8500),
  noiseAnchors = data.frame(time = c(0, 770, 930), 
                            value = c(-30, -40, -60) + 0),
  rolloffNoise = -8,
  mouthAnchors = c(.5, .6),
  attackLen = c(20, 50),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_270.wav'))
