setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_549'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 520,
  pitchAnchors = c(270, 210), 
  vibratoDep = .5,
  temperature = 0.001, 
  rolloff = c(-20, -30),
  formants = c(850, 1350, 3100, 3750, 4900, 6200, 6800),
  noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                            value = c(-55, -40, -45, -60, -40, -60)),
  rolloffNoise = c(0, 0, -5),
  mouthAnchors = c(.5, .6),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 520,
  pitchAnchors = c(270, 210), 
  vibratoDep = .5,
  temperature = 0.001, 
  rolloff = c(-20, -30) + 8,
  formants = c(850, 1350, 3100, 3750, 4900, 6200, 6800),
  noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                            value = c(-55, -40, -45, -60, -40, -60)),
  rolloffNoise = c(0, 0, -5),
  mouthAnchors = c(.5, .6),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 520,
  pitchAnchors = c(270, 210), 
  vibratoDep = .5,
  temperature = 0.001, 
  rolloff = c(-20, -30) - 8, invalidArgAction = 'ignore',
  formants = c(850, 1350, 3100, 3750, 4900, 6200, 6800),
  noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                            value = c(-55, -40, -45, -60, -40, -60)),
  rolloffNoise = c(0, 0, -5),
  mouthAnchors = c(.5, .6),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
pitchMedian = 250
subFreq = 120  
subDep = 90
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 520,
  pitchAnchors = c(270, 210), 
  vibratoDep = .5,
  nonlinRandomWalk = c(rep(1, 50), rep(0, 50)),
  subFreq = 120, subDep = c(90, 10),
  temperature = 0.001, 
  rolloff = c(-20, -30),
  formants = c(850, 1350, 3100, 3750, 4900, 6200, 6800),
  noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                            value = c(-55, -40, -45, -60, -40, -60)),
  rolloffNoise = c(0, 0, -5),
  mouthAnchors = c(.5, .6),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_260_120_38.wav'))


## CHAOS
s = soundgen(
  sylLen = 520,
  pitchAnchors = c(270, 210), 
  vibratoDep = .5,
  nonlinRandomWalk = c(rep(2, 50), rep(0, 50)),
  subDep = 0, jitterDep = c(1.5, .5), shimmerDep = 15,
  temperature = 0.001, 
  rolloff = c(-20, -30),
  formants = c(850, 1350, 3100, 3750, 4900, 6200, 6800),
  noiseAnchors = data.frame(time = c(0, 350, 520, 530, 700, 830), 
                            value = c(-55, -40, -45, -60, -40, -60)),
  rolloffNoise = c(0, 0, -5),
  mouthAnchors = c(.5, .6),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_260.wav'))
