setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'mgg_551'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 1800, 
  pitchAnchors = c(240, 200),
  rolloff = c(-20, -18, -23, -28),
  vibratoDep = .2,
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 46), rep(2, 16), rep(0, 38)), 
  subDep = 0, jitterDep = 2, shimmerDep = 15,
  formants = c(800, 1400, 2500, 3700, 5000, 6800),
  noiseAnchors = data.frame(time = c(0, 640, 1800, 2000), 
                            value = c(-60, -45, -60, -80) + 5),
  rolloffNoise = -8,
  mouthAnchors = c(.55, .5, .45, .6),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')
playme(s, 22050)


# no nonlin
s = soundgen(
  sylLen = 1800, 
  pitchAnchors = c(240, 200),
  rolloff = c(-20, -18, -23, -28),
  vibratoDep = .2,
  temperature = 0.001, 
  # nonlinRandomWalk = c(rep(0, 46), rep(2, 16), rep(0, 38)), 
  # subDep = 0, jitterDep = 2, shimmerDep = 15,
  formants = c(800, 1400, 2500, 3700, 5000, 6800),
  noiseAnchors = data.frame(time = c(0, 640, 1800, 2000), 
                            value = c(-60, -45, -60, -80) + 5),
  rolloffNoise = -8,
  mouthAnchors = c(.55, .5, .45, .6),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 1800, 
  pitchAnchors = c(240, 200),
  rolloff = c(-20, -18, -23, -28) + 8,
  vibratoDep = .2,
  temperature = 0.001, 
  # nonlinRandomWalk = c(rep(0, 46), rep(2, 16), rep(0, 38)), 
  # subDep = 0, jitterDep = 2, shimmerDep = 15,
  formants = c(800, 1400, 2500, 3700, 5000, 6800),
  noiseAnchors = data.frame(time = c(0, 640, 1800, 2000), 
                            value = c(-60, -45, -60, -80) + 5),
  rolloffNoise = -8,
  mouthAnchors = c(.55, .5, .45, .6),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 1800, 
  pitchAnchors = c(240, 200),
  rolloff = c(-20, -18, -23, -28) - 8, invalidArgAction = 'ignore',
  vibratoDep = .2,
  temperature = 0.001, 
  # nonlinRandomWalk = c(rep(0, 46), rep(2, 16), rep(0, 38)), 
  # subDep = 0, jitterDep = 2, shimmerDep = 15,
  formants = c(800, 1400, 2500, 3700, 5000, 6800),
  noiseAnchors = data.frame(time = c(0, 640, 1800, 2000), 
                            value = c(-60, -45, -60, -80) + 5),
  rolloffNoise = -8,
  mouthAnchors = c(.55, .5, .45, .6),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## SUBHARMONICS
pitchMedian = 220
subFreq = 100  
subDep = 70
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1800, 
  pitchAnchors = c(240, 200),
  rolloff = c(-20, -18, -23, -28),
  vibratoDep = .2,
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 46), rep(1, 16), rep(0, 38)), 
  subFreq = 100, subDep = 70,
  formants = c(800, 1400, 2500, 3700, 5000, 6800),
  noiseAnchors = data.frame(time = c(0, 640, 1800, 2000), 
                            value = c(-60, -45, -60, -80) + 5),
  rolloffNoise = -8,
  mouthAnchors = c(.55, .5, .45, .6),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_290_100_29.wav'))


## CHAOS
s = soundgen(
  sylLen = 1800, 
  pitchAnchors = c(240, 200),
  rolloff = c(-20, -18, -23, -28),
  vibratoDep = .2,
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 46), rep(2, 16), rep(0, 38)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(800, 1400, 2500, 3700, 5000, 6800),
  noiseAnchors = data.frame(time = c(0, 640, 1800, 2000), 
                            value = c(-60, -45, -60, -80) + 5),
  rolloffNoise = -8,
  mouthAnchors = c(.55, .5, .45, .6),
  throwaway = -120,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_290.wav'))
