setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_007'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 590, 
  pitchAnchors = list(time = c(0, 177, 472, 590),
                      value = c(260, 750, 700, 260)),
  temperature = 0.001, 
  rolloff = -4,
  nonlinBalance = 100, subFreq = 80, subDep = 70, jitterDep = 1.2,
  formants = c(1000, 1700, 3000), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 590, 
  pitchAnchors = list(time = c(0, 177, 472, 590),
                      value = c(260, 750, 700, 260)),
  temperature = 0.001, 
  rolloff = -4,
  # nonlinBalance = 100, subFreq = 80, subDep = 70, jitterDep = 1.2,
  formants = c(1000, 1700, 3000), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 590, 
  pitchAnchors = list(time = c(0, 177, 472, 590),
                      value = c(260, 750, 700, 260)),
  temperature = 0.001, 
  rolloff = -4 + 8, invalidArgAction = 'ignore',
  # nonlinBalance = 100, subFreq = 80, subDep = 70, jitterDep = 1.2,
  formants = c(1000, 1700, 3000), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 590, 
  pitchAnchors = list(time = c(0, 177, 472, 590),
                      value = c(260, 750, 700, 260)),
  temperature = 0.001, 
  rolloff = -4 - 8, 
  # nonlinBalance = 100, subFreq = 80, subDep = 70, jitterDep = 1.2,
  formants = c(1000, 1700, 3000), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## PITCH JUMP
s = soundgen(
  sylLen = 590, 
  pitchAnchors = list(time = c(0, 170, 171, 470, 471, 590),
                      value = c(260, 280, 750, 700, 280, 260)),
  temperature = 0.001, 
  rolloff = -4,
  # nonlinBalance = 100, subFreq = 80, subDep = 70, jitterDep = 1.2,
  formants = c(1000, 1700, 3000), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 700
subFreq = 80
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 660,  # to compensate for changing epochs
  pitchAnchors = list(time = c(0, 177, 472, 590),
                      value = c(260, 750, 700, 260)),
  temperature = 0.001, 
  rolloff = -4,
  nonlinRandomWalk = c(rep(0, 10), rep(1, 70), rep(0, 20)), 
  subFreq = 80, subDep = 60, jitterDep = 0, shortestEpoch = 50,
  formants = c(1000, 1700, 3000), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_170_80_43.wav'))

# subh2
pitchMedian = 700
subFreq = 200
subDep = 135
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 660,  # to compensate for changing epochs
  pitchAnchors = list(time = c(0, 177, 472, 590),
                      value = c(260, 750, 700, 260)),
  temperature = 0.001, 
  rolloff = -4,
  nonlinRandomWalk = c(rep(0, 10), rep(1, 70), rep(0, 20)), 
  subFreq = 200, subDep = 135, jitterDep = 0, shortestEpoch = 50,
  formants = c(1000, 1700, 3000), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_170_200_43.wav'))


## CHAOS
s = soundgen(
  sylLen = 590, 
  pitchAnchors = list(time = c(0, 177, 472, 590),
                      value = c(260, 750, 700, 260)),
  temperature = 0.001, 
  rolloff = -4,
  nonlinRandomWalk = c(rep(0, 10), rep(2, 70), rep(0, 20)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(1000, 1700, 3000), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_170.wav'))
