setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_010'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 490,
  pitchAnchors = list(time = c(0, 80, 250, 370, 420, 421, 490),
                      value = c(1000, 2900, 3200, 2900, 2170, 1170, 1000)),
  interpol = 'approx',
  rolloff = c(-5, 0, -25), rolloffOct = 0, rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = c(.5, 1, 0), shimmerDep = 10,
  formants = c(1100, 2300, 3100, 4000, 5300, 6200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 490,
  pitchAnchors = list(time = c(0, 80, 250, 370, 420, 421, 490),
                      value = c(1000, 2900, 3200, 2900, 2170, 1170, 1000)),
  interpol = 'approx',
  rolloff = c(-5, 0, -25), rolloffOct = 0, rolloffKHz = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = c(.5, 1, 0), shimmerDep = 10,
  formants = c(1100, 2300, 3100, 4000, 5300, 6200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 490,
  pitchAnchors = list(time = c(0, 80, 250, 370, 420, 421, 490),
                      value = c(1000, 2900, 3200, 2900, 2170, 1170, 1000)),
  interpol = 'approx',
  rolloff = c(-5, 0, -25) + 8, rolloffOct = 0, rolloffKHz = 0, 
  invalidArgAction = 'ignore',
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = c(.5, 1, 0), shimmerDep = 10,
  formants = c(1100, 2300, 3100, 4000, 5300, 6200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 490,
  pitchAnchors = list(time = c(0, 80, 250, 370, 420, 421, 490),
                      value = c(1000, 2900, 3200, 2900, 2170, 1170, 1000)),
  interpol = 'approx',
  rolloff = c(-5, 0, -25) - 8, rolloffOct = 0, rolloffKHz = 0, 
  invalidArgAction = 'ignore',
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = c(.5, 1, 0), shimmerDep = 10,
  formants = c(1100, 2300, 3100, 4000, 5300, 6200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## PITCH JUMP
s = soundgen(
  sylLen = 490,
  pitchAnchors = list(time = c(0, 80, 81, 250, 370, 420, 421, 490),
                      value = c(1000, 1450, 2900, 3200, 2900, 2170, 1170, 1000)),
  interpol = 'approx',
  rolloff = c(-5, 0, -25), rolloffOct = 0, rolloffKHz = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = c(.5, 1, 0), shimmerDep = 10,
  formants = c(1100, 2300, 3100, 4000, 5300, 6200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 2900
subFreq = 90
subDep = 150
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 620,  # to compensate for changing epochs
  pitchAnchors = list(time = c(0, 80, 250, 370, 420, 421, 490),
                      value = c(1000, 2900, 3200, 2900, 2170, 1170, 1000)),
  interpol = 'approx',
  rolloff = c(-5, 0, -25), rolloffOct = 0, rolloffKHz = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 50), rep(0, 30)), 
  subFreq = 90, subDep = 150, jitterDep = 0, 
  shortestEpoch = 50, invalidArgAction = 'ignore',
  formants = c(1100, 2300, 3100, 4000, 5300, 6200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_240_90_83.wav'))

# subh2
pitchMedian = 2900
subFreq = 200
subDep = 350
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 610,  # to compensate for changing epochs
  pitchAnchors = list(time = c(0, 80, 250, 370, 421, 490),
                      value = c(1000, 2900, 3200, 2900, 1170, 1000)),
  interpol = 'approx',
  rolloff = c(-5, 0, -25), rolloffOct = 0, rolloffKHz = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 50), rep(0, 30)), 
  subFreq = 200, subDep = 350, jitterDep = 0, 
  shortestEpoch = 50, invalidArgAction = 'ignore',
  formants = c(1100, 2300, 3100, 4000, 5300, 6200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_240_200_83.wav'))


## CHAOS
s = soundgen(
  sylLen = 490,
  pitchAnchors = list(time = c(0, 80, 250, 370, 421, 490),
                      value = c(1000, 2900, 3200, 2900, 1170, 1000)),
  interpol = 'approx',
  rolloff = c(-5, 0, -25), rolloffOct = 0, rolloffKHz = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(2, 50), rep(0, 30)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  shortestEpoch = 50, invalidArgAction = 'ignore',
  formants = c(1100, 2300, 3100, 4000, 5300, 6200), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_240.wav'))
