setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_025'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 1040,
  pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                            value = c(200, 410, 405, 200)),
  rolloff = 0, rolloffOct = 0,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                  freq = c(400, 1000, 900, 700), 
                                  width = 300, amp = 16),
                  f2 = data.frame(time = c(0, .1, 1), 
                                  freq = c(1900, 1700, 1600), 
                                  width = 350, amp = 18),
                  f3 = data.frame(freq = 2600, width = 400, amp = 25),
                  f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
  noiseAnchors = -10,
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

playme(s, 22050)

# no nonlin
s = soundgen(
  sylLen = 1040,
  pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                            value = c(200, 410, 405, 200)),
  rolloff = 0, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                  freq = c(400, 1000, 900, 700), 
                                  width = 300, amp = 16),
                  f2 = data.frame(time = c(0, .1, 1), 
                                  freq = c(1900, 1700, 1600), 
                                  width = 350, amp = 18),
                  f3 = data.frame(freq = 2600, width = 400, amp = 25),
                  f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
  # noiseAnchors = -10,
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 1040,
  pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                            value = c(200, 410, 405, 200)),
  rolloff = 0 + 8, rolloffOct = 0, invalidArgAction = 'ignore',
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                  freq = c(400, 1000, 900, 700), 
                                  width = 300, amp = 16),
                  f2 = data.frame(time = c(0, .1, 1), 
                                  freq = c(1900, 1700, 1600), 
                                  width = 350, amp = 18),
                  f3 = data.frame(freq = 2600, width = 400, amp = 25),
                  f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
  # noiseAnchors = -10,
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 1040,
  pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                            value = c(200, 410, 405, 200)),
  rolloff = 0 - 8, rolloffOct = 0, invalidArgAction = 'ignore',
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                  freq = c(400, 1000, 900, 700), 
                                  width = 300, amp = 16),
                  f2 = data.frame(time = c(0, .1, 1), 
                                  freq = c(1900, 1700, 1600), 
                                  width = 350, amp = 18),
                  f3 = data.frame(freq = 2600, width = 400, amp = 25),
                  f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
  # noiseAnchors = -10,
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## PITCH JUMP
s = soundgen(
  sylLen = 1040,
  pitchAnchors = data.frame(time = c(0, 100, 500, 501, 620, 621, 910, 1040),
                            value = c(200, 410, 405, 480, 480, 405, 400, 200)),
  rolloff = 0, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = 2, shimmerDep = 20,
  formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                  freq = c(400, 1000, 900, 700), 
                                  width = 300, amp = 16),
                  f2 = data.frame(time = c(0, .1, 1), 
                                  freq = c(1900, 1700, 1600), 
                                  width = 350, amp = 18),
                  f3 = data.frame(freq = 2600, width = 400, amp = 25),
                  f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
  # noiseAnchors = -10,
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 400
subFreq = 90
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1040,
  pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                            value = c(200, 410, 405, 200)),
  rolloff = 0, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 40), rep(1, 40), rep(0, 20)), 
  subFreq = 90, subDep = 50, jitterDep = 0,
  formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                  freq = c(400, 1000, 900, 700), 
                                  width = 300, amp = 16),
                  f2 = data.frame(time = c(0, .1, 1), 
                                  freq = c(1900, 1700, 1600), 
                                  width = 350, amp = 18),
                  f3 = data.frame(freq = 2600, width = 400, amp = 25),
                  f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
  # noiseAnchors = -10,
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_410_90_14.wav'))

# subh2
pitchMedian = 400
subFreq = 150
subDep = 67
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1040,
  pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                            value = c(200, 410, 405, 200)),
  rolloff = 0, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 40), rep(1, 40), rep(0, 20)), 
  subFreq = 150, subDep = 67, jitterDep = 0,
  formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                  freq = c(400, 1000, 900, 700), 
                                  width = 300, amp = 16),
                  f2 = data.frame(time = c(0, .1, 1), 
                                  freq = c(1900, 1700, 1600), 
                                  width = 350, amp = 18),
                  f3 = data.frame(freq = 2600, width = 400, amp = 25),
                  f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
  # noiseAnchors = -10,
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_410_150_14.wav'))


## CHAOS
s = soundgen(
  sylLen = 1040,
  pitchAnchors = data.frame(time = c(0, .1, .9, 1),
                            value = c(200, 410, 405, 200)),
  rolloff = 0, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 40), rep(2, 40), rep(0, 20)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = list(f1 = data.frame(time = c(0, .1, .9, 1), 
                                  freq = c(400, 1000, 900, 700), 
                                  width = 300, amp = 16),
                  f2 = data.frame(time = c(0, .1, 1), 
                                  freq = c(1900, 1700, 1600), 
                                  width = 350, amp = 18),
                  f3 = data.frame(freq = 2600, width = 400, amp = 25),
                  f4 = data.frame(freq = 3600, width = 400, amp = 25)), 
  # noiseAnchors = -10,
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = flatEnv(s, samplingRate = 22050, windowLength = 50, method = 'peak')

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_410.wav'))
