setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_059'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$dom
# a$pitchAutocor

# original
s = soundgen(
  sylLen = 420, 
  pitchAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(330, 412, 420, 360)),
  rolloff = -8, rolloffOct = 0,
  temperature = 0.001,
  nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 15, shortestEpoch = 100,
  formants = c(960, 1450, 2700, 3700, 4900, 5800),
  formantWidth = 2,
  mouthAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(.2, .5, .45, .4)),
  noiseAnchors = data.frame(time = c(0, 400, 490),
                            value = c(-20, -20, -60) + 10),
  rolloffNoise = -10,
  attackLen = 20,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

# no nonlin
s = soundgen(
  sylLen = 420, 
  pitchAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(330, 412, 420, 360)),
  rolloff = -8, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 15, shortestEpoch = 100,
  formants = c(960, 1450, 2700, 3700, 4900, 5800),
  formantWidth = 2,
  mouthAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(.2, .5, .45, .4)),
  noiseAnchors = data.frame(time = c(0, 400, 490),
                            value = c(-30, -30, -60)),
  rolloffNoise = -10,
  attackLen = 20,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 420, 
  pitchAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(330, 412, 420, 360)),
  rolloff = -8 + 4, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 15, shortestEpoch = 100,
  formants = c(960, 1450, 2700, 3700, 4900, 5800),
  formantWidth = 2,
  mouthAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(.2, .5, .45, .4)),
  noiseAnchors = data.frame(time = c(0, 400, 490),
                            value =  c(-30, -30, -60)),
  rolloffNoise = -10,
  attackLen = 20,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 420, 
  pitchAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(330, 412, 420, 360)),
  rolloff = -8 - 4, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 15, shortestEpoch = 100,
  formants = c(960, 1450, 2700, 3700, 4900, 5800),
  formantWidth = 2,
  mouthAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(.2, .5, .45, .4)),
  noiseAnchors = data.frame(time = c(0, 400, 490),
                            value =  c(-30, -30, -60)),
  rolloffNoise = -10,
  attackLen = 20,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
pitchMedian = 400
subFreq = 80
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 420, 
  pitchAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(330, 412, 420, 360)),
  rolloff = -8, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 60), rep(0, 10)), 
  subFreq = 75, subDep = 55,
  formants = c(960, 1450, 2700, 3700, 4900, 5800),
  formantWidth = 2,
  mouthAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(.2, .5, .45, .4)),
  noiseAnchors = data.frame(time = c(0, 400, 490),
                            value =  c(-30, -30, -60)),
  rolloffNoise = -10,
  attackLen = 20,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_250_80_28.wav'))

# subh2
pitchMedian = 400
subFreq = 200
subDep = 110
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 420, 
  pitchAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(330, 412, 420, 360)),
  rolloff = -8, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 60), rep(0, 10)), 
  subFreq = 200, subDep = 110,
  formants = c(960, 1450, 2700, 3700, 4900, 5800),
  formantWidth = 2,
  mouthAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(.2, .5, .45, .4)),
  noiseAnchors = data.frame(time = c(0, 400, 490),
                            value =  c(-30, -30, -60)),
  rolloffNoise = -10,
  attackLen = 20,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_250_200_28.wav'))


## CHAOS
s = soundgen(
  sylLen = 420, 
  pitchAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(330, 412, 420, 360)),
  rolloff = -8, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(2, 60), rep(0, 10)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(960, 1450, 2700, 3700, 4900, 5800),
  formantWidth = 2,
  mouthAnchors = data.frame(time = c(0, 100, 330, 420),
                            value = c(.2, .5, .45, .4)),
  noiseAnchors = data.frame(time = c(0, 400, 490),
                            value =  c(-30, -30, -60)),
  rolloffNoise = -10,
  attackLen = 20,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_250.wav'))
