setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_190'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
# schwa(vocalTract = 16, formants_relative = c(-50, -50, 0, 0))  # original ff invisible, so let's make a guess
s = soundgen(
  sylLen = 550, 
  pitchAnchors = data.frame(time = c(0, 150, 170, 490, 550),
                            value = c(253, 440, 614, 711, 550)),
  rolloff = c(-15, -4, -4, -5),
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 15, shortestEpoch = 100,
  formants = c(350, 850, 2700, 3600, 5000, 6000),
  mouthAnchors = data.frame(time = c(0, 170, 550),
                            value = c(.2, .5, .45)),
  noiseAnchors = -30, rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 550, 
  pitchAnchors = data.frame(time = c(0, 150, 170, 490, 550),
                            value = c(253, 440, 614, 711, 550)),
  rolloff = c(-15, -4, -4, -5) + 4,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 15, shortestEpoch = 100,
  formants = c(350, 850, 2700, 3600, 5000, 6000),
  mouthAnchors = data.frame(time = c(0, 170, 550),
                            value = c(.2, .5, .45)),
  noiseAnchors = -30, rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 550, 
  pitchAnchors = data.frame(time = c(0, 150, 170, 490, 550),
                            value = c(253, 440, 614, 711, 550)),
  rolloff = c(-15, -4, -4, -5) - 4,
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 15, shortestEpoch = 100,
  formants = c(350, 850, 2700, 3600, 5000, 6000),
  mouthAnchors = data.frame(time = c(0, 170, 550),
                            value = c(.2, .5, .45)),
  noiseAnchors = -30, rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## PITCH JUMPS
s = soundgen(
  sylLen = 550, 
  pitchAnchors = data.frame(time = c(0, 160, 161, 490, 491, 550),
                            value = c(253, 440, 614, 711, 560, 550)),
  rolloff = c(-15, -4, -4, -5),
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 15, shortestEpoch = 100,
  formants = c(350, 850, 2700, 3600, 5000, 6000),
  mouthAnchors = data.frame(time = c(0, 170, 550),
                            value = c(.2, .5, .45)),
  noiseAnchors = -30, rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 600
subFreq = 120
subDep = 75
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 550, 
  pitchAnchors = data.frame(time = c(0, 150, 170, 490, 550),
                            value = c(253, 440, 614, 711, 550)),
  rolloff = c(-15, -4, -4, -5),
  temperature = 0.001,
  nonlinRandomWalk =  c(rep(0, 30), rep(1, 40), rep(0, 30)), 
  subFreq = 120, subDep = 75, jitterDep = 0, shortestEpoch = 50,
  formants = c(350, 850, 2700, 3600, 5000, 6000),
  mouthAnchors = data.frame(time = c(0, 170, 550),
                            value = c(.2, .5, .45)),
  noiseAnchors = -30, rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_220_120_28.wav'))

# subh2
pitchMedian = 600
subFreq = 240
subDep = 176
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 550, 
  pitchAnchors = data.frame(time = c(0, 150, 170, 490, 550),
                            value = c(253, 440, 614, 711, 550)),
  rolloff = c(-15, -4, -4, -5),
  temperature = 0.001,
  nonlinRandomWalk =  c(rep(0, 30), rep(1, 40), rep(0, 30)), 
  subFreq = 240, subDep = 176, jitterDep = 0, shortestEpoch = 50,
  formants = c(350, 850, 2700, 3600, 5000, 6000),
  mouthAnchors = data.frame(time = c(0, 170, 550),
                            value = c(.2, .5, .45)),
  noiseAnchors = -30, rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_220_240_28.wav'))


## CHAOS
s = soundgen(
  sylLen = 550, 
  pitchAnchors = data.frame(time = c(0, 150, 170, 490, 550),
                            value = c(253, 440, 614, 711, 550)),
  rolloff = c(-15, -4, -4, -5),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(2, 40), rep(0, 30)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(350, 850, 2700, 3600, 5000, 6000),
  mouthAnchors = data.frame(time = c(0, 170, 550),
                            value = c(.2, .5, .45)),
  noiseAnchors = -30, rolloffNoise = -2,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_220.wav'))
