setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_194'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 800, 
  pitchAnchors = list(time = c(0, 110, 111, 370, 540, 541, 830),
                      value = c(700, 1000, 1700, 2420, 2300, 1150, 1000)), 
  rolloff = c(-10, -5, -25),
  nonlinBalance = 100, subDep = 0, jitterDep = .1, shimmerDep = 5,
  temperature = 0.001, tempEffects = list(pitchAnchorsDep = 0), 
  formants = c(1000, 1800, 4300), 
  mouthAnchors = c(.3, .6, .5, .3),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s = soundgen(
  sylLen = 800, 
  pitchAnchors = list(time = c(0, 80, 130, 370, 550, 830),
                      value = c(700, 1000, 1700, 2420, 2300, 1000)), 
  rolloff = c(-10, -5, -25),
  # nonlinBalance = 100, subDep = 0, jitterDep = .1, shimmerDep = 5,
  temperature = 0.001, tempEffects = list(pitchAnchorsDep = 0), 
  formants = c(1000, 1800, 4300), 
  mouthAnchors = c(.3, .6, .5, .3),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 800, 
  pitchAnchors = list(time = c(0, 80, 130, 370, 550, 830),
                      value = c(700, 1000, 1700, 2420, 2300, 1000)), 
  rolloff = c(-10, -5, -25) + 8, invalidArgAction = 'ignore',
  # nonlinBalance = 100, subDep = 0, jitterDep = .1, shimmerDep = 5,
  temperature = 0.001, tempEffects = list(pitchAnchorsDep = 0), 
  formants = c(1000, 1800, 4300), 
  mouthAnchors = c(.3, .6, .5, .3),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 800, 
  pitchAnchors = list(time = c(0, 80, 130, 370, 550, 830),
                      value = c(700, 1000, 1700, 2420, 2300, 1000)), 
  rolloff = c(-10, -5, -25) - 8, invalidArgAction = 'ignore',
  # nonlinBalance = 100, subDep = 0, jitterDep = .1, shimmerDep = 5,
  temperature = 0.001, tempEffects = list(pitchAnchorsDep = 0), 
  formants = c(1000, 1800, 4300), 
  mouthAnchors = c(.3, .6, .5, .3),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## PITCH JUMPS
s = soundgen(
  sylLen = 800, 
  pitchAnchors = list(time = c(0, 110, 111, 370, 540, 541, 830),
                      value = c(700, 1000, 1700, 2420, 2300, 1150, 1000)), 
  rolloff = c(-10, -5, -25),
  # nonlinBalance = 100, subDep = 0, jitterDep = .1, shimmerDep = 5,
  temperature = 0.001, tempEffects = list(pitchAnchorsDep = 0), 
  formants = c(1000, 1800, 4300), 
  mouthAnchors = c(.3, .6, .5, .3),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 2000
subFreq = 100 
subDep = 70
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 800, 
  pitchAnchors = list(time = c(0, 80, 130, 370, 550, 830),
                      value = c(700, 1000, 1700, 2420, 2300, 1000)), 
  amplAnchors = c(80, 80, 60),
  rolloff = c(-10, -5, -25),
  nonlinRandomWalk = c(rep(0, 40), rep(1, 40), rep(0, 20)), 
  subFreq = 100, subDep = 70, jitterDep = 0, shortestEpoch = 50,
  temperature = 0.001, tempEffects = list(pitchAnchorsDep = 0), 
  formants = c(1000, 1800, 4300), 
  mouthAnchors = c(.3, .6, .5, .3),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_300_100_36.wav'))

# subh2
pitchMedian = 2000
subFreq = 600  
subDep = 470
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 800, 
  pitchAnchors = list(time = c(0, 80, 130, 370, 550, 830),
                      value = c(700, 1000, 1700, 2420, 2300, 1000)), 
  amplAnchors = c(80, 80, 60),
  rolloff = c(-10, -5, -25),
  nonlinRandomWalk = c(rep(0, 40), rep(1, 40), rep(0, 20)), 
  subFreq = 600, subDep = 470, jitterDep = 0, shortestEpoch = 50,
  temperature = 0.001, tempEffects = list(pitchAnchorsDep = 0), 
  formants = c(1000, 1800, 4300), 
  mouthAnchors = c(.3, .6, .5, .3),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_300_600_36.wav'))


## CHAOS
s = soundgen(
  sylLen = 800, 
  pitchAnchors = list(time = c(0, 80, 130, 370, 550, 830),
                      value = c(700, 1000, 1700, 2420, 2300, 1000)), 
  amplAnchors = c(80, 80, 60),
  rolloff = c(-10, -5, -25),
  nonlinRandomWalk = c(rep(0, 40), rep(2, 40), rep(0, 20)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001, tempEffects = list(pitchAnchorsDep = 0), 
  formants = c(1000, 1800, 4300), 
  mouthAnchors = c(.3, .6, .5, .3),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_300.wav'))
