setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_210'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 110, 111, 180, 350, 940, 941, 1100, 1200),
    value = c(700, 1150, 1550, 2000, 2240, 1940, 1180, 900, 500)),
  amplAnchors = data.frame(time = c(0, .8, 1),
                           value = c(0, 0, -20)),
  temperature = 0.001,
  nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(1150, 1700, 3600, 4500, 6000),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 180, 350, 920, 991, 1100, 1200),
    value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
  amplAnchors = data.frame(time = c(0, .8, 1),
                           value = c(0, 0, -20)),
  temperature = 0.001,
  # nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(1150, 1700, 3600, 4500, 6000),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +8
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 180, 350, 920, 991, 1100, 1200),
    value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
  amplAnchors = data.frame(time = c(0, .8, 1),
                           value = c(0, 0, -20)),
  temperature = 0.001,
  # nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
  rolloff = 0 + 8, rolloffKHz = 0, invalidArgAction = 'ignore',
  formants = c(1150, 1700, 3600, 4500, 6000),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+8.wav'))

# no nonlin rolloff -8
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 180, 350, 920, 991, 1100, 1200),
    value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
  amplAnchors = data.frame(time = c(0, .8, 1),
                           value = c(0, 0, -20)),
  temperature = 0.001,
  # nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
  rolloff = 0 - 8, rolloffKHz = 0, invalidArgAction = 'ignore',
  formants = c(1150, 1700, 3600, 4500, 6000),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-8.wav'))


## PITCH JUMPS
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 110, 111, 180, 350, 940, 941, 1100, 1200),
    value = c(700, 1150, 1550, 2000, 2240, 1940, 1180, 900, 500)),
  amplAnchors = data.frame(time = c(0, .8, 1),
                           value = c(0, 0, -20)),
  temperature = 0.001,
  # nonlinBalance = 85, subFreq = 850, subDep = 350, jitterDep = .7, shimmerDep = 10,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(1150, 1700, 3600, 4500, 6000),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 2000
subFreq = 120 
subDep = 90
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 180, 350, 920, 991, 1100, 1200),
    value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
  amplAnchors = data.frame(time = c(0, .8, 1),
                           value = c(0, 0, -20)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 60), rep(0, 20)), shortestEpoch = 50,
  subFreq = 120, subDep = 90, jitterDep = 0,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(1150, 1700, 3600, 4500, 6000),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_120_43.wav'))

# subh2
pitchMedian = 2000
subFreq = 750
subDep = 510
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 180, 350, 920, 991, 1100, 1200),
    value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
  amplAnchors = data.frame(time = c(0, .8, 1),
                           value = c(0, 0, -20)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 60), rep(0, 20)), shortestEpoch = 50, 
  subFreq = 750, subDep = 510, jitterDep = 0, invalidArgAction = 'ignore',
  rolloff = 0, rolloffKHz = 0, 
  formants = c(1150, 1700, 3600, 4500, 6000),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_300_750_43.wav'))


## CHAOS
s = soundgen(
  sylLen = 1200, 
  pitchAnchors = list(
    time = c(0, 180, 350, 920, 991, 1100, 1200),
    value = c(700, 2000, 2240, 1940, 1180, 900, 500)),
  amplAnchors = data.frame(time = c(0, .8, 1),
                           value = c(0, 0, -20)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(2, 60), rep(0, 20)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(1150, 1700, 3600, 4500, 6000),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.4, .6, .1)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_500.wav'))
