setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_213a'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 50, 520, 521, 920, 980),
    value = c(1000, 1900, 1860, 1720, 1550, 1100)),
  temperature = 0.001, 
  nonlinBalance = 100, subDep = 70, jitterDep = .2,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(900, 1300, 3300, 4300),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 50, 521, 920, 980),
    value = c(1000, 1900, 1720, 1550, 1100)),
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 70, jitterDep = .2,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(900, 1300, 3300, 4300),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 50, 521, 920, 980),
    value = c(1000, 1900, 1720, 1550, 1100)),
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 70, jitterDep = .2,
  rolloff = 0 + 6, rolloffKHz = 0, invalidArgAction = 'ignore',
  formants = c(900, 1300, 3300, 4300),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 50, 521, 920, 980),
    value = c(1000, 1900, 1720, 1550, 1100)),
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 70, jitterDep = .2,
  rolloff = 0 - 6, rolloffKHz = 0, 
  formants = c(900, 1300, 3300, 4300),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## PITCH JUMPS
s = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 80, 81, 520, 521, 920, 980),
    value = c(1000, 1260, 1900, 1860, 1720, 1550, 1100)),
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 70, jitterDep = .2,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(900, 1300, 3300, 4300),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 1700
subFreq = 90  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 50, 521, 920, 980),
    value = c(1000, 1900, 1720, 1550, 1100)),
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 20), rep(1, 70), rep(0, 10)), shortestEpoch = 50,
  subFreq = 90, subDep = 50, jitterDep = 0,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(900, 1300, 3300, 4300),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_600_90_20.wav'))

# subh2
pitchMedian = 1700
subFreq = 280  
subDep = 160
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 50, 521, 920, 980),
    value = c(1000, 1900, 1720, 1550, 1100)),
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 20), rep(1, 70), rep(0, 10)), shortestEpoch = 50, 
  subFreq = 280, subDep = 160, jitterDep = 0,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(900, 1300, 3300, 4300),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_600_280_20.wav'))


## CHAOS
s = soundgen(
  sylLen = 980, pitchAnchors = list(
    time = c(0, 50, 521, 920, 980),
    value = c(1000, 1900, 1720, 1550, 1100)),
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 30), rep(2, 55), rep(0, 15)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  rolloff = 0, rolloffKHz = 0, 
  formants = c(900, 1300, 3300, 4300),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_600.wav'))
