setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_244'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 260, pitchAnchors = list(
    time = c(0, 63, 64, 160, 260),
    value = c(800, 1100, 1800, 2100, 940)),
  temperature = 0.05,
  nonlinBalance = 100, subDep = 0, jitterDep = 0.1,
  formants = c(850, 1700, 2500, 4000),
  rolloffParab = 10, rolloffParabHarm = 2, rolloff = -2,
  mouthAnchors = c(0, .5, .5, 0),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)


seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s = soundgen(
  sylLen = 260, pitchAnchors = list(
    time = c(0, 40, 80, 160, 260),
    value = c(800, 1100, 1800, 2100, 940)),
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = 0.1,
  formants = c(850, 1700, 2500, 4000),
  rolloffParab = 10, rolloffParabHarm = 2, rolloff = -2,
  mouthAnchors = c(0, .5, .5, 0),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)


seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 260, 
  pitchAnchors = list(
    time = c(0, 40, 80, 160, 260),
    value = c(800, 1100, 1800, 2100, 940)),
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = 0.1,
  formants = c(850, 1700, 2500, 4000),
  rolloffParab = 10, rolloffParabHarm = 2, rolloff = -2 + 6, invalidArgAction = 'ignore',
  mouthAnchors = c(0, .5, .5, 0),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 260, 
  pitchAnchors = list(
    time = c(0, 40, 80, 160, 260),
    value = c(800, 1100, 1800, 2100, 940)),
  temperature = 0.001,
  # nonlinBalance = 100, subDep = 0, jitterDep = 0.1,
  formants = c(850, 1700, 2500, 4000),
  rolloffParab = 10, rolloffParabHarm = 2, rolloff = -2 -6,
  mouthAnchors = c(0, .5, .5, 0),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## PITCH JUMPS
s = soundgen(
  sylLen = 260, 
  pitchAnchors = list(
    time = c(0, 63, 64, 160, 260),
    value = c(800, 1100, 1800, 2100, 940)),
  temperature = 0.05,
  # nonlinBalance = 100, subDep = 0, jitterDep = 0.1,
  formants = c(850, 1700, 2500, 4000),
  rolloffParab = 10, rolloffParabHarm = 2, rolloff = -2,
  mouthAnchors = c(0, .5, .5, 0),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)


seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 1700
subFreq = 90  
subDep = 60
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 330,  # to compensate for changing epochs
  pitchAnchors = list(
    time = c(0, 40, 80, 160, 260),
    value = c(800, 1100, 1800, 2100, 940)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 10), rep(1, 70), rep(0, 10)), shortestEpoch = 50,
  subFreq = 90, subDep = 60, jitterDep = 0, 
  formants = c(850, 1700, 2500, 4000),
  rolloffParab = 10, rolloffParabHarm = 2, rolloff = -2,
  mouthAnchors = c(0, .5, .5, 0),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_180_90_32.wav'))

# subh2
pitchMedian = 1700
subFreq = 400  
subDep = 280
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 310,  # to compensate for changing epochs
  pitchAnchors = list(
    time = c(0, 40, 80, 160, 260),
    value = c(800, 1100, 1800, 2100, 940)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 10), rep(1, 70), rep(0, 10)), shortestEpoch = 50,
  subFreq = 400, subDep = 280, jitterDep = 0, 
  formants = c(850, 1700, 2500, 4000),
  rolloffParab = 10, rolloffParabHarm = 2, rolloff = -2,
  mouthAnchors = c(0, .5, .5, 0),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_180_400_32.wav'))


## CHAOS
s = soundgen(
  sylLen = 260, 
  pitchAnchors = list(
    time = c(0, 40, 80, 160, 260),
    value = c(800, 1100, 1800, 2100, 940)),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(2, 70), rep(0, 10)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15, 
  formants = c(850, 1700, 2500, 4000),
  rolloffParab = 10, rolloffParabHarm = 2, rolloff = -2,
  mouthAnchors = c(0, .5, .5, 0),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)


seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_200.wav'))
