setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_322'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 680, 
  pitchAnchors = list(
    time = c(0, 90, 91, 360, 590, 680),
    value = c(1000, 1120, 1900, 2300, 2040, 1240)),
  rolloff = c(-10, -5, -5, -10),
  temperature = 0.001,
  nonlinBalance = 80, shortestEpoch = 100, subDep = 0, jitterDep = 1,
  formants = c(900, 2100, 3500, 4500), 
  mouthAnchors = c(.4, .6, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s2 = soundgen(
  sylLen = 55, 
  pitchAnchors = c(620, 600),
  rolloff = -30,
  temperature = 0.001,
  formants = NULL, vocalTract = 13,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1 * 5, s2, insertionPoint = length(s1) + 22050 * .04)
playme(s, 22050)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s1 = soundgen(
  sylLen = 680, 
  pitchAnchors = list(
    time = c(0, 60, 120, 360, 590, 680),
    value = c(1000, 1120, 1900, 2300, 2040, 1240)),
  rolloff = c(-10, -5, -5, -10),
  temperature = 0.001,
  # nonlinBalance = 80, shortestEpoch = 100, subDep = 0, jitterDep = 1,
  formants = c(900, 2100, 3500, 4500), 
  mouthAnchors = c(.4, .6, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 5, s2, insertionPoint = length(s1) + 22050 * .04)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s1 = soundgen(
  sylLen = 680, 
  pitchAnchors = list(
    time = c(0, 60, 120, 360, 590, 680),
    value = c(1000, 1120, 1900, 2300, 2040, 1240)),
  rolloff = c(-10, -5, -5, -10) + 6, invalidArgAction = 'ignore',
  temperature = 0.001,
  # nonlinBalance = 80, shortestEpoch = 100, subDep = 0, jitterDep = 1,
  formants = c(900, 2100, 3500, 4500), 
  mouthAnchors = c(.4, .6, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 5, s2, insertionPoint = length(s1) + 22050 * .04)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s1 = soundgen(
  sylLen = 680, 
  pitchAnchors = list(
    time = c(0, 60, 120, 360, 590, 680),
    value = c(1000, 1120, 1900, 2300, 2040, 1240)),
  rolloff = c(-10, -5, -5, -10) - 6, invalidArgAction = 'ignore',
  temperature = 0.001,
  # nonlinBalance = 80, shortestEpoch = 100, subDep = 0, jitterDep = 1,
  formants = c(900, 2100, 3500, 4500), 
  mouthAnchors = c(.4, .6, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 5, s2, insertionPoint = length(s1) + 22050 * .04)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## PITCH JUMPS
s1 = soundgen(
  sylLen = 680, 
  pitchAnchors = list(
    time = c(0, 90, 91, 360, 590, 680),
    value = c(1000, 1120, 1900, 2300, 2040, 1240)),
  rolloff = c(-10, -5, -5, -10),
  temperature = 0.001,
  # nonlinBalance = 80, shortestEpoch = 100, subDep = 0, jitterDep = 1,
  formants = c(900, 2100, 3500, 4500), 
  mouthAnchors = c(.4, .6, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 5, s2, insertionPoint = length(s1) + 22050 * .04)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 2000
subFreq = 110  
subDep = 80
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 680, 
  pitchAnchors = list(
    time = c(0, 60, 120, 360, 590, 680),
    value = c(1000, 1120, 1900, 2300, 2040, 1240)),
  rolloff = c(-10, -5, -5, -10),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 50), rep(1, 40), rep(0, 10)), shortestEpoch = 250, 
  subFreq = 110, subDep = 80,
  formants = c(900, 2100, 3500, 4500), 
  mouthAnchors = c(.4, .6, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 5, s2, insertionPoint = length(s1) + 22050 * .04)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_270_110_38.wav'))

# subh2
pitchMedian = 2000
subFreq = 310  
subDep = 240
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 680, 
  pitchAnchors = list(
    time = c(0, 60, 120, 360, 590, 680),
    value = c(1000, 1120, 1900, 2300, 2040, 1240)),
  rolloff = c(-10, -5, -5, -10),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 50), rep(1, 40), rep(0, 10)), shortestEpoch = 250, 
  subFreq = 310, subDep = 240,
  formants = c(900, 2100, 3500, 4500), 
  mouthAnchors = c(.4, .6, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 5, s2, insertionPoint = length(s1) + 22050 * .04)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_270_310_38.wav'))

## CHAOS
s1 = soundgen(
  sylLen = 680, 
  pitchAnchors = list(
    time = c(0, 60, 120, 360, 590, 680),
    value = c(1000, 1120, 1900, 2300, 2040, 1240)),
  rolloff = c(-10, -5, -5, -10),
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 50), rep(2, 40), rep(0, 10)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(900, 2100, 3500, 4500), 
  mouthAnchors = c(.4, .6, .4),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 5, s2, insertionPoint = length(s1) + 22050 * .04)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_270.wav'))
