setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_332'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 161, 450, 451, 530, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinBalance = 75, subFreq = 200, subDep = 120, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 120, 200, 410, 490, 530, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  # nonlinBalance = 75, subFreq = 200, subDep = 120, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 120, 200, 410, 490, 530, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10) + 6, rolloffKHz = 0, invalidArgAction = 'ignore',
  temperature = 0.001,
  # nonlinBalance = 75, subFreq = 200, subDep = 120, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 120, 200, 410, 490, 530, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10) - 6, rolloffKHz = 0, invalidArgAction = 'ignore',
  temperature = 0.001,
  # nonlinBalance = 75, subFreq = 200, subDep = 120, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## PITCH JUMPS
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 160, 161, 450, 451, 630, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  # nonlinBalance = 75, subFreq = 200, subDep = 120, jitterDep = 1, shortestEpoch = 100,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 1700
subFreq = 140  
subDep = 110
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 120, 200, 410, 490, 530, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 40), rep(0, 40)), 
  subFreq = 140, subDep = 110,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_250_140_44.wav'))


## CHAOS
s = soundgen(
  sylLen = 770, 
  pitchAnchors = list(
    time = c(0, 120, 200, 410, 490, 530, 645, 770),
    value = c(1400, 1450, 2000, 1890, 1150, 1100, 1270, 650)),
  rolloff = c(rep(0, 10), -10), rolloffKHz = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 20), rep(2, 40), rep(0, 40)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(1100, 1800, 3400),
  mouthAnchors = data.frame(time = c(0, .8, 1), value = c(.5, .5, 0)), 
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_250.wav'))
