setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_362'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 660, 
  pitchAnchors = data.frame(
    time = c(0, 104, 314, 580, 660),
    value = c(337, 380, 370, 390, 318)),
  amplAnchors = c(75, 80),
  rolloff = -7, rolloffOct = 0,
  temperature = 0.001,
  nonlinBalance = 100, subFreq = 80, subDep = 50, jitterDep = 0.4, shimmerDep = 10,
  formants = c(800, 1200, 2970, 3500, 4600, 5400),
  attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s = soundgen(
  sylLen = 660, 
  pitchAnchors = data.frame(
    time = c(0, 104, 314, 580, 660),
    value = c(337, 380, 370, 390, 318)),
  amplAnchors = c(75, 80),
  rolloff = -7, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subFreq = 80, subDep = 50, jitterDep = 0.4, shimmerDep = 10,
  formants = c(800, 1200, 2970, 3500, 4600, 5400),
  attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 660, 
  pitchAnchors = data.frame(
    time = c(0, 104, 314, 580, 660),
    value = c(337, 380, 370, 390, 318)),
  amplAnchors = c(75, 80),
  rolloff = -7 + 6, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subFreq = 80, subDep = 50, jitterDep = 0.4, shimmerDep = 10,
  formants = c(800, 1200, 2970, 3500, 4600, 5400),
  attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 660, 
  pitchAnchors = data.frame(
    time = c(0, 104, 314, 580, 660),
    value = c(337, 380, 370, 390, 318)),
  amplAnchors = c(75, 80),
  rolloff = -7 - 6, rolloffOct = 0,
  temperature = 0.001,
  # nonlinBalance = 100, subFreq = 80, subDep = 50, jitterDep = 0.4, shimmerDep = 10,
  formants = c(800, 1200, 2970, 3500, 4600, 5400),
  attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 370
subFreq = 80  
subDep = 50
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 660, 
  pitchAnchors = data.frame(
    time = c(0, 104, 314, 580, 660),
    value = c(337, 380, 370, 390, 318)),
  amplAnchors = c(75, 80),
  rolloff = -7, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 60), rep(0, 10)), 
  subFreq = 80, subDep = 50, 
  formants = c(800, 1200, 2970, 3500, 4600, 5400),
  attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_400_80_33.wav'))

# subh2
pitchMedian = 370
subFreq = 180  
subDep = 127
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 660, 
  pitchAnchors = data.frame(
    time = c(0, 104, 314, 580, 660),
    value = c(337, 380, 370, 390, 318)),
  amplAnchors = c(75, 80),
  rolloff = -7, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(1, 60), rep(0, 10)), 
  subFreq = 180, subDep = 127, 
  formants = c(800, 1200, 2970, 3500, 4600, 5400),
  attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_400_180_33.wav'))


## CHAOS
s = soundgen(
  sylLen = 660, 
  pitchAnchors = data.frame(
    time = c(0, 104, 314, 580, 660),
    value = c(337, 380, 370, 390, 318)),
  amplAnchors = c(75, 80),
  rolloff = -7, rolloffOct = 0,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 30), rep(2, 60), rep(0, 10)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(800, 1200, 2970, 3500, 4600, 5400),
  attackLen = 100,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_400.wav'))
