setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_366'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s = soundgen(
  sylLen = 1000, 
  pitchAnchors = data.frame(time = c(0, 900, 1000),
                            value = c(315, 280, 200)),
  rolloff = -5, rolloffOct = 0,
  temperature = 0.001, 
  nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
  formants = c(700, 1150, 2700, 3900),
  mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
s = soundgen(
  sylLen = 1000, 
  pitchAnchors = data.frame(time = c(0, 900, 1000),
                            value = c(315, 280, 200)),
  rolloff = -5, rolloffOct = 0,
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
  formants = c(700, 1150, 2700, 3900),
  mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s = soundgen(
  sylLen = 1000, 
  pitchAnchors = data.frame(time = c(0, 900, 1000),
                            value = c(315, 280, 200)),
  rolloff = -5 + 4, rolloffOct = 0,
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
  formants = c(700, 1150, 2700, 3900),
  mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 1000, 
  pitchAnchors = data.frame(time = c(0, 900, 1000),
                            value = c(315, 280, 200)),
  rolloff = -5 - 4, rolloffOct = 0,
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
  formants = c(700, 1150, 2700, 3900),
  mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## SUBHARMONICS
rw = c(rep(0, 10), rep(1, 60), rep(0, 30)) 

pitchMedian = 300
subFreq = 75  
subDep = 35
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1000, 
  pitchAnchors = data.frame(time = c(0, 900, 1000),
                            value = c(315, 280, 200)),
  rolloff = -5, rolloffOct = 0,
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 10), rep(1, 60), rep(0, 30)), 
  subFreq = 75, subDep = 35,
  formants = c(700, 1150, 2700, 3900),
  mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_600_75_10.wav'))

# subh2
pitchMedian = 300
subFreq = 145  
subDep = 70
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1000, 
  pitchAnchors = data.frame(time = c(0, 900, 1000),
                            value = c(315, 280, 200)),
  rolloff = -5, rolloffOct = 0,
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 10), rep(1, 60), rep(0, 30)), 
  subFreq = 145, subDep = 70,
  formants = c(700, 1150, 2700, 3900),
  mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_600_145_10.wav'))


## CHAOS
s = soundgen(
  sylLen = 1000, 
  pitchAnchors = data.frame(time = c(0, 900, 1000),
                            value = c(315, 280, 200)),
  rolloff = -5, rolloffOct = 0,
  temperature = 0.001, 
  nonlinRandomWalk = c(rep(0, 10), rep(2, 60), rep(0, 30)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = c(700, 1150, 2700, 3900),
  mouthAnchors = data.frame(time = c(0, .9, 1), value = c(.5, .4, 0)),
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_600.wav'))
