setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_394'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 250, 
  pitchAnchors = data.frame(time = c(0, 220, 250),
                            value = c(780, 1000, 920)),
  amplAnchors = c(80, 80, 70),
  rolloff = -6, rolloffOct = -1,
  temperature = 0.001, 
  formants = list(f1 = 1200, f2 = c(1900, 1750, 1700), f3 = c(2100, 3000, 3100), f4 = 4400), 
  attackLen = 25,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  sylLen = 1860, 
  pitchAnchors = data.frame(time = c(0, 240, 670, 790, 990, 1250, 1530, 1860),
                            value = c(730, 880, 814, 840, 770, 945, 695, 620)),
  vibratoFreq = 5, vibratoDep = .2,
  amplAnchors = c(0, 0, -5),
  rolloff = -6, rolloffOct = -1,
  temperature = 0.001, 
  formants = c(1200, 1700, 3100, 4400),
  formantWidth = 2,
  mouthAnchors = c(.4, .6, .1, .6, 0),
  attackLen = 75,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1, s2, insertionPoint = length(s1) + 22050 * .07)
playme(s, 22050)


# no nonlin
seewave::savewav(s2, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +4
s2 = soundgen(
  sylLen = 1860, 
  pitchAnchors = data.frame(time = c(0, 240, 670, 790, 990, 1250, 1530, 1860),
                            value = c(730, 880, 814, 840, 770, 945, 695, 620)),
  vibratoFreq = 5, vibratoDep = .2,
  amplAnchors = c(0, 0, -5),
  rolloff = -6 + 4, rolloffOct = -1,
  temperature = 0.001, 
  formants = c(1200, 1700, 3100, 4400),
  formantWidth = 2,
  mouthAnchors = c(.4, .6, .1, .6, 0),
  attackLen = 75,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s2, f = 22050, filename = paste0(filename, '_000_r+4.wav'))

# no nonlin rolloff -4
s2 = soundgen(
  sylLen = 1860, 
  pitchAnchors = data.frame(time = c(0, 240, 670, 790, 990, 1250, 1530, 1860),
                            value = c(730, 880, 814, 840, 770, 945, 695, 620)),
  vibratoFreq = 5, vibratoDep = .2,
  amplAnchors = c(0, 0, -5),
  rolloff = -6 - 4, rolloffOct = -1,
  temperature = 0.001, 
  formants = c(1200, 1700, 3100, 4400),
  formantWidth = 2,
  mouthAnchors = c(.4, .6, .1, .6, 0),
  attackLen = 75,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s2, f = 22050, filename = paste0(filename, '_000_r-4.wav'))


## PITCH JUMPS
s2 = soundgen(
  sylLen = 1860, 
  pitchAnchors = data.frame(time = c(0, 250, 251, 670, 790, 990, 1250, 1350, 1351, 1860),
                            value = c(730, 750, 880, 814, 840, 770, 945, 930, 695, 620)),
  vibratoFreq = 5, vibratoDep = .2,
  amplAnchors = c(0, 0, -5),
  rolloff = -6 - 4, rolloffOct = -1,
  temperature = 0.001, 
  formants = c(1200, 1700, 3100, 4400),
  formantWidth = 2,
  mouthAnchors = c(.4, .6, .1, .6, 0),
  attackLen = 75,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s2, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
rw = soundgen:::getRandomWalk(len = 100, rw_range = 100)
rw1 = soundgen:::getIntegerRandomWalk(rw, nonlinBalance = 25, minLength = 10, plot = TRUE) # c(rep(0, 10), rep(1, 60), rep(0, 30)) 
rw1[rw1 == 2] = 1
mean(rw1 == 1) * 1860

pitchMedian = 800
subFreq = 90  
subDep = 75
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s2 = soundgen(
  sylLen = 1860, 
  pitchAnchors = data.frame(time = c(0, 240, 670, 790, 990, 1250, 1530, 1860),
                            value = c(730, 880, 814, 840, 770, 945, 695, 620)),
  vibratoFreq = 5, vibratoDep = .2,
  amplAnchors = c(0, 0, -5),
  rolloff = -6, rolloffOct = -1,
  nonlinRandomWalk = rw1, subFreq = 90, subDep = 75,
  temperature = 0.001, 
  formants = c(1200, 1700, 3100, 4400),
  formantWidth = 2,
  mouthAnchors = c(.4, .6, .1, .6, 0),
  attackLen = 75,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s2, f = 22050, filename = paste0(filename, '_010_950_90_50.wav'))

# subh2
pitchMedian = 800
subFreq = 180  
subDep = 170
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s2 = soundgen(
  sylLen = 1860, 
  pitchAnchors = data.frame(time = c(0, 240, 670, 790, 990, 1250, 1530, 1860),
                            value = c(730, 880, 814, 840, 770, 945, 695, 620)),
  vibratoFreq = 5, vibratoDep = .2,
  amplAnchors = c(0, 0, -5),
  rolloff = -6, rolloffOct = -1,
  nonlinRandomWalk = rw1, subFreq = 180, subDep = 170,
  temperature = 0.001, 
  formants = c(1200, 1700, 3100, 4400),
  formantWidth = 2,
  mouthAnchors = c(.4, .6, .1, .6, 0),
  attackLen = 75,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s2, f = 22050, filename = paste0(filename, '_010_950_180_50.wav'))


## CHAOS
rw2 = rw1
rw2[rw2 == 1] = 2
mean(rw2 == 2)

s2 = soundgen(
  sylLen = 1860, 
  pitchAnchors = data.frame(time = c(0, 240, 670, 790, 990, 1250, 1530, 1860),
                            value = c(730, 880, 814, 840, 770, 945, 695, 620)),
  vibratoFreq = 5, vibratoDep = .2,
  amplAnchors = c(0, 0, -5),
  rolloff = -6, rolloffOct = -1,
  nonlinRandomWalk = rw2, subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001, 
  formants = c(1200, 1700, 3100, 4400),
  formantWidth = 2,
  mouthAnchors = c(.4, .6, .1, .6, 0),
  attackLen = 75,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s2, f = 22050, filename = paste0(filename, '_001_950.wav'))
