setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_400'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
t = c(0, 200, 320, 430, 1570, 1650)
s = soundgen(
  sylLen = 1650, 
  pitchAnchors = data.frame(time = t, 
                            value = c(570, 880, 805, 925, 915, 650)),
  amplAnchors = data.frame(time = t, 
                           value = c(80, 80, 65, 80, 75, 70)),
  vibratoFreq = 3, vibratoDep = .25,
  rolloff = c(-12, -15, rep(-8, 6), -9, -12), # -9, 
  rolloffOct = -1,
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
  formants = list(
    f1 = data.frame(time = t, freq = c(400, 600, 900, 700, 700, 700)),
    f2 = data.frame(time = t, freq = c(1600, 1600, 1900, 1600, 1600, 1500)),
    f3 = data.frame(time = t, freq = c(3400, 3300, 2100, 3400, 3400, 3200)),
    f4 = 4500
  ),
  noiseAnchors = data.frame(time = t, value = c(-30, -30, -10, -30, -40, -40)),
  rolloffNoise = -7,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
playme(s, 22050)
seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')


# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 1650, 
  pitchAnchors = data.frame(time = t, 
                            value = c(570, 880, 805, 925, 915, 650)),
  amplAnchors = data.frame(time = t, 
                           value = c(80, 80, 65, 80, 75, 70)),
  vibratoFreq = 3, vibratoDep = .25,
  rolloff = c(-12, -15, rep(-8, 6), -9, -12) + 6, 
  rolloffOct = -1,
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
  formants = list(
    f1 = data.frame(time = t, freq = c(400, 600, 900, 700, 700, 700)),
    f2 = data.frame(time = t, freq = c(1600, 1600, 1900, 1600, 1600, 1500)),
    f3 = data.frame(time = t, freq = c(3400, 3300, 2100, 3400, 3400, 3200)),
    f4 = 4500
  ),
  noiseAnchors = data.frame(time = t, value = c(-30, -30, -10, -30, -40, -40)),
  rolloffNoise = -7,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -4
s = soundgen(
  sylLen = 1650, 
  pitchAnchors = data.frame(time = t, 
                            value = c(570, 880, 805, 925, 915, 650)),
  amplAnchors = data.frame(time = t, 
                           value = c(80, 80, 65, 80, 75, 70)),
  vibratoFreq = 3, vibratoDep = .25,
  rolloff = c(-12, -15, rep(-8, 6), -9, -12) - 6, 
  rolloffOct = -1,
  temperature = 0.001, 
  # nonlinBalance = 100, subDep = 50, subFreq = 75, jitterDep = 0.1,
  formants = list(
    f1 = data.frame(time = t, freq = c(400, 600, 900, 700, 700, 700)),
    f2 = data.frame(time = t, freq = c(1600, 1600, 1900, 1600, 1600, 1500)),
    f3 = data.frame(time = t, freq = c(3400, 3300, 2100, 3400, 3400, 3200)),
    f4 = 4500
  ),
  noiseAnchors = data.frame(time = t, value = c(-30, -30, -10, -30, -40, -40)),
  rolloffNoise = -7,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## SUBHARMONICS
pitchMedian = 900
subFreq = 100  
subDep = 55
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1650, 
  pitchAnchors = data.frame(time = t, 
                            value = c(570, 880, 805, 925, 915, 650)),
  amplAnchors = data.frame(time = t, 
                           value = c(80, 80, 65, 80, 75, 70)),
  vibratoFreq = 3, vibratoDep = .25,
  rolloff = c(-12, -15, rep(-8, 6), -9, -12), # -9, 
  rolloffOct = -1,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 40), rep(1, 30), rep(0, 30)), 
  subFreq = 100, subDep = 55, 
  formants = list(
    f1 = data.frame(time = t, freq = c(400, 600, 900, 700, 700, 700)),
    f2 = data.frame(time = t, freq = c(1600, 1600, 1900, 1600, 1600, 1500)),
    f3 = data.frame(time = t, freq = c(3400, 3300, 2100, 3400, 3400, 3200)),
    f4 = 4500
  ),
  noiseAnchors = data.frame(time = t, value = c(-30, -30, -10, -30, -40, -40)),
  rolloffNoise = -7,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_100_19.wav'))

# subh2
pitchMedian = 900
subFreq = 300  
subDep = 165
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 1650, 
  pitchAnchors = data.frame(time = t, 
                            value = c(570, 880, 805, 925, 915, 650)),
  amplAnchors = data.frame(time = t, 
                           value = c(80, 80, 65, 80, 75, 70)),
  vibratoFreq = 3, vibratoDep = .25,
  rolloff = c(-12, -15, rep(-8, 6), -9, -12), # -9, 
  rolloffOct = -1,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 40), rep(1, 30), rep(0, 30)), 
  subFreq = 300, subDep = 165, 
  formants = list(
    f1 = data.frame(time = t, freq = c(400, 600, 900, 700, 700, 700)),
    f2 = data.frame(time = t, freq = c(1600, 1600, 1900, 1600, 1600, 1500)),
    f3 = data.frame(time = t, freq = c(3400, 3300, 2100, 3400, 3400, 3200)),
    f4 = 4500
  ),
  noiseAnchors = data.frame(time = t, value = c(-30, -30, -10, -30, -40, -40)),
  rolloffNoise = -7,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_300_19.wav'))


## CHAOS
s = soundgen(
  sylLen = 1650, 
  pitchAnchors = data.frame(time = t, 
                            value = c(570, 880, 805, 925, 915, 650)),
  amplAnchors = data.frame(time = t, 
                           value = c(80, 80, 65, 80, 75, 70)),
  vibratoFreq = 3, vibratoDep = .25,
  rolloff = c(-12, -15, rep(-8, 6), -9, -12), # -9, 
  rolloffOct = -1,
  temperature = 0.001,
  nonlinRandomWalk = c(rep(0, 40), rep(2, 30), rep(0, 30)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  formants = list(
    f1 = data.frame(time = t, freq = c(400, 600, 900, 700, 700, 700)),
    f2 = data.frame(time = t, freq = c(1600, 1600, 1900, 1600, 1600, 1500)),
    f3 = data.frame(time = t, freq = c(3400, 3300, 2100, 3400, 3400, 3200)),
    f4 = 4500
  ),
  noiseAnchors = data.frame(time = t, value = c(-30, -30, -10, -30, -40, -40)),
  rolloffNoise = -7,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_500.wav'))
