setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_440'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
s1 = soundgen(
  sylLen = 480, 
  pitchAnchors = data.frame(time = c(0, 150, 380, 480), 
                            value = c(550, 1000, 1055, 840)),
  amplAnchors = c(80, 80, 75),
  rolloff = c(-20, -4, -2, -4, -20), rolloffOct = 0,
  temperature = 0.001, 
  formants = c(900, 1500, 3200, 4400),
  rolloffNoise = 0,
  attackLen = 60,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s1, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

s2 = soundgen(
  sylLen = 410, 
  pitchAnchors = data.frame(time = c(0, 410), 
                            value = c(1680, 1200)),
  amplAnchors = c(80, 40),
  rolloff = -100, invalidArgAction = 'ignore',
  temperature = 0.2, 
  formants = c(900, 1500, 3200, 4400),
  mouthAnchors = c(.5, .3),
  nonlinBalance = 100, subDep = 0, jitterDep = .75, shimmerDep = 20,
  noiseAnchors = data.frame(time = c(-110, 50, 250, 500), 
                            value = c(-60, -20, -35, -60) + 10),
  rolloffNoise = -7,
  attackLen = 60,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

s = addVectors(s1 * 2, s2, insertionPoint = length(s1) - 22050 * .21)
playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 4))

# no nonlin
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s1 = soundgen(
  sylLen = 480, 
  pitchAnchors = data.frame(time = c(0, 150, 380, 480), 
                            value = c(550, 1000, 1055, 840)),
  amplAnchors = c(80, 80, 75),
  rolloff = c(-20, -4, -2, -4, -20) + 6, rolloffOct = 0, invalidArgAction = 'ignore',
  temperature = 0.001, 
  formants = c(900, 1500, 3200, 4400),
  rolloffNoise = 0,
  attackLen = 60,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 2, s2, insertionPoint = length(s1) - 22050 * .21)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s1 = soundgen(
  sylLen = 480, 
  pitchAnchors = data.frame(time = c(0, 150, 380, 480), 
                            value = c(550, 1000, 1055, 840)),
  amplAnchors = c(80, 80, 75),
  rolloff = c(-20, -4, -2, -4, -20) - 6, rolloffOct = 0, invalidArgAction = 'ignore',
  temperature = 0.001, 
  formants = c(900, 1500, 3200, 4400),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 2, s2, insertionPoint = length(s1) - 22050 * .21)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## PITCH JUMPS
s1 = soundgen(
  sylLen = 480, 
  pitchAnchors = data.frame(time = c(0, 130, 131, 390, 391, 480), 
                            value = c(550, 750, 1000, 1055, 900, 840)),
  amplAnchors = c(80, 80, 75),
  rolloff = c(-20, -4, -2, -4, -20), rolloffOct = 0, invalidArgAction = 'ignore',
  temperature = 0.001, 
  formants = c(900, 1500, 3200, 4400),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 2, s2, insertionPoint = length(s1) - 22050 * .21)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 1000
subFreq = 70  
subDep = 70
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 480, 
  pitchAnchors = data.frame(time = c(0, 150, 380, 480), 
                            value = c(550, 1000, 1055, 840)),
  amplAnchors = c(80, 80, 75),
  rolloff = c(-20, -4, -2, -4, -20), rolloffOct = 0,
  nonlinRandomWalk = c(rep(0, 40), rep(1, 60)), 
  subFreq = 70, subDep = 70,
  temperature = 0.001, 
  formants = c(900, 1500, 3200, 4400),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 2, s2, insertionPoint = length(s1) - 22050 * .21)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_290_130_59.wav'))  # de factor not quite 70 Hz

# subh2
pitchMedian = 1000
subFreq = 210  
subDep = 195
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s1 = soundgen(
  sylLen = 480, 
  pitchAnchors = data.frame(time = c(0, 150, 380, 480), 
                            value = c(550, 1000, 1055, 840)),
  amplAnchors = c(80, 80, 75),
  rolloff = c(-20, -4, -2, -4, -20), rolloffOct = 0,
  nonlinRandomWalk = c(rep(0, 40), rep(1, 60)), 
  subFreq = 210, subDep = 195,
  temperature = 0.001, 
  formants = c(900, 1500, 3200, 4400),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 2, s2, insertionPoint = length(s1) - 22050 * .21)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_290_210_59.wav'))

## CHAOS
s1 = soundgen(
  sylLen = 480, 
  pitchAnchors = data.frame(time = c(0, 150, 380, 480), 
                            value = c(550, 1000, 1055, 840)),
  amplAnchors = c(80, 80, 75),
  rolloff = c(-20, -4, -2, -4, -20), rolloffOct = 0,
  nonlinRandomWalk = c(rep(0, 40), rep(2, 60)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001, 
  formants = c(900, 1500, 3200, 4400),
  rolloffNoise = 0,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
s = addVectors(s1 * 2, s2, insertionPoint = length(s1) - 22050 * .21)
playme(s, 22050)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_290.wav'))
