setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/soundgen')
filename = 'sr_561'

# a = analyze(paste0('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/soundgen_confirm/stimuli/ut_cut/', filename, '.wav'), ylim = c(0, 4), pitchMethods = c('dom', 'autocor'), minVoicedCands = 1)
# a$pitch

# original
rw = c(rep(0, 20), rep(2, 65), rep(0, 15))
t = c(0, 200, 650, 780)
s = soundgen(
  sylLen = 780, 
  pitchAnchors = data.frame(time = t, 
                            value = c(506, 810, 760, 415)),
  rolloff = c(-15, -4, -4, -4, -4, -6, -15) - 4, rolloffOct = 1,
  nonlinRandomWalk = rw, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001, 
  formants = list(f1 = data.frame(time = t, freq = c(300, 950, 800, 400)),
                  f2 = data.frame(time = t, freq = c(700, 1450, 1350, 700)),
                  f3 = c(2700, 2500), f4 = c(3600, 3500), f5 = c(4700, 4500)),
  formantWidth = 1.5,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::meanspec(s, f = 22050, alim = c(-80, 0), flim = c(0, 8), dB = 'max0')

playme(s, 22050)
spectrogram(s, 22050, osc = T, ylim = c(0, 4))

# no nonlin
s = soundgen(
  sylLen = 780, 
  pitchAnchors = data.frame(time = t, 
                            value = c(506, 810, 760, 415)),
  rolloff = c(-15, -4, -4, -4, -4, -6, -15) - 4, rolloffOct = 1,
  # nonlinRandomWalk = rw, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001, 
  formants = list(f1 = data.frame(time = t, freq = c(300, 950, 800, 400)),
                  f2 = data.frame(time = t, freq = c(700, 1450, 1350, 700)),
                  f3 = c(2700, 2500), f4 = c(3600, 3500), f5 = c(4700, 4500)),
  formantWidth = 1.5,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r00.wav'))


## ROLLOFF
# no nonlin rolloff +6
s = soundgen(
  sylLen = 780, 
  pitchAnchors = data.frame(time = t, 
                            value = c(506, 810, 760, 415)),
  rolloff = c(-15, -4, -4, -4, -4, -6, -15) - 4 + 6, rolloffOct = 1,
  # nonlinRandomWalk = rw, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001, 
  formants = list(f1 = data.frame(time = t, freq = c(300, 950, 800, 400)),
                  f2 = data.frame(time = t, freq = c(700, 1450, 1350, 700)),
                  f3 = c(2700, 2500), f4 = c(3600, 3500), f5 = c(4700, 4500)),
  formantWidth = 1.5,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)
seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r+6.wav'))

# no nonlin rolloff -6
s = soundgen(
  sylLen = 780, 
  pitchAnchors = data.frame(time = t, 
                            value = c(506, 810, 760, 415)),
  rolloff = c(-15, -4, -4, -4, -4, -6, -15) - 4 - 6, rolloffOct = 1,
  # nonlinRandomWalk = rw, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001, 
  formants = list(f1 = data.frame(time = t, freq = c(300, 950, 800, 400)),
                  f2 = data.frame(time = t, freq = c(700, 1450, 1350, 700)),
                  f3 = c(2700, 2500), f4 = c(3600, 3500), f5 = c(4700, 4500)),
  formantWidth = 1.5,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_000_r-6.wav'))


## PITCH JUMPS
s = soundgen(
  sylLen = 780, 
  pitchAnchors = data.frame(time = c(0, 165, 166, 500, 501, 650, 780), 
                            value = c(506, 578, 820, 810, 770, 760, 415)),
  rolloff = c(-15, -4, -4, -4, -4, -6, -15) - 4, rolloffOct = 1,
  # nonlinRandomWalk = rw, subDep = 0, jitterDep = 2, shimmerDep = 20,
  temperature = 0.001, 
  formants = list(f1 = data.frame(time = t, freq = c(300, 950, 800, 400)),
                  f2 = data.frame(time = t, freq = c(700, 1450, 1350, 700)),
                  f3 = c(2700, 2500), f4 = c(3600, 3500), f5 = c(4700, 4500)),
  formantWidth = 1.5,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_100.wav'))


## SUBHARMONICS
pitchMedian = 750
subFreq = 70  
subDep = 45
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 780, 
  pitchAnchors = data.frame(time = t, 
                            value = c(506, 810, 760, 415)),
  rolloff = c(-15, -4, -4, -4, -4, -6, -15) - 4, rolloffOct = 1,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 65), rep(0, 15)), 
  subFreq = 75, subDep = 45,
  temperature = 0.001, 
  formants = list(f1 = data.frame(time = t, freq = c(300, 950, 800, 400)),
                  f2 = data.frame(time = t, freq = c(700, 1450, 1350, 700)),
                  f3 = c(2700, 2500), f4 = c(3600, 3500), f5 = c(4700, 4500)),
  formantWidth = 1.5,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_75_32.wav'))  

# subh2
pitchMedian = 750
subFreq = 250  
subDep = 165
dnorm(pitchMedian / round(pitchMedian / subFreq), mean = 0, sd = subDep) /  dnorm(0, mean = 0, sd = subDep)

s = soundgen(
  sylLen = 780, 
  pitchAnchors = data.frame(time = t, 
                            value = c(506, 810, 760, 415)),
  rolloff = c(-15, -4, -4, -4, -4, -6, -15) - 4, rolloffOct = 1,
  nonlinRandomWalk = c(rep(0, 20), rep(1, 65), rep(0, 15)), 
  subFreq = 250, subDep = 165,
  temperature = 0.001, 
  formants = list(f1 = data.frame(time = t, freq = c(300, 950, 800, 400)),
                  f2 = data.frame(time = t, freq = c(700, 1450, 1350, 700)),
                  f3 = c(2700, 2500), f4 = c(3600, 3500), f5 = c(4700, 4500)),
  formantWidth = 1.5,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_010_500_250_32.wav'))  


## CHAOS
s = soundgen(
  sylLen = 780, 
  pitchAnchors = data.frame(time = t, 
                            value = c(506, 810, 760, 415)),
  rolloff = c(-15, -4, -4, -4, -4, -6, -15) - 4, rolloffOct = 1,
  nonlinRandomWalk = c(rep(0, 20), rep(2, 65), rep(0, 15)), 
  subDep = 0, jitterDep = 1.5, shimmerDep = 15,
  temperature = 0.001, 
  formants = list(f1 = data.frame(time = t, freq = c(300, 950, 800, 400)),
                  f2 = data.frame(time = t, freq = c(700, 1450, 1350, 700)),
                  f3 = c(2700, 2500), f4 = c(3600, 3500), f5 = c(4700, 4500)),
  formantWidth = 1.5,
  addSilence = 0, samplingRate = 22050, pitchSamplingRate = 22050,
  play = T, plot = T, osc = T, ylim = c(0, 8)
)

seewave::savewav(s, f = 22050, filename = paste0(filename, '_001_500.wav'))
